*******************************************
***  Pisa G. Ruggiero 30/7/2007         ***
***                                     ***
***  Layout   apparatus for K+ -> pivv  ***
***                                     ***
*******************************************
**********************************************
************  A P P A R A T U S  *************
**********************************************


*************************************************************************
*************** B E G I N   B E A M   O P T I C S ***********************
*************************************************************************
device  rettcil          *** Cu collimator 
nome     XCH0   K0
writeout
flags    dump
detect   Kp  dump
detect   pip dump
detect   mup
detect   all dump
materiali Cu  none
cface     0.0      0.0       30.0
dtin      1.5      1.5       95.
totout    15.0    25.0       95.
end

device  rettcil          *** Fe collimator 
nome     XCHA   KA
flags    dump
detect   Kp  dump
detect   pip dump
detect   mup
detect   all dump
materiali Fe  none
cface     0.0      0.0       130.0
dtin      2.0      0.0       30.
totout    25.0     46.0      30.
end

device  rettcil
nome     TCX03   K3
flags    dump
detect   Kp   
detect   pip  
detect   mup
detect   all  dump
materiali   Fe   none
cface    0.0    0.0      168.5    
dtin     2.8    0.0      161.5   
totout   80.0   80.0     161.5    
end

**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 
device   quadrupole
nome     QNR5    Q1
flags    magn
detect   char   dump
materiali   Fe   none
cface    0.0        0.0       375.0
vfield   -1449.67   1.0         
sizein    2.75      2.75      149.5 
sizeout   2.9       2.9       149.5
end

device   quadrupole
nome     QNR9     Q2
flags    magn
detect   char   dump
materiali   Fe   none
cface    0.0        0.0       718.0
vfield   3173.00    1.0 
sizein   2.75       2.75     149.5
sizeout  2.9        2.9      149.5
end

device   quadrupole
nome     QNR13    Q3
flags    magn
detect   char   dump   
materiali   Fe   none
cface    0.0        0.0      1138.0
vfield   -2353.33   1.0
sizein    3.25      3.25    149.5
sizeout   3.45      3.45    149.5
end
**********************************
*** END FOCUSING QUADRUPOLES ***
********************************** 


************************
*** BEGIN ACHROMAT 1 ***
************************ 
device   magnete
nome     Mtr17  
flags    magn
detect   char        noreg
materiali   Fe   none
cface    0.0       0.0      1496.0
field    -16546.0   0.0      0.0   
sizein   1.8      9.0       180.
sizeout  3.6      18.8      180.   
end

device   magnete
nome     Mtr21
flags    magn
detect   char       noreg
materiali   Fe   none
cface    0.0       0.0      1916.0
field    16546.0   0.0      0.0 
sizein   1.8      14.75     180.
sizeout  3.6      18.80     180.
end

device   rettcil     
nome     Tax24      T71
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Cu  Air
cface     0.0       0.0      2307.0
centrin   0.0      -9.85     0.0
rin       0.65      0.65     20.25
sizeout   40.       60.      20.25
end
device   rettcil     
nome     Tax242      T72
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Cu  Air
cface     0.0       0.0      2347.5
centrin   0.0      -9.85     0.0
rin       0.59      0.59     20.25
sizeout   40.       60.      20.25
end
device   rettcil     
nome     Tax243      T73
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0       0.0      2388.0
centrin   0.0      -9.85     0.0
rin       0.53      0.53     20.25
sizeout   40.       60.      20.25
end
device   rettcil     
nome     Tax244      T74
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0       0.0       2428.5
centrin   0.0      -9.85      0.0
rin       0.47      0.47      6.75
sizeout   40.       60.       6.75
end
device   rettcil     
nome     Tax245      T75
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0       -0.0      2442.0
centrin   0.0      -9.85      0.0
rin       0.46      0.46      6.75
sizeout   40.       60.       6.75
end
device   rettcil     
nome     Tax246      T76
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0       0.0       2455.5
centrin   0.0      -9.85      0.0
rin       0.45      0.45      6.65
sizeout   40.       60.       6.65
end

*** POSITRON ABSORBER ******************** 
device   ciliret
nome     XCON25 XC2
flags    veto
detect   Kp   
detect   pip  
detect   mup
materiali   Fe   none
cface    0.0    -10.0      2468.5
sizein   0.5    0.5        0.4   
rout     17.8   17.8       0.4  
end
device   rettangolo
nome     XCON26 XC6
flags    veto
detect   Kp   
detect   pip  
detect   mup
materiali   W  none 
cface    0.0    -10.0      2469.3
sizein   0.5    0.5        0.2
end
device   ciliret
nome     XCON27 XC7
flags    veto
detect   Kp   
detect   pip  
detect   mup
materiali   Fe   none
cface    0.0    -10.0      2469.7
sizein   0.5    0.5        0.4   
rout     17.8   17.8       0.4  
end
***************************************** 


device   rettcil     
nome     Tax281      T81
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0        0.0      2470.5
centrin   0.0      -10.15     0.0
rin       0.45      0.45      6.65
sizeout   40.       60.       6.65
end
device   rettcil     
nome     Tax282      T82
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0        0.0      2483.5
centrin   0.0      -10.15     0.0
rin       0.46      0.46      6.75
sizeout   40.       60.       6.75
end
device   rettcil     
nome     Tax283      T83
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0        0.0      2497.0
centrin   0.0      -10.15     0.0
rin       0.47      0.47      6.75
sizeout   40.       60.       6.75
end
device   rettcil     
nome     Tax284      T84
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0        0.0      2510.5
centrin   0.0      -10.15     0.0
rin       0.53      0.53      20.25
sizeout   40.       60.       20.25
end
device   rettcil     
nome     Tax285      T85
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe  Air
cface     0.0        0.0      2551.0
centrin   0.0      -10.15     0.0
rin       0.59      0.59      20.25
sizeout   40.       60.       20.25
end
device   rettcil     
nome     Tax286      T86
flags    veto
detect   Kp   
detect   pip  
detect   mup
detect   all   dump
materiali  Fe Air  
cface     0.0        0.0      2591.5
centrin   0.0      -10.15     0.0
rin       0.65      0.65      20.25
sizeout   40.       60.       20.25
end

device   magnete
nome     Mtr29
flags    magn
detect   char       noreg
cface    0.0        0.0     2667.0
field    16546.0    0.0     0.0
sizein   1.8       14.75    180.
sizeout  3.6       18.8     180.
end

device   magnete
nome     Mtr33
flags    magn
detect   char       noreg
cface    0.0        0.0     3087.0
field    -16546.0   0.0     0.0
sizein   1.8       14.75    180.
sizeout  3.6       18.8     180.
end
**********************
*** END ACHROMAT 1 ***
********************** 


**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 
device   quadrupole
nome     QNL36    q4
flags    magn
detect   char       dump
materiali   Fe   none
cface    0.0        0.0      3506.0
vfield  -2140.0     1.0
totin    10.6       10.6     299.
totout   11.16      11.16    299.
end

device  rettret          *** Coll. 1
nome     XCS38   C1    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    3840.5    
sizein    5.0   1.8    50.      
sizeout   5.0   11.8   50.
end

device   quadrupole
nome     QNL41      q5 
flags    magn
detect   char       dump
cface    0.0        0.0      3983.5
vfield   2360.75    1.0
totin    10.56      10.6     299.
totout   11.16      11.16    299.
end

device  rettret          *** Coll.2 
nome     XCS43   C2    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    4318.0    
sizein    2.7   5.0   50.      
sizeout   12.7  5.0   50.
end

device   quadrupole
nome     QNL46      q6 
flags    magn
detect   char       dump
materiali   Fe   none
cface    0.0        0.0      4461.0
vfield   -1773.75   1.0
totin    10.56      10.6     299.
totout   11.16      11.16    299.
end
********************************
*** END FOCUSING QUADRUPOLES ***
******************************** 

**********************************************
*** BEGIN COLLIMATORS AND MU FILTER STAGES ***
**********************************************
device  rettret          *** Coll.3 
nome     XCS48   C31
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    4795.5    
sizein    5.0  0.2    20.      
sizeout   5.0  10.2   20.
end
device  rettret          *** Coll.3 
nome     XCS49   C32    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    4835.5    
sizein    5.0  0.12   10.      
sizeout   5.0  10.2   10.
end
device  rettret          *** Coll.3 
nome     XCS50   C33    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup 
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    4855.5    
sizein    5.0  0.2    20.      
sizeout   5.0  10.2   20.
end
********************************************
*** END COLLIMATORS AND MU FILTER STAGES ***
********************************************

**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 
device   quadrupole
nome     QNL61      q7 
flags    magn
detect   char       dump
materiali   Fe   none
cface    0.0        0.0      5966.0
vfield   -1582.5    1.0
totin    10.56      10.6     299.
totout   11.16      11.16    299.
end

device   quadrupole
nome     QNL65      q8 
flags    magn
detect   char       dump
materiali   Fe   none
cface    0.0        0.0      6309.0
vfield   1085.0     1.0
totin    10.56      10.6     299.
totout   11.16      11.16    299.
end
********************************
*** END FOCUSING QUADRUPOLES ***
******************************** 

device  rettret          *** Coll.4/5 
nome     XCH67   C4    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    6643.5    
sizein    2.7  1.5    50.      
sizeout   12.7 11.5   50.
end

device   cilindro         *** CEDAR DETECTOR 
nome     CEDAR      CV
writeout
flags    none
detect   char 
materiali   H210   H210 
cface     0.0       0.0    6911.3
dtout     52.       0.     631.7
end

**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 
device   quadrupole
nome     QFS77    q9
flags    magn
detect   char       dump
cface    0.0        0.0      7631.0
vfield   -1709.4    1.0
totin    9.5       9.5    80.
totout   9.8       9.8    80.
end

device   quadrupole
nome     QFS79   q10
flags    magn
detect   char       dump
cface    0.0        0.0      7831.0
vfield   1732.8     1.0
totin    9.5        9.5    80.
totout   9.8        9.8    80.
end
********************************
*** END FOCUSING QUADRUPOLES ***
******************************** 

device  gigatrack      *** SPIBES1 DETECTOR 
nome     Spibes1   B1
writeout
flags    none
detect   char
mem       0.1
materiali Si none
cface    0.0        0.0    7960.0
totout   6.0        2.7    0.04
end

device   rettret         *** SCRAPER 1
nome     XCM83      X0
flag     dump
detect   Kp     dump
detect   pip    dump
detect   mup
materiali Fe   none
cface     0.0       0.0    8038.5
sizein    4.0       2.0    250.
sizeout   4.2       2.2    250.
end

************************
*** BEGIN ACHROMAT 2 ***
************************ 
device   magnete      
nome     MBP87
flags    magn
detect   char       noreg 
cface    0.0        0.0       8611.5
field    0.0        -16678.0  0.0
sizein   6.45       3.6       125.
sizeout  6.7        3.85      125.
end

device   magnete      
nome     MBP91
flags    magn
detect   char       noreg 
cface    6.0        0.0       8971.5
field    0.0        16678.0   0.0
sizein   6.45       3.6       125.
sizeout  6.7        3.85      125.
end

device  gigatrack       *** SPIBES2 DETECTOR (y = +6cm) 
nome     Spibes2   B2
writeout
flags    none
detect   char
mem       0.1
materiali Si none
cface    6.0    0.0    9280.0
totout   6.0    2.7    0.04
end

device   magnete
nome     MBP95
detect   char       noreg 
cface    6.0        0.0       9365.5
**field    0.0        16678.0   0.0
field    0.0        15380.0   0.0
sizein   6.45       3.6       125.
sizeout  6.7        3.85      125.
end

device   magnete
nome     MBP99
detect   char       noreg 
cface    0.0        0.0       9725.5
**field    0.0        -16678.0  0.0
field    0.0        -14179.0  0.0
sizein   6.45       3.6       125.
sizeout  6.7        3.85      125.
end
**********************
*** END ACHROMAT 2 ***
********************** 

device  rettret          *** Coll.6/7 
nome     XCH02   C6    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    10100.0    
sizein    3.6  1.8    50.      
sizeout   13.6 11.8   50.
end

device  gigatrack        *** SPIBES3 DETECTOR 
nome     Spibes3   B3
writeout
flags    none
detect   char
mem       0.1
materiali Si none
cface    0.0    0.0    10240.0
totout   6.0    2.7    0.04
end
*********************************************************************
*************** E N D   B E A M   O P T I C S ***********************
*********************************************************************
done
end_all
