*******************************************
***  Firenze G. Ruggiero 4/8/2009       ***
***                                     ***
***  Layout   apparatus for beam test   ***
***                                     ***
*******************************************
**********************************************
************  A P P A R A T U S  *************
**********************************************


*************************************************************************
*************** B E G I N   B E A M   O P T I C S ***********************
*************************************************************************
device  rettcil          *** Cu collimator 
nome     XCH0   K0
writeout
flags    dump
detect   Kp  dump
detect   pip dump
detect   mup
detect   p dump
materiali Cu Air 
cface     0.0      0.0       30.0
dtin      1.5      1.5       95.
totout    15.0    25.0       95.
mem -1
end

device  rettcil          *** Fe collimator 
nome     XCHA   KA
flags    dump
detect   Kp  dump
detect   pip dump
detect   mup
detect   p dump
materiali Fe  Air
cface     0.0      0.0       130.0
dtin      2.0      2.0       30.
totout    25.0     46.0      30.
mem -1
end

device   rettangolo          
nome     ALUM1     AlW1
flags    none
detect   char 
materiali  Alce   Alce 
cface     0.0       0.0    168.46
totout    120.      120.   0.04
mem -1
end

device  rettcil
nome     TCX03   K3
flags    dump
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0    0.0      168.5    
dtin     2.8    2.8      161.5   
totout   80.0   80.0     161.5    
mem -1
end

device  rettcil
nome     TCX04   K4
flags    dump
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0    0.0      330.0    
dtin     2.8    2.8      3.0   
totout   120.0  120.0     3.0    
mem -1
end

**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 

device   quadrupole
nome     QNR5    Q1
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0        0.0       375.0
vfield   -1432.8733   1.0         
sizein    2.75      2.75      149.5 
sizeout   30.0      40.0      149.5
mem -1
end

device   quadrupole
nome     QNR9     Q2
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0        0.0       718.0
vfield   3167.5633    1.0 
sizein   2.75       2.75     149.5
sizeout  30.0       40.0     149.5
mem -1
end

device   quadrupole
nome     QNR13    Q3
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0        0.0      1138.0
vfield   -2353.7767   1.0
sizein    2.75      2.75    149.5
sizeout   30.0      40.0    149.5
mem -1
end
**********************************
*** END FOCUSING QUADRUPOLES ***
********************************** 


************************
*** BEGIN ACHROMAT 1 ***
************************ 
device   magnete
nome     Mtr17  
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0       0.0      1496.0
field    -18201.0   0.0      0.0   
sizein   1.8      9.0       180.
sizeout  34.5     60.0      180.   
mem -1
end

device   magnete
nome     Mtr21
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0       0.0      1916.0
field    18201.0   0.0      0.0 
sizein   1.8      14.75     180.
sizeout  34.5     60.0     180.
mem -1
end

device   rettangolo          
nome     ALUM2     AlW2
flags    none
detect   char 
materiali  Alce   Alce 
cface     0.0       0.0    2300.9
totout    120.      120.   0.08
mem -1
end

device   rettcil     
nome     Tax24      T71
flags    veto
detect   Kp dump  
detect   pip dump 
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0       0.0       2307.0
centrin   0.0      -10.75      0.0
rin       0.75      0.75      16.5
sizeout   40.       60.       16.5
mem -1
end

device   xtax     
nome     Tax24a      T7a
flags    veto
detect   Kp dump  
detect   pip  dump
detect   mup
detect   p   dump
materiali  Cu  Air
cface     0.0       0.0      2340.0
centrin   0.0      -10.75    0.0
sizeout   40.       60.      3.75
sizein    0.675     0.675    3.75
fortax    0.66      0.66     3.75
mem -1
end

device   xtax     
nome     Tax242      T72
flags    veto
detect   Kp dump  
detect   pip dump 
detect   mup
detect   p   dump
materiali  Cu  Air
cface     0.0       0.0      2347.5
centrin   0.0      -10.75     0.0
sizeout   40.       60.      16.5
sizein    0.66      0.66     16.5
fortax    0.61      0.61     16.5
mem -1
end

device   xtax     
nome     Tax24b      T7b
flags    veto
detect   Kp dump  
detect   pip  dump
detect   mup
detect   p   dump
materiali  Cu  Air
cface     0.0       0.0      2380.5
centrin   0.0      -10.75     0.0
sizeout   40.       60.      3.75
sizein    0.61     0.61      3.75
fortax    0.60     0.60      3.75
mem -1
end

device   xtax     
nome     Tax243      T73
flags    veto
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0       0.0      2388.0
centrin   0.0      -10.75     0.0
sizeout   40.       60.      16.5
sizein    0.60      0.60     16.5
fortax    0.55      0.55     16.5
mem -1
end

device   xtax     
nome     Tax24c      T7c
flags    veto
detect   Kp dump  
detect   pip  dump
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0       0.0      2421.0
centrin   0.0      -10.75     0.0
sizeout   40.       60.      3.75
sizein    0.55     0.55      3.75
fortax    0.54     0.54      3.75
mem -1
end

device   xtax     
nome     Tax244      T74
flags    veto
detect   Kp dump  
detect   pip dump 
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0       0.0       2428.5
centrin   0.0      -10.75     0.0
sizeout   40.       60.       10.25
sizein    0.54      0.54      10.25
fortax    0.51      0.51      10.25
mem -1
end

device   xtax     
nome     Tax245      T75
flags    veto
detect   Kp dump  
detect   pip dump 
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0       0.0      2449.0
centrin   0.0      -10.75      0.0
sizeout   40.       60.       6.5
sizein    0.51      0.51      6.5
fortax    0.50      0.50      6.5
mem -1
end

device   rettcil     
nome     Tax246      T76
flags    veto
detect   Kp dump  
detect   pip dump 
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0       0.0       2462.0
centrin   0.0      -10.75      0.0
rin       0.50      0.50      3.25
sizeout   40.       60.       3.25
mem -1
end

*** POSITRON ABSORBER ******************** 
device   rettangolo
nome     XCON25 XC2
flags    veto
detect   Kp   
detect   pip  
detect   p  
detect   mup
materiali   W  W 
cface    0.0    -11.0      2469.3
sizein   2.0    2.0        0.2
mem -1
end
***************************************** 


device   rettcil     
nome     Tax281      T81
flags    veto
detect   Kp dump   
detect   pip dump  
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0        0.0      2470.5
centrin   0.0      -11.25     0.0
rin       0.5       0.5       3.25
sizeout   40.       60.       3.25
mem -1
end

device   xtax     
nome     Tax282      T82
flags    veto
detect   Kp dump   
detect   pip dump  
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0        0.0      2477.0
centrin   0.0      -11.25     0.0
sizeout   40.       60.       6.5
sizein    0.50      0.50      6.5
fortax    0.51      0.51      6.5
mem -1
end

device   xtax     
nome     Tax283      T83
flags    veto
detect   Kp dump   
detect   pip dump  
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0        0.0      2490.0
centrin   0.0      -11.25     0.0
sizeout   40.       60.       10.25
sizein    0.51      0.51      10.25
fortax    0.54      0.54      10.25
mem -1
end

device   xtax     
nome     Tax28a      T8a
flags    veto
detect   Kp dump  
detect   pip  dump
detect   mup
detect   p   dump
materiali  Cu  Air
cface     0.0       0.0      2510.5
centrin   0.0      -11.25     0.0
sizeout   40.       60.      3.75
sizein    0.54     0.54      3.75
fortax    0.55     0.55      3.75
mem -1
end

device   xtax     
nome     Tax284      T84
flags    veto
detect   Kp dump   
detect   pip dump  
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0        0.0      2518.0
centrin   0.0      -11.25     0.0
sizeout   40.       60.       16.5
sizein    0.55      0.55      16.5
fortax    0.6      0.6      16.5
mem -1
end

device   xtax     
nome     Tax28b      T8b
flags    veto
detect   Kp dump  
detect   pip  dump
detect   mup
detect   p   dump
materiali  Cu  Air
cface     0.0       0.0      2551.0
centrin   0.0      -11.25     0.0
sizeout   40.       60.      3.75
sizein    0.60     0.60      3.75
fortax    0.61     0.61      3.75
mem -1
end

device   xtax     
nome     Tax285      T85
flags    veto
detect   Kp dump   
detect   pip dump  
detect   mup
detect   p   dump
materiali  Fe  Air
cface     0.0        0.0      2558.5
centrin   0.0      -11.25     0.0
sizeout   40.       60.       16.5
sizein    0.61      0.61      16.5
fortax    0.66      0.66      16.5
mem -1
end

device   xtax     
nome     Tax28c      T8c
flags    veto
detect   Kp dump  
detect   pip  dump
detect   mup
detect   p   dump
materiali  Cu  Air
cface     0.0       0.0      2591.0
centrin   0.0      -11.25     0.0
sizeout   40.       60.      3.75
sizein    0.66      0.66     3.75
fortax    0.675      0.675     3.75
mem -1
end

device   xtax     
nome     Tax286      T86
flags    veto
detect   Kp dump   
detect   pip dump  
detect   mup
detect   p   dump
materiali  Fe Air  
cface     0.0        0.0      2599.0
centrin   0.0      -11.25     0.0
sizeout   40.       60.       16.5
sizein    0.675      0.675      16.5
fortax    0.75      0.75      16.5
mem -1
end

device   rettangolo          
nome     ALUM3     AlW3
flags    none
detect   char 
materiali  Alce   Alce 
cface     0.0       0.0    2642.1
totout    120.      120.   0.08
mem -1
end

device   magnete
nome     Mtr29
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0        0.0     2667.0
field    18201.0    0.0     0.0
sizein   1.8       14.75    180.
sizeout  34.5      60.0     180.
mem -1
end

device   magnete
nome     Mtr33
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0        0.0     3087.0
field    -18201.0   0.0     0.0
sizein   1.8       14.75    180.
sizeout  34.5      60.0     180.
mem -1
end
**********************
*** END ACHROMAT 1 ***
********************** 


**************************************
******* BEGIN FOCUSING QUADRUPOLES ***
************************************** 
device   quadrupole
nome     QNL36    q4
flags    magn
detect   Kp dump 
detect   pip dump 
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0        0.0      3506.0
vfield  -2134.9275     1.0
totin    10.6       10.6     299.
totout   40.0       60.0     299.
mem -1
end

device  rettret          *** Coll. 1
nome     XCS38   C1    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface     0.0  0.0    3840.5    
sizein    5.0   2.0    50.      
sizeout   5.0   12.0   50.
mem -1
end

device   quadrupole
nome     QNL41      q5 
flags    magn
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface    0.0        0.0      3983.5
vfield   2356.905    1.0
totin    10.6       10.6     299.
totout   40.0       60.0     299.
mem -1
end

device  rettret          *** Coll.2 
nome     XCS43   C2    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface     0.0  0.0    4318.0    
sizein    3.2   5.0   50.      
sizeout   13.2  5.0   50.
mem -1
end

device   quadrupole
nome     QNL46      q6 
flags    magn
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface    0.0        0.0      4461.0
vfield   -1766.655   1.0
totin    10.6      10.6     299.
totout   40.0      60.0     299.
mem -1
end
********************************
*** END FOCUSING QUADRUPOLES ***
******************************** 

**********************************************
*** BEGIN COLLIMATORS AND MU FILTER STAGES ***
**********************************************
device  rettret          *** Coll.3 
nome     XCS48   C31
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface     0.0  0.0    4795.5    
sizein    5.0  0.2    20.      
sizeout   5.0  10.2   20.
mem -1
end

device  rettret          *** Coll.3 
nome     XCS49   C32    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface     0.0  0.0    4835.5    
sizein    5.0  0.12   10.      
sizeout   5.0  10.2   10.
mem -1
end

device  rettret          *** Coll.3 
nome     XCS50   C33    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup 
detect   p   dump
materiali   Fe   none
cface     0.0  0.0    4855.5    
sizein    5.0  0.2    20.      
sizeout   5.0  10.2   20.
mem -1
end

device muflt
nome   Fltmu FLM
detect   Kp      dump
detect   pip     dump
detect   mup 
detect   p     dump
materiali  Fe  none
cface   0.0         -4.0      5033.5
centrin   0.0       4.0      0.0 
field   0.0    -18000.0      0.0  // direzione
totin    4.        12.0      780.
totout  174.       116.0     780.
mem -1
end 

********************************************
*** END COLLIMATORS AND MU FILTER STAGES ***
********************************************

**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 
device   quadrupole
nome     QNL61      q7 
flags    magn
detect   Kp      dump
detect   pip     dump
detect   mup 
detect   p     dump
materiali   Fe   none
cface    0.0        0.0      5966.0
vfield   -1591.2825    1.0
totin    10.6      10.6    299.
totout   40.0      60.0    299.
mem -1
end

device   quadrupole
nome     QNL65      q8 
flags    magn
detect   Kp      dump
detect   pip     dump
detect   mup 
detect   p     dump
materiali   Fe   none
cface    0.0        0.0      6309.0
vfield   1089.1175     1.0
totin    10.6      10.6     299.
totout   40.0      60.0     299.
mem -1
end
********************************
*** END FOCUSING QUADRUPOLES ***
******************************** 
device  rettret          *** Coll.4/5 
nome     XCH67   Cx4    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface     0.0  0.0    6643.5    
sizein    2.7  1.5    50.      
sizeout   12.7 11.5   50.
mem -1
end

device   rettangolo          
nome     CXXX      C4
writeout
flags    none
detect   char 
materiali  Ckv   Ckv 
cface     0.0       0.0    6643.5
sizeout   2.7  1.5    50.      
end

device   cilindro          
nome     CEDAL1      CAL1
flags    none
detect   char 
materiali  Alce   Alce 
cface     0.0       0.0    6906.5
dtout     52.       0.     0.04
mem -1
end
device   cilindro         *** CEDAR DETECTOR 
nome     CEDAR      CV
writeout
flags    none
detect   char 
materiali   H23   H23 
cface     0.0       0.0    6911.3
dtout     50.       50.     631.7
end
device   cilindro          
nome     CEDAL2      CAL2
flags    none
detect   char 
materiali  Alce   Alce 
cface     0.0       0.0    7546.00
dtout     52.       0.     0.04
mem -1
end

**********************************
*** BEGIN FOCUSING QUADRUPOLES ***
********************************** 

device  corona     
nome     PIPE1   PI1
flags    dump 
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface    0.0        0.0    7546.0
dtin    15.6    15.6    88.0
dtout   15.9    15.9    88.0
mem -1
end

device   quadrupole ** up: foc x defoc y
nome     QFS77    q9
flags    magn
detect   Kp      dump
detect   pip     dump
detect   mup 
detect   p     dump
materiali   Fe   none
cface    0.0        0.0      7631.0
vfield   -1899.1489    1.0
totin    9.5       9.5    80.
totout   42.2      42.2    80.
mem -1
end

device  corona     
nome     PIPE2   PI2
flags    dump 
detect   Kp   dump
detect   pip  dump
detect   mup
detect   p   dump
materiali   Fe   none
cface    0.0        0.0    7711.0
dtin    15.6    15.6    120.0
dtout   15.9    15.9    120.0
mem -1
end

device   quadrupole ** up: foc y defoc x
nome     QFS79   q10
flags    magn
detect   Kp      dump
detect   pip     dump
detect   mup 
detect   p     dump
materiali   Fe   none
cface    0.0        0.0      7831.0
vfield   1849.1489     1.0
totin    9.5        9.5    80.
totout   42.2       42.2    80.
mem -1
end
********************************
*** END FOCUSING QUADRUPOLES ***
******************************** 

device  rettangolo 
nome     Spibes1   B1
writeout
flags    none
detect   char
mem       0.1
materiali Si none
cface    0.0        0.0    7960.0
totout   6.0        2.7    0.04
end

************************
*** BEGIN ACHROMAT 2 ***
************************ 
device   magnete      
nome     MBP87
flags    magn
detect   Kp dump
detect   pip dump
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0       33.5     8045.5
centrin  0.0  -33.5 0.0 
field   -16678.0   0.0     0.0
sizein   3.6       6.45    125.
sizeout  75.       40.     125.
mem -1
end

device   magnete      
nome     MBP87
flags    magn
detect   Kp dump
detect   pip dump
detect   mup
detect   p  dump
materiali   Fe   none
cface    0.0       33.5     8405.5
centrin  0.0  -33.5 0.0 
field    16678.0   0.0     0.0
sizein   3.6       6.45    125.
sizeout  75.       40.     125.
mem -1
end

device   rettret         *** scraper 
nome     XCM83      X0
flag     dump
detect   Kp     dump
detect   pip    dump
detect   mup
detect   all    dump
materiali Fe   none
cface     0.0      -5.0    8728.5
sizein    7.6       2.75   250.
sizeout   7.85      3.0    250.
mem -1
end

device  rettangolo       *** SPIBES2 DETECTOR (y = -6cm) 
nome     Spibes2   B2
writeout
flags    none
detect   char
mem       0.1
materiali Si none
cface    0.0   -6.0    9280.0
totout   6.0    2.7   0.04
end

device   magnete
nome     MBP95
detect   char       noreg 
materiali   Fe   none
cface    0.0       -6.0       9365.5
field    16678.0    0.0       0.0
sizein   3.6        6.45      125.
sizeout  3.85       6.7       125.
mem -1
end

device   magnete
nome     MBP99
detect   char       noreg 
materiali   Fe   none
cface    0.0        0.0       9725.5
field   -16678.0    0.0       0.0
sizein   3.6        6.45      125.
sizeout  3.85       6.7       125.
mem -1
end
**********************
*** END ACHROMAT 2 ***
********************** 

device  rettret          *** Coll.6/7 
nome     XCH02   C6    
flags    dump
detect   Kp   dump
detect   pip  dump
detect   mup
detect   all   dump
materiali   Fe   none
cface     0.0  0.0    10023.0    
sizein    3.3  1.65    50.      
sizeout   13.3 11.65   50.
mem -1
end

device   magnete
nome     MBP99
detect   char       noreg 
cface    0.0        0.0       10157.5
field    0.0        7505.0  0.0
sizein   4.75       4.75      20.
sizeout  4.9        4.9       20.
mem -1
end

done
end_all
