/***************************************************************************
                          anak6g.h  -  description
                             -------------------
    begin                : Sat Jan 18 2003
    copyright            : (C) 2003 by Giuseppe Pierazzini
    email                : peppe@unipi.it
 ***************************************************************************/

#ifndef ANAK6G_H
#define ANAK6G_H

#include "anak4g.h"
#include "gmatrix.h"

/**
 Procedura per Kl->6gam analysis
  *@author Giuseppe Pierazzini
  */

class AnaK6g : public AnaK4g
{
  public:

    AnaK6g();
    ~AnaK6g();
//--- root/paw interface-see also K4gam -------
    int ngm,dead6, permut_fit,iter_fit;
    float eg_fit[6],dist_fit,cog_fit,egamt_fit,bmax;
    float ws6[3], ss6[3],vss6[3],ss6_sort,vss6_sort,dist_sort;
// second choice 
    double last_chiq,dchi2;
//-----------------------
// stuff for fit.

    gmatrix Bm64,Az41;
    gmatrix F41,R41;
    gmatrix De61,Lmd41;
    gmatrix Zm11;
    gmatrix Var66, InV66;
    gmatrix BVB;
    gmatrix GB;
    gmatrix AGBA;
    gmatrix Gx;
    gmatrix CHQ;


// for Alan fit routine..
    float  Ass[3], Ae_fit[6],Ax_fit[6],Ay_fit[6],Ase_fit[6],Asx_fit[6],Asy_fit[6],Azeta,Avita,
    Vertex[3],Vsigsq[3],Ener,Esigsq,ChiKin;

//===================================
//
    int    iter_flag,permut_flag;
    float xg_fit[6],yg_fit[6];
    double em[6],ec[6], egtk6;
    double sq[6],xg[6],yg[6];
    double dist_vertex;
    double dq[6][6];
    double xg_sav[12],yg_sav[12],zg_sav[12],eg_sav[12];
    int    idpr_fit[12],idpr_sav[12];
// double dq_fit[6][6];

//
// calcolo dei parametri cinematici ss.---------
    qvet Gq[6], Pio01, Pio23, Pio45;
    gvet Versg,Pgam;
//--------------------------

    void Reset_parm();
    int Fisica();
    void Permutazione ( int );
    int Get_Data_from_saved ( int );
    int * Get_Permuta ( int );
    int Fitta();
    double Calcolo_Vincoli ();
    double F_Vinc ( int i4,double *ec ,double dist,int id,double delta );
    void Reset_Dummy_Data();
    void Save_good_fit();
};
#endif
