/***************************************************************************
                          anake2g.cpp  - for NA48
   gmp/SGal  4 ottobre 2010
   rivisto gallorini 2012
  ***************************************************************************/
//la successione degli include può essere causa di errore.....

#include "flyoh.h"
#include "anake2g.h"
#include  "flyline.h"
#include  "flytrk.h"

using namespace std;
int E2gdebug=0;
gvet  Vert_coor(gvet,gvet,gvet,gvet);

AnaKe2g::AnaKe2g()
{
    tipo=24;
    nfit=1;
    titol="K->e v g   in NA48 " ;
    nome="Ke2g";
    Gout<<"\n Ridefinito e creato il fit di "<<titol<<endl;

    if (Le_Tracce==0)
    {
        Gout<<"\n Error.. "<<titol<<"  analisys ... Tracks non defined!"<<endl;
        exit(0);
    }
    mas_Kp=ptr_Kapp->Get_Massa();
    mas_ele=ptr_Elec->Get_Massa();
    getta_hitcal=getta_dist=getta_ele=getta_elep=getta_gam=getta_pip=0;
}
AnaKe2g::~AnaKe2g()
{}




//=============== C h a r g e  2 pions    F i t ========

int AnaKe2g::Fisica()
{

 
    if (Eventi_Generati<-100) E2gdebug=1;
    else E2gdebug=0;
    count_call++;
    good=0;;
    chiq_vert=xvtx=yvtx=zvtx=0.0;
    pxkp=pykp=pzkp=momk=0.0;
//*****************************************

    count_decay++;

    /* Kaon */
    gvet Pk_mom;
    qvet  Pkin;
 
    Pkin.setvn ( 0.0,0.0,74.0, mas_Kp ); // definizione del quadrimomento
    Pkin.putvn( pxkp,pykp,pzkp,momk );  // salvo per root

    /* Only one track */
    ntrk=Le_Tracce->Totrac;
    if (ntrk!=1) 
    {
        getta_trk++;
        good=-1;
        return -1;
    }
 
    Flytrk *Trelep=0;  
    Trelep= &Tracc[0];
    
    /* Positive track charge */
    if (Trelep->charge !=1)
    {
        getta_char++;
        good=-2;
        return -2;
    }

    /* Vertex reconstruction */
    //printf(">>>>>>>>>>> %f \n",Trelep->Pc1[2]);
    Vtxstruct Xdecay(2);
    Xdecay.P[0].setvn(0.,0.,0.); 
    Xdecay.V[0]=Pkin.NVerso(); 
    Xdecay.P[1]=Trelep->Pc1;
    Xdecay.V[1]=Trelep->Verso; // versore della traccia prima del magnete
    Xdecay.Vertice();
    chiq_vert=Xdecay.chiq;
    Xdecay.Vtx.putv( xvtx,yvtx,zvtx );
    Xdecay.Vtx.Norma();

    /* Require good chi2 for vertex reco */
    if (chiq_vert > 4.)
    {
        getta_fit++;
        good=-3;
        return -3;
    }

    /* Not enough hits in lkr */
    if (lkry->mhit<2) 
    {
        getta_hitcal++;
        good=-4;
        return -4;
    }

    /* Find associated cluster */
    int icla= -1; 
    double dtrkcl= 5.;
    for (int i=0;i<lkry->mhit;i++) //ciclo hit Lkr
    {
      gvet DXl0= lkry->M_Hits[i].Xlab - Trelep->Xlk; //coordinate hit nel Lkr
      double d= DXl0.XYNorma();
      if(d < dtrkcl) { 
	icla= i;
	dtrkcl= d; 
      }
    }

    if(icla==-1) 
    {
      good= -5;
      return -5;
    }

    /* Find candidate gamma */
    int ngood=0, igam=0;
    for (int i=0;i<lkry->mhit;i++) //ciclo hit Lkr
    {
      if(i == icla) continue;

      int nbad=0; // check badpairs
      for (int j=0;j<lkry->mhit;j++) 
      {
        if(i==j) continue; 
        double rij= (lkry->M_Hits[i].Xlab - lkry->M_Hits[j].Xlab).XYNorma(); 
        if(rij < 20.) nbad++;
      }
      
      if(lkry->me[i] > 2. && nbad==0)
      {
        ngood++;
        igam= i;
      }
    }

    if(ngood!=1) 
    {
      good= -6;
      return -6;
    }

    /* LKr veto */
    for (int i=0;i<lkry->mhit;i++) //ciclo hit Lkr
    {
      if(i==icla || i==igam) continue;
      if(lkry->me[i] > 2.) 
      {
        good= -7;
	return -7;
      }
    }
    
    /* Reconstruct kinematic */
    Bufdev *Hitelep= &lkry->M_Hits[icla];
    Bufdev *Hitgam= &lkry->M_Hits[igam];
    ecla = Hitelep->e_rivela;
    eg = Hitgam->e_rivela;
    ptrk = Trelep->P.mom;

    qvet Pelep, Pgam, Pnu;
    gvet pg,cog;

    Pelep.setvn(Trelep->P,mas_ele);
    pg = ((Hitgam->Xlab - Xdecay.Vtx).NVerso())*eg; // gamma momentum
    Pgam.setvn(pg,0.);

    Pnu= Pkin - (Pelep+Pgam); // missing mass
    MM2= Pnu.Invarq();

    xdlz= 2.*(Pkin*Pgam)/(mas_Kp*mas_Kp); // Dalitz variables
    ydlz= 2.*(Pkin*Pelep)/(mas_Kp*mas_Kp);
    zdlz= 2.*(Pkin*Pnu)/(mas_Kp*mas_Kp);

    /* Other cuts */
    
    // Track momentum
    if(ptrk < 2. || ptrk > 70.)
    {
      good=-9;
      return -9;
    }
    
    // Track acceptance on LKr 
    double re_lkr = Trelep->Xlk.XYNorma();
    if (re_lkr < 15. || re_lkr > 115.)
    {
      good=-10;
      return -10;
    }

    // Track acceptance on DCHs
    double re_dch1= Trelep->Pc1.XYNorma(); // DCH1
    if (re_dch1 < 12. || re_dch1 > 115.)
    {
      good=-10;
      return -10;
    }

    double re_dch3= Trelep->Pc3.XYNorma(); // DCH3
    if (re_dch3 < 12. || re_dch3 > 115.)
    {
      good=-10;
      return -10;
    }

    double re_dch4= Trelep->Pc4.XYNorma(); // DCH4
    if (re_dch4 < 12. || re_dch4 > 115.)
    {
      good=-10;
      return -10;
    }

    // Track acceptance on CHOD
    double xe_hod= Trelep->Pc4.x + Trelep->P.x/Trelep->P.z * (hodo->M_Hits[0].Xlab.z-Trelep->Pc4.z); 
    double ye_hod= Trelep->Pc4.y + Trelep->P.y/Trelep->P.z * (hodo->M_Hits[0].Xlab.z-Trelep->Pc4.z); 
    double re_hod= sqrt(pow(xe_hod,2) + pow(ye_hod,2));
    if (re_hod < 14. || re_hod > 115.)
    {
      good=-10;
      return -10;
    }

    // Gamma radius at DCH1
    double xg_dch1= Hitgam->Xlab.x + pg.x/pg.z * (Trelep->Pc1.z-Hitgam->Xlab.z); 
    double yg_dch1= Hitgam->Xlab.y + pg.y/pg.z * (Trelep->Pc1.z-Hitgam->Xlab.z); 
    double rg_dch1= sqrt(pow(xg_dch1,2) + pow(yg_dch1,2));
    if (rg_dch1 < 12. || rg_dch1 > 115.)
    {
      good=-10;
      return -10;
    }

    // E/p 
    double eop= ecla / ptrk;
    if(eop < 0.95 || eop > 1.1) 
    {
      good= -8;
      return -8; 
    }

    // Track-cl. distance  
    if(dtrkcl > 1.5)
    {
      good=-11;
      return -11;
    }

   // x dalitz
   if(xdlz<0.) 
   {
     good= -12;
     return -12;
   }
   
   // y dalitz
   if(ydlz<0.) 
   {
     good= -13;
     return -13;
   }

   // Z vtx
   if(zvtx<-2000. || zvtx>10000.) 
   {
     good= -14;
     return -14;
   }

   // Missing mass
   if(fabs(MM2)>10.) 
   {
     good= -15;
     return -15;
   }

   // Gamma is not from bremssthralung
   double xu= Trelep->Pc1.x + Trelep->P.x/Trelep->P.z * (Hitgam->Xlab.z-Trelep->Pc1.z); 
   double yu= Trelep->Pc1.y + Trelep->P.y/Trelep->P.z * (Hitgam->Xlab.z-Trelep->Pc1.z); 
   double rbr= sqrt(pow(xu-Hitgam->Xlab.x,2) + pow(yu-Hitgam->Xlab.y,2));
   if (rbr < 8.)
   {
     good=-16;
     return -16;
   }

   

   /* Print geometry */
   //printf(">>>>> Z(DCH1)= %f \n",Trelep->Pc1.z);
   //printf(">>>>> Z(DCH2)= %f \n",Trelep->Pc2.z);
   //printf(">>>>> Z(DCH3)= %f \n",Trelep->Pc3.z);
   //printf(">>>>> Z(DCH4)= %f \n",Trelep->Pc4.z);
   //printf(">>>>> Z(CHOD)= %f \n",hodo->M_Hits[0].Xlab.z);
   //printf(">>>>> Z(LKr)= %f \n",lkry->M_Hits[0].Xlab.z);



// To be changed:
// --------------
// (1) vtx computation (CDA)
// (2) LKr & DCH accept. + dead cells
// (3) Final coll. params + origin Z pos.
// (4) Second order effects for bkg: Ke3 matrix element + PHOTOS  



// hit del nu al calorometro;
    gvet vnu=Pnu.Verso();
    gvet Xnu= Xdecay.Vtx +vnu*(Hitelep->Xlab.z-Xdecay.Vtx.z)/vnu.z;

// cog
    cog=Hitelep->Xlab*Hitelep->e_rivela+ Hitgam->Xlab*Hitgam->e_rivela+ Xnu*Pnu.e;
    cog /= Pkin.mom;

    cox = cog.x;
    coy = cog.y;
    cogd = cog.XYNorma();


    count_wnt++;
    good=1;

    return 1;

}

//======================================================================================


//----------------------------------------------------
void AnaKe2g::print_scale()
{

    Gout<<"\n -----> "<<titol<<"   Analysis Summary. <-------\n";
    Gout<<"\n Fit entries          "<<count_call;
    Gout<<"\n no tracks            "<<getta_trk;
    Gout<<"\n Wrong charge         "<<getta_char;
    Gout<<"\n No gam               "<<getta_gam;
    Gout<<"\n No elettroni         "<<getta_ele;
    Gout<<"\n No good vertex       "<<getta_fit;
    Gout<<"\n Not enough lkr hits  "<<getta_hitcal;
    Gout<<"\n Good events          "<<count_wnt;

    cout<<"\n "<<titol << " Good events          "<<count_wnt<<" Analizzati "<<count_call<<endl;
    Gout<<"\n\n ======>           d o n e     <============ ";
}
//-------------------------------------------
