/***************************************************************************
                          anakenug.cpp  per NA62 
   GMP 27-11-2010

  ***************************************************************************/
// #define MIN(x,y,z) ((x)<(y)?(x)<(z)?(x):(z):(y)<(z)?(y):(z))

#include "flyoh.h"
#include "anakenug.h"
using namespace std;
int Enugdebug=0;
//-------------------------------------------------------------
//-------------------------------------------------------------

AnaKenug::AnaKenug()
{
    tipo=32;
    nfit=2;
    titol="K--> e nu gam  in NA62  ";
    nome="Kenug";
    ntrk=good=0;
    mas_Kp=ptr_Kapp->Get_Massa();
    mas_ele=ptr_Elec->Get_Massa();
    Gout<<"\n Attivato il fit di "<<titol;
    Pk_ric=new GigaBeam();
    getta_hitcal=getta_dist=getta_ele=getta_elep=getta_gam=getta_pip=0;



}

AnaKenug::~AnaKenug() {};

//=============== C h a r g e  2 pions    F i t ========

int AnaKenug::Fisica()
{

    // analisi  K0 -> pic pi0 -> gam e- e+

    if (Eventi_Generati<-1000) Enugdebug=1;
    else Enugdebug=0;

    count_call++;
    good=0;;
    chiq_vert=xvtx=yvtx=zvtx=0.0;
    pxkp=pykp=pzkp=momk=0.0;

//*****************************************
//*****************************************
//*****************************************

    count_decay++;


    if (Trkstraw==0) {
        cout<<"\n Tracce non attivato!!! exit "<<endl;
        exit(0);
    }
    ntrk=Trkstraw->ntrk_done;
    if ( ntrk<1)   // vedere meglio.......
    {
        getta_trk++;
        good=-1;
        return -1;
    }


// get tracks pointers and charge test

    Track *Trelep=0;
    Trelep=&Trkstraw->Traccia[0];


    if ( Trelep->charge !=1)
    {// wrong charge!!!!

        getta_char++;
        good=-2;
        return -2;
    }



//gigatrack info
    gvet Pk_mom;
    qvet  Pkin;
    // ricavo l'impulso del K dal gigatrak
    Pk_mom=Pk_ric->Beam_Rec();   // impulso del beam dal gigatrack
    Pkin.setvn ( Pk_mom,mas_Kp ); // definizione del quadrimomento
    Pkin.putvn( pxkp,pykp,pzkp,momk );  // salvo per root
//    xg3=Pk_ric->xg3; //per root
//    yg3=Pk_ric->yg3; //per root

// calcolo del vertice: si usa la struttura Vtxstruct. Vedi analisi.h
    Vtxstruct Xdecay(2);
    Xdecay.P[0].setvn(Pk_ric->xg3,Pk_ric->yg3,10240.); // beam at G3 (0.,0.,10240.);
    Xdecay.V[0]=Pkin.NVerso();       //  versore del beam...
    Xdecay.P[1]=Trelep->Xmg; // coordinate della traccia al centro del magnete
    Xdecay.V[1]=Trelep->P_in.NVerso(); // versore della traccia prima del magnete
//  GET  VERTICE
    Xdecay.Vertice();
    chiq_vert=Xdecay.chiq;
    Xdecay.Vtx.putv( xvtx,yvtx,zvtx );
    Xdecay.Vtx.Norma();



    if (lkry->mhit>2&& chiq_vert>100.)
    {
        Xdecay.Vtx.print("vtx");
        Gout<<" chiq  "<<setw(8)<< chiq_vert
        <<" zv "<<setw(8)<<evento_.Gen.zv<< " mhit "<<setw(4)<<lkry->mhit <<"  Ev "<<Eventi_Generati;


    }


    if (chiq_vert>20.)
    {// wrong fit!!!!
        getta_fit++;
        good=-3;
        return -3;
    }

    if (lkry->mhit<2)
    {// not enough hits in lkr
        getta_hitcal++;
        good=-4;
        return -4;
    }
//    cout<<setprecision(3);
//    cout<<"\n ev1 "<<setw(8)<<Eventi_Generati<<" ch "<<setw(8)<< chiq_vert<<" mhit "<<setw(8)<<lkry->mhit;



    if (Enugdebug==1) Gout<<"\n Ev2 "<<setw(8)<<Eventi_Generati<< " Mid "<<setw(8)<< lkry->M_Hits[0].idm;


// riconoscimento dei cluster (hit) nel calorimetro

    Bufdev *Hitgam=0,*Hitelep=0;;
    for (int i=0;i<lkry->mhit;i++) //ciclo hit Lkr
    {

        gvet DXl0=lkry->M_Hits[i].Xlab - Trelep->Xlkr; //coordinate hit nel Lkr
        double dxy=DXl0.XYNorma();
        double rpp=lkry->me[i]/Trelep->P_in.mom;
        if (dxy<3.5&&rpp>.85)
        {
            Hitelep=&lkry->M_Hits[i];
        }
        else Hitgam=&lkry->M_Hits[i];
    }


//cout<<"\n ev2 "<<setw(8)<<Eventi_Generati<<" ch "<<setw(8)<< chiq_vert<<" mhit "<<setw(8)<<lkry->mhit;

// test di accoppiamento fatto
if (Hitgam==0) {
    getta_gam++;
    good=-6;
    return -6;
}

if (Hitelep==0) {
    getta_ele++;
    good=-8;
    return -8;
}

//cout<<"\n ev3 "<<setw(8)<<Eventi_Generati<<" ch "<<setw(8)<< chiq_vert<<" mhit "<<setw(8)<<lkry->mhit;


// test sulla energia e posizione del gamma....
double E_gamma = Hitgam->e_rivela;
double r_gamma = Hitgam->Xlab.XYNorma();

if (E_gamma<3 || E_gamma>75)
{
    getta_gam++;
    good=-10;
    return -10;
}
if (r_gamma<15 || r_gamma>116)
{
    getta_gam++;
    good=-11;
    return -11;
}
// test sulla energia e posizione dello sciame dell'elettrone....
double E_elep = Hitelep->e_rivela;
double r_elep = Hitelep->Xlab.XYNorma();

if (E_elep<3 || E_elep>75)
{
    getta_ele++;
    good=-10;
    return -10;
}
if (r_elep<15 || r_elep>116)
{
    getta_ele++;
    good=-11;
    return -11;
}

//=================================



//quadrimpulsi particelle

qvet Pkmis, Ppi0, Pelep, Pgam, Pnu;
gvet pg,cog;

pg = ((Hitgam->Xlab - Xdecay.Vtx).NVerso())*E_gamma;
Pelep.setvn(Trelep->P_in,mas_ele);
Pgam.setvn(pg,0.);

Pnu =Pkin-(Pelep+Pgam);
mnuq =Pnu.Invarq();
mnu=Pnu.m;

//energie nel sistema del K

kelep= (Pkin*Pelep)/mas_Kp;
kegam= (Pkin*Pgam)/mas_Kp;
kenu= (Pkin*Pnu)/mas_Kp;


// hit del nu al calorometro;
gvet vnu=Pnu.Verso();
gvet Xnu= Xdecay.Vtx +vnu*(Hitelep->Xlab.z-Xdecay.Vtx.z)/vnu.z;

// cog
cog=Hitelep->Xlab*Hitelep->e_rivela+ Hitgam->Xlab*Hitgam->e_rivela+ Xnu*Pnu.e;
cog /= Pkin.mom;


cox = cog.x;
coy = cog.y;
cogd = cog.XYNorma();


count_wnt++;
good=1;


return 1;

}

//======================================================================================


//----------------------------------------------------
void AnaKenug::print_scale()
{

    Gout<<"\n -----> "<<titol<<"   Analysis Summary. <-------\n";
    Gout<<"\n Fit entries          "<<count_call;
    Gout<<"\n no tracks            "<<getta_trk;
    Gout<<"\n Wrong charge         "<<getta_char;
    Gout<<"\n No gam               "<<getta_gam;
    Gout<<"\n No elettroni         "<<getta_ele;
    Gout<<"\n No good vertex       "<<getta_fit;
    Gout<<"\n Not enough lkr hits  "<<getta_hitcal;
    Gout<<"\n Good events          "<<count_wnt;

    cout<<"\n Good events          "<<count_wnt<<" done "<<count_call<<endl;
    Gout<<"\n\n ======>           d o n e     <============ ";
}
//-------------------------------------------
