/***************************************************************************
                          anak2pi.cpp  -  description
   GMP 27-11-2010

  ***************************************************************************/
// #define MIN(x,y,z) ((x)<(y)?(x)<(z)?(x):(z):(y)<(z)?(y):(z))

#include "flyoh.h"
#include "anakpip0p0dlz.h"
using namespace std;

//-------------------------------------------------------------
//-------------------------------------------------------------

AnaKpip0p0dlz::AnaKpip0p0dlz()
{
    tipo=33;
    nfit=2;
    titol="K--> pi pi0 pi0 ->gam dlz";
    nome="Kpi2p0dlz";
    ntrk=good=0;
    mas_pip=ptr_Pip->Get_Massa();
    mas_Kp=ptr_Kapp->Get_Massa();
    mas_pi0=ptr_Pi0->Get_Massa();
    mas_ele=ptr_Elec->Get_Massa();
    Gout<<"\n Attivato il fit di "<<titol;
    Pk_ric=new GigaBeam();
}

AnaKpip0p0dlz::~AnaKpip0p0dlz() {};

//=============== C h a r g e  2 pions    F i t ========

int AnaKpip0p0dlz::Fisica()
{

    // analisi  K0 -> pi0 pic e- e+



    count_call++;

    good=0;;
    chiq_vert=xvtx=yvtx=zvtx=0.0;

    momk=pxkp=pykp=pzkp=0.0;

    //taglio sul vertice generato (taglia solo gli eventi che finiscono sul collimatore)da togliere!!!
    if (evento_.Gen.zv < 10000.) {
        getta_cog++;
        return -1;
    }

//*****************************************
//*****************************************
//*****************************************

    count_decay++;


    if (Trkstraw==0) {
        cout<<"\n Tracce non attivato!!! exit "<<endl;
        exit(0);
    }
    if ( Trkstraw->ntrk_done<3)
    {
        getta_trk++;
        return -1;
    }



    Track  Trk0=Trkstraw->Traccia[0];
    Track  Trk1=Trkstraw->Traccia[1];
    Track  Trk2=Trkstraw->Traccia[2];

    if ((Trk0.charge+Trk1.charge+Trk2.charge) != 1)
    {// wrong charge!!!!
        getta_char++;
        return -1;
    }

    gvet Pk_mom;
    qvet  Pkin;
    // ricavo l'impulso del K dal gigatrak
    Pk_mom=Pk_ric->Beam_Rec();   // impulso del beam dal gigatrack
    Pkin.setvn ( Pk_mom,mas_Kp ); // definizione del quadrimomento
    Pkin.putvn( pxkp,pykp,pzkp,momk );  // salvo per root


// calcolo del vertice
    Vtxstruct Xdecay(4);
    Xdecay.P[3].setvn(0.,0.,10240.); // beam at G3 (0.,0.,10240.); Fare meglio
    Xdecay.V[3]=Pkin.NVerso();       //  versore del beam...
    Xdecay.P[0]=Trkstraw->Traccia[0].Xmg; // coordinate della traccia 0 al centro del magnete
    Xdecay.V[0]=Trkstraw->Traccia[0].P_in.NVerso(); // versore della traccia 0
    Xdecay.P[1]=Trkstraw->Traccia[1].Xmg; // coordinate della traccia 1 al centro del magnete
    Xdecay.V[1]=Trkstraw->Traccia[1].P_in.NVerso(); // versore della traccia 1
    Xdecay.P[2]=Trkstraw->Traccia[2].Xmg; // coordinate della traccia 2 al centro del magnete
    Xdecay.V[2]=Trkstraw->Traccia[2].P_in.NVerso(); // versore della traccia 2
    Xdecay.Vertice();
    chiq_vert=Xdecay.chiq;
    Xdecay.Vtx.putv( xvtx,yvtx,zvtx );

    if (chiq_vert>100.)
    {// wrong fit!!!!
        getta_fit++;
        return -1;
    }

// cinematica

    if (lkry->mhit!=6)
    {// not enough hits in lkr
        getta_ch++;
        return -1;
    }

    for (int i=0;i<lkry->mhit-1;i++)
        for (int j=i+1;j<lkry->mhit;j++)
        {
            gvet X1=lkry->M_Hits[i].Xlab - lkry->M_Hits[j].Xlab;
            if (X1.XYNorma()<3.5)
                return -1;
        }

    int npic=0, ne=0, nneg=0, npos=0;

    for (int i=0;i<lkry->mhit;i++) //ciclo hit Lkr
    {
        gvet Xl0=lkry->M_Hits[i].Xlab; //coordinate hit nel Lkr
        for (int j=0;j<3;j++) //ciclo tracce ricostruite
        {
            gvet Xdl0= Xl0-Trkstraw->Traccia[j].Xlkr; //differenza tra posizione hit Lkr e proiezione traccia
            if ( Xdl0.XYNorma()<3.5)
            {
                if (lkry->me[i]/Trkstraw->Traccia[j].P_in.mom<.85)
                    npic++;
                if (lkry->me[i]/Trkstraw->Traccia[j].P_in.mom>.95)
                {
                    ne++;
                    if (Trkstraw->Traccia[j].charge==1)
                        npos++;
                    if (Trkstraw->Traccia[j].charge==-1)
                        nneg++;
                }
            }
        }
    }
    if (npic>1)
    {
        getta_ident++;
        return -1;
    }
    if (ne!=2)
    {
        getta_ident++;
        return -1;
    }
    if (npos!=1 || nneg!=1)
    {
        getta_ident++;
        return -1;
    }
//cout<<npic<<" "<<ne<<" "<<npos<<" "<<nneg<<"     "<<endl;

//matching lkr-track jacopo

    int Copp[3]={-1,-1,-1}; //accoppia la traccia agli hit nel Lkr delle particelle cariche
    int Cope[2]={-1,-1}; //indica l'indice in Copp degli elettroni e positroni
    int Copg[3]={-1,-1,-1}; //indica l'indice dell'hit nel calorimetro dei gamma
    int ig=0, ipip=-1,jpip=-1,test=0; //ipip e jpip danno rispettivamente l'indice dell'hit nel calorimetro e l'indice della traccia

    for (int i=0;i<lkry->mhit;i++) //ciclo hit Lkr
    {
        test=0;
        gvet Xl=lkry->M_Hits[i].Xlab; //coordinate hit nel Lkr
        for (int j=0;j<3;j++) //ciclo tracce ricostruite
        {
            gvet Xdl= Xl-Trkstraw->Traccia[j].Xlkr; //differenza tra posizione hit Lkr e proiezione traccia
            if ( Xdl.XYNorma()<3.5)
            {
                test=1;
                Copp[j]=i; //accoppio la j-esima traccia con l'hit i-esimo
                if (lkry->me[i]/Trkstraw->Traccia[j].P_in.mom<.85)
                {
                    ipip=i; // è il pip: indice hit nel calorimetro
                    jpip=j; // indice traccia
                }
                else
                    if (lkry->me[i]/Trkstraw->Traccia[j].P_in.mom>.95)
                    {
                        if (Trkstraw->Traccia[j].charge==-1) //elettrone
                            Cope[0]=j;
                        else
                            Cope[1]=j;  //positrone
                    }
                break;
            }
        }
        if (ig<3 && test==0)
        {
            Copg[ig]=i;
            ig++;
        }
    }

    //tagli fiduciali sui fotoni

    for (int i=0;i<3;i++)
    {
        int j = Copg[i];
        float E_gamma = lkry->M_Hits[j].e_rivela;
        float r_gamma = lkry->M_Hits[j].Xlab.XYNorma();
        if (E_gamma<3 || E_gamma>75)
        {
            getta_gg++;
            return -1;
        }
        if (r_gamma<15 || r_gamma>116)
        {
            getta_gg++;
            return -1;
        }
    }

    //quadrimpulsi particelle

    gvet pg[3];

    qvet Pkmis, Ppi0gee, Ppi0gg;
    qvet Ppi0[3];

    qvet Ppic, Pelec, Pelep, Pgam1, Pgam2, Pgam3;

    qvet Ppartic[6];

    gvet cog, X_estrap[6], verso_pic, verso_elec, verso_elep;
    gvet versog[3];

    float mpi0[3];
    int gamgam=-1;

    /*
    versog1 = (lkry->M_Hits[Copg[0]].Xlab - Xdecay.Vtx).NVerso();
    versog2 = (lkry->M_Hits[Copg[1]].Xlab - Xdecay.Vtx).NVerso();
    versog3 = (lkry->M_Hits[Copg[2]].Xlab - Xdecay.Vtx).NVerso();
    */
    //pg = lkry->me[Copg[0]]*versog;
    for (int i=0;i<3;i++)
    {
        versog[i] = (lkry->M_Hits[Copg[i]].Xlab - Xdecay.Vtx).NVerso();
        pg[i] = lkry->M_Hits[Copg[i]].e_rivela*versog[i];
    }
	
    Ppic.setvn(Trkstraw->Traccia[jpip].P_in,mas_pip);
    Pelec.setvn(Trkstraw->Traccia[Cope[0]].P_in,mas_ele);
    Pelep.setvn(Trkstraw->Traccia[Cope[1]].P_in,mas_ele);
    Pgam1.setvn(pg[0],0.);
    Pgam2.setvn(pg[1],0.);
    Pgam3.setvn(pg[2],0.);

    //facciamo le coppie di gamma e guardiamo quelle che si avvicinano di più alla massa del pi0

    Ppi0[0] = Pgam1 + Pgam2;
    Ppi0[1] = Pgam1 + Pgam3;
    Ppi0[2] = Pgam2 + Pgam3;

    for (int i=0;i<3;i++)
        mpi0[i] = Ppi0[i].Invar();

    //ricostruisco la massa del pi0 da due gamma
    mpi0gg=mpi0[0];
    gamgam=0;
    for (int i=1;i<3;i++)
        if (fabs(mpi0gg-mas_pi0)>fabs(mpi0[i]-mas_pi0))
        {
            mpi0gg=mpi0[i];
            gamgam=i;
        }

    //ricostruisco la massa del pi0 dalitz

    if (gamgam==0)
        Ppi0gee = Pgam3 + Pelec + Pelep;
    if (gamgam==1)
        Ppi0gee = Pgam2 + Pelec + Pelep;
    if (gamgam==2)
        Ppi0gee = Pgam1 + Pelec + Pelep;

    mpi0gee=Ppi0gee.Invar();

    Pkmis = Ppic + Ppi0gee + Ppi0[gamgam];

    //massa del k

    mk = Pkmis.Invar();

    verso_pic = Ppic.NVerso();
    verso_elec = Pelec.NVerso();
    verso_elep = Pelep.NVerso();

    //somma degli impulsi

    som_impulsi = (Ppic+Pelep+Pelec+Pgam1+Pgam2+Pgam3).Norma();

    //centro di gravità

    Ppartic[0] = Ppic;
    Ppartic[1] = Pelec;
    Ppartic[2] = Pelep;
    Ppartic[3] = Pgam1;
    Ppartic[4] = Pgam2;
    Ppartic[5] = Pgam3;

    float deltaz = 0.;
    deltaz = lkry->M_Hits[Copg[0]].Xlab.z - Trkstraw->Traccia[jpip].Xmg.z;

    X_estrap[0] = Trkstraw->Traccia[jpip].Xmg + deltaz * verso_pic / verso_pic.z;
    X_estrap[1] = Trkstraw->Traccia[Cope[0]].Xmg + deltaz * verso_elec / verso_elec.z;
    X_estrap[2] = Trkstraw->Traccia[Cope[1]].Xmg + deltaz * verso_elep / verso_elep.z;
    X_estrap[3] = lkry->M_Hits[Copg[0]].Xlab;
    X_estrap[4] = lkry->M_Hits[Copg[1]].Xlab;
    X_estrap[5] = lkry->M_Hits[Copg[2]].Xlab;

    for (int i=0;i<6;i++)
        cog += X_estrap[i] * Ppartic[i].mom;
    cog /= som_impulsi;

    cox = cog.x;
    coy = cog.y;

    cogq = sqrt(cox*cox +coy*coy);

    //massa invariante del dileptone  ok

    qvet dlep;
    dlep = Pelec+Pelep;
    mmqee = dlep.Invarq();

    if (Copp[0]==-1||Copp[1]==-1||Copp[2]==-1||
            Copg[0]==-1||Copg[1]==-1||Copg[2]==-1||ipip==-1)
    {
        getta_gg++;
        return -1;
    }

  //  cout<<"mp0_1 = "<<mpi0[0]<<", mp0_2 = "<<mpi0[1]<<", mp0_3 = "<<mpi0[2]<<", mp0_finale = "<<mpi0gg<<endl; 
  //  Gout<<"mp0_1 = "<<mpi0[0]<<", mp0_2 = "<<mpi0[1]<<", mp0_3 = "<<mpi0[2]<<", mp0_finale  ="<<mpi0gg<<endl;
    
    count_wnt++;
    good=1;
    return 1;


}

//===========================================================================


//----------------------------------------------------
void AnaKpip0p0dlz::print_scale()
{

    Gout<<"\n -----> "<<titol<<"   Analysis Summary. <-------\n";
    Gout<<"\n Fit entries          "<<count_call;
    Gout<<"\n Z cut                "<<getta_cog;
    Gout<<"\n no tracks            "<<getta_trk;
    Gout<<"\n Wrong charge         "<<getta_char;
    Gout<<"\n No good vertex       "<<getta_fit;
    Gout<<"\n Not enough lkr hits  "<<getta_ch;
    Gout<<"\n Noi good identify hits  "<<getta_ident;
    Gout<<"\n Tracks-Lkr no match  "<<getta_gg;
    Gout<<"\n Good events          "<<count_wnt;

    cout<<"\n Good events          "<<count_wnt;
    Gout<<"\n\n ======>           d o n e     <============ ";
}
//-------------------------------------------
