/***************************************************************************
                          anakpivv.cpp  -  description
                             -------------------
    begin                : Sun Jan 18 2004
    copyright            : (C) 2004 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/

#include <flyoh.h>
#include <anakpivv.h>

using namespace std;
/**
Il costruttore della procedura di prova per pi nu nu analisi
*/

//==============================================

AnaKpivv::AnaKpivv()
{
    tipo=25;
    nfit=1;
    titol="K--> nu nu pip " ;
    nome="Kpivv";
    mas_Kp= ptr_Kapp->Get_Massa();
    mas_pip=ptr_Pip->Get_Massa();
    Gout<<"\n Attivato il fit di "<<titol;
    Pk_ric =new GigaBeam();
}
AnaKpivv::~AnaKpivv()
{
}

// int count_call,count_decay,getta_gg,getta_en,getta_cog,getta_tau,getta_gf,getta_ident;
// int getta_trk,getta_ch ,getta_chisq; // counter for wrong charge
// int getta_fit,count_wnt,getta_char,getta_zv;
// int counter[30];






/**
Il fit per la procedura di prova per pi nu nu analisi
*/
int AnaKpivv::Fisica()
{

    count_call++;

    good=0;
    pxkp=pykp=pzkp=momk=0.;
    pxpi=pypi=pzpi=mompi=0.;
    epi =masvv= mqvv=0.;
    pxvv=pyvv=pzvv=momvv=0.;
    xvv=yvv=zvv =0.;


    //taglio sul vertice generato (taglia solo gli eventi che finiscono sul collimatore)da togliere!!!
    if (evento_.Gen.zv < 10000.) {

        getta_zv++;
        good= -1;
        return -1;
    }

    count_decay++;

    int npt = 0 ;
    if (Trkstraw!=0)  npt = Trkstraw->ntrk_done;
    if (npt<1) {
        getta_trk++;
        good=-2;
        return -1;
    }

// ricavo l'impulso del K dal gigatrak
    Pk_mom=Pk_ric->Beam_Rec();   // impulso del beam dal gigatrack
    Pkp.setvn ( Pk_mom,mas_Kp ); // definizione del quadrimomento
    Pkp.putvn( pxkp,pykp,pzkp,momk );  // salvo per root

// Dato che si selezionano  eventi con solo una traccia, uso  l'indirizzo della traccia [0]

    Track  Trk=Trkstraw->Traccia[0];
    charge=Trk.charge;
    chiq_trk=Trk.chiq_fit;

    if (Trk.chiq_fit>10.) {
        getta_chisq++;
        good=-3;
        return -1;
    }


    if ( charge !=1. ) { //even for wrong sign study, positive cut later!
        getta_ch++;
        good=-4;
        return -1;
    }


// impulso del pione+ dallo spettromentro
    Ppi.setvn(Trk.P_in,mas_pip);
    Ppi.putvn( pxpi,pypi,pzpi,mompi );
// taglio sull'impulso del pip
    if (mompi<15. || mompi>35.) {
        getta_en++;
        good=-5;
        return -1;
    }

    // 4 camere coinvolte
    if (Trk.camere!=4) {
        good=-6;
        counter[0]++;
        return -1;
    }
// taglio radiale sulle strawchambers; d < 7.5 || d > 110
    gvet XCamera,XCamera1;
    double dq=0.;
    XCamera= Trk.Xmg + Trk.P_in*((St1x->Get_Cface().z-Trk.Xmg.z)/Trk.P_in.z);
    XCamera1=XCamera;
    XCamera=St1x->Lab2cDev(XCamera) ;
    dq=XCamera.XYNorma();
    if (dq<7.5||dq>110.) {
        counter[1]++;
        good=-7;
        return -1;
    }
    XCamera= Trk.Xmg + Trk.P_in*((St2x->Get_Cface().z-Trk.Xmg.z)/Trk.P_in.z);
    XCamera=St2x->Lab2cDev(XCamera) ;
    dq=XCamera.XYNorma();
    if (dq<7.5||dq>110.) {
        counter[2]++;
        good=-8;
        return -1;
    }
    XCamera= Trk.Xmg + Trk.P_out*((St3x->Get_Cface().z-Trk.Xmg.z)/Trk.P_out.z);
    XCamera=St3x->Lab2cDev(XCamera) ;
    dq=XCamera.XYNorma();
    if (dq<7.5||dq>110.) {
        counter[3]++;
        good=-9;
        return -1;
    }
    XCamera= Trk.Xmg + Trk.P_out*((St4x->Get_Cface().z-Trk.Xmg.z)/Trk.P_out.z);
    XCamera=St4x->Lab2cDev(XCamera) ;
    dq=XCamera.XYNorma();
    if (dq<7.5||dq>110.) {
        counter[4]++;
        good=-10;
        return -1;
    }



    epi=Ppi*Pkp/mas_Kp;            // energia del pi nel sistema Kappa
    Pvv=Pkp-Ppi;
    mqvv=Pvv.Invarq();
    masvv=Pvv.m;

    Pvv.putvn( pxvv,pyvv,pzvv,momvv );
    evv=Pvv*Pkp/mas_Kp;

// calcolo dell'impulso trasverso del pi
    gvet ptrasv;
    ptrasv= Ppi&Pkp;
    ptrasv.Norma();
    tmom=ptrasv.mom/Pkp.mom;

    // calcolo del vertice  vedi la struttura Vtxstruct in analisi.h e analisi.cpp

    Vtxstruct Xdecay(2);
    Xdecay.P[0].setvn(0.,0.,10240.); // beam at G3 (0.,0.,10240.); Fare meglio
    Xdecay.V[0]=Pkp.NVerso();       //  versore del beam...
    Xdecay.P[1]=Trkstraw->Traccia[0].Xmg; // coordinate della traccia 1 al centro del magnete (definizione)
    Xdecay.V[1]=Trkstraw->Traccia[0].P_in.NVerso(); // versore della traccia 1
    Xdecay.Vertice();
    chiq_vert=Xdecay.chiq;
    Xdecay.Vtx.putv( xvv,yvv,zvv );

 if (chiq_vert>10.) {
        getta_fit++;
        good=-12;
        return -1;
    }

   //taglio sul vertice ricostruito (livello 0)
    
   
//taglio su xvv e yvv
// evento scartato se il vertice è fuori dal tronco di cono delimitato radialmente dalla collimazione
// del fascio e in z dalla zona di decadimento
    gvet beam0 (Pk_ric->xg3,Pk_ric->yg3,10240.) ;   // beam point at gigatrack 3
    gvet bvers=Pkp.NVerso();
    gvet trkvers= (Xdecay.Vtx - beam0).NVerso();
    diverge= fabs( (trkvers&bvers).Norma());

    if (diverge>0.001) {
        counter[5]++;
        good=-13;
        return -1;
    }

    // taglio sui cluster del calorimetro
    if ( lkry->hit_recorded>1) {
        getta_gg++;
        good=-14;
        return -1;
    }

    // calcolo le coordinate estrapolate della traccia al piano del calorimeter

    gvet X_at_lkr;
    X_at_lkr= Trk.Xmg + Trk.P_out*((lkry->Get_Cface().z-Trk.Xmg.z)/Trk.P_out.z);
    X_at_lkr.putv(xlac,ylac,zlac);

    double rqcl= X_at_lkr.XYNorma();
    rqcl = rqcl*rqcl;
    // accettanza ottagonale
    if (sqrt(rqcl)<=15. || fabs( X_at_lkr.x) >= 113. ||fabs( X_at_lkr.y) >= 113. ||
            (fabs(X_at_lkr.x)+fabs(X_at_lkr.y)) >= 113.*sqrt(2.)) {
        counter[6]++;
        good=-15;
        return -1;
    }

    //distanza traccia cluster < 10 cm
    if (lkry->hit_recorded>0) {
        double dx = lkry->mxl[0] - X_at_lkr.x;
        double dy = lkry->myl[0] - X_at_lkr.y;
        if (dx*dx + dy*dy > 100) {
            counter[7]++;
            good=-16;
            return -1;
        }
    }

// accettanza dei muv1,2,3

    gvet X_at_muv;
    X_at_muv= Trk.Xmg + Trk.P_out*((muvet1->Get_Cface().z-Trk.Xmg.z)/Trk.P_out.z);
    if (fabs(X_at_muv.x)<10.&&fabs(X_at_muv.y)<10.) { //taglio interno
        counter[8]++;
        good=-17;
        return -1;
    }
    if (fabs(X_at_muv.x)>120.||fabs(X_at_muv.y)>120) { //taglio esterno
        counter[9]++;
        good=-20;
        return -1;
    }

    // muvet2
    X_at_muv= Trk.Xmg + Trk.P_out*((muvet2->Get_Cface().z-Trk.Xmg.z)/Trk.P_out.z);
    if (fabs(X_at_muv.x)<10.&&fabs(X_at_muv.y)<10.) { //taglio interno
        counter[10]++;
        good=-21;
        return -1;
    }
    if (fabs(X_at_muv.x)>120.||fabs(X_at_muv.y)>120) { //taglio esterno
        counter[11]++;
        good=-22;
        return -1;
    }

    // muvet3
    X_at_muv= Trk.Xmg + Trk.P_out*((muvet3->Get_Cface().z-Trk.Xmg.z)/Trk.P_out.z);
    if (fabs(X_at_muv.x)<10.&&fabs(X_at_muv.y)<10.) { //taglio interno
        counter[12]++;
        good=-23;
        return -1;
    }
    if (fabs(X_at_muv.x)>120.||fabs(X_at_muv.y)>120) { //taglio esterno
        counter[13]++;
        good=-24;
        return -1;
    }


//*************************************************
    count_wnt++;
    good=1;
    return 1;

}
//----------------------------------------------------


//----------------------------------------------------
void AnaKpivv::print_scale()
{
    /**
    Stampa il summary del fit.
    */

    Gout<<"\n -----> "<<titol<<" Analysis Summary <-------\n";
    Gout<<"\n Fit entries          "<<count_call;
    Gout<<"\n Good decays          "<<count_decay << " (after zv cut)";
    Gout<<"\n Rejectio for vtx     "<<getta_zv;
    Gout<<"\n No traks             "<<getta_trk;
    Gout<<"\n Charge wrong         "<<getta_ch;
    Gout<<"\n Chisq cut            "<<getta_chisq;
    Gout<<"\n Pip mom              "<<getta_en;
    Gout<<"\n Cluster cut          "<<getta_gg;



    Gout<<"\n Vertx fit wrong      "<<getta_fit;

    for (int i=0;i<13;i++)
    {
        if (counter[i]>0)  Gout<<"\n Rejection "<<setw(3)<<i<<"         "<<counter[i];

    }

    Gout<<"\n Good events          "<<count_wnt;


    Gout<<"\n\n ======>           d o n e     <============ "<<std::endl;
}
