/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 20.02.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/

#include "flyoh.h"
#include "anakpovv.h"



AnaKpovv::AnaKpovv()
		: Analisi()
{
	tipo=26;nfit=1;titol="Kl--> pi0 nu nu " ;nome="Kpovv";
	Gout<<"\n Attivato il fit di "<<titol;
}

AnaKpovv::~AnaKpovv() {}

int AnaKpovv::Fisica()
{

	if ( count_call==0 )
	{

		/*   contatori da incrementarese occorre....
		   getta_ch;
		   getta_char;
		   getta_en;
		*/


	}
	count_call++;

// se vuoi buttare e non analizzare....
//   if(Veto->mhit>0) return 0;


//
	double xx,yy,ee,et;
	cogx=cogy=cog=xx=yy=ee=et=0.0;
	np=lkry->mhit;
	int hit=lkry->mhit-1;
	while ( hit>-1 )
	{
		xpw[hit]=xx=lkry->M_Hits[hit].Xdev.x;
		ypw[hit]=yy=lkry->M_Hits[hit].Xdev.y;
		zpw[hit]=lkry->M_Hits[hit].Xdev.z;
		epw[hit]=ee=lkry->M_Hits[hit].e_rivela;
		et+=ee;
		cogx+=ee*xx;
		cogy+=ee*yy;
		hit--;
	}
	if ( et>0.0 )
	{
		cogx/=et;
		cogy/=et;
		cog=sqrt ( cogx*cogx+cogy*cogy );
	}



// questo metodo va riempito....
// si esce con 1 se ok, con 0 se analisi non ok.


	np=1;
	count_wnt++;
	return 1;       // qui adesso sempre ok!?

}
//----------------------------------------------------
void AnaKpovv::print_scale()
{
	Gout<<"\n -----> "<<titol<<" Analysis Summary <-------\n";
	Gout<<"\n Fit entries          "<<count_call;
	Gout<<"\n Too many tracks      "<<getta_ch;
	Gout<<"\n Wrong charge         "<<getta_char;
	Gout<<"\n Killed by energy     "<<getta_en;
	Gout<<"\n Good events          "<<count_wnt;
	Gout<<"\n\n ======>           d o n e     <============ "<<std::endl;
}
