/***************************************************************************
                          analisi.h  -  description
                             -------------------
    begin                : Sat Jan 18 2003
    copyright            : (C) 2003 by Giuseppe Pierazzini
    email                : peppe@unipi.it
 ***************************************************************************/

#ifndef ANALISI_H
#define ANALISI_H
#include "flyoh.h"
#include "device.h"
#include "gigabeam.h"
using namespace std;

class Vtxstruct
{
    int Ntr;
    
public:    
    gvet *P,*V;
    gvet Vtx;
    double chiq;
    Vtxstruct(int n);
    ~Vtxstruct();
    void Vertice();

};


/**
 Class Analisi: Base Class per tutte le procedure di analisi.
 *@author Giuseppe Pierazzini
  */
class Analisi
{
protected:

    const char  *nome;
    int nev;
    int tipo;
    double ana_tempo,ana_dtim;
    double msAvo,msqAvo,ctauAvo;
    double reckik;
    GigaBeam *Pk_ric;

public:
    const char *titol;
    int count_call,count_decay,getta_gg,getta_en,getta_cog,getta_tau,getta_gf,getta_ident;

    int getta_trk,getta_ch,getta_chisq ; // counter for wrong charge
    int getta_fit,count_wnt,getta_char,getta_zv;
    int getta_kabes;
    int counter[30];
    void Set_tempo_parms();


//------------------------------------------
//dummy variable for calculation...

    int idpr[12],mishit,nvar,nfit,nextra,Kmax;
    double x[12],y[12],e[12],xgood[12],ygood[12],egood[12],ek;
    double distq,dist,dsumq, diffq;
    double smaq,smbq,smcq;
    double egij[15],exij[15],eyij[15],dxij[15],dyij[15],ddij[15],mij[15];
    double dersq[24];
    double sv[24];
    gvet Pa,Pb;
    qvet q0,q1,q2,qs;
    int g0,g1,g2,g3,g4,g5,g6,flag[12];   // gi gamma index in the lkr
//--------------------------------------------

    Analisi *up,*next;
    Analisi();
    virtual ~Analisi();
    virtual int Fisica() {
        return 0;
    };
    virtual void print_scale();
    virtual int kappa() {
        return 0;
    };
    virtual void Reset_parm() {};
    virtual int MassFit() {
        return 0;
    };
    virtual int MassChiq() {
        return 0;
    };
    virtual double Distvtx() {
        return 0.;
    };
    virtual double Degij(int,int) {
        return 0.;
    };
    virtual void Ddistq() {};
    virtual void Simq(int, int) {};
    virtual float Get_chi() {
        return 0.;
    };
    void Write_titol();
    int Get_Tipo() {
        return tipo;
    };
    const char *Nome() {
        return nome;
    };

//   double Vertice2(gvet &Xvert,gvet P1,gvet V1,gvet P2,gvet V2);


};

#if defined(ANAGMP)
int IpoNum=-1;
string  IpotesiAna[10];
Analisi    *Primofit=0;
#endif

#if !defined(ANAGMP)
extern  int IpoNum;
extern  string IpotesiAna[10];
extern Analisi *Primofit;
#endif
#endif

