/***************************************************************************
                          ananemo.cpp  -  description
                             -------------------
    begin                : Sun Jan 18 2004
    copyright            : (C) 2004 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/

#include <flyoh.h>
#include <ananemo.h>
#include <gfitta.h>

using namespace std;




int ananemodbg=-1;



class Fitto:public Gfitta
{
    double cosck,sinck;

public:

    double T0;
    gvet Xp[500];


    Fitto();
    ~Fitto() {};
    gmatrix Fvincoli(int);
};

/**
 Class FITTO   particolare per fit dati Nemo.<br> 
  Fa riferimento a Gfitta.
*/

Fitto::Fitto()
{


    cosck=1./1.333;
    sinck=sqrt ( 1.-cosck*cosck );  //circa 40 gradi== .79 rad
    Vprecis=.1;
}

/**
Class AnaNemo:  Procedura in sviluppo di analisi per l'esperimento nemo
*/
AnaNemo::AnaNemo()
{

    // classe di analisi in sviluppo per nemo
    tipo=40;
    nfit=1;
    titol=" Mu in mare " ;
    nome="Nemo";

}
AnaNemo::~AnaNemo()
{}

int AnaNemo::Fisica()
{

    count_call++;
    good=0;
    chiq=-1.;
    int colpiti=mare->Nseen;

    // cut su i fotoni visti....    
    if(colpiti < 20 ) return  0;

// definizione interfaccia poere il fitting
    int ny=colpiti;
    int nv=colpiti;
    int nx=5;
    int nvec=colpiti;
// paramtri di fit
//   if (ananemodbg==1)
    Gout<<"\n\n\n  Ev "<<Eventi_Generati<<"  ANALISI DATI NEMO    parametri "<<colpiti<<" \n\n"<<flush;
    cout<<"\n\n\n  Ev "<<Eventi_Generati<<"  ANALISI DATI NEMO    parametri "<<colpiti<<" \n\n"<<flush;
    gvet Xin=mare->M_Hits[0].Xdev;
    qvet Pin=mare->Lab2Dev( mare->M_Hits[0].P );
    gvet Vin=Pin.NVerso();
    Xin.print("Xin");
    Vin.print("Vin");

////

    Fitto Prm;
    Prm.Set_dim(ny,nv,nx,nvec);

    double tmin=mare->tp[0];
    gvet Xmed;
    for (int i=0;i<nvec;i++)
    {
        double tt=mare->tp[i];  //tempo di percorrenza
        Prm.YM(i,0)=tt;
        Prm.peso=mare->peso;
        if (tmin>tt)tmin=tt;
        gvet xp( mare->xseen[i],mare->yseen[i],mare->zseen[i]);

        if (ananemodbg==1)xp.print("xp");
        if (ananemodbg==1)Gout<<setprecision(6)<<" t "<<setw(8)<< Prm.YM(i,0)<<" peso "<<setw(8)<<Prm.peso[i];

        Prm.Xp[i]=xp;
        Xmed+=xp;
    }
    Xmed/=double(colpiti);
    if (ananemodbg==1)   Xmed.print("Xmed");
    if (ananemodbg==1)Gout<<" tmin "<<tmin;



    if (ananemodbg==1)Gout<<"\n ============= METODO DEGLI AUTOVETTORI ===================="<<flush;

    gvet Vauto=Prm.Autovalore(Prm.Xp);

    //  if (ananemodbg==1)
    Vauto.print("Vauto");

    lambd0=Prm.l0;
    lambd1=Prm.l1;
    lambd2=Prm.l2;
    vxauto=Vauto.x;
    vyauto=Vauto.y;
    vzauto=Vauto.z;




    //  Vauto.print("Vauto");
    if (ananemodbg==1)Gout<<"\n =====================METODO CHIQ============================="<<flush;

    gvet Zlevel = Xmed + Vauto*(-Xmed.z-400.)/Vauto.z;
    Zlevel.print("Zlevel");
//     Fitting

//    Prm.X(0,0)=0.0; //xmu at z=-400;
//    Prm.X(1,0)=0.0; //ymu at z=-400

    Prm.X(0,0)=Zlevel.x; //xmu at z=-400;
    Prm.X(1,0)=Zlevel.y; //ymu at z=-400



    Prm.X(2,0)=Vauto.x/Vauto.z;  // tgX0
    Prm.X(3,0)=Vauto.y/Vauto.z;  // tgy0



    Prm.X(4,0)=tmin;

//     gvet Xin=mare->M_Hits[0].Xdev;
//
//      Prm.X(0,0)= Xin.x;
//      Prm.X(1,0)= Xin.y;
//     Prm.X(2,0)=0.5;  // tgX0
//     Prm.X(3,0)=0.0;  // tgy0

    if (ananemodbg==1) {
        Gout<<"\n ================    METODO CHIQ=====start===="<<flush;
        cout<<"\n ================    METODO CHIQ=====start===="<<flush;
    }


    chiq=Prm.Fitting();
 // normalizzo il chiq 
    chiq/= double( ny-nx);
    
    iter = Prm.iter;

    gvet Xref(Prm.X(0,0),Prm.X(1,0),-400.0);  // punto di ingresso del mu
    xfit=Xref.x;
    yfit=Xref.y;
    zfit=Xref.z;


    gvet Vri(Prm.X(2,0),Prm.X(3,0),1.);    // direzione di vole del mu
    Vri=Vri.NVerso();
    vxfit=Vri.x;
    vyfit=Vri.y;
    vzfit=Vri.z;
    t0fit=Prm.X(4,0);                      // tempo  zero di riferimento.


    if (ananemodbg==1)
    {
        Gout<<"\n Ev "<<Eventi_Generati<<"\n Corsa finita "<<Prm.iter<<"  con chiq  normalizzato "<< chiq<<"\n\n";

        Prm.YM.Print("YM");
        Prm.Y.Print("Y");
        Gout<<"\n Vicoli e X ";
        Prm.F.Print("F");
        Prm.X.Print("X");
        Vri.print("Vmu");
        Gout<<" Ricostruito ";
        Gout<<" T0 "<<Prm.T0<<"\n\n\n";
        gvet Xref(Prm.X(0,0),Prm.X(1,0),-400.0);
        Xref.print("Xref");




    }
    else
    {
        Gout<<"\nEv "<<Eventi_Generati<<"\n Corsa finita "<<Prm.iter<<"  con chiq normalizzato "<< chiq;
        cout<<"\nEv "<<Eventi_Generati<<"\n Corsa finita "<<Prm.iter<<"  con chiq normalizzato "<< chiq;
        Prm.X.Print("X");
        Vri.print("Vmu");
        Gout<<" Ricostruito ";


    }


//*************************************************
    count_wnt++;
    good=1;
    return 1;

}
//----------------------------------------------------


//----------------------------------------------------
void AnaNemo::print_scale()
{
    /**
    Stampa il summary del fit.
    */

    Gout<<"\n -----> "<<titol<<" Analysis Summary <-------\n";
    Gout<<"\n Fit entries          "<<count_call;
    Gout<<"\n Good decays          "<<count_decay << " (after zv cut)";
    Gout<<"\n Rejectio for vtx     "<<getta_zv;
    Gout<<"\n No traks             "<<getta_trk;
    Gout<<"\n Charge wrong         "<<getta_ch;
    Gout<<"\n Chisq cut            "<<getta_chisq;
    Gout<<"\n Pip mom              "<<getta_en;
    Gout<<"\n Cluster cut          "<<getta_gg;



    Gout<<"\n Vertx fit wrong      "<<getta_fit;

    for ( int i=0; i<13; i++ ) {
        if ( counter[i]>0 )  Gout<<"\n Rejection "<<setw ( 3 ) <<i<<"         "<<counter[i];

    }

    Gout<<"\n Good events          "<<count_wnt;


    Gout<<"\n\n ======>           d o n e     <============ "<<std::endl;
}
//========================================================
//=============================================
gmatrix Fitto::Fvincoli(int index)
{

    // index =0: Chiamata per il calcolo dei vincoli;
    // index >0: Chiamata per il calcolo delle derivate;

// procedura che dipende dal problema....
// qui un caso Particolare
    static double Vlu=.3;   // in m/ns
    gmatrix Fnow(nv,1);

//Coordinate del mu sul piano z=0;
    gvet Xref(X(0,0),X(1,0),-400.0);
    double tgx=X(2,0);
    double tgy=X(3,0);
    T0=X(4,0);
    gvet Vmu(tgx,tgy,1.);
    Vmu=Vmu.NVerso();

    /*
        double dcam=(Xp[0]-Xref)%Vmu;
        gvet Xn=(Xp[0]-Xref)-Vmu*dcam;
        double path_ck=Xn.Norma()/sinck;
        double tratto=dcam-path_ck*cosck;

        double TT0=Y(0,0)-(tratto+path_ck*1.33)/Vlu;*/

//   if(index==0) cout<<"\n Fv Y(0,0)"<<Y(0,0)<< "  T0 "<<T0<<" "<<TT0<<" tratto "
//                    << tratto<<"  tck "<< path_ck;
    double dcam;
    gvet Xn;
    double path_ck;
    double tratto;

//Calcolo dei tempi di volo (ricorda nvec=nv)

    for (int ip=0;ip<nv;ip++)
    {
        gvet Xcur=Xp[ip];
        dcam=(Xcur-Xref)%Vmu;
        Xn=(Xcur-Xref)-Vmu*dcam;  // vettore normale
        path_ck=Xn.Norma()/sinck;
        tratto=dcam-path_ck*cosck;

        double Tm = (tratto+path_ck*1.33)/Vlu;
   //     if(index==0) Gout<<"\n y " <<setw(8)<< Y(ip,0)<< " tratto "<< tratto<< " Tm " <<setw(8)<<Tm;
        Fnow(ip,0)=Y(ip,0)-Tm-T0;  // tempo totale di percorrenza




    }




    return Fnow;
}
