/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 20.02.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/

#include "flyoh.h"

#include <anauser.h>


//using namespace std;

AnaUser::AnaUser()
        : Analisi()
{
        tipo=0;
        nfit=1;
        titol="User analysis...  " ;
        nome="Auser";

        mas_Kp=   ptr_Kapp->Get_Massa();
        mas_pip=  ptr_Pip->Get_Massa();
        mas_elec =ptr_Elec->Get_Massa();


}
AnaUser::~AnaUser() {}

int AnaUser::Fisica()
{

        // attenzione attivare la procedura giusta....
        int  come=Fisica_rates();
// int  come=Fisica_giudici();
        return come;
}



//==========================

/************************/
// Test rates pe Ke4 trigger Giudici rompe....
int AnaUser::Fisica_giudici()
{

        count_call++;

// user routine ...for anticoincidence system
        chod_acc_0=rich_hit_3=muv3_acc=lkr_4x4_30=lav_12=lav_all=0;
        for ( int i=0; i<12; i++ ) lavs[i]=0;

//   if(hodo>0&&hodo->mhit>0) chod_acc_0=1;
        if ( hodox>0&&hodoy>0 ) {
                if ( hodox->mhit>1&&hodoy->mhit>1 ) chod_acc_0=1;
        }


        if ( Rich>0&&Rich->mhit>0 ) rich_hit_3=1;

        //if(Dran()<.10)rich_hit_3=0;

        // mu veto
        // simula mu veto inefficienza
        double mueffi=1.80;
        if ( Uran() <mueffi ) {
                if ( muvet1>0&&muvet1->mhit>0 ) muv3_acc=1;
                if ( muvet2>0&&muvet2->mhit>0 ) muv3_acc=1;
                if ( muvet3>0&&muvet3->mhit>0 ) muv3_acc=1;
                if ( mamud>0&&mamud->mhit>0 ) muv3_acc=1;
        }

        //  calorimetro

        DevLkr *lkr= ( DevLkr * ) lkry;
        double  dist=lkr->dist_max;
        if ( dist<0. ) lkr_4x4_30=1; // attenzione
        else  lkr_4x4_30=0;
        if ( lkr->epad44>35. && lkr->padhit>1 ) lkr_4x4_30=1;

        //Veto

        if ( anti[11]>0&& anti[11]->mhit>0 ) lav_12=1;

        for ( int i=0; i<12; i++ ) {
                lavs[i]=0;
                if ( anti[i]>0&&anti[i]->mhit>0 ) {
                        lavs[i]=1+i;
                        lav_all+=1;

                }
        }
// indice di taglio
//     buoncut=chod_acc_0 +rich_hit_3*2+(1-muv3_acc)*4+lkr_4x4_30*8+(1-lav_12)*16+(1-lav_all)*32;
        for ( int i=1; i<7; i++ ) buoncut[i]=-10;
        buoncut[0]=0;
        if ( chod_acc_0 ==1 ) buoncut[1]=1;
        if ( buoncut[1]==1&&rich_hit_3==1 ) buoncut[2]=2;
        if ( buoncut[2]==2&&muv3_acc==0 ) buoncut[3]=3;
        if ( buoncut[3]==3&&lkr_4x4_30==1 ) buoncut[4]=4;
        if ( buoncut[4]==4&&lav_12 ==0 ) buoncut[5]=5;
        if ( buoncut[5]==5&&lav_all==0 ) buoncut[6]=6;

        count_wnt++;
        return 1;
}
/*****************/

/***************************************************/

// anauser per calcolo rates di default
int AnaUser::Fisica_rates()
{

// user routine ...for anticoincidence system
        chod_acc_0=rich_hit_3=muv3_acc=lkr_4x4_30=lav_12=lav_all=0;
        for ( int i=0; i<12; i++ ) lavs[i]=0;
        count_call++;


 //       if ( hodo>0&&hodo->mhit>0 ) chod_acc_0=1;
        
        if ( hodox>0&&hodoy>0 ) {
                if ( hodox->mhit>0&&hodoy->mhit>0 ) {
                        if ( hodox->emDev>0.003&&hodoy->emDev>0.003 ) chod_acc_0=1;
                }
        }


//   if (Rich>0&&Rich->mhit>0) rich_hit_3=1;


        //if (Rich>0&&Rich->Npmseen>=3&&Rich->Npmseen<30) rich_hit_3=1;

        if ( Rich>0&&Rich->Npmseen>=3 ) rich_hit_3=1;


        // mu veto
        // simula mu veto inefficienza
        double mueffi=1.99;
        if ( Uran() <mueffi ) {
                if ( muvet1>0&&muvet1->mhit>0 ) muv3_acc=1;
                if ( muvet2>0&&muvet2->mhit>0 ) muv3_acc=1;
                if ( muvet3>0&&muvet3->mhit>0 ) muv3_acc=1;
                if ( mamud>0&&mamud->mhit>0 ) muv3_acc=1;
        }

        //  calorimetro

        DevLkr *lkr= ( DevLkr * ) lkry;
        double  dist=lkr->dist_max;
        if ( dist<40. ) lkr_4x4_30=1;
        else  lkr_4x4_30=0;


        //Veto

        if ( anti[11]>0&& anti[11]->mhit>0 ) lav_12=1;

        for ( int i=0; i<12; i++ ) {
                lavs[i]=0;
                if ( anti[i]>0&&anti[i]->mhit>0 ) {
                        lavs[i]=1+i;
                        lav_all+=1;

                }
        }
// indice di taglio
//     buoncut=chod_acc_0 +rich_hit_3*2+(1-muv3_acc)*4+lkr_4x4_30*8+(1-lav_12)*16+(1-lav_all)*32;
        for ( int i=1; i<7; i++ ) buoncut[i]=-10;
        buoncut[0]=0;
        if ( chod_acc_0 ==1 ) buoncut[1]=1;
        if ( buoncut[1]==1&&rich_hit_3==1 ) buoncut[2]=2;
        if ( buoncut[2]==2&&muv3_acc==0 ) buoncut[3]=3;
        if ( buoncut[3]==3&&lkr_4x4_30==1 ) buoncut[4]=4;
        if ( buoncut[4]==4&&lav_12 ==0 ) buoncut[5]=5;
        if ( buoncut[5]==5&&lav_all==0 ) buoncut[6]=6;


        //rate trigger pi+ pi0 e+ e-

        if ( lkr->epad44>35. ) lkr_epad_35=1;
        else  lkr_epad_35=0;

        if ( lkr->padhit>2 ) lkr_npad2=1;
        else lkr_npad2=0;

        if ( lkr->padhit>3 ) lkr_npad3=1;
        else lkr_npad3=0;


        if ( hodoy->nscinty==3 || hodox->nscintx==3 ) hod_n3x3=1;
        else hod_n3x3=0;

        for ( int i=1; i<8; i++ ) jaccut[i]=-10;
        jaccut[0]=0;
        if ( lav_12 ==0 ) jaccut[1]=1;
        if ( jaccut[1]==1&&lav_all ==0 ) jaccut[2]=2;
        if ( jaccut[2]==2&&muv3_acc==0 ) jaccut[3]=3;
        if ( jaccut[3]==3&&lkr_epad_35==1 ) jaccut[4]=4;
        if ( jaccut[4]==4&&lkr_npad2==1 ) jaccut[5]=5;
        if ( jaccut[5]==5&&lkr_npad3==1 ) jaccut[6]=6;
        if ( jaccut[6]==6&&hod_n3x3==1 ) jaccut[7]=7;

        count_wnt++;
        return 1;
}
/*********************************************/





//-------------------
void AnaUser::print_scale()
{
        Gout<<"\n -----> "<<titol<<" Analysis Summary <-------\n";
        Gout<<"\n Fit entries          "<<count_call;
        Gout<<"\n no Tracks            "<<getta_ch;
        Gout<<"\n Wrong gammas         "<<getta_gg;
        Gout<<"\n Good events          "<<count_wnt;
        Gout<<"\n\n ======>           d o n e     <============ "<<std::endl;
}
