/***************************************************************************
                          mattpar  -  description
                             -------------------
    begin                : Wed Aug 18 2004
    copyright            : (C) 2004 by gmp
    email                : peppe@newpeppe
 ***************************************************************************/
#ifndef MATTPAR_H
#define MATTPAR_H

/**
Descrive i parametri dei vari materiali usati per la costruzione dei rivelatori.
La definizione dei parametri appare in un file di tipo xxxx.app e può essere aggiornato secondo necessità.
Nei file di listing di uscita di ogni elaborazione è riportata  la lista completa dei parametri  dei materiali letti  nel file xxxx.app.
@author Giuseppe Pierazzini
*/
void     Crea_materiali_db();
class MattPar
{
  const char *nome,*status;
  int id, Z;  
  double A,ZsuA,Intl,Dedx,X0,X0l,Ro;

/*
These Class describes the parameters of various materials 
used in the constructions of the different devices.
The parameter list is at beginning of each *.app file.
@author Giuseppe Pierazzini
*/

//id numero d'ordine, Na numero medio atomico
// ro densita' in g/cm3 , rad in cm
 
  public:

  MattPar(const char *,const char *, int, double, double,double,double, double );
 ~MattPar();
   
  MattPar * primo, *next;
  void Show();
  MattPar *PntElem(std::string);
  const char *Get_Nome(){return nome;}
  int Get_Z(){return Z;}
  double Get_A(){return A;}
  double Get_ZsuA(){return ZsuA;}
  void   Set_ZsuA(double za){ZsuA=za;}
  double Get_Intl(){return Ro?Intl/Ro:0.0;}   // test on Ro
  double Get_Dedxl(){return Dedx*Ro*0.001;}  // report in Gev/cm
  double Get_Rad(){return X0;}
  double Get_Radl(){return X0l;}    //report in Gev/cm
  double Get_Ro(){return Ro;}  
};
#endif

#if defined(MAINFLYO)
MattPar *Elemento=0;
#endif
#if !defined(MAINFLYO)                      
extern MattPar *Elemento;
#endif
