/***************************************************************************
                          materia.h  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
 ***************************************************************************/

#ifndef PARTDB_H
#define PARTDB_H
void     Crea_part_db();




class Particella;
//class Reazione;

/**
Data_base Class that defines
the particle parametrs.
The data list is  written in each *.epc file.

  *@author Giuseppe Pierazzini
  */

// Struttura per i decadimenti
struct  Decadimento
{

    int frammenti;
    double rate;
    const char *nomea,*nomeb,*nomec,*nomed;

    void  Define(double r,const char *naa, const char *nbb) //dec a 2
    {
        frammenti=2;
        rate=r;
        nomea=naa;
        nomeb=nbb;
        nomec=0;
    }
    void  Define( double r,const char *naa, const char *nbb, const char *ncc) //dec a 3
    {
        frammenti=3;
        rate=r;
        nomea=naa;
        nomeb=nbb;
        nomec=ncc;
    }
};

class Part_db
{

    const char *nome;
    int id, see, charg;
    //id numero d'ordinr,  see visibilita'
    double massa, width, ctau;

public:
    int ncan;
    Decadimento *Canale;
    Part_db * primo, *next;

    Part_db (const char *ptrnome, int vis, int ch, double ms, double wd,double ct);
    ~Part_db();
    void Controlla_rates( );
    void Show();
    void Notseen (const char *);
    const char *Ptbsdat (const char *);
    Part_db   *Pntmatter(const char *);
    const char *Get_Nome() {
        return nome;
    }
    double Get_Massa() {
        return massa;
    }
    Part_db *Get_matter (const char *, Particella *);
    const char *Idm_Nome(int);



};


#if defined(MAINFLYO)
Part_db *Matter=0;
#endif
#if !defined(MAINFLYO)
extern Part_db *Matter;
#endif
#if defined(MAIN)
const char *Gam="",*Mum="",*Mup="",*Munu="";
const char *Pic2="",*Pi02="";
const char *P00p="",*Pvv="",*Gg2="",*Ppgg="";
const char *Res="",*Res2="",*Res3="",*Res4="",*Res5="",*Vmas2="",*Vmas3="";
const char *Mumd="dmum",*Mupd="dmup";
const char *Dum="",*Dum2="",*Dlz="", *Cms="",*Booh="";
const char *Elep="", *Elec="",*Eta="";
const char *Kapm = "Km", *Kapp="Kp",*Neutrino="nu";
const char *Kapl = "Kl", *Kaps="Ks", *Kap0="K0";
const char *Pim="pim",*Pip="pip",*Pi0="pi0",*Protone="p",*Neutrone="n";
const char *Nusg="",*E4ch="",*Nug="",*Fuse="Fuse";
const char *Beam = "beam",*Bers="bers", *Char = "char";
const char *Neut = "neut", *All = "all";
const char *Pair="Pair", *Brem="Brem";
const char *Lepstar="lep*", *Gamstar="gam*";
const char *Bullet="bullet";
const char *Sinv="";

const char *A_Kap0=0,*A_Protone=0,*A_Neutrone=0;
const char *Lambda=0,*A_Lambda=0,*Uus=0,*A_Uus=0;
const char *Uds=0,*A_Uds=0, *Dds=0,*A_Dds=0;
const char *Uss=0,*A_Uss=0, *Dss=0,*A_Dss=0;
const char *Sss=0,*A_Sss=0;

const char *Bari = "C.M.";
// puntatori a partucelle classiche...
Part_db *ptr_Gam=0,*ptr_Elec=0,*ptr_Elep=0,*ptr_Neutrino=0,*ptr_Mum=0,*ptr_Mup=0;
Part_db *ptr_Neutrone=0,*ptr_Protone=0,*ptr_Pim=0,*ptr_Pip=0,*ptr_Pi0=0;
Part_db *ptr_Eta=0,*ptr_Kapm=0,*ptr_Kapp=0,*ptr_Kapl=0,*ptr_Kaps=0,*ptr_Kap0=0;
Part_db *ptr_Lambda=0,*ptr_A_Lambda=0;
Part_db *ptr_dum=0,*ptr_boo=0;

Part_db *ptr_Uus=0,*ptr_A_Uus=0,*ptr_Uds=0,*ptr_A_Uds=0,*ptr_Dds=0,*ptr_A_Dds=0;
Part_db *ptr_Uss=0,*ptr_A_Uss=0,*ptr_Dss=0,*ptr_A_Dss=0;
Part_db *ptr_Sss=0,*ptr_A_Sss=0;




#endif



#if !defined(MAIN)
extern const char *Gam,*Mum,*Mup,*Munu,*Fuse;
extern const char *Pic2,*Pi02;
extern const char *P00p,*Pvv,*Gg2,*Ppgg;
extern const char *Res,*Res2,*Res3,*Res4,*Res5,*Vmas2,*Vmas3;
extern const char *Mumd,*Mupd;
extern const char *Dum,*Dum2, *Dlz, *Cms, *Booh;
extern const char *Elep, *Elec,*Eta,*Nusg,*E4ch,*Nug;
extern const char *Kapm,*Kapp,*Kapl,*Kaps,*Kap0,*Neutrino;
extern const char *Pim,*Pip,*Pi0,*Protone,*Neutrone;

extern const char *A_Kap0,*A_Protone,*A_Neutrone;
extern const char *Lambda,*A_Lambda,*Uus,*A_Uus;
extern const char *Uds,*A_Uds, *Dds,*A_Dds;
extern const char *Uss,*A_Uss, *Dss,*A_Dss;
extern const char *Sss,*A_Sss;

extern const char *Beam,*Bers,*Char;
extern const char *Neut, *All;
extern const char *Pair, *Brem;
extern const char *Sinv;
extern const char *Lepstar, *Gamstar,*Bullet;
extern const char *Bari;

extern Part_db *ptr_Gam,*ptr_Elec,*ptr_Elep,*ptr_Neutrino,*ptr_Mum,*ptr_Mup;
extern Part_db *ptr_Neutrone,*ptr_Protone,*ptr_Pim,*ptr_Pip,*ptr_Pi0;
extern Part_db *ptr_Eta,*ptr_Kapm,*ptr_Kapp,*ptr_Kapl,*ptr_Kaps,*ptr_Kap0;
extern Part_db *ptr_Lambda,*ptr_A_Lambda;
extern Part_db *ptr_dum,*ptr_boo;

extern Part_db *ptr_Uus,*ptr_A_Uus,*ptr_Uds,*ptr_A_Uds,*ptr_Dds,*ptr_A_Dds;
extern Part_db *ptr_Uss,*ptr_A_Uss,*ptr_Dss,*ptr_A_Dss;
extern Part_db *ptr_Sss,*ptr_A_Sss;
#endif

#endif





















