/***************************************************************************
                          devclot.cpp  -  description
                             -------------------
    begin                : Mon Dec 8 2003
    copyright            : (C) 2003 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "devclot.h"
/**
Cilindro con un buco ottagonale
*/

DevClOt::~DevClOt()
{}
DevClOt::DevClOt()
{
    devtype=TypDevClOt;
    devclass="Cili_Ottg";
    Firot=.707107;
}


void DevClOt::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Cilindro con buco ottagonale "<<std::endl;
    Device::Prgeom();
}
//----------------- -----P o s i z i o n e ---
int DevClOt::Posizione()
{
    //     Posizione della particella rispetto questo dev
    // Le distanze di un punto interno dai piani del
    // rivelatore sono tutte negative o nulle data
    // la definizione delle normali ai piani ( verso l'esterno)
    // Le distanze di un punto esterno sono sia positive che negative:
    // ma almeno  una distanza e' positiva.
    // X_dev   e' la posizione  della particella rispeto al sistema del dev
    // Ruoto di -45 gradi il punto e lo paragono con i lati inclinati....
    // ripeto la stessa procedura di prima per simmetria (Lout non cambia);
    // double Firot=0.707107= 1/sqrt(2.);
    // X_rot   e' la posizione rotata di 45 gradi

    // da verificare ?????????????????????????

    P_Cin=X_dev-Centrin;

    drinq= P_Cin[0]*P_Cin[0]+P_Cin[1]*P_Cin[1];  //??????????

    if ( (DevCln::Posizione())>0) return 1;
    P_Crot.setvn(Firot*(P_Cin.x+P_Cin.y),Firot*(P_Cin.y-P_Cin.x), P_Cin.z);
// Calcolo anche il vettore ruotato
//Test now on X_dev
    if (fabs( X_dev.x)>Lin.x) return 0;
    if (fabs( X_dev.y)>Lin.y) return 0;
    if (fabs( X_dev.z)>Lin.z) return 0;


//Test now on X_rot
    if (fabs( P_Crot.x)>Lin.x) return 0;
    if (fabs( P_Crot.y)>Lin.y) return 0;
    if (fabs( P_Crot.z)>Lin.z) return 0;
    return -1;  //-1 nel buco  0 se interno, 1 se esterno.




}
//----------------------C a m E s t e r --------------------
// calcola il cammino esterno per raggiungere il rivelatore...
// eridata da DevCl::CamEster()

//----------------------C a m I n t e r --------------------
// calcola il cammino interno per uscire dal rivelatore...
// vedi la routine nella classe base rettangolo.
// V_dev e' il versore della traiettoria nel dev
// V_rot e' il versore ruotato di 45 gradi per i lati inclinati
//
double DevClOt::CamInter()
{
    // calcolo il cammino verso le  superfici del cilindro
    // e  quattro dei lati dell'ottagono
    // le distanze sono per definizione negative...
    // e scelgo il cammino positivo  maggiore
    // camm in uscita e' sempre definito
    // prima la classe base....
    camm=DevCln::CamInter();


// colpisco la parete del buco?

    double cammino =Cam_su_Rt(P_Cin,V_dev,Lin);
// roto di 45 gradi per controllare il moto rispetto ai piani inclinati...
    V_rot.setvn ( Firot* ( V_dev.x+V_dev.y ),Firot* ( V_dev.y-V_dev.x ), V_dev.z );

    // P_Crot.setvn(Firot*(P_Cin[0]+P_Cin[1]),Firot*(P_Cin[1]-P_Cin[0]), P_Cin[2]); // già noto
    double camm2 = Cam_su_Rt(P_Crot,V_rot,Lin);

    if (camm2>0.0&&cammino >0.0) // tutti positivi
    {
        if (camm2>cammino) cammino=camm2;   // deve essere maggiore?????? controllare !!!!!
    }
    else if (camm2<0.0&&cammino<0.0) // tutti negativi
    {
        if (camm2>cammino) cammino=camm2;
    }
    else
        if (camm2>0)cammino=camm2;  // si sceglie il positivo

    if (cammino>0.0&&cammino<camm)camm=cammino; // picchia prima la sup del buco...
    return camm;
}
//=========================================
//===============================================================
//--------------- C a m B u c o ---------------------------------
double DevClOt::CamBuco()
{

    camm =Cam_da_Rt(P_Cin,V_dev,Lin);
// roto di 45 gradi per controllare il moto rispetto ai piani inclinati...
    V_rot.setvn ( Firot* ( V_dev.x+V_dev.y ),Firot* ( V_dev.y-V_dev.x ), V_dev.z );

    // P_Crot.setvn(Firot*(P_Cin[0]+P_Cin[1]),Firot*(P_Cin[1]-P_Cin[0]), P_Cin[2]); // già noto
    double camm2 = Cam_da_Rt(P_Crot,V_rot,Lin);
    if (camm2<camm)camm=camm2;
    return camm;


}
