/***************************************************************************
                          devclrt.cpp  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "devclrt.h"

// using namespace std;

void DevClRt::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Cilindrico con buco di x "<<Lin.x<<" e y " <<Lin.y<<" rettangolare ";
    Device::Prgeom();
}
//======================================================
//----------------- -----P o s i z i o n e ---
int DevClRt::Posizione()
{
    if ( DevCln::Posizione()>0) return 1; //  il punto e' esterno
// se sono interno al rivelatore verifico se siamo nel buco
    P_Cin=X_dev-Centrin;

    
    if     (fabs(P_Cin.x)>Lin.x||
            fabs(P_Cin.y)>Lin.y||
            fabs(P_Cin.z)>Lin.z) return 0;

// ritorno -1 se il punto e' nel buco altrimento ritorno 0
    return -1;
}
//----------------------C a m E s t e r --------------------
// usa quella di Cilindro per eredita'
//===========================================================
//----------------------C a m I n t e r --------------------

double DevClRt::CamInter()
{
//uso quella di Cilindro  per calcolare il cammino
// interno senza il buco...
    camm=DevCln::CamInter();

    //poi verifico se colpisce le pareti del buco ..
    double cammino=Cam_su_Rt(P_Cin,V_dev,Lin);
    if (cammino>0.0&&cammino<camm)camm=cammino;
    return camm;


}
//===============================================================
//--------------- C a m B u c o ---------------------------------
double DevClRt::CamBuco()
{
    camm= Cam_da_Rt(P_Cin,V_dev,Lin);
    return camm;
}
