/***************************************************************************
                          devflt  -  description
                             -------------------
    begin                : Sun Aug 15 2004
    copyright            : (C) 2004 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/

#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1
#define EPSR     1.0E-3
#define MAXITER   500

#include "parm.h"
#include "evento.h"
#include "particella.h"
#include "reazione.h"
#include "devflt.h"

using namespace std;

DevFlt::DevFlt()
        : DevRtCl()
{
    devtype=TypDevFlt;
    devclass="Magn_Filter";
//magnete        Mag.con buco per filtro   DevFlt          22
// attenzione rivedre bene la definizione dei vettori dev....per rotazioni e traslazioni dal lab.....
//  campo costante  campo=0 default;
//  campo variabile campo>0; Definire.... ricorda!
    campo=0;
}


DevFlt::~DevFlt()
{
}

//----------------- --------
void DevFlt::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Mag in FE con buco cilindrico senza campo."<<std::endl;
    Device::Prgeom();
    Gout<<"\n";
}
//======================================================
// =======  Magnet tracking

// vettori ==> gvet VW,PL,PT,X,XIN,PIN,P,KIK,RHO,CRHO;

int DevFlt::Traccia(Particella *pr)
{

// see the DevMagn:: Traccia()
// 18/03/03 update: general tracing.. the magnetic field now could be variable
// and without any restriction..
// attention! inside the magnet no brems, nor pairprod for the moment..
// the track tracing is iterative with step size small enough  to keep the
// tracing errors to very low  values
//
//*****
// La carica elementare nel sistema Ibrido e'
//    ec=.299792458[ Gev/c * T**(-1) m **(-1) ]
// va qui moltiplicata per 10e-6 poiche'
// si usa il Gauss ed il Centimetro; segue...
// r(cm)=[p cos(lambda)(GeV)]/(2.9979258e-7 * H(Gauss) )

//   const double ec=2.99792458e-7;
//****


// qui il campo è differente da zero solo nel ferro... il campo nel buco è nullo!!!
// si vuole filtrare via i muoni....

    if (nowpos==ESTERNO || nowpos==INBUCO)  // se esterno o nel buco traccia regolarmente...
    {
        Device::Traccia(pr);
        return  0;
    }
// allora e' INTERNO: si traccia in campo magnetico.
    if (pr->P.norma == 0.0)     return  0;    // no motion ....
    if (pr->Get_Charg() == 0.0)               // neutra traccio regolamente
    {
        Device::Traccia(pr);
        return  0;
    }

    return Traccia_in_magn(pr);
}
