/***************************************************************************
                          devmagn.cpp  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1
#define EPSR     1.0E-3
#define MAXITER   500

#include "parm.h"
#include "part_db.h"
#include "evento.h"
#include "particella.h"
#include "reazione.h"
#include "devmagn.h"

using namespace std;

DevMagn::DevMagn()
{
    devtype=TypDevMagn;
    devclass=" Experimental Magnet";
    fun=Magn;
    Gout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> typ "<<devtype;
    //  campo costante  campo=0 default;
    //  campo variabile campo>0; Definire.... ricorda!
    campo=0;
}


DevMagn::~DevMagn()
{}

// in Gvect.h e' definita l'algebra per i  vettori (gvet)) 3d....
// vettori di giuseppe
//===============================================================
//=================DevMagn==============================
//----------------- --------
void DevMagn::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Magnete rettang. con buco rettang.";
    Device::Prgeom();
    Gout<<std::endl;
}
//======================================================
// =======  Magnet tracking

// vettori ==> gvet VW,PL,PT,X,XIN,PIN,P,KIK,RHO,CRHO;

int DevMagn::Traccia(Particella *pr)
{

    // 18/03/03 update: general tracing.. the magnetic field now could be variable
    // and without any restriction..
    // *****attention! inside the magnet no brems, nor pairprod for the moment..
    // the track tracing is iterative with step size small enough  to keep the
    // tracing errors to very low  values
    //
    //*****
    // La carica elementare nel sistema Ibrido e'
    //    ec=.299792458[ Gev/c * T**(-1) m **(-1) ]
    // va qui moltiplicata per 10e-6 poiche'
    // si usa il Gauss ed il Centimetro; segue...
    // r(cm)=[p cos(lambda)(GeV)]/(2.9979258e-7 * H(Gauss) )
    //**
    // note 2007 the field is in the hole!

  //  const double ec=2.99792458e-7;



    if (nowpos==ESTERNO)         return Device::Traccia(pr); // se esterno traccia regolarmente...
    else if (nowpos==INTERNO)
    { // se interno (!no nel buco) traccio regolarmente per i mu.. le altre particelle sono perse...
        if (pr->Get_Nome()==Mum||pr->Get_Nome()==Mup) return Device::Traccia(pr);
        else  return -1;       // traccia lost in the frame
    }
    if (pr->P.norma == 0.0)     return  0;                  // no motion ....
    if (pr->Get_Charg() == 0.0) return Device::Traccia(pr);  // neutra traccio regolamente dritto

    return Traccia_in_magn(pr);
    
    
    
    
}



