/***************************************************************************
                          devot.cpp  -  description
                             -------------------
    begin                : Sat Dec 6 2003
    copyright            : (C) 2003 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "devot.h"
#include "particella.h"
using namespace std;
DevOt::DevOt()
{
    devtype=TypDevOt;
    devclass="Ottagon";
    Firot=.707107;
    Lout.y=Lout.x;
};
DevOt::~DevOt()
{
}


void DevOt::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  ottagonale  senza buco "<<std::endl;
    Device::Prgeom();
}
//----------------- -----P o s i z i o n e ---
int DevOt::Posizione()
{
//     Posizione della particella rispetto questo dev
// Le distanze di un punto interno dai piani del
// rivelatore sono tutte negative o nulle data
// la definizione delle normali ai piani ( verso l'esterno)
// Le distanze di un punto esterno sono sia positive che negative:
// ma almeno  una distanza e' positiva.
// X_dev   e' la posizione  della particella rispeto al sistema del dev
// Ruoto di -45 gradi il punto e lo paragono con i lati inclinati....
// ripeto la stessa procedura di prima per simmetria (Lout non cambia);
// double Firot=0.707107= 1/sqrt(2.);
// X_rot   e' la posizione rotata di 45 gradi
    X_rot.setvn ( Firot* ( X_dev.x+X_dev.y ),Firot* ( X_dev.y-X_dev.x ), X_dev.z );

//Test now on X_dev
    if (fabs( X_dev.x)>Lout.x) return 1;
    if (fabs( X_dev.y)>Lout.y) return 1;
    if (fabs( X_dev.z)>Lout.z) return 1;

// ora ruoto e verifico  ancora
//Test now on X_rot
    if (fabs( X_rot.x)>Lout.x) return 1;
    if (fabs( X_rot.y)>Lout.y) return 1;
    if (fabs( X_rot.z)>Lout.z) return 1;
    return 0;  // 0 se interno, 1 se esterno. Il buco qui non c'e'.
}
//----------------------------------------------------------
//----------------------C a m E s t e r --------------------
// calcola il cammino esterno per raggiungere il rivelatore...
// vedi la routine nella classe base rettangolo.
// V_dev e' il versore della traiettoria nel dev
// V_rot e' il versore ruotato di 45 gradi per i lati inclinati
//
double DevOt::CamEster()
{

    camm =Cam_su_Rt(X_dev,V_dev,Lout);
// roto di 45 gradi per controllare il moto rispetto ai piani inclinati...
    V_rot.setvn ( Firot* ( V_dev.x+V_dev.y ),Firot* ( V_dev.y-V_dev.x ), V_dev.z );
    double camm2 = Cam_su_Rt(X_rot,V_rot,Lout);

    if (camm2>0.0&&camm>0.0)
    {
        if (camm2>camm) camm=camm2;  // maggiore ??????
    }
    else if (camm2<0.0&&camm<0.0)
    {
        if (camm2>camm) camm=camm2;
    }
    else
        if (camm2>0)camm=camm2;

    return camm;
}

//----------------------C a m I n t e r --------------------
// calcola il cammino interno per uscire dal rivelatore...
// vedi la routine nella classe base rettangolo.
// V_dev e' il versore della traiettoria nel dev
// V_rot e' il versore ruotato di 45 gradi per i lati inclinati
//
double DevOt::CamInter()
{
    camm =Cam_da_Rt(X_dev,V_dev,Lout);
// roto di 45 gradi per controllare il moto rispetto ai piani inclinati...
    V_rot.setvn ( Firot* ( V_dev.x+V_dev.y ),Firot* ( V_dev.y-V_dev.x ), V_dev.z );
    double camm2 = Cam_da_Rt(X_rot,V_rot,Lout);
    if (camm2<camm)camm=camm2;
    return camm;
}















