/***************************************************************************
                          devotot.cpp  -  description
                             -------------------
    begin                : Sun Dec 7 2003
    copyright            : (C) 2003 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "devotot.h"

DevOtOt::~DevOtOt() {
}


//================== DevOtOt ======Erede di DevOt
DevOtOt::DevOtOt()
{
    devtype=TypDevOtOt;
    devclass="Ottg_Ottg";
}

//----------------- --------
void DevOtOt::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Ottagonale con buco ottagonale  "<<std::endl;
    Device::Prgeom();
}

//======================================================
//----------------- -----P o s i z i o n e ---
int DevOtOt::Posizione()
{

    if ( DevOt::Posizione()>0) return 1; //  il punto e' esterno

    // se sono interno al rivelatore verifico se siamo nel buco

    P_Cin=X_dev-Centrin;   // mi riferisco al centro del buco interno
// Calcolo anche il vettore ruotato
    P_Crot.setvn(Firot*(P_Cin.x+P_Cin.y),Firot*(P_Cin.y-P_Cin.x), P_Cin.z);

//Test now on X_dev
    if (fabs( X_dev.x)>Lin.x) return 0;
    if (fabs( X_dev.y)>Lin.y) return 0;
    if (fabs( X_dev.z)>Lin.z) return 0;


//Test now on X_rot
    if (fabs( P_Crot.x)>Lin.x) return 0;
    if (fabs( P_Crot.y)>Lin.y) return 0;
    if (fabs( P_Crot.z)>Lin.z) return 0;
    return -1;  //-1 nel buco  0 se interno, 1 se esterno.

}
//----------------------C a m E s t e r --------------------
// usa quella di DevOt  per eredita'
//===========================================================
//----------------------C a m I n t e r --------------------

double DevOtOt::CamInter()
{
//uso quella di DevRt per calcolare il cammino
// interno senza il buco...
    camm=DevOt::CamInter();
    // colpisco la parete del buco?

    double cammino =Cam_su_Rt(P_Cin,V_dev,Lin);
// roto di 45 gradi per controllare il moto rispetto ai piani inclinati...
    V_rot.setvn ( Firot* ( V_dev.x+V_dev.y ),Firot* ( V_dev.y-V_dev.x ), V_dev.z );

    // P_Crot.setvn(Firot*(P_Cin[0]+P_Cin[1]),Firot*(P_Cin[1]-P_Cin[0]), P_Cin[2]); // già noto
    double camm2 = Cam_su_Rt(P_Crot,V_rot,Lin);

    if (camm2>0.0&&cammino >0.0) // tutti positivi
    {
        if (camm2>cammino) cammino=camm2;   // deve essere maggiore?????? controllare !!!!!
    }
    else if (camm2<0.0&&cammino<0.0) // tutti negativi
    {
        if (camm2>cammino) cammino=camm2;
    }
    else
        if (camm2>0)cammino=camm2;  // si sceglie il positivo

    if (cammino>0.0&&cammino<camm)camm=cammino; // picchia prima la sup del buco...
    return camm;
}
//===============================================================
//--------------- C a m B u c o ---------------------------------
double DevOtOt::CamBuco()
{
    camm =Cam_da_Rt(P_Cin,V_dev,Lin);
// roto di 45 gradi per controllare il moto rispetto ai piani inclinati...
    V_rot.setvn ( Firot* ( V_dev.x+V_dev.y ),Firot* ( V_dev.y-V_dev.x ), V_dev.z );

    // P_Crot.setvn(Firot*(P_Cin[0]+P_Cin[1]),Firot*(P_Cin[1]-P_Cin[0]), P_Cin[2]); // già noto
    double camm2 = Cam_da_Rt(P_Crot,V_rot,Lin);
    if (camm2<camm)camm=camm2;
    return camm;

}
