/***************************************************************************
                          devquad.cpp  -  description
                             -------------------
    begin                : Thu Jan 9 2003
    copyright            : (C) 2003 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1
#define EPSR     1.0E-3
#define MAXITER   500

#include "parm.h"
#include "part_db.h"
#include "particella.h"
#include "reazione.h"
#include "evento.h"
#include "devquad.h"

//using namespace std;
DevQuad::DevQuad(){
  devtype=TypDevQuad;
  devclass="Quadrupol";
// quadropulo: campo  quadrupolare ==> campo = 1
  campo=1;
  if(Dbref<=0.0)
  { Dbref=1.;
    Gout<<"\n In Quad "<<nome<<"  Distance for field normalization in 'vfield' card not defined...forced to  1 cm.";
    
  }
   Bref/=Dbref;
}
DevQuad::~DevQuad(){
}
//----

gvet& DevQuad::Get_Field(gvet &P)
{
// Il campo e' descritto da curve equipotenziali iperboliche.
// l'intensita' e' normalizzata a B (bref) ad 1 cm (dbref) dal centro.
// l' intensita' cresce con la distanza dal centro.
// P e' il raggio vettore.
//    Field.setvn( P[0]*Bref,-P[1]*Bref,0.);

    Field.setvn( P.y*Bref,P.x*Bref,0.);
/*   
   Puls.print("Puls");
   P.print( evento_.Event, nome);
   Field.print( evento_.Event, "B");
*/
   return Field;
}

//----------------- --------
void DevQuad::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Quadrupolo con utile interno cilidrico";
    Device::Prgeom();
    Gout<<std::endl;
}
//======================================================
// =======  Magnet tracking

// vettori ==> gvet VW,PL,PT,X,XIN,PIN,P,KIK,RHO,CRHO;

int DevQuad::Traccia(Particella *pr)
{

    if (nowpos==ESTERNO)         return Device::Traccia(pr); // se esterno traccia regolarmente...
    else if (nowpos==INTERNO)
    { // se interno (!no nel buco) traccio regolarmente per i mu.. le altre particelle sono perse...
        if (pr->Get_Nome()==Mum||pr->Get_Nome()==Mup) return Device::Traccia(pr);
        else  return -1;       // traccia lost in the frame
    }
    if (pr->P.norma == 0.0)     return  0;                  // no motion ....
    if (pr->Get_Charg() == 0.0) return Device::Traccia(pr);  // neutra traccio regolamente dritto

    return Traccia_in_magn(pr);
    
    
}



