/***************************************************************************
                          devrtcl.cpp  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "devrtcl.h"
#include "evento.h"

using namespace std;


//==================  DevRtCl=======Erede di DevRt
DevRtCl::DevRtCl()
{
    devtype=TypDevRtCl;
    devclass="Dev_RtCl";
    rin = Lin[1]=Lin[0];
    rinq=rin*rin;
}

//----------------- --------
void DevRtCl::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Rettang. con buco cilin di rin "<<rin;
    Device::Prgeom();

}

//======================================================
//----------------- -----P o s i z i o n e ---
int DevRtCl::Posizione()
{
    P_Cin=X_dev-Centrin;
    
    drinq= P_Cin[0]*P_Cin[0]+P_Cin[1]*P_Cin[1];

    if ( DevRt::Posizione()>0) return 1;
//  sono forse nel buco ...controllo meglio i limiti
    if  (fabs(P_Cin.z)>Lin.z||
            P_Cin.XYNorma()>rin) return 0;
    // ritorno -1  perche' nel buco
    return -1;
}
//----------------------C a m E s t e r --------------------
// usa quella di DevRt  per eredita'
//===========================================================
//----------------------C a m I n t e r --------------------

double DevRtCl::CamInter()
{
//uso quella di DevRt per calcolare il cammino
// interno senza il buco...

    camm=DevRt::CamInter();
    //poi verifico se colpisce le pareti del buco ..
    double cammino=Cam_su_Cln(P_Cin,V_dev,Lin);
    if (cammino>0.0&&cammino<camm)camm=cammino;
    return camm;
}
//===============================================================
//--------------- C a m B u c o ---------------------------------
double DevRtCl::CamBuco()
{
    camm=Cam_da_Cln(P_Cin,V_dev,Lin);
    return camm;
}

