/***************************************************************************
                          DevSfera.cpp  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "evento.h"
#include "parm.h"
#include "part_db.h"
#include "particella.h"
#include "devsfera.h"


using namespace std;

DevSfera::~DevSfera()
{
}
//==================  Sfera=======Erede di RettEdro
DevSfera::DevSfera()
{
    devtype=TypDevSfera;
    devclass="Sfera";
    Ray_abs=1;
    rout=Sfera.x;
    routq=rout*rout;
    rin=Sfera.y;
    rinq=rin*rin;

    rbuco=Sfera.z;  // attenzione a definire le dimensione del buco di ingresso del beam...
    rbucoq=rbuco*rbuco;
    zbucoout= sqrt ( routq-rbucoq ); // superficie base del cilindro esterna.
    zbucoin = sqrt ( rinq-rbucoq ); // superficie base della separazione del cilindro interno.
    Lcili.x=Lcili.y=rbuco;    //dimensioni totali del cilindro
    Lcili.z=zbucoout;
}

//----------------- --------
void DevSfera::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Corona sferica [R,r: "<< rout<<","<<rin<<" cm]   con un buco cilin. di "<<rbuco<<" cm";
    Device::Prgeom();

}

//======================================================
//----------------- -----P o s i z i o n e ---
int DevSfera::Posizione()
{

    P_Cin=X_dev-Centrin;
//   P_Cin.print(pr_dev->Get_Nome());

    if (fabs(X_dev.z)>=zbucoout) return 1;//e' fuori
    if (X_dev.norma>rout ) return 1;    //e' fuori



    if ( P_Cin.Norma()<rin )return -1; // è interno tra i due gusci sferici

    // è forse anche nel buco all'ingresso?

    if (X_dev.XYNorma()<rbuco) return  -2; // è nel buco cilindrico

    return 0; // è tra i due gusci e non nelle due porzioni di  buco cilindrico...
}
//----------------------------------------------------------
//----------------------C a m E s t e r --------------------
double DevSfera::CamEster()
{
// calcolo il cammino positivo verso la  superfice della sfera
// e scelgo il cammino maggiore
// calcolo i coefficienti della equazione intersezione di una retta con la sfera.




    camm= Cam_su_Sfera(X_dev,V_dev,rout);
    if (camm<0)return camm;

// verifico meglio al buco

    gvet xnew=X_dev+V_dev*camm;

    if (xnew.XYNorma()<rbuco)
    {
        double t=-1.;
        if (V_dev.z>0.0) t=-(zbucoout + X_dev.z)/V_dev.z;
        else if ( V_dev.z<-0.0)t=(zbucoout - X_dev.z)/V_dev.z;
        if (t>0.0&&t>camm)camm=t;
    }
    return camm;
}
//===========================================================
//----------------------C a m I n t e r --------------------
double DevSfera::CamInter()
{   // attenzione la sfera può essere decentrata in z
    camm=Cam_da_Sfera(X_dev,V_dev,rout);
    double tratto= Cam_su_Sfera(P_Cin,V_dev,rin);
    if (tratto>0.0&& tratto<camm) camm=tratto;
    tratto = Cam_su_Cln(X_dev,V_dev,Lcili);
    if (tratto>0.0&& tratto<camm)camm=tratto;
    return camm;
}
//===========================================================
//----------------------C a m I n t e r --------------------
double DevSfera::CamBuco()
{  // attenzione la sfera può essere decentrata in z
    gvet xnew;
    if (pos_corrente==-1) {
        camm=Cam_da_Sfera(P_Cin,V_dev,rin);

        xnew=X_dev+V_dev*camm;
        if (xnew.XYNorma()<rbuco)
        {
            camm+=Cam_da_Cln(xnew,V_dev,Lcili);


            return camm;
        }
    }

    else if (pos_corrente==-2)
    {
        // il cilindro ha lo stesso sistema di ref della sfera esterna
        camm =Cam_da_Cln(X_dev,V_dev,Lcili);
        xnew=X_dev+V_dev*camm-Centrin;
        xnew.Norma();


        if (fabs(xnew.norma)<rin) {
            camm+=Cam_da_Sfera(xnew,V_dev,rin);


            return camm;
        }

    }


    return camm;
}
//===============================================

//================================================


int DevSfera::Traccia ( Particella * pr)
{ 
    if (nowpos==0&&Ray_abs>0) return Traccia_in_materia(pr);
 //    cout<<"\n ev "<<Eventi_Generati<< " nowpos  "<<nowpos<< "  "<<pr->pathok;
    return Device::Traccia(pr);

}
