/***************************************************************************
                          devsolenoide.cpp  -  description
                             -------------------
    begin                : Thu Jan 9 2003
    copyright            : (C) 2003 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1

#include "evento.h"
#include "parm.h"
#include "part_db.h"
#include "particella.h"
#include "devsolenoide.h"

using namespace std;
DevSolenoide::DevSolenoide(){
  devtype=TypDevSolenoide;
  devclass="Solenoide";  
  campo=0;
 // fun=Magn;
// Solenoide: campo=0 perchè costante 
}
DevSolenoide::~DevSolenoide(){
}
//=================DevSolenoide==============================
//----------------- --------
void DevSolenoide::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Solenoide ";
    Device::Prgeom();
    Gout<<std::endl;
}
//======================================================
// =======  Magnet tracking


int DevSolenoide::Traccia(Particella *pr)
{
 
    if (nowpos==ESTERNO)         return Device::Traccia(pr); // se esterno traccia regolarmente...
    else if (nowpos==INTERNO)return Device::Traccia(pr);
   
    if (pr->P.norma == 0.0)     return  0;                  // no motion ....
    if (pr->Get_Charg() == 0.0) return Device::Traccia(pr);  // neutra traccio regolamente dritto

   int iok=Traccia_in_magn(pr);  
 //  cout<<"\n iok "<<iok; 
     
     return iok;
}

