/***************************************************************************
 *   Copyright (C) 2009 by giuseppe Pierazzini                                      *
 *   giuseppe@pierazzini.it                                                               *
 *                                                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 *                                                                         *
 *  Dipartimento di Fisica  E.Fermi / INFN Pisa Italy                      *
 ***************************************************************************/
#ifndef DEVSVETO_H
#define DEVSVETO_H

#include <devcrn.h>



/**
Procedura per al simulazine in dettaglio di un sistema di veto internamente strutturato

 *@author Giuseppe Pierazzini
  */


class DevSveto : public DevCrn
{double drinq,rin,rinq;

  double latox,latoy,latoz, rmedia;
  gvet *U_bl,*U_sc; //Versori degli assi dei blocchi e dei settori.
  gvet *C_bl,*C_sc; // centri dei blocchi e dei settori
  int Blocchi, Strati,iblocco,isector,istrato;  
  double FaseBase[5],Dfi;




public:
    DevSveto();
  virtual   ~DevSveto();
  virtual int Posizione();
  virtual double CamInter();
   virtual double CamBuco();
  virtual void  Prgeom();
  virtual int Get_Structinfo();
};

#endif
