/***************************************************************************
                          devtoro.cpp  -  description
                             -------------------
    begin                : Thu Jan 9 2003
    copyright            : (C) 2003 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1

#include "evento.h"
#include "parm.h"
#include "part_db.h"
#include "particella.h"
#include "devtoro.h"

using namespace std;

DevToro::DevToro(){
  devtype=TypDevToro;
  devclass="Toroidale";  
  campo=1;
 // fun=Magn;
// Toroide: campo=1   perchè variabile 
}
DevToro::~DevToro(){
}
//=================DevToro==============================
//----------------- --------
void DevToro::Prgeom()
{
    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ] Magnete  Toroidale con intensità "<< Bref<< " gaus  al centro del dev ";
    Device::Prgeom();
    Gout<<std::endl;
}
//======================================================
// =======  Magnet tracking


int DevToro::Traccia(Particella *pr)
{
 
    if (nowpos==ESTERNO||nowpos<=INBUCO)         return Device::Traccia(pr); // se esterno traccia regolarmente...
// qui interno 
    if (pr->P.norma == 0.0)     return  0;                  // no motion ....
    if (pr->Get_Charg() == 0.0) return Device::Traccia(pr);  // neutra traccio regolamente dritto
   int iok=Traccia_in_magn(pr);  
 //  cout<<"\n iok "<<iok; 
     return iok;

}

gvet& DevToro::Get_Field(gvet &P)
{
  
// Il campo e' toroidale all'interno del dev
    gvet assez(0.,0.,1.);
    gvet VR=X_dev.NVerso();  //direzione del raggio.
    Field = (assez&VR)*Bref;
    Field.Norma();
   return Field;
}

