/***************************************************************************
                          devhac.cpp  -  description
                             -------------------
    begin                : Tue Jul 31 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "evento.h"
#include "devhac.h"
#include "particella.h"
#include "triggerbox.h"

DevHac::DevHac()
{
	devtype=TypDevHac;
  devclass="Had_RtCl";
}
DevHac::~DevHac()
{}
//----------------- --------
void DevHac::Prgeom()
{

	Gout<<"==================  R i v e l a t o r e =================";
	Gout<<"\n --> < "<<nome <<" >  [ "<<fun
	<<" ]  Hadron Calorimeter:  Rettang. con buco cilindrico "<<std::endl;
	Device::Prgeom();
}
//=======-----------------------------------
void DevHac::DataSmear()
{
	// It Operates on the dev_variables of type (2): M_Hits
	double xh,yh,ep,norma;
	emDev=0.0;
	int i=0;
	sepm=120.;
	while ( i<=nhit )
	{

		xh=M_Hits[i].Xdev.x;
		yh=M_Hits[i].Xdev.y;
		norma=sqrt ( xh*xh+yh*yh );
		// distanza minima dal centro
		if ( norma<sepm ) sepm=norma;
		//  calcolo degli errori per il calorimetro    da rivedere.
		ep=M_Hits[i].e_rivela;
		if ( ep>0.0 )
		{
			double err=20./sqrt ( ep );  // energy error for hac
			emDev+=M_Hits[i].e_rivela =Pgauss ( err,ep );
		}
		i++;
	}

}
