/***************************************************************************
                          devcedar.h  -  description    2011
  
 ***************************************************************************/

#ifndef DEVCEDAR_H
#define DEVCEDAR_H

#include "devcln.h"

/**NA62 device
The CERN CEDAR counter (see Figure 1) has been designed to identify particles of a specific mass by
making the detector blind to the Cerenkov light produced by particles of different mass. The
Cerenkov light emitted by particles of different mass is then not transported by the CEDAR optics
through the diaphragm slit onto the light detectors but absorbed on its way.
===
Element                            Z (mm)
Entrance window                       0
Upstream end of quartz windows      1111
Condenser plane                     1211
Diaphragm plane                     1251
Chromatic corrector upstream end    2234
Mangin mirror exit                  5772
Exit window                         5772
===
  *@author Giuseppe Pierazzini
  */

class DevCedar : public DevCln {
public: 
	DevCedar();
	~DevCedar();
  virtual int  SimulaDev();
  virtual void  Prgeom();
 
};

#if defined(MAIN)
DevCedar *cedar=0;
#else
extern DevCedar *cedar;
#endif



#endif
