/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 2005 /2011    *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/Na48/NA62                                                        *
 ***************************************************************************/

#include "flyoh.h"
//#include "user.h"

//using namespace std;


DevGtk::DevGtk()
        : DevRt()
{
    devtype=TypDevGig ;
    devclass="GT_Rt";	 	 	
	Gout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> typ "<<devtype; 
}


DevGtk::~DevGtk()
{
}

//////////////
// PUBLIC MEHTODS //
//////////////



int DevGtk::SimulaDev()
{
	if(mhit<1) return 0;
// quantizza i dati geometricamente secondo la size dei pad
   for ( int k=0; k<mhit; k++ )
    {  int padx = int ( ( M_Hits[k].Xdev.x+ParGTX ) /ParGTPSize );
       int pady = int ( ( M_Hits[k].Xdev.y+ParGTY ) /ParGTPSize );   
        
        M_Hits[k].Xdev.x = (double(padx)+0.5)*ParGTPSize-ParGTX ;
        M_Hits[k].Xdev.y = (double(pady)+0.5)*ParGTPSize-ParGTY;
        M_Hits[k].Xlab= Devc2Lab( M_Hits[k].Xdev);
        

    }

    return 1;
}

void DevGtk::DataSmear()
{
// qui errori 
    for ( int k=0; k<mhit; k++ )
    {               
// time smearing  
        M_Hits[k].tempo = Pgauss(ParGTTRes,M_Hits[k].tempo);
    }
}

//////////
// CONSTANTS //
//////////
const int DevGtk::MAXHIT = 6;
const double DevGtk::ParGTX = 3.0;  // cm Station X-Size
const double DevGtk::ParGTY = 1.35; // cm Station y-Size
const double DevGtk::ParGTPSize = 0.03; // cm Pad Size
const double DevGtk::ParGTIneff = 0.02; // Inefficiency of the station
const double DevGtk::ParGTTRes = 0.150; // ns Time resolution
const double DevGtk::ParGTTBinSize = 0.200; // ns TDC bin size
