/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 2005/2011     *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA62                                                             *
 ***************************************************************************/
#ifndef DEVGTK_H
#define DEVGTK_H

#include <devrt.h>


/** NA62 device 
 * 
The GigaTracKer (GTK) is a core part of the NA62 experiment. It is a spectrometer that provides
precise measurements of momentum, time and angle of the incoming 75 GeV/c kaon beam. 
The Gigatracker is composed of three stations (GTK1, GTK2 and GTK3) mounted around four
achromat magnets as shown in the Detector Requirements and Performance GTK description.
The spectrometer is composed of three hybrid silicon pixel stations. Each
station is made of one hybrid silicon pixel detector with a total size of 63.1 mm x 29.3 mm containing
18000 300 μm x 300 μm pixels arranged in a matrix of 90 x 200 elements. With this configuration the
detector matches the expected beam dimensions of ~60 mm × 27 mm. The pixel dimensions and the
distances between stations are adapted to deliver the required momentum and direction resolution.

by	@author G.Ruggero
*/

class DevGtk : public DevRt
{
  
public:
    DevGtk ();
    ~DevGtk();
// Variables
    // Methods  old Rencostruct...
   void  DataSmear();
   int SimulaDev();
   double Get_Res(){return ParGTTRes;};

private:

    // Some constants
    static const int MAXHIT;
    static const double ParGTX,ParGTY,ParGTPSize,ParGTDX,ParGTIneff,ParGTTRes,ParGTTBinSize;
};


#if defined(MAIN)
DevGtk *giga1=0,*giga2=0,*giga3=0; 
#else
extern DevGtk *giga1,*giga2,*giga3;
#endif







#endif
