/***************************************************************************
                          devlkr.h  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/

#ifndef DEVLKR_H
#define DEVLKR_H

#include "devotcl.h"
#include "devcrn.h"
/**
Il rivelatore in liquid krypton usato dall'apparato NA48/NA62.
Sono definite le procedure per tracciare le particelle al suo interno, l'aggiunta degli errori nei parametri rivelati e una simulazione realistica del rivelatore.
  *@author Giuseppe Pierazzini
  */
//=============================================

struct Picco
  {
    int ix,iy;
//    double x,y;
//    double e;
  };

struct Cella
  {

    int id;    // number 0<=id<=16384; id=128*(127-iy)+ix
    int ix,iy;
    double x,y;
    double Xcella,Ycella;
    double e;
    void Set_index ( double x,double y,int ix,int iy );
    void Rilascia_E ( double sig,double e_in );
    void Cella2Pad();
  };

struct PadRaster
  {
    int padhit;
    int npeak;
    double dist_max;
    double epad28,m28x,m28qx,m28y,m28qy;
    double epad44,m44x,m44qx,m44y,m44qy;
    double quad1,quad2,quad3,quad4;

    union { double pad28[1024];
        double padx28[64][16];
      };
    union { double pad44[1024];
        double padxy44[32][32];
      };

    union  {short  PADflag_l[1024];
        short PADflag[32][32];
      };
    Picco Peak[10];       // massimo 10 picchi

    void Reset();
    void Momenti();
    void Get_Peak();
    int  Peak_mask ( int ix ,int iy );

  };

//=========================  Calorimetro  Lkry========================
//=========================  Calorimetro  Lkry========================
//=========================  Calorimetro  Lkry========================

class DevLkr:public DevOtCl
// Cilindro con buco circolare interno
  {
  protected:

// variabili di comodo
    double x,y,ep,se,sx;
    int i,ht,hi,dead;
    double xyd,ee, etcls;
    double rr, xfr,slope;
    int Fusione;
    static const float Deadcl[90][2];

  public:
    DevLkr();
    ~DevLkr();

    virtual int Traccia ( Particella * );
    virtual void  DataSmear();
    virtual void  Prgeom();
    virtual int SimulaDev();
    virtual void Reset_RootData();
    int Get_DeadCel ( double x,double y );
//    virtual int Get_Structinfo();
    void Pad_Filling( );
    void E_pio_Relesed (Bufdev *);
    void E_pio_Cluster(Bufdev *);
    double sepm;

// informazioni root
    int padhit;
    float dist_max;
    float epad28,m28x,m28qx,m28y,m28qy;
    float epad44,m44x,m44qx,m44y,m44qy;
    float quad1, quad2, quad3, quad4;

  };
#if defined(MAIN)
//Device *lkry=0;

DevLkr *lkry=0;

#else
//extern Device *lkry;
extern DevLkr *lkry;

#endif
#endif
