/***************************************************************************
                          devmuv.cpp  -  description  2010
                             -------------------

  ***************************************************************************
  *                                                                         *
  *   NA62  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "parm.h"
#include "evento.h"
#include "devmuv.h"
#include "particella.h"
#include "part_db.h"

DevMuv::DevMuv()
{
    devtype=TypDevMuv;
    devclass="MuV_RtRt";	 
Gout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> typ "<<devtype; 
}
DevMuv::~DevMuv()
{}
//----------------- --------
void DevMuv::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Muon veto   Rettangolare"<<std::endl;
    Device::Prgeom();
}

int DevMuv::SimulaDev()
{
  
   float Xmuv=0.,Ymuv=0.;
   for (int i=0;i<16;i++)     muvx[i]=muvy[i]=0.;

   ntiles=0;
  
   for ( int k=0;k<mhit;k++ )
    {
// attenzione si lavora nel sistema del dev...

      Bufdev Hit_k=M_Hits[k]; // K-esimo Hit in esame.
      int ntilesx = 0, ntilesy = 0;
      double restox = 0., restoy = 0.;
//      if(debugtubi>0)   Hit_k.Xdev.print(Hit_k.pnome);   
     

       // if(Hit_k.Pr->charg==0.) continue;  // skip the neutral particles

        Xmuv= Hit_k.Xdev.x ;
   Ymuv= Hit_k.Xdev.y ;
   
   if(fabs(Xmuv)<0.04) return -1;
   
   ntilesx = (Xmuv+132)/22;
   ntilesy = (Ymuv+132)/22;
   
   restox = (Xmuv+132)-(ntilesx+0.5)*22;
   restoy = (Ymuv+132)-(ntilesy+0.5)*22;
   
   if(fabs(restox)>10.999 || fabs(restoy)>10.999) return -1;
 
   muvx[ntiles]=Xmuv;
   muvy[ntiles]=Ymuv;
   ntiles++;
    }
  
  return 1;

}