/*
    GmP  Dev Rich   28.03.2012
*/


/*    Codici di return

Check_Pm()  verifica se urta un pm
    N   indice del pm colpito.
   -1   fuori spot a destra
   -2   fuori spot a sinistra
   -3   intra pm a destra
   -4   intra pm a sinistra.

 Pipe_ombra() verifica se il fotone urta la pipe
    0  non urta
  -10  urta la pipe

Ring()   Traccia il fotone
     0   return ok ==> arriva fino allo schermo dei rivelatori.
   -10   urta la pipe
   -11   non urta lo specchio
   -12   è nella pipe
   -13   urta la pipe dopo la riflessione
   -14   non urta la base dove sono i pm
   -15   è nella pipe

///////////////

 Make_Cerenkov_light: return "tratto"
 --> Set_Fotone()
      --> Ring()
           --> Pipe_Ombra()
           --> Pipe_Ombra()
      --> Check_PM()

////////////////
*/







#include "parm.h"
#include "part_db.h"
#include "devrich.h"
#include <evento.h>

using namespace GmpConst;
using namespace std;

int Debugrich=0;

int  Pipe_ombra ( gvet X_indev,gvet V_indev,double raggio,double Dzeta );
//void Grafica(gvet Xin, gvet Vz, LuceCerenkov &LC)
using namespace std;

DevRich::DevRich()
        :DevCrn()
{


        devtype=TypDevRich;
        devclass="Ring Imaging Cherenkov";
        Gout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> typ "<<devtype;


        Ncvfoto=Phms=-1;
        if ( extrawork==1 ) {

                //
                Phm =new FotoSpot[1000];
                Ckv_light=new LuceCerenkov[150];


//  produzione per traccia
                Fototrk=new int[10];
                Pmtrk =new int[10];
                Pathtrk=new float[10];

                for ( int i=0; i<10; i++ )  Fototrk[i]=Pmtrk[i]=0;


                Ftseen=new int[200];    // flag fotone non visto =-1 altrimenti è il num pm
                traknum=new int[200];
                Xcvk=  new float[200]; // coordinate del fotona alla nascita
                Ycvk=  new float[200];
                Zcvk=  new float[200];
                Vxcvk=  new float[200]; //versore di del fotona alla nascita
                Vycvk=  new float[200];
                Vzcvk=  new float[200];
                Xspot= new float[200]; // coordinate sul piano dei pm
                Yspot= new float[200];
                // tagxz,tangyz,mom del primario...
                tanxz=new float[200];
                tanyz=new float[200];
                tetaz=new float[200];
                mom=new float[200];

// costruisco la spot dei pm
                Make_Spot();
        }
}

DevRich::~DevRich()
{
}

int DevRich::SimulaDev()
{

        int Totpm=0;
        FotoLost=0;
        Ncvfoto=0;
        Npmseen=Npcolpiti=0;
        SottoSoglia=0;
        for ( int i=0; i<1000; i++ )  Pmflagsx[i]=Pmflagdx[i]=0;
        if ( extrawork==0 ) return 0;
        if ( mhit<1 ) return 0;

        if ( Debugrich>0 )  Gout<<"\n\n RICH Debug ev gen. "<<setw ( 8 ) <<Eventi_Generati<< "  mhit  "<<setw ( 3 ) <<mhit;

        // get the track parameters..

        for ( int mhi=0; mhi<mhit; mhi++ ) {
                if ( M_Hits[mhi].Pr->Get_Charg() ==0 ) continue; //skip neutral particle

                Fototrk[mhi]=Pmtrk[mhi]=0;
                gvet Xin=M_Hits[mhi].Xdev;
                qvet Pin=Lab2Dev ( M_Hits[mhi].P );



                if ( Pin.mom<0.5|| Pin.z<0.01 ) { //skip the tracks of low mom or  going backward
                        if ( Debugrich>0 ) {
                                string nomp=M_Hits[mhi].pnome;
                                cout<<"\n skip trak "<< nomp<< " mom "<<Pin.mom<< " pz "<<Pin.z;
                        }
                        continue;
                }


// ck light: nft fotoni  utili  e npmc colpiti dalla luce cerkov della traccia ....
                if ( Debugrich>0 ) Gout<<"\n Debg ev gen. "<<Eventi_Generati<<" traccia "<<mhi<<" "<<M_Hits[mhi].pnome<<"  mom "<<Pin.mom;

                int nft=0,npmc=0;
                gvet Xstart=Xin;
                double tratto= Make_Cerenkov_light ( Pin, Xin, nft,npmc );

                if ( Debugrich==3 ) {
                        Xstart.print ( "Xs" );
                        Gout<<" ev "<<Eventi_Generati<<" "<<M_Hits[mhi].Pr->Get_Nome() << " mom "<<setw ( 8 ) <<Pin.mom;

                        Xin.print ( "Xout" );
                        Gout<<setprecision ( 4 ) <<"  tratto  "<<setw ( 8 ) <<tratto<<" "<<setw ( 4 ) <<nft<<" "<<setw ( 4 ) <<npmc;
                }

                if ( nft>0&& tratto>0.0 ) {

                        Fototrk[mhi]=nft;
                        Pmtrk[mhi]=npmc;
                        Pathtrk[mhi]=tratto;

                        if ( Debugrich>0 ) {
                                Totpm+=npmc;
                                Gout<<"\n "<< M_Hits[mhi].pnome<<" Fotoni  gen. "<<setw ( 8 ) <<nft
                                    << " pm colpiti "<<Pmtrk[mhi]<<" tratto "<<setw ( 8 ) <<tratto
                                    << " mom "<<setw ( 8 ) <<Pin.mom
                                    << " Totpm "<<setw ( 5 ) <<Totpm;


                        }

// trasfer data for root
                        for ( int iph=0; iph<nft; iph++ ) {

                                int itp=iph+Ncvfoto;
                                Ftseen[itp]= Ckv_light[iph].fato ;

//             cout<<"\n fotone "<<setw(4)<<iph   << " pm seen "<<setw(6)<<Ftseen[itp] ;

                                traknum[itp]= mhi;
                                if ( itp==0 )  traknum[itp]= -1;
                                Xcvk[itp]= Ckv_light[iph].X.x;  // coordinate  del fotone alla nascita
                                Ycvk[itp]= Ckv_light[iph].X.y;
                                Zcvk[itp]= Ckv_light[iph].X.z;
                                Vxcvk[itp]= Ckv_light[iph].V.x;  // versore del fotone alla nascita
                                Vycvk[itp]= Ckv_light[iph].V.y;
                                Vzcvk[itp]= Ckv_light[iph].V.z;

                                Xspot[itp]=Ckv_light[iph].Xback.x;// coordinate  del fotone al piano dei rivelatori
                                Yspot[itp]=Ckv_light[iph].Xback.y;

                                tanxz[itp]=Ckv_light[iph].tgxz;
                                tanyz[itp]=Ckv_light[iph].tgyz;
                                tetaz[itp]= Ckv_light[iph].tetaz;

                                mom[itp]=Pin.mom;

                        }
                        Ncvfoto+=nft;
                }

        }

        Count_Pm_colpiti();

        if ( Debugrich==2 ) {
                cout<<"\n Ev g." <<setw ( 8 ) <<Eventi_Generati<<" Sommario:  Rich mhit "<<setw ( 3 ) <<mhit
                    <<setw ( 5 ) <<" fotoni "<<Ncvfoto<< "  pm colpiti "<<setw ( 5 ) <<Npcolpiti<< "  pm seen "<<setw ( 5 ) <<Npmseen
                    << " fotoLost "<<setw ( 5 ) <<FotoLost;

                Gout<<"\n Ev g. " <<setw ( 8 ) <<Eventi_Generati<<" Sommario:  Rich mhit "<<setw ( 3 ) <<mhit
                    <<setw ( 5 ) <<" fotoni "<<Ncvfoto<< "  pm colpiti  "<<setw ( 5 ) <<Npcolpiti<< "  pm seen"<<setw ( 5 ) <<Npmseen
                    <<" [sx "<< "] fotoLost "<<setw ( 5 ) <<FotoLost;
        }


        return Npmseen;
}
//=================

//===========
void DevRich::Make_Spot()
{
// genera la mappa dei rivelatori esagonali sullo schermo finale del rich;

        if ( Phms>0 ) return;

        static double  cos30=0.866025403784;
        static double Dx=1.8;   //diametro del Pm!
        static double Dy= Dx*cos30;
        double xx=0., yy=0.;
        int np=0;
        int num=0;

        for ( int Iyy=-18; Iyy<18; Iyy++ ) {
                for ( int Ixx=-18; Ixx<18.; Ixx++ ) {

                        yy=Iyy*Dy;
                        if ( ( Iyy%2 ) ==0 ) xx=Ixx*Dx+Dx/2.;
                        else xx=Ixx*Dx;


                        if ( ( xx*xx+yy*yy ) <900. ) {
                                Phm[np].id=np;
                                Phm[np].Ix=Ixx+18;
                                Phm[np].Iy=Iyy+18;
                                Phm[np].X=xx;
                                Phm[np].Y=yy;
                                Phm[np].code= ( Iyy+18 ) *100+Ixx+18;
                                np++;
                        }
                        num++;

                }
        }
        Phms=np;
        Gout<<"\n  PmSpot done. Elemens: "<<Phms<<"  Iter generati " <<num<<endl;
}

//============== MAKE_CRENKOV_LIGHT
//===============================================================
double  DevRich::Make_Cerenkov_light ( qvet Pin, gvet & Xin, int & nft,int & npmc )
{
        // Conteggioo dei  fotoni  prodotti
// Xin in coordinate interne al dev RICH
        double beta= Pin.mom/Pin.e;

// attenzione il valore dell'indice di rifrazione fissa il raggio ..
//  double cosc=1./(1.000067*beta);
        double cosc=1./ ( 1.000062*beta );

        if ( cosc>1.0 ) {
                SottoSoglia++;
                return 0.0;
        }
        double sinc=sqrt ( 1.-cosc*cosc );

//  cout<<"\n sinc "<<sinc;
//   double alfa=1./(100.*sinc*sinc);
        double alfa=.70/ ( 100.*sinc*sinc );
//Calcolo dei cammini di emissione
// calcolo di un sistema di riferimento  (versori: vx,vy,vz)
// con asse z lungo la linea di volo della particella padre
        gvet Vz= Pin.NVerso();   // pensato anche come asse Z
        gvet YY ( 0.,1.,0. );    // asse Y del Dev
        gvet Vx= YY&Vz;
        Vx=Vx.NVerso();
        gvet Vy=Vz&Vx;




        if ( Debugrich==3 ) {
                Gout<<"\n\n ev "<<Eventi_Generati;

                Xin.print ( "Xin" );
                Gout<<" alla base upstream";
                Vz.print ( "Vin" );
                Gout<<" Versore part. incidente.";
        }





        //Trasporto la particella sulla superficie utile upstream di base del Rich
        double t=0.;

        if ( Xin.z<-850 ) {
                t= ( -850.-Xin.z ) /Vz.z;
                Xin+=Vz*t;
        }


//===============

        // primo fotone virtuale per il calcolo del centro..

//     Ckv_light[nft].Set_Fotone(Xin,Vz,Pin,nft,npmc);
//     if (Debugrich==1) {
//
//         Ckv_light[nft].Xback.print("centro");
//         Gout<<" fato "<< Ckv_light[nft].fato;
//
//     if (Ckv_light[nft].fato>-5) {
//         gvet cfx= Ckv_light[nft].Xback;
//
//         double rot=  cfx.XYNorma();
//
//         Gout<<"\n "<<setprecision(4)
//         <<setw(10)<<cfx.x<<" "<<setw(10)<<cfx.y<<" "<<setw(10)<<rot<<" "<<setw(10)
//         << setw(10)<<Ckv_light[nft].tetaz<<" "<<setw(10)<< Pin.mom<<" fato "<< Ckv_light[nft].fato;
//
//     }}
//
//     if (Ckv_light[nft].fato>-5) nft++;
//======================


//  posizioni di emissione luce lungo il cammino della particella padre

        double tratto=0.0;  // tratto percorso nel rich prima di uscire.
        gvet X=Xin;
        while ( X.z<850.0 ) {
                t= -alfa*log ( Dran() );
                X+=Vz*t;

//===============
// si verica che l'emissione avvenga nel volume utile del Rich

                if ( X.z>849.99 ) break;
                double drs=X.XYNorma();
                if ( drs<8.5 ) break;  // into the pipe....
// superfice laterale tre le basi di raggio 194.0 cm e 162.5 a z= +-850.cm .
// double rnow= 194.0 - 31.5*(X.z+850.0)/1700.;  ovvero
                double rnow=178.25-31.5*X.z/1700.;
                if ( drs>rnow ) {
                        break;
                }
//================



//Direzione di volo del gamma emesso.
// randomize in fi
                double fi=DuePiGreco*Dran();
                gvet V = Vx*sinc*cos ( fi ) +Vy*sinc*sin ( fi ) +Vz*cosc;


// traccio il fotone: riflessione sugli specchi e rivelazione dai pm
// se ok incremento

//==============    S E T _ F O T O N E    ======

                if ( nft<150 ) {

                        if ( Ckv_light[nft].Set_Fotone ( X,V,Pin,nft ) ==1 ) npmc++;
                        if ( Ckv_light[nft].fato>-5 ) nft++;
                        else FotoLost++;

                        //if(Ckv_light[nft].fato<-9) cout<<"\n Destino "<<Ckv_light[nft].fato;
                } else {
                        cout<<"\n Too many cerenkonv gammas..(correggere dim) "<<nft<< " in questa traccia "<<endl;
                        return tratto;

                }
                Xin=X;
                tratto+=t;
//     Xin.print("xcur"); Gout<<" t "<<t<<" tr "<<tratto<< " nft "<<nft;

        }
        return tratto;
}

//============================



int LuceCerenkov::Ring()

{
        // definizione dei parametri  della parabola  Fuoco=af cm
// si lavora in cordinate del dev
        static double af=1700.;
        static gvet Zbase ( 0.,0.,af/2. );
        gvet Fpiu ( 0.,0.,af );
        gvet Fmeno ( 0.0,0.,-af );
        Xback.Reset();

        // verifico se il fotone urta  la pipe all'interno del Rich

        if ( Pipe_ombra ( X,V,8.5, 850.0 ) <0 ) return -10;

        // Riferisco la X  alla base del RICH (sistema di riferimento più comodo per la parabola)
        gvet Xs=X-Zbase;

        // trasporto la coordinata alla base positiva del RICH (ora a zero)
        double t= ( -Xs.z ) /V.z;
        Xs+=V*t;
        Xs.Norma();


        if ( Debugrich==3 ) {
                Gout<<endl;
                X.print ( "X" );
                Gout<<" in Ring ev "<<Eventi_Generati;
                Gout<<" Coor.ta iniziale  del fotone ";
                V.print ( "V" );
                Gout<<" Versore iniziale del fotone ";
                Xs.print ( "XsBase" );
                Gout<<" Coor.ta shiftata alla base con  z=0";
        }// test on position

        double drs=Xs.XYNorma();
        if ( drs>162.5 ) return -11; // non picchia nello spechio... out of the Rich
        if ( drs<8.5 )  return -12; // inside the pipe...

// definisce il fuoco dello specchio da colpire (parte delle x positive o negative)
//


        if ( Xs.x<0. ) {
//       Fpiu.setvn(79.94,0.0,af);      // 47 mrad
//       Fmeno.setvn(-79.94,0.0,-af);
                Fpiu.setvn ( 72.0,0.0,af ); // spostato a 42.353
                Fmeno.setvn ( -72.0,0.0,-af );


        } else {


                Fpiu.setvn ( -79.94,0.0,af );
                Fmeno.setvn ( 79.94,0.0,-af );

        }


        // calcolo del punto di impatto sullo specchio parabolico con metodo iterativo!
        gvet Vf = Fpiu.NVerso(); // direzione dell'asse della parabola.
        // Equazione del paraboloide di rotazione (Xs-Fmeno)**2=[(Xs-Fpiu).Vf]**2
        t=0.0;
        for ( int i=0; i<16; i++ ) {

                double XsVf=Xs%Vf;
                double XsF= ( Xs%Fmeno );
                double VF= V%Fmeno;
                t= ( Xs.normaq-XsVf*XsVf -4.*XsF ) / ( 4.*VF );
                Xs+=V*t;
                Xs.Norma();


                if ( fabs ( t ) <0.0001 ) break;
        }

        gvet Xspecchio= Xs;




// calcolo della normale allo specchio in Xs, (gradiente alla parabola)
        gvet Vn;
        Vn= Vf* ( ( Xs-Fpiu ) %Vf ) - ( Xs-Fmeno ); // gradiente


        Vn=Vn.NVerso();

// calcolo della riflessione del vettore V del fotone
        gvet Vpp= Vn* ( V%Vn );
        gvet Vr=V -2.*Vpp;
        Vr.Norma();


        Xs=Xs+Zbase;   // ritorno al rif del centro dev. Shift del vettore XS a centro del dev

// verifico nuovamente se il fotone riflesso è ostacolato dalla pipe
        if ( Pipe_ombra ( Xs,Vr,8.5,850.0 ) <0 ) return -13;


// calcolo del punto di arrivo del fotone sullo schermo upstream
        double Zback=-850.; // Zback posizione del piano dei rivelatori
        Xback=Xs + Vr* ( Zback-Xs.z ) /Vr.z;

        if ( Debugrich==3 ) {
                Xs.Norma();
                Xspecchio.print ( "Xspe" );
                Gout<<" Coor.ta  allo specchio ";
                Xs.print ( "Xsc" );
                Gout<<" Coor.ta riferita al centro Rich ";
                Vn.print ( "Vn" );
                Gout<<" Normale allo specchio ";
                Vr.print ( "Vr" );
                Gout<<" Versore riflesso ";
                Xback.print ( "Xback" );
                Gout<<" Coor.ta ai rivelatori ";
        }

        drs=Xs.XYNorma();

        if ( drs>194.0 ) return -14; // non urta la base upstream del Rich... out of the Rich
        if ( drs<8.5 )  return -15; // inside the pipe...

        return 0;
}

//==================

//============    strutture  ======
int LuceCerenkov::Set_Fotone ( gvet Xin,gvet Vin,gvet Pin,int nft )
{

        gvet Xsc;
        id=nft;   // indice del fotone creato....
        X=Xin;
        V=Vin;
        tgxz=Pin.x/Pin.z;
        tgyz=Pin.y/Pin.z;
        tetaz=sqrt ( tgxz*tgxz+tgyz*tgyz );
        mom =Pin.mom;

        // cout<<"\n ev "<<Eventi_Scritti<< "  Id "<<id <<" Npmseen "<<Rich->Npmseen;
        //  Pin.print("Pin");

//trasporta il fotone sullo schermo dei rivelatori finale
        // Ring definisce le coordinate Xback del fotone sul piano dei pm
        // a meno che che il fotone non arrivi sul piano dei rivelatori
        fato=0;
        if ( ( fato=Ring() ) <0 ) { //cout<<"\n fato "<<fato;
                return fato;
        }

        // è arrivato sullo schermo !


// controllo se il fotone ha colpito  un Pm
        fato=Check_Pm();

        if ( fato <0 ) {
                Pmseen=0;
                return fato;
        }
//ok memorizzo il puntatore del Pm colpito
        Pmseen=&Rich->Phm[fato];
        if ( Xback.x<0.0 ) Rich->Pmflagsx[fato]++;
        else Rich->Pmflagdx[fato]++;



//      cout<<"  pm aggiunto" ;
        return 1;
}
//=====================
void LuceCerenkov::Print ( string tit )
{

        Gout<<"\n Ev "<<setw ( 6 ) <<Eventi_Generati<<" id "<<id
            <<" X "<<setw ( 8 ) <<X.x<<"  "<<setw ( 8 ) <<X.y<<" "<<setw ( 8 ) <<X.z
            <<" Hit "<<setw ( 8 ) <<Xback.x<<"  "<<setw ( 8 ) <<Xback.y<<" "<<setw ( 8 ) <<Xback.z
            <<" Pad ";

        if ( Pmseen >0 )
                Gout<<setw ( 8 ) << Pmseen;
        else Gout<<"   -1";
}
//=====================
void DevRich::Count_Pm_colpiti()
{

        // conteggio dei pm colpiti


        for ( int i=0; i<1000; i++ ) { // loop sui fotoni già creati  meno questo
                if ( Pmflagsx[i]>0 ) {
                        Npcolpiti+= Pmflagsx[i];
                        Npmseen++;
                }
                if ( Pmflagdx[i]>0 ) {
                        Npcolpiti+= Pmflagdx[i];
                        Npmseen++;
                }
        }
}




int LuceCerenkov::Check_Pm()

{
        // verifica se il nuovo hit colpisce un Pm

        FotoSpot *pad=Rich->Phm; // pointer to spot (matrice) dei Pm
        int n=Rich->Phms;  // dimenisone della spot
        // raggio del W.cone

        double xx=Xback.x;

        if ( xx>0.0 ) {
                xx-=160.0;    //  pad non colpito a destra
                if ( sqrt ( xx*xx+Xback.y*Xback.y ) >32.0 ) return -1;
        } else {

                xx+=160.0;    // a sinistra
                if ( sqrt ( xx*xx+Xback.y*Xback.y ) >32.0 ) return -2;
        }


        // cout<<"\n Ev "<<setprecision(4)<<Eventi_Generati<<" "<<setw(8)<<x<<" "<<setw(8)<<Xback.y<<" "<<setw(8)<<Xback.z;



        for ( int i=0; i<n; i++ ) {
                double dx=xx-pad[i].X;
                double dy=Xback.y-pad[i].Y;
                double distq=dx*dx+dy*dy;
                if ( distq<=0.82 ) return i;    // pm colpito..

        }
//pad non esistente
        if ( Xback.x>0. ) return  -3;
        return -4;

}




//======================

void FotoSpot::Print ( string Tit )
{

        Gout<<setprecision ( 3 ) <<fixed;
        Gout<<"\nEv "<<setw ( 8 ) <<Eventi_Generati<<" "<<Tit<<" n "<<setw ( 4 ) <<id
            <<" "<<setw ( 8 ) <<X<<"  "<<setw ( 8 ) <<Y;

        Gout<<" "<<setw ( 3 ) <<Ix<<" "<<setw ( 3 ) <<Iy<<" code "
            <<setw ( 8 ) <<code;
}

//std::ofstream Grf;

// ==================================================
// procedura di servizio
// void Grafica(gvet Xin, gvet Vz, LuceCerenkov &LC)
// {
//
//     if (!Grf.is_open())Grf.open ( "grafico.plt" ,ios::out );
//     Grf<<setprecision(3);
//     Grf<<"\n "<<setw(9)<<Xin.x<<" "<<setw(9)<<Xin.y<<" " <<setw(9)<<Vz.x<<" "<<setw(9)<<Vz.y<<" "<<setw(6)<<Vz.z
//     <<" "<<setw(9)<<LC.X.x<<" "<<setw(9)<<LC.X.y<<" "<<setw(9)<<LC.X.z<<" "
//     <<setw(9)<<LC.V.x<<" "<<setw(9)<<LC.V.y<<" "<<setw(9)<<LC.V.z<<" "
//     <<setw(9)<<LC.Xback.x<<" "<<setw(9)<<LC.Xback.y;
//
// }



int  Pipe_ombra ( gvet X_indev,gvet V_indev,double raggio,double Dzeta )
{
// deriva da Device::Cam_su_Cln()




        gvet VV ( V_indev.x,V_indev.y,0.0 ) ;
        double sintet=VV.norma;
        if ( sintet<0.001 ) return 0; //ok:  vola parallelo all'asse della pipe
        VV=VV.Verso();
        gvet Xp ( X_indev.x,X_indev.y,0.0 );
        double  b=VV%Xp;

        double dist_min= fabs ( VV.x*X_indev.y-VV.y*X_indev.x );
        if ( dist_min> raggio ) return 0; //ok: passo troppo lontano dall'asse della pipe

// bene... allora qui calcolo il punto di impatto con la superficie laterale
        double corda=sqrt ( raggio*raggio-dist_min*dist_min ); // in effetti è  la semicorda !!!

        double t= ( -corda-b ) /sintet; // Scelgo la soluzione più vicina

//     X_indev.print("X"); Gout<<"  ev "<<Eventi_Scritti;
//     V_indev.print("V"); Gout<<" Parm "<<dist_min<<" "<<corda<<" "<<t;
//     gvet xnow = X_indev+V_indev*t;
//     xnow.print("Xdead");

        if ( t<=0.0 ) return 0;

        if ( t>=0.0 ) { //vera per definizione... ma .....
                // check limiti in zeta
                double z=X_indev.z+V_indev.z*t;
                if ( fabs ( z ) >Dzeta ) return 0; // ok: urta la pipe fuori dal Rich
                // (X_indev+V_indev*t).print("pic");
        }


        return -10;
}



