/***************************************************************************
                          devrich.cpp  -  description
                             -------------------
    copyright            :2011 by Giuseppe Pierazzini
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/



#ifndef DEVRICH_H
#define DEVRICH_H

#include "devcrn.h"

using namespace GmpConst;
using namespace std;
//============================================
//====    Strutture ==================
struct FotoSpot
{
 int id;

 int code;
 double X,Y;
 int Ix,Iy;
 FotoSpot(){ id=0;};  
 //void   SetPm(double , double);
 void Print(string);
 
};


struct LuceCerenkov
{
  int id;
  int trk;
  int fato;
  double tgxz,tgyz,tetaz,mom;
  gvet X,V,Xback;
  FotoSpot *Pmseen;
  LuceCerenkov(){id=0;trk=-1;fato=0;Pmseen=0;}
  int Set_Fotone(gvet x ,gvet v,gvet p,int nft);
  int Check_Pm();
 int  Ring();
 void Print(string);
};









//====   end  Strutture ==================

//=======================



class DevRich : public DevCrn
{
   

public:
  
  
 int Pmflagsx[1000],Pmflagdx[1000];  //attenzione dimensioni > massimo n. pm per spot
 FotoSpot  *Phm;  // lista dei rivelatori finali Pm
 int Phms;
 LuceCerenkov *Ckv_light;
 int SottoSoglia;
 int Ncvfoto,Npcolpiti,Npmseen,FotoLost;
 // per root: coordinate dei fotoni alla spot...
    int   *Fototrk,*Pmtrk;
    int   *traknum,*Ftseen;
    float *tanxz,*tanyz,*tetaz,*mom,*Xcvk,*Ycvk,*Zcvk,*Vxcvk,*Vycvk,*Vzcvk,*Xspot,*Yspot;
    float *Pathtrk;
    
    DevRich();

    ~DevRich();
    virtual int SimulaDev(); 
    double Make_Cerenkov_light(qvet P,gvet& Xin,int &nft,int &npmc);  // ritorna il cammino fatto
    void Make_Spot();
    void Count_Pm_colpiti();
};


#if defined(MAIN)
DevRich *Rich=0;
#else
extern DevRich *Rich;
#endif





#endif // DEVRICH_H







