/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 20.02.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/

#include "parm.h"
#include "part_db.h"
#include "apparato.h"
#include "particella.h"
#include "evento.h"
#include "devstraw.h"

using namespace std;


int Debugstraw=-1;


// attenzione Tet è passato come reference pointer...
void Strawlib ( string Dir,string Nomef,double *&Tet, double **&Prob );


//=========================================

DevStraw::DevStraw() : DevRtRt()
{
    devtype=TypDevStraw;
    devclass="Strw_RtRt";
    Gout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> typ "<<devtype;
    static DevStraw *laststraw = 0;
    if ( laststraw== 0 ) FirstStraw=this;
    else             laststraw->nextstraw = this;    // linking
    upstraw=laststraw;
    laststraw = this;
    this->nextstraw = 0;    // end linking

    for (int i=0;i<16;i++) {
        Wirecoor[i]=Wiredtim[i]=Wiretraild[i]=Wiredtempo[i]=Wiretrails[i]=0.;
    };

// attenzione questa istruzione va corretta a seconda del path...da aggiustare
//  char *Direttor={"../../mslibrary"};
    string Direttor= "../../mslibrary";

    Gout<<"\n Multiple Scattering data for dev "<< nome;

    if ( StrTetPip!=0 ) Gout<<" allready done.";
    else
    {

        Strawlib ( Direttor,string("pionplus"),StrTetPip, StrProbPip );
        Strawlib ( Direttor,string("muon" ),   StrTetMup, StrProbMup );
        Strawlib ( Direttor,string("positron"),StrTetElep,StrProbElep );


        /*    for ( int i=0;i<1200;i++ )
            {
              Gout<<"\n "<<i<<" " <<StrProbPip[10][i]<<" " <<StrProbPip[40][i]<<" " <<StrProbPip[70][i];
            }
        */

    }
    tubiseen=0;
// test of this particular measured buffer dimension
    int dim= working_buffer;
    if (dim<MemoryBuffer)
    {
        dim=MemoryBuffer;
        Gout<<"\n In device ** "<<nome <<" **  measur_buffer adjusted to ==> "<<dim;
    }


}


DevStraw::~DevStraw()
{
}

void DevStraw::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Straw chamber rettangolari  "<<std::endl;
    Device::Prgeom();
}


int DevStraw::Mscatter( Particella * pr, double tratok )
{
//-------------------------------------------------
//              M S C A T T E R
//-------------------------------------------------

// =======  Multiple Scattering Routine =====
// at t e n z i o n e ... aggiustare per magnete e sfera!!!


//  if (Eventi_Generati>6587&&Eventi_Generati<6589)Debugstraw=1;
//    else Debugstraw=-1;

    if (Scatter==0) return 0;    // no multiple scattering required
    lrad=nowpos?lradb:lradi;

    if (lrad <= 0.0             ||   // no multiscat.
            pr->charg == 0.0           ||   // no charge
            tratok < 0.001          )       // no crossed space
        return 0;
//===============================
    qvet Pprev;
    double randx,randy;
    int libMom,jbin,passx,passy;
    double libProb,dthx,dthy;
    int pplus,positron,muon;

   if(Debugstraw>0) {
   
   Gout<<"\n\n Ev "<<Eventi_Generati<<" Multiple scattering for  "<<pr->Get_Nome()<<" in " <<nome;
    pr->Get_Gp().print("p_ gen");
    pr->P.print("p_prima");
     
  }
    
    
    
    
    if ( pr->P.norma<=6. || pr->P.norma>65. ) {
        return  Device::Mscatter ( pr,tratok );
    }

    if ( pr->Get_Nome() !=Pip && pr->Get_Nome() !=Elep && pr->Get_Nome() !=Mup )
    {
        return  Device::Mscatter ( pr,tratok );
    }

//  qui  pioni elettroni e muoni positivi tra 6 e 65 GeV/c

// Multiple Scattering library implementation
    // No gaussian  multiple scattering for Pip,Elep,and Mup

    // Define type of particle
    pplus = positron = muon = 0;
    if ( !strcmp ( pr->Get_Nome(),"pip" ) )  pplus = 1;
    if ( !strcmp ( pr->Get_Nome(),"elep" ) ) positron = 1;
    if ( !strcmp ( pr->Get_Nome(),"mup" ) )  muon = 1;


    // Smear the coordinate according to the MSlib
    libProb = 0;
    passx = passy = 0;
    dthx = dthy = 0;
    randx = Dran();
    randy = Dran();
    libMom = ( int ) pr->P.norma;
    for ( jbin=0;jbin<1200;jbin++ )
    {
        if ( pplus )    libProb = StrProbPip[libMom][jbin];
        if ( positron ) libProb = StrProbElep[libMom][jbin];
        if ( muon )     libProb = StrProbMup[libMom][jbin];
//               libProb = libMSProb[libMom][jbin];
        if ( !passx && libProb>randx )
        {
            if ( pplus )    dthx = StrTetPip[jbin];
            if ( positron ) dthx = StrTetElep[jbin];
            if ( muon )     dthx = StrTetMup[jbin];
//                dthx = msTheta[jbin];
            passx = 1;
        }
        if ( !passy && libProb>randy )
        {
            if ( pplus )    dthy =  StrTetPip[jbin];
            if ( positron ) dthy =  StrTetElep[jbin];
            if ( muon )     dthy =  StrTetMup[jbin];
//                dthy = msTheta[jbin];
            passy = 1;
        }
    }
//             cout << dthx << " " << dthy <<" p " <<pr->P.mom;
//              cout << " angolo "<<sqrt(dthx*dthx+dthy*dthy)/pr->P.mom<< endl;
            
            
            
            

  
    pr->P.x += pr->P.norma*dthx;
    pr->P.y += pr->P.norma*dthy;
    pr->Vers=pr->P.Verso();
    
 if(Debugstraw>0) pr->P.print("p_dopo");


//-------------------------------------------------
//              D e g r a d o

// =======  Multiple Scattering energy loss =====

// do nothing if ....
    if ( Perdita ==0 )        return 0;    // no loss

    if ( nowpos==0 )       {
        Ro=Roint;
        Dedx=Dedxint;
    }
    else if ( nowpos==-1 ) {
        Ro=Robuc;
        Dedx=Dedxbuc;
    }
    else return 0;

    if ( Ro  == 0.0 )         return 0;  // no densita'
    if ( Dedx == 0.0 )        return 0;  // no Dedx

//  p=Puls.norma;
    double p=0.;
    double persa=0.0;
    persa= Dedx*tratok; //in GeV
    double ee=pr->P.e;
    if ( persa>= ( ee-pr->massa ) )
    {
        persa=ee-pr->massa;
        p=0.0;
        ee=pr->massa;
    }
    else
    {
        ee-=persa;
        p = sqrt ( ee*ee - pr->massa*pr->massa );
    }


    gvet Pscat=pr->Vers*p;
    pr->P.x=Pscat.x;
    pr->P.y=Pscat.y;
    pr->P.z=Pscat.z;
    pr->P.z = ee;
    pr->P.Norma();
    if ( Debugon==1 )
        Gout<<" de="<<setw ( 6 ) <<persa<<" P "<<setw ( 6 ) <<pr->P.norma;

// Gout<<"\n  Msc  "<<pr->nome<<" gnhit "<< gnhit<<" ghcir "<<ghcir;
    if ( rivela==0 ) Hits[nhit].e_rivela+=persa; // attenzione nello hit generato...
    return 0;
}
//==========================================================



//=============================================================
//-----> Lettura dati esterni
//===============================================================
// Strawlib no gaussian Multiscattering data  reading procedure
void Strawlib ( string Dir,string Nomef,double * &Tet, double **&Prob )
{

// Dir = cartella dei dati
// Nomef = nemo base dei nomi: pionplus, positron, muon.
// Tet puntatore agli angoli
// puntatore alla Prob

    if ( Tet!=0 )  //nothing to do ..allready done...
    {
        Gout<<"\n StrawLib for "<<Nomef<<" already done.";
        Gout<<"\n StrawLib for "<<Nomef<<" already done.";
        return;
    }

// first time here.. read the no gaussian  m.s. straw library data
//=====================================
//read data from files....to memorize data in memory.
//  int row=80; col=1200 array[raw][col];
// allocate memory for Tet[80]
    Tet= new  double[1200];
    // allocate memory for  Prob[80][1200];
    Prob= new double* [80];
    for ( int j = 0; j < 80; j ++ )
        Prob[j] = new double[1200];
//=====================================

    std::ifstream MSlibrary;
    char *Numero=new char[12];
//
    int j,k;
    double prb,msNcount[1200],msN;
    string Finput = string ( " " );
    for ( j=0;j<80;j++ )
    {
// the input file = path/
        sprintf ( Numero,"%d.db", ( j*1000+500 ) );
        Finput= Dir  + "/"+ Nomef + "_" + Numero;
        MSlibrary.open ( Finput.c_str(),ios::in );
        if ( MSlibrary.is_open() )
        {
            if ( j<1 ) Gout<<"\n Reading Straw lib: " << Finput;
            if ( j<1 ) Gout<<"\n Reading Straw lib: " << Finput;
        }
        else
        {
            Gout<<"\n The Straw lib: " << Finput
            <<" is missing  --> Controllare DevStraw::DevStraw() exit!";
            Gout<<"\n The Straw lib: " << Finput
            <<" is missing  --> Controllare DevStraw::DevStraw() exit!";
            exit ( 0 );
        }
        msN = 0;
        for ( k=0;k<1200;k++ )
        {
            MSlibrary >> Tet[k] >> msNcount[k];
            msN += msNcount[k];
        }
        MSlibrary.close();

        prb = 0;
        if ( !msN ) continue;
        for ( k=0;k<1200;k++ )
        {
            Prob[j][1199-k] = 1.-prb;
            prb += msNcount[1199-k]/msN;
        }
    }
    cout << "\n  MS library for Straw Chambers Loaded for " << Nomef<<endl;
    Gout << "\n  MS library for Straw Chambers Loaded for " << Nomef<<endl;
}

//========================================================================
//====================================================================
// costanti  della geometria per il posizionamento dei tubi.. !!
// Nota: calcolo solo se un tubo è stato attraversato e non;
// numero di tubi per piano: 112
const double Tubraggio= 0.4875;
const double passo=1.76;
const double d12=1.524;
const double d13=3.429;
const double d14=4.953;
const double XTref1= -55.5*passo;
const double XTref2= XTref1+passo/2.;
const double XTref3= XTref1+passo/4.;
const double XTref4= XTref1-passo/4.;
const double drifttime=150.0;
const double conv2time=drifttime/Tubraggio;
const double trailing_res=15.;
const double trailing_res_max=60.;   //new
const double tleading_res=6.;
const double tleading_res_max=150.0; //ns
const long   trigger_span=6; //ns   //new


int debugtubi=-1;

// Distanza in zeta del piano 2 dal piano 1  d12= sqrt(3/4)*passo=1.524 cm
// Distanza del piano 3 dal piano 1:         d13= sqrt(3/4)*(2*passo+pass4) =3.429 cm
// Distanza del piano 4 dal piano 1:         d14= sqrt(3/4)*(3*passo+pass4) =4.953 cm



//=====

int DevStraw::SimulaDev()
{


    tubiseen=ntub1=ntub2=ntub3=ntub4=0;
    for (int i=0;i<16;i++)     toc_tubo1[i]=toc_tubo2[i]=toc_tubo3[i]=toc_tubo4[i]=0;

 //   if (Eventi_Generati>6587&&Eventi_Generati<6589)debugtubi=1;
 //   else debugtubi=0;


 
    // simulaziome fili toccati

// calcolo dei delle straw attraversate
//
// Ricordo alcuni parametri geometrici
// passo = 1.76 cm uguale alla distanza tra i centri delle straw su di uno stesso piano
// Distanza in zeta del piano 2 dal piano 1  d12= sqrt(3/4)*passo=1.524 cm
// Distanza del piano 3 dal piano 1:         d13= sqrt(3/4)*(2*passo+pass4) =3.429 cm
// Distanza del piano 4 dal piano 1:         d14= sqrt(3/4)*(3*passo+pass4) =4.953 cm

// centro in x dello straw tube  più a destra  del piano 1: Xt= -basecm
// centro in x dello straw tube  più a destra  del piano 2: Xt= -104.56+passo/2  = -103.68 cm
// centro in x dello straw tube  più a destra  del piano 3: Xt= -104.56+passo/4 = -104.12 cm
// centro in x dello straw tube  più a destra  del piano 4: Xt= -104.56-passo/4 = -105.00 cm

    
    
 // reset
    tempo_trigger=0.0;
    long Tnano= evento_.Gen.tempo;
    tempo_trigger=double((Tnano/trigger_span)*trigger_span) + trigger_span/2.;  // tempo quantizzato??? in span di 6 ns
    
    
 
  if(debugtubi>0){ 
    Gout<<"\n\n\n Debug in Devstraw  Ev "<<Eventi_Generati<< " ========= Straw "<<nome<<" mhit "<< mhit<< " Time "<<tempo_trigger<<" \n";
  
  for(int i=0;i<mhit;i++) Gout<<" ["<<setw(8)<<M_Hits[i].pnome<<" "<<setw(8)<<M_Hits[i].Xlab.x<<" "<<setw(8)<<M_Hits[i].Xlab.y<<
                                " "<<setw(8)<<M_Hits[i].Xdev.x<<"]"; 
  }


    double X1=0.,X2=0.,X3=0.,X4=0., tgxz=0.;
//  Gout<<"\n Device "<<nome<<"  mhit "<<mhit<<"\n";

    for ( int k=0;k<mhit;k++ )
    {
// attenzione si lavora nel sistema del dev...

      Bufdev Hit_k=M_Hits[k]; // K-esimo Hit in esame.
    
//      if(debugtubi>0)   Hit_k.Xdev.print(Hit_k.pnome);   
     

        if(Hit_k.Pr->charg==0.) continue;  // skip the neutral particles

        gvet verso=Lab2Dev(Hit_k.Vers);
        tgxz=verso.x/verso.z;
        X1= Hit_k.Xdev.x ;
        double tempo_hit=Hit_k.tempo;

       
         
        
        
        int tb1=Set_tubo(ntub1,X1-XTref1,tempo_hit,tubo1,t_end_tb1,t_start_tb1,tmp_tubo1,toc_tubo1);
        X2= X1 + tgxz*d12;
        int tb2=Set_tubo(ntub2,X2-XTref2,tempo_hit,tubo2,t_end_tb2,t_start_tb2,tmp_tubo2,toc_tubo2);
        X3= X1 + tgxz*d13;
        int tb3=Set_tubo(ntub3,X3-XTref3,tempo_hit,tubo3,t_end_tb3,t_start_tb3,tmp_tubo3,toc_tubo3);
        X4= X1 + tgxz*d14;
        int tb4=Set_tubo(ntub4,X4-XTref4,tempo_hit,tubo4,t_end_tb4,t_start_tb4,tmp_tubo4,toc_tubo4);
         
         if(debugtubi>0) { 
           Gout<<setprecision(2)<<fixed;
         Gout<<"\n Hit "<<k<<" da "<<setw(8)<<Hit_k.Pr->Get_Nome()<<" x,y_dev "<<setw(8)<<Hit_k.Xdev.x<<" "<<setw(8)<<Hit_k.Xdev.y;
         
         if(tb1>-1) Gout<<" [p1 "<<setw(3)<<tubo1[tb1]<<" "<<setw(8)<<t_start_tb1[tb1]-tempo_hit<<"]";
         if(tb2>-1) Gout<<" [p2 "<<setw(3)<<tubo2[tb2]<<" "<<setw(8)<<t_start_tb2[tb2]-tempo_hit<<"]";
         if(tb3>-1) Gout<<" [p3 "<<setw(3)<<tubo3[tb3]<<" "<<setw(8)<<t_start_tb3[tb3]-tempo_hit<<"]";
         if(tb4>-1) Gout<<" [p4 "<<setw(3)<<tubo4[tb4]<<" "<<setw(8)<<t_start_tb4[tb4]-tempo_hit<<"]"; 
        }  
        

    }
    // set the errors....
    // prima di definire gli errori occorre conoscere come viene esattamente generato
    // il segnale di trailing e tleading.

    Set_tubi_errors(ntub1, t_start_tb1, t_end_tb1);
    Set_tubi_errors(ntub2, t_start_tb2, t_end_tb2);
    Set_tubi_errors(ntub3, t_start_tb3, t_end_tb3);
    Set_tubi_errors(ntub4, t_start_tb4, t_end_tb4);   
    
    tubiseen=ntub1+ntub2+ntub3+ntub4;
    
    if(debugtubi>0){
      Gout<<"\n Dopo gli errori. Piano [canale ,tleading, trailing]...";
      Print_debug_tubi();
    }
    
    
    
    nwire=0;
    if (tubiseen>1) Get_wire();

   if(debugtubi>0&&nwire>0)
    Gout<<"\n in "<<nome<<" [mhit "<<mhit<<" w "<<nwire <<"] tbs: "<<ntub1<<" "<<ntub2<<" "<<ntub3<<" "<<ntub4<<" TotTubi "<<tubiseen<<endl;

    return 1;

}
// ** Dedfinisce il tubo toccato e i parametri temporali...
int  DevStraw::Set_tubo(int &nb,double DX,double hit_time,int *tubo,double *T0, double *Ts, double *Tmp,int *Tcc)
{
    double tt0=0.0;
    double tts=0.0;
    double tth=0.0;
    if (nb>15)return 0;   // massimo num di tubi toccati per piano
    int  ntb =DX/passo +0.5;

    double  resto=  DX -ntb*passo ;   //distanza del punto dall'asse del tubo
    if ( fabs(resto) > Tubraggio) {
        //if(Eventi_Generati==28) Gout<<"\n Tublog "<< nome <<setw(3)<<nb<<" " <<setw(8)<<DX<< " resto "<<setw(8)<<resto;
        return -1;
    }

    double T0now=hit_time;                         // vero tempo dell'evento
    double Tsnow= hit_time+fabs(resto)*conv2time;  // calcolo del tempo di drift....


    // test tubi ...  già toccato??
    int toc=-1;
    for (int i=0;i<nb;i++) // loop sui tubi già memorizzati ( necessaria anche se pipeline è off)
    {
        if (tubo[i]==ntb)
        {
            toc=i;      //tubo "i" già toccato
            tt0=T0[i];
            tts=Ts[i];
            tth=Tmp[i];
            Tcc[i]++;
//            Gout<<"\n ev "<<Eventi_Generati<<" i "<<i <<" "<< ntb;
            break;
        }
    }



    // con o senza pipeline definisco un nuovo tubo
    if (toc==-1)
    {
        //       define new tubo...
        tubo[nb]=ntb;
        T0[nb]=T0now;    // t_end
        Ts[nb]=Tsnow;    // t_start
        Tmp[nb]=hit_time;
        nb++;
        return nb-1;
    }

    // qui solo se toc >-1 c'è sovrapposizione

// **********  se pipeline off aggiusto i tempi e ritorno.
    if (Pipeline==0)
    {

        //       Gout<<"\n ev "<<Eventi_Generati<<" toc "<<toc <<" "<< ntb<< " sovrapposizione!";
        if (T0now>tt0) T0[toc]=T0now;
        if (Tsnow<tts) Ts[toc]=Tsnow;
        return toc;
    }


//  c'è sovrapposizione .... ma non temporale ?

    if ( (tt0+drifttime)<Tsnow|| (T0now+drifttime)<tts )  // stesso tubo ma non c'è sovrapposizione temporale
    {
//       define new hit nello stesso tubo...
        tubo[nb]=ntb;
        T0[nb]=T0now;
        Ts[nb]=Tsnow;
        Tmp[nb]=hit_time;
        nb++;
        return nb-1;
    }

// stesso tubo e qui c'è sovrapposizione temporale

// ricordare la successione dei segnali: t_leading è la salita, t_trailing è alla fine impulso...
// quindi un impulso pileup (or di due impulsi o più!)  è in genera un segnale più largo...
// a sinistra la salita corrisponde al t-leading prima arrivato,
// mentre  a destra il t_trailing corrisponde all'ultimo arrivato...
    if (T0now>tt0) T0[toc]=T0now;
    if (Tsnow<tts) Ts[toc]=Tsnow;
    if (hit_time<tth) Tmp[toc]=hit_time;
    return toc;
}


//  errori temporali

void DevStraw::Set_tubi_errors(int ntot, double *Ts, double *T0)
{
    for (int itb=0;itb<ntot;itb++)
    {
        T0[itb]=Pgauss(trailing_res,T0[itb]);   // t-end
        Ts[itb]=Pgauss(tleading_res,Ts[itb]);   // t-start
    }
}
//=============
void DevStraw::Print_debug_tubi()
{
   
   if(ntub1>0)
   {Gout<<"\n P1";
  for(int i=0;i<ntub1;i++) 
    Gout<<" ["<<setw(3)<<tubo1[i]<<" "<<setw(8)<<t_start_tb1[i]-tempo_trigger<<" "<<setw(8)<<t_end_tb1[i]-tempo_trigger<<"]";
  }
  
  
   if(ntub2>0)
   {Gout<<"\n P2";
  for(int i=0;i<ntub2;i++) 
    Gout<<" ["<<setw(3)<<tubo2[i]<<" "<<setw(8)<<t_start_tb2[i]-tempo_trigger<<" "<<setw(8)<<t_end_tb2[i]-tempo_trigger<<"]";
  }
  
  
   if(ntub3>0)
   {Gout<<"\n P3";
  for(int i=0;i<ntub3;i++) 
    Gout<<" ["<<setw(3)<<tubo3[i]<<" "<<setw(8)<<t_start_tb3[i]-tempo_trigger<<" "<<setw(8)<<t_end_tb3[i]-tempo_trigger<<"]";
  }
  
   if(ntub4>0)
   {Gout<<"\n P4";
  for(int i=0;i<ntub4;i++) 
    Gout<<" ["<<setw(3)<<tubo4[i]<<" "<<setw(8)<<t_start_tb4[i]-tempo_trigger<<" "<<setw(8)<<t_end_tb4[i]-tempo_trigger<<"]";
  }
  
  
  
  
}
//*********************************************************************

void DevStraw::Get_wire()
{

    if (mhit<1) return;

    for (int i=0;i<16;i++) use_tubo1[i]=use_tubo2[i]=use_tubo3[i]=use_tubo4[i]=-1;
    for (int i=0;i<16;i++)
    {
        Wiret12[i]=Wiret34[i]=Wireout[i]=0.0;
        Wirecoor[i]=Wiredtim[i]=Wiretraild[i]=Wiretrails[i]=Wiredtempo[i]=0.0;
    }


    if (debugtubi==1) Gout<<"\n\n  Get Wire summary in "<<nome;
//******************************************************************************
// nuovo metodo! to select tubes
    nwire=0;
    
    

    int can1,can2,can3,can4;
    int bit1,bit2,bit3,bit4;
 //   int base;
    
    
     for (int ht1=-1;ht1<ntub1;ht1++)
    {
     bit1=0;
     can1=-1;
    if (ht1>-1) {
       can1=tubo1[ht1];
       bit1=1;
         }
    
       for (int ht2=-1;ht2<ntub2;ht2++)
    {
     bit2=0;
     can2=-1;
    if (ht2>-1) {
       can2=tubo2[ht2];
       bit2=1;
         }
         
       for (int ht3=-1;ht3<ntub3;ht3++)
    {
     bit3=0;
     can3=-1;
    if (ht3>-1) {
       can3=tubo3[ht3];
       bit3=1;
         }
         
    for (int ht4=-1;ht4<ntub4;ht4++)
    {
     bit4=0;
     can4=-1;
    if (ht4>-1) {
       can4=tubo4[ht4];
       bit4=1;
         }   
         
       int tcode= bit1*8+bit2*4+bit3*2+bit4;   
       
         
       if(Check_code(tcode,can1,can2,can3,can4)<0) continue;  
         
   if (debugtubi==1)
                    {
                      
                        Gout<<"\n Can "<<setw(3)<<can1<<" "<<setw(3)<<can2<<" "<<setw(3)<<can3<<" "<<setw(3)<<can4;
             //           Gout<<" Bbs "<<setw(2)<<bit1<<" "<<setw(2)<<bit2<<" "<<setw(2)<<bit3<<" "<<setw(2)<<bit4;
                        Gout<<" cd "<<setw(2)<< tcode;
                    }
                    
      Define_wire(ht1,ht2,ht3,ht4, tcode);       
         
            
    }}}}
    


   // verifico se l'evento nella camera è stato costruito con pileup

    flag_pileup=0;

    for (int i=0;i<nwire;i++)
    {
        if (Wiredtempo[i]!=0)
            flag_pileup++;
    }


}


// check code

int  DevStraw::Check_code(int tcode, int can1,int can2,int can3,int can4)
{
 
//************************************************************
//    definizione  tcode   (can è il canale toccato nei piani 1,2,3,4
//------         pn1   pn2   pn3  pn4     tcode
//canale         0     can   0    can+1   5
//               0     can   can  0       6
//               0     can   can  can+1   7   
//               can   0     0    can     9
//               can   0     can  0      10
//               can   0     can  can    11
//               can   can-1 0    can    13
//               can   can   can  0      14
//************************************************************* 
     int ok=-1;
    switch (tcode)
    {
      case 5:
      if(can2+1==can4)ok=1; 
      break;
      case 6:
      if(can2==can3)ok=1; 
      break;
      case 7:
      if(can2==can3&&can2+1==can4) ok=1;
      break;
      case 9:
      if(can1==can4)ok=1; 
      break;
      case 10:
      if(can1==can3)ok=1;  
      break;
      case 11:
      if(can1==can3&&can1==can4) ok=1;
      break;
      case 13:
      if(can1-1==can2&&can1==can4) ok=1;
      break; 
      case 14:
      if(can1==can3&&can1==can2) ok=1;
      break;
      default:
      break;
}
return ok;

}


int  DevStraw::Define_wire(int ht1,int ht2,int ht3,int ht4, int tcode)
{

//************************************************************
//    definizione  tcode   (can è il canale toccato nei piani 1,2,3,4
//------         pn1   pn2   pn3  pn4     tcode
//canale         0     can   0    can+1   5
//               0     can   can  0       6
//               0     can   can  can+1   7   
//               can   0     0    can     9
//               can   0     can  0      10
//               can   0     can  can    11
//               can   can-1 0    can    13
//               can   can   can  0      14
//*************************************************************

    double tend1,tend2,tend3,tend4;
    double tstr1,tstr2,tstr3,tstr4;
    tend1=tend2=tend3=tend4=tstr1=tstr2=tstr3=tstr4=0.0;
    double xwr,xwrout;
    double tstart12,tstart34, tdrift,tend12,tend34;
    tstart12=tstart34=tdrift=tend12=tend34=0.0;
    
// canali , tempi di drift (tleading), tempi di end ( trailing) e test sul trailing...
    if (debugtubi==1)Gout<<setprecision(2)<<" [Te";
    int c1=-1,c2=-1,c3=-1,c4=-1;
    if (ht1>-1) {
        c1=tubo1[ht1];
        tstart12=tstr1=t_start_tb1[ht1]-tempo_trigger;
        tend12=tend1=t_end_tb1[ht1]-tempo_trigger;
        if (debugtubi==1)Gout<<" "<<setw(8)<<tend1;
        if ( fabs(tend1)>trailing_res_max)return 0;
    }
    if (ht2>-1) {
        c2=tubo2[ht2];
        tstart12=tstr2=t_start_tb2[ht2]-tempo_trigger;
        tend12=tend2=t_end_tb2[ht2]-tempo_trigger;
        if (debugtubi==1)Gout<<" "<<setw(8)<<tend2;
        if ( fabs(tend2)>trailing_res_max)return 0;
    }
    if (ht3>-1) {
        c3=tubo3[ht3];
        tstart34=tstr3=t_start_tb3[ht3]-tempo_trigger;
        tend34=tend3=t_end_tb3[ht3]-tempo_trigger;
        if (debugtubi==1)Gout<<" "<<setw(8)<<tend3;
        if ( fabs(tend3)>trailing_res_max)return 0;
    }
    if (ht4>-1) {
        c4=tubo4[ht4];
        tstart34=tstr4=t_start_tb4[ht4]-tempo_trigger;
        tend34=tend4=t_end_tb4[ht4]-tempo_trigger;
        if (debugtubi==1)Gout<<" "<<setw(8)<<tend4;
        if ( fabs(tend4)>trailing_res_max)return 0;
    }
    if (debugtubi==1)Gout<<setprecision(2)<<"] [Td ";
    switch (tcode)
    {

//case   5,6,9,10, but  7,11,13,14;

    case 5:    // secondo e quarto piano toccati

 //       if (c2==c4)return 0; //in questa configurazione il quarto canale è diverso di + una unità dal... vediu Check_code 
//test di compatibilità temporale
        tdrift=tstart12+tstart34;
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        xwr= tubo2[ht2]*passo+XTref2 + tstr2/conv2time;   // attento al segno
        xwrout=tubo4[ht4]*passo+XTref4 - tstr4/conv2time;


        break;

    case 6:    // secondo e terzo piano toccati
//test di compatibilità temporale
        tdrift=tstart12+tstart34;  
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;
        if ( fabs(tend4)>trailing_res_max)return 0;
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        xwr= tubo2[ht2]*passo+XTref2 - tstr2/conv2time;
        xwrout=tubo3[ht3]*passo+XTref3 + tstr3/conv2time;
        break;



    case 9:   // primo e quarto
        tdrift=tstart12+tstart34; 
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        xwr= tubo1[ht1]*passo+XTref1 - tstr1/conv2time;   // attento al segno
        xwrout=tubo4[ht4]*passo+XTref4 + tstr4/conv2time;

        break;


    case 10:   // primo e terzo
        tdrift=tstart12+tstart34;    
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        xwr= tubo1[ht1]*passo+XTref1 + tstr1/conv2time;   // attento al segno
        xwrout=tubo3[ht3]*passo+XTref3 - tstr3/conv2time;

        break;
  
 ///================
 /// colpiti anche tre piani.....si verifica se si ottiene valori temporali migliori...       

    case 7:    // secondo, terzo  e quarto piano toccati

//test di compatibilità 

//        if (c2==c4)return 0; //in questa configurazione il quarto canale è diverso ... vedi Check_code 
        tend34=0.33*(tend2+tend3+tend4);
        tstart34=0.5*(tstr3+tstr4);
        tdrift=tstart12+tstart34;  
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;   
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        if (fabs(tstr3+tstr4-2.*drifttime)>+.7*tleading_res_max) return 0;
        xwr= tubo2[ht2]*passo+XTref2 - tstr2/conv2time;
        xwrout=tubo4[ht4]*passo+XTref4 - tstr4/conv2time;


        break;

    case 11:   // primo,terzo e quarto 

        tend34=0.33*(tend1+tend3+tend4);                        //media 
        tstart34=0.5*(tstr3+tstr4);                      //media perche la tracciia sfiora i due tubi....
        tdrift=tstart12+tstart34; 
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;   
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        if (fabs(tstr3+tstr4-2.*drifttime)>+.7*tleading_res_max) return 0;
        xwr= tubo1[ht1]*passo+XTref1 + tstr1/conv2time;   // attento al segno
        xwrout=tubo4[ht4]*passo+XTref4 + tstr4/conv2time;
        break;

    case 13:  // primo, secondo e quarto
//       if (c2==c1)return 0; //in questa configurazione il secondo  canale è can-1 vedi Check_code
        tend12=0.33*(tend1+tend2+tend4);
        tstart12=0.5*(tstr1+tstr2);
        tdrift=tstart12+tstart34; 
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        if (fabs(tstart12-drifttime)>+.7*tleading_res_max) return 0;
//        xwr= tubo1[ht1]*passo+XTref1 - tstr1/conv2time;   // attento al segno
        
         xwr= 0.5*(tubo2[ht2]*passo+XTref2+ tubo1[ht1]*passo+XTref1)+ (tstr2-tstr1)*Tubraggio/(tstr2+tstr1);
        
        xwrout=tubo4[ht4]*passo+XTref4 - tstr4/conv2time;
        break;

    case 14:   // primo secondo e terzo
        tend12=0.33*(tend1+tend2+tend3);
        tstart12=0.5*(tstr1+tstr2);
        tdrift=tstart12+tstart34;  
        if (debugtubi==1)Gout<<setprecision(2)<<setw(8)<<tdrift;
        if ( fabs(tdrift-drifttime)>tleading_res_max) return 0;
        if (fabs(tstart12-drifttime)>+.7*tleading_res_max) return 0;
  ///      xwr= tubo1[ht1]*passo+XTref1 + tstr1/conv2time;   // attento al segno
        
        
         xwr= 0.5*(tubo2[ht2]*passo+XTref2+ tubo1[ht1]*passo+XTref1)+ (tstr1-tstr2)*Tubraggio/(tstr1+tstr2);
        
        xwrout=tubo3[ht3]*passo+XTref3 + tstr3/conv2time;

        break;
    default:
      
       if (debugtubi==1)Gout<<"]";
        return 0;
    }
 if (debugtubi==1)Gout<<"]";
    if (debugtubi==1)Gout<<setprecision(3)<<setw(8)<<" Xwx "<<setw(8)<<xwr<<" "<<setw(8)<<xwrout;

    // check per coordinate già definite...
    int icur=nwire,iold=-1;

    for (iold=0;iold<nwire;iold++)
    {
        double xwold= Wirecoor[iold];
        double xwout= Wireout[iold];
        
        if ( fabs(xwr-xwold)>0.45||fabs(xwrout-xwout)>0.45) continue;   

        // which the best....
        if (fabs(tdrift-drifttime)<fabs(Wiredtim[iold]-drifttime)) { // the best is the new one
            if (debugtubi==1)Gout<<" **Rpl "<<iold<<" with this" ;
            icur=iold;
            break;
        }
        else
        {   // here  we do nothing...
            if (debugtubi==1)Gout<<" **Fnd at  "<<iold;
            return 1;
        }

    }
// define the wire if new or replace the old one if the present is better in drift time...
// icur== nwire for a new wire definition; icur<nwire for replacing...
//    int wplan1[16],wplan2[16],wplan3[16],wplan4[16];
//    int nwire;
//    float Wirecoor[16],Wirecout[16],Wiredtim[16],Wiretraild[16],Wiretrails[16], Wiredtempo[16];  // coordinate del filo colpito....calcolo in simuladev.
//    float  Wiret12[16],Wiret34[16];


    double temp12=0.0;
    if (ht1>-1)temp12=tmp_tubo1[ht1];
    else if (ht2>-1)temp12=tmp_tubo2[ht2];
    Wirecoor[icur]=xwr;
    Wireout[icur]=xwrout;
    Wiret12[icur]=tstart12;
    Wiret34[icur]=tstart34;
    Wiredtim[icur]=tdrift;
    Wiretraild[icur]=tend34-tend12;
    Wiretrails[icur]=tend34+tend12;
    Wiredtempo[icur]=evento_.Gen.tempo-temp12;
    wplan1[icur]=c1;
    wplan2[icur]=c2;
    wplan3[icur]=c3;
    wplan4[icur]=c4;

    if (icur==nwire) nwire++;


    return 1;
}




