/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 05.09.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/
#ifndef DEVSTRAW_H
#define DEVSTRAW_H

#include <devrtrt.h>

/**
   @author Gmp
**/

class DevStraw : public DevRtRt
{
private:

 //   double Xwire[16],Xwiredtim[16],Xwiretraildiff[16],Xwiretrailsom[16],Xwiredtempo[16];


    double Totdriftsav,Trailingsomma,Trailingdiff;
    double Tstart12,Tstart34;
    double segno34;
    double tempo_trigger;


public:
    DevStraw *upstraw,*nextstraw;
    DevStraw();
    ~DevStraw();
    void Prgeom();
    int Mscatter ( Particella *, double ) ;
    int SimulaDev();
    int  Set_tubo(int &nb,double DX,double hit_time,int *tubo,double *T0, double *Ts, double *Tmp,int *Tcc);
    void Set_tubi_errors(int itb, double *Ts, double *T0);
    void Print_debug_tubi();
    void Get_wire();
    int Check_code(int,int,int,int,int);
    int  Define_wire(int ic1,int ic2,int ic3,int ic4, int tcode);


// informazioni anche per root
    int tubiseen,flag_pileup;
    int ntub1,tubo1[16],use_tubo1[16] ,toc_tubo1[16];
    int ntub2,tubo2[16],use_tubo2[16] ,toc_tubo2[16];
    int ntub3,tubo3[16],use_tubo3[16] ,toc_tubo3[16];
    int ntub4,tubo4[16],use_tubo4[16] ,toc_tubo4[16];

    double t_start_tb1[16],t_end_tb1[16],tmp_tubo1[16];  //t_strat, t_end,t_tempo
    double t_start_tb2[16],t_end_tb2[16],tmp_tubo2[16];
    double t_start_tb3[16],t_end_tb3[16],tmp_tubo3[16];
    double t_start_tb4[16],t_end_tb4[16],tmp_tubo4[16];

//

    int nwire;
    int wplan1[16],wplan2[16],wplan3[16],wplan4[16];
    float Wirecoor[16],Wireout[16],Wiredtim[16],Wiretraild[16],Wiretrails[16], Wiredtempo[16];  // coordinate del filo colpito....calcolo in simuladev.
    float  Wiret12[16],Wiret34[16];

};

// data  pointer
#if defined(MAIN)
DevStraw *FirstStraw=0;
// puntatori ai dati per il multiplescattering corretto.
double *StrTetPip=0;
double *StrTetElep=0;
double *StrTetMup=0;
double **StrProbPip=0;
double **StrProbElep=0;
double **StrProbMup=0;

DevStraw *St1x=0, *St1y=0, *St1u=0, *St1v=0, *St2x=0, *St2y=0, *St2u=0, *St2v=0;
DevStraw *St3x=0, *St3y=0, *St3u=0, *St3v=0, *St4x=0, *St4y=0, *St4u=0, *St4v=0;


#endif
#if !defined(MAIN)
extern DevStraw *FirstStraw;
extern double *StrTetPip;
extern double *StrTetElep;
extern double *StrTetMup;
extern double **StrProbPip;
extern double **StrProbElep;
extern double **StrProbMup;

extern DevStraw *St1x, *St1y, *St1u, *St1v, *St2x, *St2y, *St2u, *St2v;
extern DevStraw *St3x, *St3y, *St3u, *St3v, *St4x, *St4y, *St4u, *St4v;



#endif

#endif

