/***************************************************************************
                          inout.cpp  -  description
                             -------------------
    begin                :02.09.2011
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA62..... M.C.  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
// procedura Get_cam in sviluppo  dal  25.08.2011

#define CEPSI 1.0e-6
#include "flyoh.h"

//        Tirrenia   GmP 4.09.
#include <ctype.h>

#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1
#define EPSR     1.0E-200

using namespace GmpConst;
using namespace std;


double sinPhi=0.0, cosPhi=1.0;

void Device::Leggi_schede_dev()
{
    // legge  le schede di definizione...
    string stringline,label,label2,nosi;
    char line[128];
    double ax,ay,az;
    int centro_dato= 0;

    Cardcur->getline ( line, 128 );
    while ( !Cardcur->eof() )
    {

        stringline=line;
        stringstream scheda;
        scheda<<line;
        scheda>>label;

        if ( Dbginput==1 )
        {
            Gout<<"\n Label: "<<label<<"  riga:"<<line<<flush;
        }

        if ( stringline.size()      <1  ||
                label.find ( "**" )  ==0  ||
                label.find ( "\\\\" ) ==0  ||
                label.find ( "//" )  ==0 )
        {
            Cardcur->getline ( line, 128 );
            continue;
        } //line empty or comment ...read next line


        if ( label.find ( "device" ) == 0 )
        {
            Gout<<"\n Label: "<<label<<"  riga:"<<line<<flush;
            Gout<<"\n Device card out of sequence !!!\n "<<flush;
            cout<<"\n Device card out of sequence !!!\n "<<flush;
            exit ( 0 );
        }
        else if ( label.find ( "nome" ) == 0 )
        {
            scheda>>nome>>nickname;
        }




        else if ( label.find ( "flags" ) == 0 ||
                  label.find ( "fun" ) == 0 )
        {
            label="";
            scheda>>label;
            if ( label.find ( None ) == 0 )  fun = None;
            else if ( label.find ( Trig ) == 0 )   fun = Trig;
            else if ( label.find ( Veto ) == 0 )  fun = Veto;
            else if ( label.find ( Magn ) == 0 )  fun = Magn;
            else if ( label.find ( Trigh ) == 0 )  fun = Trigh;
            else if ( label.find ( Dead ) == 0 )   fun = Dead;
            else if ( label.find ( Dump ) == 0 )  fun = Dump;
            else if ( label.find ( Gasint ) == 0 ) fun =  Gasint;
            else if ( label.find ( Bersaglio ) == 0 ) fun =  Bersaglio;
            else
            {
                Gout<<"\n Device "<<nome<< "... flags error:  "<<label;
                exit ( 0 );
            }
        }

        else if ( label.find ( "extrawork" ) == 0 ) {
            extrawork=1;
            cout<<"\n Abilitato un extra work in "<<nome;
            Gout<<"\n Abilitato un extra work in "<<nome;
        }

        else if ( label.find ( "detect" ) == 0 )
        {
            if ( nvede< 20 )
            {
                label="";
                scheda>>label;
                nvede++;
                const char *ptm;
                if ( ( ptm = Matter->Ptbsdat ( label.c_str() ) ) != 0 )
                {
                    vede[nvede] = ptm;
                }
                else if ( label.find ( All ) == 0 )  vede[nvede] = All;
                else if ( label.find ( Char ) == 0 ) vede[nvede] = Char;
                else if ( label.find ( Neut ) == 0 ) vede[nvede] = Neut;
                else
                {
                    Gout<<"\n Device parameter error ==> "<< label<<endl;
                    cout<<"\n Device parameter error ==> "<< label<<endl;
                    exit ( 0 );
                }
                assorb[nvede]=0;
                label="";
                scheda>>label;
                if ( label.size() !=0 )
                {
                    if ( label.find ( "enevd" ) ==0 ) assorb[nvede]=1;
                    else if ( label.find ( "dump" ) ==0 ) assorb[nvede]=2; // dump ma registra
                    else if ( label.find ( "noreg" ) ==0 ) assorb[nvede]=3; // non registra
                    else if ( label.find ( "cdump" ) ==0 ) assorb[nvede]=4; // dump ma non registra
                }
            }
        }


        else if ( label.find ( "esclu" ) == 0 )
        {
            escludi=1;
            accedi=100;
            Gout<<"\n dev "<<nome<< " esluso by user ... ";
        }
        else if ( label.find ( "writeout" ) == 0 ) wrout=1;

        else if ( label.find ( "buffer" ) == 0 ) // working buffer: standard 30
        {
            scheda>>working_buffer;

        }



        else if ( label.find ( "centro" ) == 0 )
        {
            if ( centro_dato!=0 )
            {
                Gout<<"\n  Error: centro duplicato! in dev "<< idev<<endl;
                exit ( 1 );
            }
            centro_dato=1;
            scheda>>ax>>ay>>az;
            Centro.setvn ( ax,ay,az );
            Centro=Centro-Lab_Zero;
            Centro.Norma();
        }
        else if ( label.find ( "cface" ) == 0 ) // coord.centro superficie di ingresso
        {
            if ( centro_dato!=0 )
            {
                Gout<<"\n  Error: centro or cface duplicato! in dev "<< idev<<endl;
                exit ( 1 );
            }
            centro_dato=2;
            scheda>>ax>>ay>>az;
            Cface.setvn ( ax,ay,az ); 
            Cface=Cface-Lab_Zero;
            Cface.Norma();

        }
        else if ( label.find ( "centrin" ) == 0 )   // centro del buco...coordinate interne
        {
            scheda>>ax>>ay>>az;
            Centrin.setvn ( ax,ay,az );
        }
        else if ( label.find ( "versx" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Nx.setvn ( ax,ay,az );
        }
        else if ( label.find ( "versy" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Ny.setvn ( ax,ay,az );
        }
        else if ( label.find ( "versz" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Nz.setvn ( ax,ay,az );
        }
        else if ( label.find ( "rotap" ) == 0 ||label.find ( "rotaz" ) == 0)  // rotazioni
        {
            // per rotazioni più complesse occorre cambiare il codice...
            //per il momento si fa una unica rotazione attorno ad un asse x,y,o z.
            double Phi;   // in gradi
            scheda>>Phi;
            Phi*=PiGreco/180.;
            sinPhi = sin ( Phi );
            cosPhi = cos ( Phi );
// la rotazione è attorno all'asse zeta del laboratorio...
// ridefinisco i versori del device rispetto al sistema del lab.
            Nx.setvn ( cosPhi, sinPhi,0.0 );
            Ny.setvn ( -sinPhi, cosPhi,0.0 );
            Nz.setvn ( 0.0,    0.0,   1.0 );
        }                                          // END RUGGIERO


        else if (label.find ( "rotay" ) == 0)  // rotazioni
        {
            double Phi;   // in gradi
            scheda>>Phi;
            Phi*=PiGreco/180.;
            sinPhi = sin ( Phi );
            cosPhi = cos ( Phi );
// la rotazione è attorcosPhi);no all'asse y
// ridefinisco i versor  0.0 );i del device rispetto al sistema del lab.

            Nx.setvn (cosPhi,  0.0,  -sinPhi);
            Ny.setvn ( 0.0,    1.0,     0.0 );
            Nz.setvn (sinPhi,  0.0,   cosPhi);

        }


        else if ( label.find ( "rotax" ) == 0)  // rotazioni
        {
            double Phi;   // in gradi
            scheda>>Phi;
            Phi*=PiGreco/180.;
            sinPhi = sin ( Phi );
            cosPhi = cos ( Phi );
// la rotazione è attorno all'asse x
// ridefinisco i versori del device rispetto al sistema del lab.

            Nx.setvn ( 1.0,    0.0,  0.0 );
            Ny.setvn (0.0 ,  cosPhi, sinPhi);
            Nz.setvn (0.0,  -sinPhi, cosPhi);
        }

        else if ( label.find ( "substr" ) == 0  )
        {
            scheda>>nosi;
            if (nosi=="yes"||nosi=="si"||nosi=="y")
                strutture_interne=1;
            else if (nosi=="no"||nosi=="not") strutture_interne=0;
            else
            {
                Gout<<"\n strutture_interne mal definite "<<nosi;
                exit(0);
            }
        }



        else if ( label.find ( "sizein" ) == 0 ||
                  label.find ( "rin" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Lin.setvn ( ax,ay,az );
        }

        else if ( label.find ( "totin" ) == 0 ||
                  label.find ( "dtin" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Lin.setvn ( ax*.5, ay*.5, az*.5 );
        }

        else if ( label.find ( "sizeout" ) == 0 ||
                  label.find ( "rout" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Lout.setvn ( ax,ay,az );
            Devsize=Lout.norma*1.1;
        }
        else if ( label.find ( "totout" ) == 0 ||
                  label.find ( "dtout" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Lout.setvn ( ax*.5,ay*.5,az*.5 );
            Devsize=Lout.norma*1.1;
        }

        else if ( label.find ( "sfdim") == 0 )  // sfera
        {
            scheda>>ax>>ay>>az;
            Sfera.setvn( ax,ay,az);
            Lout.setvn ( ax,ax,ax);
            Lin.setvn ( ay,ay,ay);
            Devsize=Lout.norma*1.1;
        }



        else if ( label.find ( "opens" ) == 0 )
        {
            scheda>> OpenSector;
            OpenSector*= 0.017453293;
        }
        else if ( label.find ( "fortax" ) == 0 )
            // per definire dimensioni semiapertura del foro finale  interno dei tax
        {
            scheda>>ax>>ay>>az;
            Fortax.setvn ( ax,ay,az );
        }

        else if ( label.find ( "field" ) == 0 )
        {
            scheda>>ax>>ay>>az;
            Field.setvn ( ax,ay,az );
            Bref=ax;
            Field_sav=Field;
        }
        else if ( label.find ( "vfiel" ) == 0 )
        {
            //      Bref e posizione valore di riferimento del campo
            //      per il focussing quadrupoli.....
            scheda>>Bref ;
            scheda>>Dbref;
            Field.setvn ( Bref,0.0,0.0 );
            Field_sav=Field;
        }
        else if ( label.find ( "magki" ) == 0 )
            scheda>>reckik;
        else if ( label.find ( "mem" ) == 0 )
        {
            scheda>> t_dead_mem ;
            if ( Tpipe<t_dead_mem ) Tpipe=t_dead_mem;
        }

        else if ( label.find ( "registra" ) == 0 )
        {
            scheda>> label;
            if ( label=="no" ) registra=0;  //default=1;
        }

        else if ( label.find ( "materiali" ) == 0 )
        {

            scheda>>mattint>>mattbuc;
            Get_Materiali();
        }
        else if ( label.find ( "brems" ) == 0 ) scheda>>maxBrems;
        else if ( label.find ( "pair" ) == 0 ) scheda>>maxPair;

        //--------------------------------------------------
        //  the  following procedure is obsolate
        else if ( label.find ( "radi" ) == 0 )
        {
            Gout<<"\n In dev "<<nome
            <<"  \"radi\" too old ... to be subtituted by \"materiali\" card ...thanks " ;
        }
        else if ( label.find ( "dens" ) == 0 )
        {
            Gout<<"\n In dev "<<nome
            <<"  \"dens\" too old ... to be subtituted by \"materiali\" card ...thanks ";
        }
        //----------------------------------------------------


        //exit dev generation
        else if ( label.find ( "end" ) == 0 ||
                  label.find ( "done" ) == 0 )
        {
            if ( centro_dato==2 ) // calcolo il vero centro del dev
            {
                Centro=Cface;
                Centro.z+=Lout.z;
                Centro.Norma();
            }
            else if ( centro_dato==1 )
            {
                Cface=Centro;
                Cface.z-=Lout.z;
                Cface.Norma();
            }
            else
            {
                Gout<<"\n Error: Missing centro in dev "<<idev<<endl;
                exit ( 1 );
            }

            if ( escludi==1 ) wrout=0;

// attenzione  aggiustamento memoria di lavoro se richieste dimensioni maggiori di 30 !!!!!!!
// device buffers: local, circular, after dev simulation and measured buffer for root using.
// standard dim=30

            Make_working_buffer ( working_buffer );
            Make_measur_buffer ( working_buffer );


            return;
        }
        //  next for debug.....
        else if ( label.find ( "stopr" ) == 0 )
        {
            Gout<<"\n Stop run by operator. "<<endl;
            cout<<"\n Stop run by operator. "<<endl;
            exit ( 0 );
        }
        Cardcur->getline ( line, 120 );
    }




}


//--------------------------------------------
void Device::Dev_summary()
{
    if ( Tot_seen!=0 && escludi!=1 )
    {
        int ns;
        for ( int i=0;i<40;i++ ) if ( ( ns=Part_hit[i] ) !=0 )
            {
                Gout.setf ( ios::fixed, ios::floatfield );
                Gout<<"\n Dev "
                <<setw ( 10 ) <<nome
                <<" "<<setw ( 3 ) <<idev
                <<" sees "<<setw ( 9 ) <<ns
                <<"  "<<setw ( 6 ) <<vede[i]
                <<"   Tot: "<<setw ( 9 ) <<Tot_seen<<setprecision ( 2 )
                <<"  Z_lim.["<<setw ( 8 ) <<Centro.z-Lout.z
                <<" <---> "<<setw ( 8 ) <<Centro.z+Lout.z<<"]"<<flush;
            }
    }
    if ( next!=0 ) next->Dev_summary(); //iterate !

}

//-------------------------------------------

void Device::PrgeomId()
{

    if ( this==Apparato )
    {
        Gout<<"\n\n==================  Detectors block =====================\n";
        Gout<<"\n   Id     nome   nikname  exl.    Norma_in  Norma_out  Wrbf   type \n";
    }
    Gout.setf ( ios::fixed, ios::floatfield );
    Gout<<setprecision ( 2 ) <<"\n "<<setw ( 3 ) <<idev
    <<setw ( 10 ) <<nome<<"   ["<<setw ( 6 ) <<nickname<<"] "
    <<" "<<escludi
    << "    "<<setw ( 8 ) << Centro.Norma()
    << "    "<<setw ( 8 ) << (Cface+2.*Lout).Norma()
    << " "<<setw ( 4 ) <<working_buffer
    << "   "<<setw ( 4 ) <<devtype<<" <=> "<<devclass;
    if ( next!=0 ) next->PrgeomId();
    else Gout<<"\n===========  End apparatus list   ============\n \n \n";
}


void Device::Prgeom()
{


    Gout<<"\n Dev   Id ="<<setw ( 4 ) <<idev
    <<"\n Dev Type ="<<setw ( 4 ) <<devtype
    <<"\n Nome = "<<nome<< "    Nik: "<<nickname;
    if ( escludi==1 ) Gout<<"\n\n Rivelatore  E S C L U S O  dall'utente";

    Gout<<endl;
    if ( Cface.norma>0. )
        Cface.print ( "S.Lab" );
    Centro.print ( "C_lab" );
    gvet Cfine(0.0,0.,Lout.z);
    Cfine=Devc2Lab(Cfine);
    Cfine.print ( "E.Lab" );
    Lout.print ( "Lout" );
    if ( Lin.norma>0. )
    {
        if ( Centrin.norma>0. ) Centrin.print ( "C_in" );
        Lin.print ( "Lin" );
        double dtet=Lin.x/Cfine.z;
        Gout<<" Dtx(mrad) = "<<dtet*1000.;
        dtet=Lin.y/Cfine.z;
        Gout<<" Dty(mrad) = "<<dtet*1000.;
        double dw=PiGreco*Lin.x*Lin.y/(Centro.z*Centro.z);
        Gout<<" Dw (micStr) = "<<dw*1000000.;
    }

//cordinate nel lab






    if ( Fortax.norma>0. )
    {
        Fortax.print ( "Linend" );
    }
    Gout<<endl;
    Nx.print ( "Nx" );
    Ny.print ( "Ny" );
    Nz.print ( "Nz" );
    //campo.....
    if ( strutture_interne>0. )
    {
        Gout<<"\n Ci son strutture interne annidate !";
    }

    if ( campo==0 ) Field.print ( "Field" );
    if ( campo==1 ) Gout<<"\n Bref                "<<setprecision ( 3 ) <<fixed<<setw ( 11 ) <<Bref;
    if ( campo==2 ) Gout<<"\n Campo magnetico variabile!";
    if ( campo==0 ) Gout<<"\n Reconstruction magic kik "<< setw ( 7 ) <<reckik;
    Gout<<"\n Memoria in ns             "<<setw ( 6 ) <<t_dead_mem;
    Gout<<"\n Working buffers           "<<setw ( 6 ) <<working_buffer;
    if ( wrout==1 ) Gout<<"\n Writeout ok";
    else Gout<<"\n Writeout off...";
    Gout<<"\n Radiation  lenghts list: "<<lradi<<" " <<lradb<<" "<<liint<<" "<<libuc;

    Gout<<endl;
    Gout.setf ( ios::floatfield );
    if ( lradi != 0.0 || lradb != 0.0 ||liint!=0.0||libuc!=0.0)
    {
        Gout.setf ( ios::right,ios::adjustfield );
        Gout<<setfill ( ' ' ) <<setprecision ( 5 )
        <<"\n Dev  stuff:           "<<setw ( 10 ) <<mattint<<"  in hole: "<<setw ( 10 ) <<mattbuc<<"  "
        <<"\n DensInt, DensBuco     "<<setw ( 10 ) <<Roint<<"  "<<setw ( 10 ) <<Robuc<<"  g/cm3"
        <<"\n Zint, Zbuc            "<<setw ( 10 ) <<Zint <<"  "<<setw ( 10 ) <<Zbuc<<"  Atom. charges"
        <<"\n Aint, Abuc            "<<setw ( 10 ) <<Aint <<"  "<<setw ( 10 ) <<Abuc<<"  Atom. Numbers"
        <<"\n Radin,Radb            "<<setw ( 10 ) <<lradi<<"  "<<setw ( 10 ) <<lradb<<"  "
        << ( Scatter==0?"M.S. off":"M.S. on " )
        <<"\n InterInt,InterBuco    "<<setw ( 10 ) <<liint<<"  "<<setw ( 10 ) <<libuc
        <<"\n Dedxint,Dedxbuc       "<<setw ( 10 ) <<Dedxint<<"  "<<setw ( 10 ) <<Dedxbuc<<"  Gev/cm  "
        << ( Perdita==0?"Loss off":"Loss on" )
        <<"\n MaxBrems, MaxPair     "<<setw ( 10 ) << maxBrems<<"  "<<setw ( 10 ) <<maxPair
        <<"\n Hardcluster           "<<setw ( 10 ) << extrawork;
    }
    else  Gout<<"\n No internal material defined! ";

    Gout.setf ( ios::floatfield );

    Gout<<"\n";
    int vst;
    int idt=0;;
    if ( nvede>-1 ) Gout<<"\n Lista delle particelle rivelate.\n";
    while ( idt<=nvede )
    {
        vst=assorb[idt];
        Gout<<"\n"<<idt<<" ->   Detect: < "<<setw ( 7 ) <<vede[idt]<<" >  "<<setw ( 7 ) <<
        ( vst==0?"Seen": vst==1?"Dump":vst==2?"Dump  and reg.":"Dump but not reg." );
        idt++;
    }
    Gout<<"\n---------------\n";
}


