/***************************************************************************
                          traccia.cpp  -  description
                             -------------------
    redone               : 02.09.2011
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : pierazzini@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA62.... M.C.  simulation program.     Utility for tracing                                        *
  *                                                                         *
  ***************************************************************************/


#define CEPSI 1.0e-6

//        Tirrenia   GmP 02.09.2011
#include <ctype.h>
#include <parm.h>
#include <evento.h>
#include <device.h>

using namespace GmpConst;
using namespace std;
int Tracingdebug=0;
//================================  U T I L I T Y    T R A C I N G    ============================

//================   T R A C C I A ====================================
//================   T R A C C I A ====================================
//================   T R A C C I A ====================================

/**
 Traccia le particelle nell'apparato per un tratto come definito in Get_camm().
Nel tracciare la particella si tiene conto della possibilita'
della pair production e del bremsstrhalung. <br>
*/

int Device::Traccia ( Particella *pr )
{


    int iter=0;
    // impulso ==0 no tracing ... return;
    if ( pr->P.norma == 0.0 ) return 1;

    lint=nowpos?libuc:liint; //get the interaction length
    
    
 //if (Eventi_Generati>6587&&Eventi_Generati<6589)Tracingdebug=1;
 //   else Tracingdebug=-1;
    
   if(Tracingdebug>0&&pr->Get_Gx().z>9000.) {
   
   Gout<<"\n\n Ev "<<Eventi_Generati<<" Multiple scattering for  "<<pr->Get_Nome()<<" in " <<nome;
    pr->X.print("X");
    pr->Get_Gp().print("p_ gen");
    pr->P.print("p_prima");
     
  }

    if ( fun==Bersaglio&& pr->rg!=0&&lint>0.0&&nowpos<1 )
    {   // se qui è un caso particolare... particelle si distrugge  nel dev
        // Il dev fa da bersaglio
        // ed è interna o nel buco ( è qui c'è di default)
        // e la lunghezza di interazione è definita non nulla!
        // si ridefisce il cammino se interagisce nel bersaglio
        pr->Get_Bersaglio ( this,lint );
        if ( pr->Ifato==-3 )
        { // la particella è stata distrutta!!!
            pr->Move ( pr->pathok );  // nuovo path (ma vedere meglio)
            pr->last_path=pr->pathok;
            pr->rg->dw->X=pr->rg->X=pr->X;    // definisco la posizione del C.M.
            pr->rg->dw->Gx=pr->rg->Gx=pr->X;
            return -3;   // la bullet muore nel dev
        }
    }

    double tratok=pr->pathok;
    lrad=nowpos?lradb:lradi; //get the radiation  length
    if ( lrad==0. )     // no radiation...
    {
        // free flight
        pr->Move ( tratok );
        pr->last_path=tratok;
        return 0;
    }

// qui lrad != 0

    if ( pr->charg ==0.0 )
    {

// se è un gamma fa Pair_Production


        if ( pr->Pair_Production>0&& Pair_done<maxPair ) //        Pair production activated?
        {
          
          
            if ( pr->P.e<0.002 ) // Energy cutoff .... fare meglio
            {
                Hits[nhit].e_rivela+=pr->P.e;  // aggiorno l'energia persa...
                Hits[nhit].idead=-18;
                pr->Ifato=-18;
                pr->P.setqn ( 0.,0.,0.,pr->massa);
                pr->pathok=0.0;
                return -18;
            }
            
            
            pr->Get_Pair ( this,tratok,lrad );
            Hits[nhit].idead=pr->Ifato;
            pr->pathok=tratok; //redefine (if nedeed) free path before pair prod..
        }
        pr->Move ( tratok );
        pr->last_path=tratok;
        return 0;
    }
    
    
    
//  qui lrad != 0   ed è carica
    int crepa;
    double passdone=0.0;
    double passo= lrad;

// fa bremsstrahlung

    while ( passdone<tratok )
    {
        double diff=tratok-passdone;
        if ( diff <passo ) passo =diff+0.001;

        if ( pr->Brems_Production>0 && Brem_done<maxBrems )
        {
            if ( pr->Get_Brems ( this,passo,lrad ) !=0 )
            {
                pr->Move ( passo );  // divido per 2  ??? media
                Mscatter ( pr,passo );
                pr->last_path=passdone+passo;
                Hits[nhit].idead=pr->Ifato;
                return 0;
            }
        }
        // qui se non c'è stato brems...
        pr->Move ( passo );   //forse passo/2  ???!|!!
        if ( ( crepa=Mscatter ( pr,passo ) ) !=0 )
        {
            pr->last_path=passdone+passo;

            Hits[nhit].idead=crepa;
            return crepa;
        }
        passdone+=passo;
        iter++;
    }
    Hits[nhit].idead=pr->Ifato;
    Hits[nhit].last_path =pr->last_path=tratok;
    
    //debug
    
    if(Tracingdebug>0&&pr->Get_Gx().z>9000.) pr->P.print("p_dopo");

    
    return 0;

}
//=============================================================================================================
//================================  U T I L I T Y    M A G   T R A C I N G   ============================

int Device::Traccia_in_magn(Particella *pr)
{

    // 18/03/03 update: general tracing.. the magnetic field now could be variable
    // and without any restriction..
    // *****attention! inside the magnet no brems, nor pairprod for the moment..
    // the track tracing is iterative with step size small enough  to keep the
    // tracing errors to very low  values
    //
    //*****
    // La carica elementare nel sistema Ibrido e'
    //    ec=.299792458[ Gev/c * T**(-1) m **(-1) ]
    // va qui moltiplicata per 10e-6 poiche'
    // si usa il Gauss ed il Centimetro; segue...
    // r(cm)=[p cos(lambda)(GeV)]/(2.9979258e-7 * H(Gauss) )
    //**
    // note 2007 the field is in the hole!


    const double ec=2.99792458e-7;

    if (pr->P.norma == 0.0)     {
        Gout<<"\n Magnetic tracing.. no puls  ... exit...";
        exit(0);
    }
    if (pr->Get_Charg() == 0.0) {
        Gout<<"\n Magnetic tracing.. no charge... exit...";
        exit(0);
    }
    if (campo<=0 && Field.norma == 0.0) {
        Gout<<"\n   Mgnetic tracing .. no field... exit...";
        exit(0);
    }


    // neutra traccio regolamente dritto
   if (Tracingdebug==10)
    {// ok nel caso di campo costante ==> valore significativo
   
   Gout<<endl; 
   pr->X.print("X");
 Gout<<" Da tracciare  Ev="
        <<setprecision(0)<<fixed
        <<setw(6)<<Eventi_Generati<<" "
        <<setw(6)<<pr->Get_Nome()<<" in"
        <<setw(6)<<nome<<"  pthmax,done,fare "
        <<setprecision(1)<<fixed
         <<setw(7)<<pr->path_max
         <<setw(7)<<pr->path_done
        <<setw(7)<<pr->pathok;
     pr->P.print("P"); 
    }
    //------------ tracing in the field....
    // nota  X_indev coordinate riferite al dev traslato e rotato se necessario
    // nota  P_indev impulso  riferito al dev rotato se necessario

    pr_dev=pr;
    gvet XIN=X_dev=Lab2cDev ( pr->X ); // trasla al centro dev e ruota
    X_dev.Norma();
    gvet X_Curr=XIN;
    gvet PIN=Lab2Dev(pr->P);
 
    gvet Puls=PIN;
    gvet Pvers=V_dev=Puls.NVerso();


    int pos_iniziale=pos_corrente= Posizione();
    if (pos_iniziale<0) X_Curr=X_dev-Centrin;

    double vol_max=pr->pathok;




    double freestep=Get_Cammino(); // cammino potenziale in linea retta  per uscire dal magnete
    if (freestep>vol_max) freestep=vol_max;

    if (campo>0) Field=Get_Field(X_Curr);


    // nota il  sistema di riferimento dei vettori e' quello del dev.
    // predico il raggio di curvatura.... massimo...
    double rho= 9999999. ;
    if (Field.norma>0.0001)rho = Puls.Norma()/(ec*Field.norma);

    // il calcolo corretto e'  rho= (P&H).Norma/(H_norma**2*ec)

    if (Tracingdebug==10)
    {// ok nel caso di campo costante ==> valore significativo

        double forkik=ec*Field.norma*freestep*pr->Get_Charg();
        Gout<<"\n\n Traccia  Ev="
        <<setprecision(0)<<fixed
        <<setw(6)<<Eventi_Generati<<" "
        <<setw(6)<<pr->Get_Nome()<<" in"
        <<setw(6)<<nome<<"  pth="
        <<setprecision(1)<<fixed
        <<setw(7)<<pr->pathok<<" frestp="
        <<setw(7)<<freestep<<" rho="
        <<setw(7)<<rho<<" kik="
        <<setprecision(4)<<fixed
        <<setw(6)<<forkik;
        Field.print("Field");



    }



    /*************/
    if (rho<2.*freestep) return 1;   // la particella resta intrappolata....

    // definizione dello step.

    double step =rho/3000.;
// if(step<0.04)step=0.04;
    double stepmin=freestep/400.;

    if (step<stepmin)step=stepmin;
    else if (step>3.)step=3.;
    if (step>freestep) step= freestep+0.01;


    double dse = step*ec*pr->Get_Charg();
    double path=0.0;
    int iter_mag=0;

    // tracing main loop  =======================
    while (iter_mag++<500)
    {
        if (campo>0) Field=Get_Field(X_Curr);     //variabile

        /*
            evento_.Event,nome,pr->Get_Nome(),pr->pathok,cam_max,rho);
            Pvers.print("pvers");
            X_Curr.print(pr->Get_Nome());
            Field.print("Field")
        */

        Puls+= Pvers&Field * dse;        // Aggiorno P dopo un cammino ds
        Pvers=Puls.NVerso();             // calcola la nuova direzione di volo
        X_Curr+= step*Pvers;           // aggiorno la posizione
        path+=step;                   // aggiorno il cammino

        //  check for end  iteration...
        if (step>freestep) break;       // decaduta...o uscita dal mag...
        freestep-=step;                 //aggiorno il cammino da fare

        //    test if still inside the right pos
        V_dev=Pvers;
        if (pos_iniziale>-1) X_dev=X_Curr;
        else  X_dev=X_Curr+Centrin;
        if ((pos_corrente= Posizione())!= pos_iniziale) break;



        if (step>freestep)              // se supero con uno step il cammino restante allora...
        {

            //    allora calcolo il cammino potenziale restante...


            freestep=Get_Cammino();
            if (freestep>vol_max-path)freestep=vol_max-path;
            if (step>freestep)
            {
                step= freestep+0.01;
                if (step<0.05)break;
                dse = step*ec*pr->Get_Charg();
            }
        }
    }

// tracing end ====================================

    if (iter_mag> 499)
    {
        Gout<<"\n\n Ev="<<evento_.Gen.Event<<" Trac. in "<<nome
        <<" iter "<<iter_mag<<" for "<<  pr->Get_Nome()<< " P norma "<< pr->P.norma
        <<" freestp "<<freestep<<"  rho="<<rho<<" to many step "<<step;
        
         PIN.print("Pin");      Gout<<" vxz "<<PIN.x/PIN.z<<" vyz "<<PIN.y/PIN.z;
          Puls.print("Pout");Gout<<" vxz "<<Puls.x/Puls.z<<" vyz "<<Puls.y/Puls.z;
         gvet KIK=Puls-PIN;
        KIK.Norma();
        KIK.print("KIK");
        //     Field.print("Last Field");
        Gout<<"\n Done "<<std::endl;
        
        
        
        
        return 2;
    }
    // tracing end ====================================

    /*****************************/
    if (Tracingdebug==2) // &&idev==22)
    {
        Gout<<"\n ev "<<Eventi_Generati<<"  "<<nome<<" for "<<pr->Get_Nome()<<" Zstp="
        <<std::setprecision(2)<<fixed
        <<setw(6)<<freestep<<" Path="
        <<setprecision(1)<<fixed
        <<setw(7)<<path<<" Iter="
        <<setw(5)<<iter_mag;
        XIN.print("Xin");
        X_Curr.print("Xout");
        PIN.print("Pin");      Gout<<" vxz "<<PIN.x/PIN.z<<" vyz "<<PIN.y/PIN.z;
        Puls.print("Pout");Gout<<" vxz "<<Puls.x/Puls.z<<" vyz "<<Puls.y/Puls.z;

        gvet KIK=Puls-PIN;
        KIK.Norma();
        KIK.print("KIK");
        //     Field.print("Last Field");
        Gout<<"\n Done "<<std::endl;
    }
    /*****************************/
//out

    pr->P.setvn(Dev2Lab(Puls),pr->Get_Massa());    // nota calcola anche la norma
    pr->Vers=Pvers;
    
  
    
    if (pos_iniziale>-1) X_dev=X_Curr;
    else  X_dev=X_Curr+Centrin;
    pr->X=Devc2Lab(X_dev)+ 0.01*pr->Vers;
     pr->pathok=path;
    pr->path_done+=path;
 
    
   
    return (0);
}
//==========================
double  Device::Get_Cammino()
{
// usata da traccia in magnete 
    switch (pos_corrente)
    {
    case 1:
        return CamEster();
        break;

    case 0:
        return CamInter();
        break;
    case -1:
    case -2:
        return CamBuco();
        break;
    default:
        return 0.;


    }


}
//==============================================   RAY TRACING STUDY =====
int  Device::Traccia_in_materia(Particella *pr)
{
    static double camnorma=1.;
    double camm_max=pr->pathok;
    if (camm_max>camnorma)camnorma=camm_max; // normalizzazione dinamica.

    double abs=0.95; // opacità: se alta maggiore  è  la probabilità di morte...
    double prob_di_morte =abs*camm_max/camnorma;
// test for  living...
    if (Dran()<prob_di_morte)
    {
        Hits[nhit].idead=19;
        pr->Ifato=19;
        pr->P.setqn ( 0.,0.,0., pr->massa );
        Hits[nhit].last_path = pr->last_path=0.0;
//      cout <<"\n "<<setw(6)<<Eventi_Generati<<" END corsa  in "<<nome;
        return -19;

    }
//   vive....
    pr->Move(camm_max);
    pr->last_path=camm_max;
    Hits[nhit].last_path =camm_max;
    //    cout <<"\n "<<setw(6)<<Eventi_Generati<<" Esce da "<<nome<<" dopo "<<camm_max<<" di cammino";
    return 0;
}






