/***************************************************************************
                          devmare.cpp  -  description  for nemo experiment
                                  Radiatore  Marino
                             -------------------
    begin                : Tue Jul 31 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/



#include "parm.h"
#include "evento.h"
#include "particella.h"
#include "triggerbox.h"
#include "devmare.h"

using namespace std;
using namespace GmpConst;

int Debugmare=-1;

Om_frame::Om_frame()
{
// evice in svluppo per nemo
// la struttura interna è definita rispetto riferimento interno del device
//  Quindi le torri stanno nella parte alte del deve... vedere meglio....


// attenzione    ATTENZIONE  attenzione    ATTENZIONE attenzione    ATTENZIONE
/// attenzione l'unità di misura qui è il m . Il file epc deve essere dato im metri..
// e costanti devono essere scritte di conseguenza...


    N_Om=8;
    N_Cluster=8;
    N_Towerx=9;
    N_Towery=9;
    N_Tower=N_Towerx*N_Towery; //10x10
    Ntwx2=N_Towerx/2;
    Ntwy2=N_Towery/2;

// maglia torri
    dxtower= 100.; //distanza x tra le torri in metri
    dytower= 100.; //distanza y tra le torri in metri
    raggio=.220;   // raggio del PM in metri
    raggioq=raggio*raggio;
    nseen=0;

//... info on the OM position and direction
//... number of OMs in the cluster , list of x(m), y(m), z(m),
//                x      y       z     in Cluster sYstem
    Om_Xpos[0].setv ( -6.86 , 0.  , 20. );
    Om_Xpos[1].setv ( -6.28 , 0.  , 19.91 );
    Om_Xpos[2].setv ( 6.28 , 0.  , 19.91 );
    Om_Xpos[3].setv ( 6.86 , 0.  , 20.0 );
    Om_Xpos[4].setv ( 0    ,-6.86,-20 );
    Om_Xpos[5].setv ( 0    ,-6.28,-20.09 );
    Om_Xpos[6].setv ( 0    , 6.28,-20.09 );
    Om_Xpos[7].setv ( 0    , 6.86,-20 );


//... zenith(teta_degree), azimuth(fi_degree) of each OM in the cluster
//          vx      vy       vz     Versori

    Om_Verso[0].setv ( -1.0 , 0.0  , 0.0 ); // (degree 90,180);
    Om_Verso[1].setv ( 0.0 , 0.0  ,-1.0 ); // (degree 180,180);
    Om_Verso[2].setv ( 0.0 , 0.0  ,-1.0 ); // (degree 180,0);
    Om_Verso[3].setv ( 1.0 , 0.0  , 0.0 ); // (degree 90,0);
    Om_Verso[4].setv ( 0.0 ,-1.0  , 0.0 ); // (degree 90,270);
    Om_Verso[5].setv ( 0.0 , 0.0  ,-1.0 ); // (degree 180,270);
    Om_Verso[6].setv ( 0.0 , 0.0  ,-1.0 ); // (degree 180,90);
    Om_Verso[7].setv ( 0.0 , 1.0  , 0.0 ); // (degree 90,90);
    for ( int i=0; i<8; i++ ) Om_Verso[i].Norma();

// altezza (z) del centro cluster
//               Dist(m)       PMT_ID
// OM_cluster: 1 1 662.050   8     1 2 3 4 5 6 7 8
// OM_cluster: 2 1 582.230   8  9 10 11 12 13 14 15 16
// OM_cluster: 3 1 502.410   8  17 18 19 20 21 22 23 24
// OM_cluster: 4 1 422.590   8  25 26 27 28 29 30 31 32
// OM_cluster: 5 1 342.770   8  33 34 35 36 37 38 39 40
// OM_cluster: 6 1 262.950   8  41 42 43 44 45 46 47 48
// OM_cluster: 7 1 183.130   8  49 50 51 52 53 54 55 56
// OM_cluster: 8 1 103.310   8  57 58 59 60 61 62 63 64

    Om_Cluster[0].setv ( 0.0 ,0.0, 662.050 );
    Om_Cluster[1].setv ( 0.0 ,0.0, 582.230 );
    Om_Cluster[2].setv ( 0.0 ,0.0, 502.410 );
    Om_Cluster[3].setv ( 0.0 ,0.0, 422.590 );
    Om_Cluster[4].setv ( 0.0 ,0.0, 342.770 );
    Om_Cluster[5].setv ( 0.0 ,0.0, 262.950 );
    Om_Cluster[6].setv ( 0.0 ,0.0, 183.130 );
    Om_Cluster[7].setv ( 0.0 ,0.0, 103.310 );

    for (int icl=0;icl<8;icl++)Om_Cluster[icl].z-=400.;   // attenzione dipende dal dev mare....

    // make the pm array

    N_PM=N_Cluster*N_Om;  //Tipico 64
    // genero le posizioni di ciascun PM nello spazio relativo ad una torre
    PM_Xpos = new gvet [N_PM];
    for ( int i=0; i<N_PM; i++ ) {
        int i8=i%8;
        int ic=i/8;
        PM_Xpos[i]=Om_Xpos[i8]+ Om_Cluster[ic];

        //   PM_Xpos[i].print ( "xpos" );

    }

/////PrintAll_Om();

};

void  Om_frame::PrintAll_Om()
{
// 
    for ( int tx=0; tx<N_Towerx/8; tx++ ) {
        for ( int ty=0; ty<N_Towery/8; ty++ ) {
            gvet Xtorre ( ( tx-Ntwx2 ) *dxtower, ( ty-Ntwy2 ) *dytower,0.0 );

            for (int icl=0;icl<N_Cluster;icl++)//Cluster loop
            {
                gvet Xcls=Om_Cluster[icl];

                for ( int ip=0; ip<N_Om; ip++ ) {
                    gvet Xpm=  Om_Xpos[ip]+Xcls+Xtorre;
                    Xpm.print("xpm");
                    Gout<<" "<<setw(4)<<tx<<" "<<setw(4)<<ty<<" "<<setw(4)<<icl<<" "<<setw(4)<<ip;
                }

            }
        }
    }
}


///==================================================================
///==================================================================
///==================================================================




int Om_frame::Om_urto ( gvet X, gvet V ,double tratto)
{
//    static double latox=mare->Get_Lout().x;
//    static double latoy=mare->Get_Lout().y;
//    static double latoz=mare->Get_Lout().z;


    gvet Xpm,Vpm;
    int Ipm=-1;


    static double Cluce=.30 ;  //c= cm/ns
    static double lambda =68.0; // coefficiente di assorbimento 6800 centimetri.
    // calcolo i limiti delle
//   X.print("X_ck");
//   V.print("V_ck");Gout<<" tct "<< V.z;

    for (int i=0;i<N_Cluster;i++)
    {
        int icl=i;           // parto dall'alto se V.z<0.
        if (V.z>0.) icl=7-i; //ovvero parto dal basso  se il mu sale...
        gvet Xcls=Om_Cluster[icl];
        //Xcls.print("Xcls");
//=================
// verifico le torri interessate in x e y

        gvet Xroad=X +  V*((Xcls.z-X.z)/V.z);

////???????????????????????????????????????????????????????????????????????????????????????????
        int itxmin= Xroad.x/dxtower  + Ntwx2;
        int itymin= Xroad.y/dytower  + Ntwy2;
        int itxmax=itxmin+2;
        int itymax=itymin+2;
// check on limits
        if ( itxmin<0 ) itxmin=0;
        else   if ( itxmin>N_Towerx ) itxmin=N_Towerx;
        if ( itymin<0 ) itymin=0;
        else if ( itymin>N_Towery ) itymin=N_Towery;
        if ( itxmax>N_Towerx ) itxmax=N_Towerx;
        else  if ( itxmax<0 ) itxmax=0;
        if ( itymax>N_Towery ) itymax=N_Towery;
        else if ( itymax<0 ) itymax=0;

        //     Xroad.print("Xroad"); Gout<<"\n itx "<<itxmin<<" "<<itxmax<<" ity  "<<itymin<<" "<<itymax;

// ==========

        for ( int tx=itxmin; tx<itxmax; tx++ ) {
            for ( int ty=itymin; ty<itymax; ty++ ) {

                gvet Xtorre ( ( tx-Ntwx2 ) *dxtower, ( ty-Ntwy2 ) *dytower,0.0 );


                //        Xtorre.print("Xtorre");   Gout<<"  itx,ity. "<<tx<<" "<<ty;
                for ( int ip=0; ip<N_Om; ip++ ) {
                    Xpm=  Om_Xpos[ip]+Xcls+Xtorre;

// vedo se ci urto
                    gvet DX=Xpm-X;
                    double scal=DX%V;

                    if ( scal<0.0001 ) continue;  // va nel senso sbagliato....

                    double distq=DX.normaq-scal*scal;

                    //    cout<<"\n d "<<sqrt(distq)<< " scal "<<scal;

                    if ( distq>raggioq ) continue;     // non ci picchia...
// ci picchia...
                    //   cout<<"\n d "<<distq<<" ragq "<<raggioq<< " scal "<<scal;

// calcolo il punto sulla sfera del pm...
                    double tcv= scal - sqrt ( raggioq-distq );

                    // getto per assorbimento luce...
                    double lucepulso = exp (-tcv/lambda);
                    if (lucepulso<0.2)continue; // soglia sull'impulso

                    gvet Xcont=X+V*tcv;
                    gvet VRc=Xcont-Xpm;
                    gvet DVCR=VRc;
                    VRc.Norma();
                    double r_dist=VRc.norma;
                    //    VRc.print("VRc");
                    VRc=VRc.NVerso();
                    Vpm=Om_Verso[ip];
                    double Cvista= Vpm%VRc;

//                                 VRc.print("Vrc");
//                                 Vpm.print("Vpm");
//
// //                                 Xcont.print ( "xc" );
//                              Gout<<"\n t "<<t<<" c "<<Cvista;


                    if ( Cvista<0.008 ) continue; // fuori efficienza.



                    Ipm= ( ty*N_Towerx+tx ) *64+icl*8+ip;

                    // cout<<"\n nseen "<<nseen<<"  "<<Ipm;

                    double tptime=(tratto+tcv*1.33)/Cluce;
// si verifica che sia stato toccato un vecchio pm nell'intervallo di
                    for (int i=0;i<nseen;i++)
                    {
                        if ( Ipm==mare->OMhit[i]&&fabs(tptime-mare->tp[i])<4.) // vedere meglio....
                        {
                            mare->peso[i]++;
                            return nseen;
                        }
                    }

                    if (nseen<498) {
                        mare->xseen[nseen]=Xpm.x;   // coordinate dell'OM 
                        mare->yseen[nseen]=Xpm.y;
                        mare->zseen[nseen]=Xpm.z;
                        mare->OMhit[nseen]=Ipm;   //id dell OM visto
                        mare->Icl[nseen]=icl;    // cluster interessato
                        mare->Ip[nseen]=ip;      //Id dell'OM nel cluster 
                        mare->peso[nseen]++;     // numero di volte che è stato toccato lo stesso OM in meno di 4 ns
                        mare->effi[nseen]=Cvista;  // coseno tra raggio di impatto sul'OM e la sua direzione di osservazione.
                        mare->tp[nseen]=tptime;   // tempo di arrivo del fotone sull'OM 
                        nseen++;
                    }
                    else  if (nseen>497) {
                        Gout<<"\n Troppi Om seen... exit! "<<nseen<<endl;
                        cout<<"\n Troppi Om seen... exit! "<<nseen<<endl;

                        return -99;
                    }

                    if (Debugmare==20)
                    {
                        gvet Xcam= V*tcv;
                        X.print("X");
                        V.print("V");
                        Xroad.print("Xroad");
                        Gout<<" itxm. "<<itxmin<<" "<<itxmax<<" itym  "<<itymin<<" "<<itymax<< " seen "<<nseen;
                        Xpm.print("Xpm");
                        Gout<<"  itx,ity. "<<tx<<" "<<ty;
                        Xcam.print("Xcam");
                        Xcont.print("Xcont");
                        Gout<<" tcv "<<tcv;
                        VRc.print("Vcr");
                        Gout<<"  r_dis "<<r_dist<< " cvis "<<Cvista<<"\n\n";
                    }

                    break;

                }

            }
        }
    }


    mare->Nseen=nseen;
    return Ipm;
}

//=========================================


DevMare::DevMare()
{
   cout<<"\n in DevMare "<<flush;
    devtype=TypDevMare;
    devclass="Mare_Rt";
    mare=this;
    Array.nseen=0;
    Ncvk=0;
    Nseen=0;
    cout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> type "<<devtype<< " pointer: mare->"<<flush;
    Gout<<"\n\n < "<<nome <<" > Dev Id "<<idev<<" Device type <"<<devclass<<"> type "<<devtype<< " pointer: mare->"<<flush;
}
DevMare::~DevMare()
{}
//----------------- --------
void DevMare::Prgeom()
{

    Gout<<"==================  R i v e l a t o r e =================";
    Gout<<"\n --> < "<<nome <<" >  [ "<<fun
    <<" ]  Radiatore marino:  Rettangolare "<<std::endl;
    Device::Prgeom();
}
//=======-----------------------------------
void DevMare::DataSmear()
{


}

int DevMare::Get_Structinfo()
{
    int code=-1;

    return code;
}


int DevMare::SimulaDev()
{
    Ncvk=0;
    Nseen=0;
    for(int i=0;i<500;i++)
    {  
     OMhit[i]=Icl[i]=Ip[i]=0;
     effi[i]=xseen[i]=yseen[i]=zseen[i]=tp[i]=peso[i]=0.0; 
    }
      mu_tratto=0.;  
    if ( mhit<1 ) return 0;

    gvet Xin=M_Hits[0].Xdev;
    qvet Pin=Lab2Dev ( M_Hits[0].P );

    double tratto=Make_Cerenkov_light ( Pin,  Xin );
    cout<<"\n Ev "<<Eventi_Generati<< "   tratto "<<setw(8)<<tratto<<" ncvk "<<Ncvk<<" Omhit "<<totpeso<<"  nseen "<<Nseen<<endl;
    return 0;
}

//============== MAKE_CRENKOV_LIGHT
//===============================================================
double  DevMare::Make_Cerenkov_light ( qvet Pin, gvet Xin )

{

    if (Debugmare==1) {
        Gout<<"\n Ev "<<Eventi_Generati<< " Simula dev ";
        Pin.print("Pin");
        Xin.print("Xin");
    }


    Array.nseen=0;
// Xin in coordinate interne al dev
    double beta= Pin.mom/Pin.e;
// attenzione il valore dell'indice di rifrazione fissa il raggio ..

    double cosc=1./ ( 1.333*beta );

    if ( cosc>1.0 ) {
//        SottoSoglia++;
        return 0.0;
    }
    double sinc=sqrt ( 1.-cosc*cosc );  //circa 40 gradi== .79 rad
 
    double alfa=.3/ (3000.*sinc*sinc ); // in metri   (circa 40 fotoni  per cm) 
    
//Calcolo dei cammini di emissione
// calcolo di un sistema di riferimento  (versori: vx,vy,vz)
// con asse z lungo la linea di volo della particella padre
    gvet Vz= Pin.NVerso();   // pensato anche come asse Z
    gvet YY ( 0.,1.,0. );    // asse Y del Dev
    gvet Vx= YY&Vz;
    Vx=Vx.NVerso();
    gvet Vy=Vz&Vx;
//
    if ( Debugmare==1 ) {
        Gout<<"\n\n ev "<<Eventi_Generati;

        Xin.print ( "Xin" );
        Gout<<" Inizio traccia ";
        Vz.print ( "Vin" );
        Gout<<" Versore traccia.";
    }

    double t,tratto=0.0;  // tratto percorso nel rich prima di uscire.

    gvet X=Xin;
    while ( X.z<Lout.z ) {
        t= -alfa*log ( Dran() );
        X+=Vz*t;
        Ncvk++;
        if (Ncvk%100000==0)cout<<"\n Ck n. "<<Ncvk<<" Nseen "<<Nseen<<" z "<<X.z;

//               if ( Ncvk%100==0 ) Gout<<"\n Ncvk " <<Ncvk<<" z "<<X.z<<"  beta "<<beta
//               <<"  sinc " <<sinc<<"   alfa "<<alfa <<"   t " << t;
//===============
// si verica che l'emissione avvenga nel volume utile

        if ( X.z>Lout.z ) break;
        if ( fabs ( X.x ) >Lout.x ) break;
        if ( fabs ( X.y ) >Lout.y ) break;
//================

//Direzione di volo del gamma emesso.
// randomize in fi
        double fi=DuePiGreco*Dran();
        gvet V = Vx*sinc*cos ( fi ) +Vy*sinc*sin ( fi ) +Vz*cosc;

//==============    S E T _ F O T O N E    ======
// traccio il fotone: se incontra un Pm

        int ipret= Array.Om_urto ( X,V,tratto );
        

        if ( Debugmare==2 ) {
            X.print("X");
            Gout<<" ncvk "<<Ncvk<<"  nseen "<<Array.nseen;
            V.print("V");
            Gout<<" scal "<< V%Vz;
        }

        tratto+=t;
        
        // cout<<"\n t "<<t<<" tr "<<tratto;

        if (ipret==-99) break;

    }
    mu_tratto=tratto;
    Nseen=Array.nseen;
    totpeso=0.0;
    for(int i=0;i<Nseen;i++)
     totpeso+=peso[i];
 
    return tratto;
}
