/***************************************************************************
                          carte.cpp  -  description
                             -------------------
    begin                : Sat Dec 9 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA48  simulation program.           New version    3.02.2005                               *
 *                                                                         *
 ***************************************************************************/

//   Cp in obj
#include <flyoh.h>
#include <flyoana.h>
#include <analisi.h>
/*
#define ATOLW  atol(strtok(0," \n"))
#define ATOFW  atof(strtok(0," \n"))*/
#define NOTDEFINED -999999.

//using namespace std;

/** \file  carte.cpp
Legge le carte (dai file xxx.epc e yyyy.app ) di controllo della simulazione, che contengono:
<ul>
<li>la descrizione in dettaglio dell'apparato (vedi device.h e device.cpp),
<li>i data_base dei materiali usati ( vedi matterpar.h),
<li>i data_base delle particelle più comuni in uso nella simulazione e
<li>la descrizione in dettaglio di tutte le reazioni attivate nella simulazione (vedi reazione.h).
</ul>
<br>
*@author Giuseppe Pierazzini
*/




void DevGeoTipo ( string );
void ReaTipo ( string );
int  AnaTipo ( string );


/*--------------------------------------------------------------*/
/*                R e a d i n                                   */
/*--------------------------------------------------------------*/
/* it  reads in the input data cards              Readin        */

void
Legge_input_file ( const char *datin )
{
    //  random generator inizialitialization correlato o no
    //  Correla =0  no correlazione
    //  Correla =1  inizializza la partenza con il numero di run
    //  Correla =2 inizializza con num. evento e run
    //  Correla =4  per special run K+ e K-

    Device *dev=Apparato;
    std::ifstream Card;
    //-------------------------------
    Card.open ( datin, ios::in );
    if ( !Card )
    {
        Gout<<"\n Input file  NOT opened        ==> "<< datin;
        Gout<<"\n no input files ..program stop !!! \n"<<endl;
        exit ( -1 );
    }
    else
        Gout<<"\n Read the input_file           ==> "<<datin<<endl;


    //--------------------------------
    char line[156];
    string stringline,label,label2;
    double a1,a2,a3;
    int ia1,ia2;

    Card.getline ( line, 156 );
    while ( !Card.eof() )
    {

        Cardcur=&Card;
// decodifica
        stringline=line;
        stringstream scheda;
        scheda<<line;
        scheda>>label;
        if ( Dbginput==1 )
        {
            Gout<<"\n Carte label: "<<label<<"  Linea:"<<line;
        }

        if ( stringline.size()      <1  ||
                label.find ( "**" )  ==0  ||
                label.find ( "\\\\" ) ==0  ||
                label.find ( "//" )  ==0 )
        {
            Card.getline ( line, 156 );
            continue;
        } //line empty or comment ...read next line

        if ( label.find ( "end_a" ) ==0 )    break;
        else if ( label.find ( "done" ) ==0 );
        else if ( label.find ( "stopr" ) ==0 )
        {
            Gout<< "\n Stop by operator. ";
            exit ( 0 ); /* for internal debug */
        }
        else if ( label.find ( "nota" ) ==0 ) Commenta ( datin );  //end with: done,end,fine,*/
        else if ( label.find ( "note" ) ==0 ) Commenta ( datin );
        else if ( label.find ( "comme" ) ==0 ) Commenta ( datin );
        //-----Key words begin --------
        else if ( label.find ( "corr" ) ==0 )   scheda>>Correla;
        else if ( label.find ( "run" ) ==0 )
        {
            if ( evento_.Gen.Run==0 ) scheda>>evento_.Gen.Run;
        }
        else if ( label.find ( "maxev" ) ==0 )
        {
            if ( evento_.Mxev==0 ) scheda>>evento_.Mxev;
        }
        else if ( label.find ( "labze" ) ==0 )
        {
            if ( Lab_Zero.x!=-999999. )
            {
                Gout<<"\n 'labzero' card out of sequence..put at beginning!! exit..."<<endl;
                exit ( 0 );
            }

            scheda>>a1>>a2>>a3;
            Lab_Zero.setvn ( a1,a2,a3 );
        }
        else if ( label.find ( "unit" ) ==0 )
        {
            scheda>>label2;
            if ( label2.find ( "meter" ) ==0 || label2.find ( "metro" ) ==0 ) {
                flyo_unit=0.01; // coefficiente   da centimetro a metro
                Gout<<"\n\n Nota: <-- è stata selezionata una nuova unita di lunghezza  by operator -->";
                Gout<<"\n La nuova unità di  misura è il metro....(unità standard di flyo è il cm). fattore: "<<flyo_unit;
                Gout<<"\n Attenzione adesso tutte le lunghezze dei device etcc devono essere fornite in metri, nelle files epc e app."<<endl;

            }
            else Gout<<"\n Unità di misura non aggiornata.... label: "<< label2<< "   errata? (valide meter o metro) "
                "\n default centimetro " <<endl;
        }
        else if ( label.find ( "fiduc" ) ==0 )
        {
            if ( Lab_Zero.x==-999999. )
            {
                Gout<<"\n 'labzero' card out of sequence..put at beginning!! exit..."<<endl;
                exit ( 0 );
            }

            if (End_fid!=1.e+10)
            {
                cout<<"\n Fiducial space double definition: Exit! "<<endl;
                exit(0);
            }
            scheda>>a1>>a2;
            Beg_fid=a1-Lab_Zero[2];
            if (a2>=1.e+9)End_fid=1.e+9; // set pratically  no upper limits
            else {
                double aux =a2-Lab_Zero[2];
                if ( aux>0. ) End_fid=aux;
            }
        }
        else if ( label.find ( "zona" ) ==0 )   // nmassima distanza dal centro lab.
        {
            if ( Lab_Zero.x==-999999. )
            {
                Gout<<"\n 'labzero' card out of sequence..put at beginning!! exit..."<<endl;
                exit ( 0 );
            }


            scheda>>a1;
            Zona=a1-Lab_Zero.z;
            if ( Zona<fabs(Lab_Zero.z)) Zona=fabs(Lab_Zero.z);  // per sicurezza

        }
        else if ( label.find ( "debgl" ) ==0 )   scheda>>evento_.Debg_last;
        else if ( label.find ( "debgf" ) ==0 )   scheda>>evento_.Debg_first;
        else if ( label.find ( "ppp" ) ==0 )   scheda>>ppp;
        else if ( label.find ( "tburst" ) ==0 )
        {
            scheda>>a1;
            TBurst->Set_Tburst ( a1 );
        }
        else if ( label.find ( "illum" ) ==0 )   Luce=new Illumina(); // default 0
        else if ( label.find ( "radx" ) ==0 )
        {
            scheda>>ia1>>ia2;
            Radio=new Radiografia ( ia1,ia2 );
        }
        else if ( label.find ( "error" ) ==0 )   Errori=1;
        else if ( label.find ( "scatt" ) ==0 )   Scatter=1;
        else if ( label.find ( "perdi" ) ==0 )   Perdita=1;
        else if ( label.find ( "pairp" ) ==0 )   Abilita_Pair=1;
        else if ( label.find ( "brems" ) ==0 )   Abilita_Brems=1;
        else if ( label.find ( "wrtntal" ) ==0 )  WrtNt=10;
        else if ( label.find ( "wrtall" ) ==0 )  WrtNt=10;
        else if ( label.find ( "vieta" ) ==0 ) Vieta=1;
        else if ( label.find ( "wrtnt" ) ==0 )   WrtNt = 1; // default 0
        else if ( label.find ( "wrtgood" ) ==0 )   WrtNt = 1; // default 0


        else if ( label.find ( "tracc" ) ==0 )    Wtrk = 1; // default 0
        else if ( label.find ( "trigg" ) ==0 )  Trigger_low_on=1;

        else if ( label.find ( "dbginput" ) ==0 ) Dbginput = 1;
        else if ( label.find ( "materiali" ) ==0 );
        else if ( label.find ( "data_bas" ) ==0 );
        else if ( label.find ( "unseen" ) ==0 )
        {
            string wrd;
            scheda>>wrd;
            while ( scheda.eof() ==0 )
            {
                Matter->Notseen ( wrd.c_str() );
                scheda>>wrd;
            }
        }

//==========
        else if ( label.find ( "beam" ) ==0 )
        {
            scheda>>label2;
            ReaTipo (label2 );
        }
        else if ( label.find ( "decay" ) ==0 || label.find ( "urto" ) ==0 )
        {  // un decadimento o un urto generano la stessa particella incidente...
            scheda>>label2;
            ReaTipo ( label2 );
        }
        else if ( label.find ( "story" ) ==0 )
        {
            scheda>>ia2;
            Offset_story=ia2;
        }




//===========
        else if ( label.find ( "devic" ) ==0 )
        {
            scheda>>label2;
            DevGeoTipo ( label2 );
        }
        else if ( AnaTipo ( label ) ==1 );   // obsolate....torna sempre zero....
        else if (label.find ( "ipotesi" ) ==0 )
        {
            scheda>>label2;
            IpoNum++;
            IpotesiAna[IpoNum]=label2;
            Gout<<"\n Ipotesi letta: "<<label2<< " --> num "<<IpoNum;
            cout<<"\n Ipotesi letta: "<<label2<< " --> num "<<IpoNum;
        }

        else if ( label.find ( "include" ) ==0 ) // more data file
        {

            string newfile;
            scheda>>newfile;
            if ( newfile.size() >0 )
            {
                Gout<<"\n New input file                ==> "<<newfile<<"  called by " <<datin;
                Legge_input_file ( newfile.c_str() );
                Gout<<"\n Back to file                  ==> "<<datin;
            }
            else
            {
                Gout<<"\n New file called by            ==> "<<datin<<"   not opened... Error "<<endl;
                exit ( -1 );
            }

        }
        else if ( label.find ( "pr_data" ) ==0&&Matter  !=0 )  Matter->Show();
        else if ( label.find ( "pr_reaz" ) ==0&&Reaction!=0 )  Reaction->Stampa();
        else if ( label.find ( "pr_mate" ) ==0&&Elemento!=0 )  Elemento->Show();
        else if ( label.find ( "pr_devId" ) ==0&&Apparato!=0 ) Apparato->PrgeomId();
        else if ( label.find ( "pr_devic" ) ==0&&Apparato!=0 )
        {
            dev=Apparato;
            Gout<<"\n\n==================  Detectors block =====================\n";
            while ( dev!=0 )
            {
                dev->Prgeom();
                dev=dev->next;
            }
            Gout<<"\n===========  End apparatus list   ============\n \n \n";
        }
        else Gout<<"\n Scheda errata ?? : "<<stringline<< " of  size "<< stringline.size();
        //----------  Key words  end  ----------
        Card.getline ( line, 156 );
    }
    Gout<<"\n End reading; close the file   ==> "<<datin;
    Card.close();
}


void Sommario_Input_Data()
{
    //--------------------------------------------------------------------------

    Gout<<"\n\n  *********************************************";
    Gout<<"\n  --   Driving Parameters  S u m m a r y     --"<<endl;


    if ( Apparato!=0 )
    {
        // final summary

        Gout<<setprecision ( 3 );
        Gout<<"\n  Run number           = "<<evento_.Gen.Run;
        Gout<<"\n  Max  Events          = "<< evento_.Mxev;
        Gout<<"\n  Debug, first event   = "<<evento_.Debg_first;
        Gout<<"\n  Debug, last  event   = "<<evento_.Debg_last;
        Gout<<"\n  Lab System bias x,y,z= "<< setw ( 9 ) <<Lab_Zero.x<<" "<<setw ( 9 )
        <<Lab_Zero.y<<" "<<setw ( 9 ) <<Lab_Zero.z;
        Gout<<"\n  Max z  (Zona)        = "<<Zona;
        Gout<<"\n  Beg_fid <-> End_fid  = "<<Beg_fid<<" <-> "<< End_fid;
        Gout<<"\n  Protons per burst    = "<< ppp;
        Gout<<"\n  T Burst in sec       = "<< TBurst->Get_Tburst() *1.e-9;
        Gout<<"\n  Production ppp/ns    = "<< ppp/TBurst->Get_Tburst()
        << " with  Tau "<<TBurst->Get_Tburst() /ppp;

        Gout<<"\n----\n";
        Gout<<"\n  Random. Correlated   = "
<<( Correla?Correla-1?Correla-2?Correla-4?"Run+CP":"K+K-":"Run+Ev":"Run":"no" );
        Gout<<"\n  Dbginput status      = "<< ( Dbginput?"si":"no" );
        Gout<<"\n  Error smearing       = "<< ( Errori?"si":"no" );
        Gout<<"\n  PairProduction       = "<< ( Abilita_Pair?"si":"no" );
        Gout<<"\n  Bremsstrhalung       = "<< ( Abilita_Brems?"si":"no" );
        Gout<<"\n  Multiple Scattering  = "<< ( Scatter?"si":"no" );
        Gout<<"\n  Energy loss          = "<< ( Perdita?"si":"no" );
        Gout<<"\n----\n";

        Gout<<"\n  Trigger low level    = "<< ( Trigger_low_on?" on ":"no" );
        Gout<<"\n  Pipeline status      = "<< ( Pipeline?" on ":"off" )<<"  Tpipe "<<( Pipeline?Tpipe:0. );
        Gout<<"\n  Write dati (WrtN)    = "<< ( WrtNt?"si":"no" ) <<"  "<<WrtNt;
Gout<<"\n  Write data_out       = "<< ( WrtNt?WrtNt-10?"good":"All":"no" )
        <<"  "<<WrtNt;

        Gout<<"\n  Write data out type  = "<<Wrtype<<"  "<<Wrt_type_out;
        Gout<<"\n  Illumina end coord.  = "<< ( Luce?"si":"no" );
        Gout<<"\n  Write radx picture   = "<< ( Radio?"si":"no" );
        if ( Radio!=0 )
            Gout<<" - Rivelatori tra "<<Radio->primo_dev<<" e "<<Radio->ultimo_dev;
        Gout<<"\n  Write tracks out     = "<< ( Wtrk?"si":"no" );


        Gout<<"\n--   Fit definition  --\n";

        Analisi  *ana=Primofit;
        while (ana != 0)
        {
            if ( ana!=0) Gout<<"\n  Definito il fit: "<< ana->titol;
            ana=ana->next;
        }
        Gout<<"\n--End  fit definition  --\n";
        //

        Gout<<"\n\n  ************ End parameter list  ***********\n\n";

    }

}
//=============================================================
//---------------- D e v G e o T i p o -----------------------
void DevGeoTipo ( string geometria )
{

    /**********************  vedi Device.h
        Scelta della classe che descrive il rivelatore

    Control word in epc   shape              class     device Type
    (first 5 characters)done
      no             no                      Device          0
    rettangolo     parallelepipedo           DevRt           1
    rettrett       parall. con buco rett.    DevRtRt         2
    cilindro       cilindro                  DevCln          3
    rettcili       parall. con buco cili.    DevRtCl         4
    cilirett       cilin. con buco rett.     DevClRt         5
    corona         corona cilindrica         DevCrn          6
    ottagono       ottagonale                DevOt           7
    ottagono       ott.con buco ottag.       DevOtOt         8
    ottagono       ott. con buco cil.        DevOtCl         9
    cilindro       cilind. con buco ott.     DevClOt        10


    magnete        magnete                   DevMagn         20
    quadrupolo     quadrupolo magnetico      DevQuad         21
    magnete        Mag.con buco per filtro   DevFlt          22
    fluka          Dec.Reg. shape-beam-gas   DevFluka        23

    chamber        Mwire Chamber             DevMwc          50
    lkr48          calorimetro(Na48)         DevLkr          51
    chod           hodoscopio (NA62)         DevChod         52
    hac48          Adron.calor(NA48)         DevHac          53
    ytax           acromat collimator        DevYTax         54
    xtax           acromat collimator        DevXTax         55
    bluetube       Blu tube                  DevBlue         57

    software       no shape                  DevTrk          100
    basedev        Rivelatore di base        DevBase         500
    **********************/

    Device *dev=0;
    if ( geometria.size() == 0 )
    {
        Gout<<"\n Device geometry error !!! \n"<<endl;
        exit ( 0 );
    }

    // definizione dello zero (bias) del sistema del lab. Tutti i rivelatori sono
    // spostati di conseguenza..
    if ( Lab_Zero[0]==NOTDEFINED )
    {
        Gout<<"\n \n *** System lab origin NOT defined.. forced to zero!!!";
        Lab_Zero.setvn ( 0.,0.,0. );
    }

    // choice of device geom

    if      ( geometria.find ( "cedar" ) ==0 ) dev= new DevCedar;
    else if ( geometria.find ( "chamb" ) ==0 ) dev= new DevMwc; //==CiliCili
    else if ( geometria.find ( "chanti") ==0 ) dev= new DevChanti;
    else if ( geometria.find ( "chod"  ) ==0 ) dev= new DevChod;
    else if ( geometria.find ( "cilin" ) ==0 ) dev= new DevCln; //==Cilindrico
    else if ( geometria.find ( "cilir" ) ==0 ) dev= new DevClRt;
    else if ( geometria.find ( "cilot" ) ==0 ) dev= new DevClOt;//==Cili_otto
    else if ( geometria.find ( "coron" ) ==0 ) dev= new DevCrn;  //==CiliCili
//    else if ( geometria.find ( "fluka" ) ==0 ) dev= new DevFluka;
    else if ( geometria.find ( "gigat" ) ==0 ) dev= new DevGtk;
    else if ( geometria.find ( "hac48" ) ==0 ) dev= new DevHac;
    else if ( geometria.find ( "hod48" ) ==0 ) dev= new DevChod;
    else if ( geometria.find ( "irc"   ) ==0 ) dev= new DevIrc;
    else if ( geometria.find ( "lav"   ) ==0 ) dev= new DevLav;
    else if ( geometria.find ( "lkr48" ) ==0 ) dev= new DevLkr;
    else if ( geometria.find ( "lkr62" ) ==0 ) dev= new DevLkr;
    else if ( geometria.find ( "lveto" ) ==0 ) dev= new DevLav;
    else if ( geometria.find ( "magne" ) ==0 ) dev= new DevMagn;
    else if ( geometria.find ( "muflt" ) ==0 ) dev= new DevFlt;
    else if ( geometria.find ( "muveto") ==0 ) dev= new DevMuv;
    else if ( geometria.find ( "mare") ==0 )   dev= new DevMare;//==Rettangolare
    else if ( geometria.find ( "ottag" ) ==0 ) dev= new DevOt;   //==Ottagonale
    else if ( geometria.find ( "ottci" ) ==0 ) dev= new DevOtCl; //==Ottag_cil
    else if ( geometria.find ( "ottot" ) ==0 ) dev= new DevOtOt; //==Ottag_otta
    else if ( geometria.find ( "quadr" ) ==0 ) dev= new DevQuad;
    else if ( geometria.find ( "retre" ) ==0 ) dev= new DevRtRt; //==Ret_ret
    else if ( geometria.find ( "retta" ) ==0 ) dev= new DevRt;   //==Rettangolare
    else if ( geometria.find ( "rettc" ) ==0 ) dev= new DevRtCl; //==Rett_cil
    else if ( geometria.find ( "rette" ) ==0 ) dev= new DevRt;   //==Rettangolare
    else if ( geometria.find ( "rettr" ) ==0 ) dev= new DevRtRt; //==Ret_ret
    else if ( geometria.find ( "rich"  ) ==0 ) dev= new DevRich;
    else if ( geometria.find ( "sac"   ) ==0 ) dev= new DevSac;
    else if ( geometria.find ( "settor") ==0 ) dev= new DevSector;
    else if ( geometria.find ( "sfera" ) ==0 ) dev= new DevSfera;
    else if ( geometria.find ( "straw" ) ==0 ) dev= new DevStraw;
    else if ( geometria.find ( "solenoi" ) ==0)dev= new DevSolenoide;
    else if ( geometria.find ( "toro" ) ==0)   dev= new DevToro;
    else if ( geometria.find ( "sveto" ) ==0 ) dev= new DevSveto;
    else if ( geometria.find ( "xtax"  ) ==0 ) dev= new DevXTax;
    else if ( geometria.find ( "ytax"  ) ==0 ) dev= new DevYTax;

    else
    {

        Gout<<"\n Device    => geom wrong!!! "<<geometria;
        exit ( 0 );
    }
    if (dev!=0) Gout<<"\n Last dev done: "<<dev->Get_Nome()<<" nik: "<<dev->Get_NickName();
    //Gout<<endl;
}
//==============================================================
//---------------------  R e a T i p o ------------------------
void ReaTipo (  string label )
{
    Reazione *rea=0;
    const char *part;

    if ( label.size() == 0 )
    {
        Gout<<"\n Decay error !!! \n"<<endl;
    }
    part= Matter->Ptbsdat ( label.c_str() );


    // choice of reaction type
    if ( part==Kapl )  rea=new ReaKld (  );
    else if ( part==Kaps )  rea=new ReaKsd (  );
    else if ( part==Kap0 )  rea=new ReaK0d (  );
    else if ( part==Kapm )  rea=new ReaKmd (  );
    else if ( part==Kapp )  rea=new ReaKpd (  );
    else if ( part==Pim )   rea=new Reapmd (  );
    else if ( part==Pip )   rea=new Reappd (  );
    else if ( part==Mum )   rea=new Reamumd (  );
    else if ( part==Mup )   rea=new Reamupd (  );
    else if ( part==Eta )   rea=new ReaEtad (  );
    else if ( part==Elec )  rea=new ReaEleb (  );
    else if ( part==Elep )  rea=new ReaEleb (  );
    else if ( part==Protone)rea=new ReaPb (  );
    else if ( part==Gam )   rea=new ReaGam (  );
    else if ( part==Lambda )rea=new ReaLambda (  );
    else if ( part==Sinv)   rea=new ReaSinv();
    else if ( label.find ( "csi" ) ==0 ) rea=new ReaCsid (  );
    else if ( label.find ( "pi0d" ) ==0 ) rea=new ReaPi0d (  );
    else
    {
        Gout<<"\n Decay wrong starting label!!! "<< label<<" \n"<<endl;
        exit ( 0 );
    }
    if (rea==0) {
        Gout<<"\n Errore in  ReaTipe "<<endl;
        exit(0);
    }

}
//---------------- A n a T i p o ----------------------------

int AnaTipo ( string ipotesi )
{
    //    fits
    //int K4g,K6g,K2p,K3p,K3l,Ka2pi,Pi2g,E2g,E6g,K2p2g,Bea;
    //int Kenu,Kpc2g,Kpcp0,Kpcp0g,Kpc2p0,K2p0enu,K2pcenu,Kpc3g.....

    if ( ipotesi == "fascio"  ||
            ipotesi == "user"         ||
            ipotesi == "k4g"          ||
            ipotesi == "k6g"          ||
            ipotesi == "k2p"          ||
            ipotesi == "k3p"          ||
            ipotesi == "k3l"          ||
            ipotesi == "ka2pi"        ||
            ipotesi == "pi2g"         ||
            ipotesi == "e2g"          ||
            ipotesi == "e6g"          ||
            ipotesi == "kl2"          ||
            ipotesi == "ke2g"         ||
            ipotesi == "kpc2g"        ||
            ipotesi == "kpcpi0"       ||
            ipotesi == "kpc2p0"       ||
            ipotesi == "kppcenu"      ||
            ipotesi == "kpp0enu"      ||
            ipotesi == "kpivv"        ||
            ipotesi == "kmunu"        ||
            ipotesi == "kpip0"        ||
            ipotesi == "kpip0ee"      ||
            ipotesi == "kpip0dlz"     ||
            ipotesi == "kpip0p0dlz"   ||
            ipotesi == "klambda"      ||
            ipotesi == "kpovv"        ||
            ipotesi == "kenug"        ||
            ipotesi == "kpievg"       ||
            ipotesi == "kmvg")

    {
        Gout<<"\n**** Obsolete \""<<ipotesi<<"\"  command for hypothesis.... Put \"ipotesi\" just before "<<ipotesi<<"  ..now  exit!"<<endl;
        cout<<"\n**** Obsolete \""<<ipotesi<<"\"  command for hypothesis.... Put \"ipotesi\" just before "<<ipotesi<<"  ..now  exit!"<<endl;

        exit(0);
    }

    else return 0;

}

//======================
//======================

void Commenta ( const char *datin )
{
    char line[80];
    string logistica;
    Cardcur->getline ( line, 80 );
    Gout<<"\n\n || ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" ;
    Gout<<"\n || ----   U S E R  N O T E  / Promemoria  ----";
    Gout<<"\n || from file:  "<<datin ;
    while ( !Cardcur->eof() )
    {
        Gout<<"\n |> ";
        Gout<<line;
        logistica=line;
        if ( logistica.size() !=0 )
        {
            if ( logistica.find ( "done" ) == 0 ) break;
            if ( logistica.find ( "end" ) == 0 ) break;
            if ( logistica.find ( "fine" ) == 0 ) break;
            if ( logistica.find ( "stop" ) == 0 ) break;
            if ( logistica.find ( "*/" ) == 0 ) break;
        }
        Cardcur->getline ( line, 80 );
    }
    Gout<<"\n ||   ---- User Note  / Promemoria  E N D  ---- ";
    Gout<<"\n || ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n" ;

}

