/***************************************************************************
                          evento.cpp  -  description
                             -------------------
    begin                : Sun May 27 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#define EVENTO

#include "flyoh.h"
#include "flyoana.h"
#include "evento.h"

//using namespace std;
/**
Procedura per memorizzare nel buffer Bufeve circolare  i dati di generazione dell'evento
 se  è attivata la pipeline.
*/
Evento::Evento()
{
//default
  Gen.Run =1000; 
  Mxev=120;
  Mxevscr=0;
  Gen.Event = Debg_first = Evenlast=0;
  Gen.Ifus=0;
  Debg_last = 3;
  Gen.type=Gen.lastype=0;
  SizeCircularBuffer=100;
  MemEvPos=0;

}


void Evento::Put_Header_into_Buffer()
{
// se è attivata la pipeline memorizzo i dati di generazione dell'evento
  // nel buffer circolare di evento.
  HeaderEv[MemEvPos]=Gen;
//  Gout<<"\n --> Ev "<<Gen.Event<<" in memPos "<<MemEvPos<<" at time "<<Gen.tempo;
  MemEvPos++;
  MemEvPos= MemEvPos%SizeCircularBuffer;  // circular buffer

}

//------------------------------

void Evento::Define_Standard_Header()
{
  // store the header info in Gen
  Particella *pr,*pdw,*prg;
  pr=SelRea->avo;

  //   type=100*pr->Get_Idm()+SelRea->Get_Id(); and
  //   lastype   defined in Reazione->AddGen()

  Gen.ift=pr->Get_Ifato();
  Gen.Pipev=0;  

// 
  
  
  Gen.dt_reaz=SelRea->Rea_tempo-SelRea->Rea_tempo_last;
  Gen.pxk=pr->Get_Gpx();
  Gen.pyk=pr->Get_Gpy();
  Gen.pzk=pr->Get_Gpz();
  Gen.pk =pr->Get_Gpn();
  SelRea->Xtarg.putv( Gen.xt,Gen.yt,Gen.zt );
  pr->X.putv( Gen.xv,Gen.yv,Gen.zv );
  Gen.pkf =pr->P.norma;
  Gen.pxkf=pr->P[0];
  Gen.pykf=pr->P[1];
  Gen.pzkf=pr->P[2];

//  clear of next data....

  float *zero=&Gen.x1f;
  for ( int i=0;i<20;i++ )
  {
    zero[i]=0.0;
  }

  pdw=pr->dw;
  if ( pdw!=0 )
  {
    pdw->X.putv( Gen.x1f,Gen.y1f,Gen.z1f );
    pdw->Get_Gp().putv( Gen.px1g,Gen.py1g,Gen.pz1g);
    Gen.mas1=pdw->Get_Massa();
    pdw->P.putv( Gen.px1f,Gen.py1f,Gen.pz1f);
  }
  prg=pr->rg;
  if ( prg!=0 )
  {
    prg->X.putv( Gen.x2f,Gen.y2f,Gen.z2f );
    prg->Get_Gp().putv( Gen.px2g,Gen.py2g,Gen.pz2g);
    Gen.mas2=prg->Get_Massa();
    prg->P.putv( Gen.px2f,Gen.py2f,Gen.pz2f);
  }
  
  
  
/*
// Vedi PartFase....
  if ( SelRea->ss_done==0 )
  {
    Gen.gss1=Gen.gss2=Gen.gss3=0.0;
    Gen.gvss1=Gen.gvss2=Gen.gvss3=0.0;
    Gen.gss_sort=0.0;
  }*/


  Gen.rea_sel=SelRea;

}






//=================================================================
int  Evento::Get_Header_from_Buffer()
{
  Ntrigg=Ntrigg%SizeCircularBuffer;  // circular buffer
  double trigger_time = HeaderEv[Ntrigg].tempo; //if -1 event allready used to reject
  double tnow=TBurst->Get_Tempo();

  if ( trigger_time< 0. ) return -1;


  if ( ( tnow-trigger_time ) <Tpipe ) return -1; // Tpipe not yet elapsed from the last event...get out

  // ok copio l'header in Gen.
  Gen=HeaderEv[Ntrigg];
  SelRea=Gen.rea_sel;     // questo non dovrebbe servire ... da qui in poi potrebbe essere scorretto...
  /*
     Gout<<"\n Get from buffer Ev "<<Gen.Event<<" Ntrigb "<<Ntrigg<<" trig_time "
         <<trigger_time<< " tnow "<<tnow
         <<" type "<< Gen.type;
  */


  HeaderEv[Ntrigg].tempo=-1.;   // trigger  killed
  Ntrigg++;



  // get the  dev  hits
  Device *dev=Apparato;
  while ( dev!=0 )
  {
    if ( dev->escludi!=1 )
      dev->GetWindowHits ( trigger_time );
    dev= dev->next;

  }
  if ( evento_.Gen.Pipev>0 ) SelRea->Pipev++;
  return 1;

}
