/***************************************************************************
                          evento.h  -  description
                             -------------------
    begin                : Sun May 27 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
 ***************************************************************************/

#ifndef EVENTO_H
#define EVENTO_H

#include<string.h>
#include <partfase.h>
class Reazione;

/**
Buffer di riferimento con le informazione di generazione. Vedi Evento.
  *@author Giuseppe Pierazzini
  */

struct Bufeve
{
// attenzione prima di cambiare verificare outnt.cpp per le informazioni ROOT!!!
  
  int type;                  // indice rea*100 + indice beam: type=id*100 + avo->Get_Idm();
  int lastype;               // della reazione passata (studio di correlazioni)
//  int burst;                  // numero di burst
  int Event;                 // Numero evento
  int Run;                   // numero run
  int ift;                   // beam fate
  int trigger_flag;          // Minum bias trigger coded (vedi in main).
  int iterfase;              // numero di iterazioni per la generazione nello spazio dellfasi X elemento matrice 
  int Pipev;                 // Event with accidental into the pipe_time_window of one dev.
  int Ipair;                 // pair productions done in the event
  int Ibrem;                 // bremsstrhalung done  in  the envent
  int Idlz;                  // dalitz done  in  the envent
  int Itsrt;                 // Short tail gamma correction in calorimeter done
  int Itlg;                  // Long tail gamma correction in calorimeter done
  int Ifus;                  // Fusion number in calorimeter
  double tempo;               // Event time  (che ha generato il trigger)
  float  dt_tdif;  
  float  dt_beam;             // Time difference from this   and the last particle beam generation
  float  dt_begfid;           // differenze eventi all'inizio della zona di fiducia
  float  dt_trig;            // Time difference between this and the last levl0-triggered event
  float  dt_reaz ;             //  Time difference between this and the last similar reaction
  float  dt_write;
  
  float  xt,yt,zt;           // Genrated target point
  float  xv,yv,zv;           // Decay vertex of beam particle (K,pio,....)
  float  pxk,pyk,pzk,pk;     // Generated momenta of beam
  float  pxkf,pykf,pzkf,pkf; // Momenta of beam at the decay point
// the next parameters are defined only if the corresponding particles exist.
//sono le particelle di decadimento avo->dw and avo->dw->rg;
  float  x1f,y1f,z1f;        // Decay of particle 1
  float  px1g,py1g,pz1g,mas1;// Generated momenta of particle 1
  float  px1f,py1f,pz1f;     // Momenta of p1 at last point of its path.
  float  x2f,y2f,z2f;        // Decay of particle 1  (?)
  float  px2g,py2g,pz2g,mas2;// Generated momenta of particle 2 (?)
  float  px2f,py2f,pz2f;     // Momenta of p2 at last point of its path.

// Valoro generati per debug e definiti solo per i decadimenti secondo lo spazio fasi.. vedi tre corpi
// NOTA attenzione se nello stesso evento ci sono più risonze qui si fa casino, si sovrascrive ????? rivedere...
  float mres12,mres34,mres123,mres23,mres45;
  float eres12,eres34,eres123,eres23;
  float ge1,ge2,ge3,ge4,ge5;
  float  gss1,gss2,gss3;

  Reazione *rea_sel;          // pointer to the reaction tree
};
/**
Parametri di riferimento di ciascun evento. <br> Qui trovi i dati di generazione di
ogni particella alla nascita e alla sua fine. Queste informazioni possono essere usate per avere anche una "radiografia" dell'apparato, con un grafico (per esempio di 50000 eventi) tridimensionale delle coordinate di fine traccia.

  *@author Giuseppe Pierazzini
  */

class Evento
{
  public:
// do not touch ....header dati..
    int MemEvPos;
    int SizeCircularBuffer;
    Bufeve Gen;
    Bufeve HeaderEv[100];  // Buffer circolare


    long Debg_first,Debg_last,Evenlast;
    long Mxev, Mxevscr;

    Evento();
    ~Evento() {};
    void Put_Header_into_Buffer();
    int  Get_Header_from_Buffer();
    void Define_Standard_Header();
    void Store_Gen();  // nascita e morte delle particelle
    void SaveDevMeas();
};
#endif


#if defined(MAINFLYO)

Evento evento_;
int Ntrigg=0;
double ppp=1.e+12;  //default...   see in file epc
long Eventi_Generati=0, Eventi_Prodotti=0,Eventi_Scritti=0;
#endif

#if !defined(MAINFLYO)

extern Evento evento_;
extern int Ntrigg;
extern double ppp;
extern long Eventi_Generati,Eventi_Prodotti,Eventi_Scritti;
#endif
