/***************************************************************************

C    Na48  flyo  main program      Tirrenia 11.06.01
Dal 2004 e' tutto in CVS
***********************************************/
#define MAIN

#include "flyoh.h"
#include "flyoana.h"
#include "fasemax.h"

int Maindebug=-1;
void Get_Data_Gen();
void Compatibility();

/** \file  main.cpp
Flyo è un montecarlo veloce,  scritto completamente in C++, compatibile con Root e con Paw, particolarmente adatto per la
simulazione di eventi di fisica delle alte energia in apparati di forme complesse ed arbitrarie.<br>

main:
<ul>
<li> inizializza la procedura di simulazione: flyoinit()
<li> legge i dati di imput da terminali
<li> legge i file .app e .epc per definire l'apparato sperimentale e la serie di reazioni da simulare
<li> da inizio alla Loop di generazione degli eventi: flyoevento()
<li> memorizza i dati generati in un buffer circolare se Pileup is on.
<li> rielabora gli eventi  per simulare i vari rivelatori nei dettagli richiesti: flyosimuladev()
<li> parte la ricostruzione od analisi degli eventi secondo ipotesi stabilite ed abilitate: FitsControl()
<li> chiama la procedura di scrittura dei dati su file: Scrivi_Dati(1)
</ul>
Nota <br>
La elaborazione degli eventi accumulati è in genere sincrona con i trigger, mentre  nel caso che sia on il Pileup  la simulazione  fine dei device [flyosimuladev()],l'analisi e la scrittura sono eseguiti in modo asincrono alla generazione. In particolare l'analisi sugli eventi, accumulati nel buffer circolare,  parte solo dopo un lasso di tempo, (per esempio Tpipe=250 ns) per da agio alle informazioni via, via generate di popolare le time slot della pipeline (qui di 25 ns) prima e dopo adiacenti all'evento che ha generato il trigger  come accede nella realtà.

*@author Giuseppe Pierazzini

*/
int main ( int argc, char *argv[] )
{
    gargc=argc;
    gargv=argv;

    //  all init..
    flyoinit();
    Gout<<"\n Flyoinit done. "<<flush;

    //==========
// test on comnpatibility...
    Compatibility();
    //==========
//init fits, and the data out_file
    FitsControl ( 0 );
    Gout<<"\n FitsControl(0) done. "<<flush;

    Scrivi_Dati ( 0 );
    Gout<<"\n Scrivi_nt(0)) done. "<<flush;


// ========================================================

//***********************************************************
//***********************   L O O P   ***********************
//***********************************************************

    SelRea=0;

    //     MAIN   LOOP
    while (Eventi_Scritti<evento_.Mxevscr&&Eventi_Generati<evento_.Mxev)
    {

        Eventi_Generati++;
        evento_.Gen.Event=Eventi_Generati;
        // reset reazioni e  devices...
        if ( SelRea!=0 ) SelRea->Reset_Rea();


//  ==== E V E N T      G E N E R A T I O N   ====
        Reset_Devices();


        evento_.Gen.tempo=TBurst->Get_ProdTempo();  // istante della generazione...
        evento_.Gen.dt_tdif=TBurst->dt_dif;  // differenza in t tra due eventi generati.

        
// event tracing         
        
        evento_.Gen.trigger_flag=flyoevento();

  //  cout<<"\n Ev "<<Eventi_Generati <<" " <<evento_.Gen.trigger_flag<<" fato "<<SelRea->avo->Get_Ifato();

        if (Maindebug==1) cout << "\n\n Ev "<<Eventi_Generati<<" Scritti "<<Eventi_Scritti<<" trg0 "<< evento_.Gen.trigger_flag<<flush;
//  ==== E V E N T     D O N E   ====

// flyoevento() ritorna  Gen.trigger_flag,  un numero:
// a)  positivo che dipende dai dev colpiti : ok
  
// b) -10,-11 se la generazione beam è fallita-> si salta al prossimo evento
// c)  <= -1000 se stato colpito un veto (dev flag veto) ->si  salta al prossimo evento
        
//    attenzione la flag veto non è compatibile con pipeline on poichè l'evento      
//    non viene tracciato completamente!!!!
        
// se il beam è fallito evento_.Gen.trigger_flag=-2  (rivedre per sveltire.)

        if ( evento_.Gen.trigger_flag<0 ) continue; // if not positive skip to the next  event
 if (Maindebug==1) cout << "\n Ev "<<Eventi_Generati<<" Scritti "<<Eventi_Scritti<<" trg1 "<< evento_.Gen.trigger_flag<<flush;
//     cout<<"\n ev "<<Eventi_Generati<<" trg "<< evento_.Gen.trigger_flag<< " ft "<<SelRea->avo->Get_Ifato()
//      <<"  zona "<<SelRea->avo->X.z;

//========== ====================
        if ( SelRea->rea_type!=-1) //Verifico che non sia un evento oer test beam
        {
            // se il beam è distrutto nel frame di un dev o dump prima di decadere ...skip the event...
            // per debug del fascio o visualizzare il profile di tutto il fascio
            // commentare la seguente riga ...attenzione può alterare  la distribuzione della divergenza
            // del fascio poichè alcuni eventi sono tagliati asimmetricamente dall'acromat....
            if (SelRea->avo->Get_Ifato()>0) continue;

            // si eliminano gli eventi con il Kp che decade fuori Zona max
            // attenzione per le normalizzazioni.
            if ( End_fid<1.e+9&&SelRea->avo->X.z>Zona) continue;
            
           if (Maindebug==1) cout << "\n Ev "<<Eventi_Generati<<" Scritti "<<Eventi_Scritti<<" trg2 "<< evento_.Gen.trigger_flag<<flush; 
            
        }


//===========  ====================

        if ( Luce!=0 ) Luce->Store_Illumina();// better if Luce  activated without the pipeline. See Compatibility()

        evento_.Define_Standard_Header();      // event title and basic parameters...
        if ( Pipeline==1 ) evento_.Put_Header_into_Buffer();

//=====================================================
//-----------------------------------------------------
// inizio loop  per la elaborazione degli eventi memorizzati nel buffer circolare.
// che hanno generato un trigger di basso livello: almeno un device toccato (done).
// La elaborazione dei trigger è asincrona rispetto alla generazione,
// si elaborano comunque tutti gli eventi con  trigger generati Tpipe ns prima dell'ultimo evento generato.
// se la pipeline non è attivata la loop è dummy....
        if (Maindebug==1) cout << "\n Ev "<<Eventi_Generati<<" Scritti "<<Eventi_Scritti<<" trg3 "<< evento_.Gen.trigger_flag<<flush;
      
        
        while ( 1 )
        {
            if ( Pipeline==1 )
            {
// estraggo i titoli dal buffer degli header...
// estraggo i dati delle pipeline dei dev in una finestra di
// +- Tpipe attorno al tempo del trigger
// il trigger dev essere almeno "Tpipe" ns prima del tempo attuale.
                if ( evento_.Get_Header_from_Buffer() <0 ) break; //if no more events ... skip...
            }
            else Get_Data_Gen();  // semplicemente copia i dati generati nel buffer  M_Hits

//==================================== S I M U L A ===========================


            flyosimuladev();

            Eventi_Prodotti++;

            if (Maindebug==1)   cout << "\n Ev "<<Eventi_Generati<<" Simula dev done "<<flush;

//==================================== E N D      S I M U L A ================


// if Trigger_box is on .. check the level 0 trigger.
            if ( Trigger!=0 )
            {
                evento_.Gen.trigger_flag=Trigger->Level0();
                if (evento_.Gen.trigger_flag==0 ) {// if not... skip and look for a new trigger
                    if ( Pipeline==0 ) break;
                    else continue;
                }
            }
            evento_.Gen.dt_trig=TBurst->Get_dt_trig();

// in Get_DatiOut(); si copiano i dati misurati ( M_Hits ) nelle variabili standard  per Root
// altre variabili per Root possono essere state definite altrove... (in SimulaDev per esempio!)
// ricordarsi di azzerare le variabili Root aggiunte in Reset_RootData();
            Device *pv;
            pv=Apparato;
            while ( pv!=0 )
            {
                if ( pv->escludi==0 ) pv->Get_DatiOut();
                pv=pv->next;
            }
            if ( Radio!=0 ) Radio->Store_Radx(); //take a radiografy of the apparatus!!!
//===============================================================
// si procede all'analisi dei dati misurati se richiesto
            if ( Primofit!=0 )   FitsControl ( 1 );

// e si scrive tutto sul file di uscita
    if (Maindebug==1)   cout << "\n Ev "<<Eventi_Generati<<" Scritto "<<flush;

            Scrivi_Dati ( 1 );

            if ( Pipeline==0 ) break;
        }


    }
//=====end event main loop  ======

//==== closing the simulation ===============
//==================
//  program ends.....

    if ( Fasemx!=0 ) Fasemx->Info();
    Gout<<"\n\n ======>>>  E n d      p r o g r a m    s u m m a r y "<<endl;
    if ( Primofit!=0 ) FitsControl ( 2 );
    Scrivi_Dati ( 2 );
    flyoend();
    Gout<<"\n  Eventi: generati "<<setw(9)<<Eventi_Generati<<" prodotti "<<setw(9)<<Eventi_Prodotti<<" scritti "<<setw(9)<<Eventi_Scritti;
    cout<<"\n  Eventi: generati "<<setw(9)<<Eventi_Generati<<" prodotti "<<setw(9)<<Eventi_Prodotti<<" scritti "<<setw(9)<<Eventi_Scritti;
    cout<<"\n\n ======>>>  E n d      p r o g r a m  "<<endl;
    return 0;
}
//=================================================================

//=================================================================
/**
Seleziona i dev da usare o da escludere nella procedura di simulazione.
*/
void  Get_Data_Gen()
{
    Device *dev=Apparato;
    while ( dev!=0 )
    {
        if ( dev->escludi!=1 ) dev->Fill_Default();
        dev= dev->next;
    }
}
//=================================================================
/**
Compabilità  tra le procedure richieste
*/
void  Compatibility()
{
    // compatibility....
    if ( Pipeline==1 &&  Luce!=0 )
    {
        Gout<<"\n ****  Pipeline and Illumina  incompatibilty... attention ..."<< endl;
        cout<<"\n ****  Pipeline and Illumina  incompatibilty... attention ..."<< endl;
        exit ( 0 );
    }
    if ( Pipeline==1 && Radio!=0 )
    {
        Gout<<"\n ****  Pipeline and Radx  incompatibilty... attention! ..."<< endl;
        cout<<"\n ****  Pipeline and Radx  incompatibilty... attention! ..."<< endl;
        exit ( 0 );
    }
    // triger of low level on....
    if ( Trigger_low_on==1 ) Gout<<"\n ***** -> trgtest <-  set up... did you test the Trigger->Calcola procedure?"<<endl;
}
