/***************************************************************************
                          parm.h  -  description
                             -------------------
    begin                : Sun Nov 26 2000
    copyright            : (C) 2000 by Giuseppe m Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA48  titles for simulation program.                                  *
 *                                                                         *
 ***************************************************************************/
#ifndef PARM_H
#define PARM_H

/**
Title
 Base parametrs....
@author Giuseppe Pierazzini
*/
#include<iostream>
#include<fstream>
#include<iomanip>
#include<string>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cmath>
#include <iosfwd>
#include <sstream>

// CP violation  program...... in Obj!!     New version  3.01.2005
//definizioni

#include "gvet.h"


namespace GmpConst
{
	/**
	 Variabili di comodo e definizioni di parametri con visibilità globale.
	*/
	const double PiGreco =3.14159265358979323846;
	const double DuePiGreco= 2.*PiGreco;
	const double EPSI = 1.00e-64;
	const double SQRT2=1.414213562;
	const double SINCOS45=1./SQRT2;

}

#if defined(MAIN)
double flyo_unit=1.0;
// in-out operators definitions
std::ofstream Gout;
std::ofstream Wrout;
std::ifstream *Cardcur;
int WrtNt=0,WRTALL=10,Vieta=0, Wrtype=-1,Debugon=1, Dbginput=0;
int Dbg_dev_start=0,Dbg_dev_stop=100;
int gargc;
char *OutDir=0;
char **gargv;
char OutGn[256],*Cardin=0;
std::string Wrt_type_out="root";
#endif

#if !defined(MAIN)
extern double flyo_unit;
extern std::ofstream Gout;
extern std::ofstream Wrout;
extern std::ifstream *Cardcur;
extern int WrtNt,WRTALL,Vieta,Wrtype,Debugon, Dbginput;
extern int Dbg_dev_start,Dbg_dev_stop;
extern char *OutDir;
extern int gargc;
extern char **gargv;
extern char OutGn[256],*Cardin;
extern std::string Wrt_type_out;
#endif



// free  Function definition

double  Bran();
double  Bgauss ( double s, double c );
double  Dran();
double  Dgauss ( double s, double c );
double  Pran();
double  Pgauss ( double s, double c );
double  Uran();
double  Ugauss ( double s, double c );


void    Set_Run_Random();
void    Set_Ev_Random();



void     File_Manager();
void     Legge_input_file ( const char * );
void     check_file_name ( const char *,std::string &);
double   Fspace ( double, double, double );
void     Commenta ( const char * );
void     Sommario_Input_Data();

void     flyoinit();
int      flyoevento();
void     flyosimuladev();
void     flyoend();


#if defined(MAIN)
// definition of flyo driving parameters with the default values.
// End_fixed for default  to infinity....1000 Km! 
double Beg_fid = 0.0, End_fid =1.0e+10, Zona=30000.;
int Errori=0, Scatter=0, Perdita=0;
int  Correla=0,Wtrk=0;
int Mostra=1;
int colpo=0, visto = 0,debaggati=0;
gvet Lab_Zero ( -999999.,-999999.,-999999. );
int Pipeline=0,Trigger_low_on=0;
int GasBegin=0;
int Offset_story=0;
#endif

#if !defined(MAIN)
extern int Errori,Scatter, Perdita;
extern double Beg_fid, End_fid, Zona;
extern int Correla,Wtrk;
extern int Mostra;
extern int colpo, visto,debaggati;
extern gvet Lab_Zero;
extern int Pipeline, Trigger_low_on;
extern int GasBegin;
extern int Offset_story;
#endif

#endif











