/***************************************************************************
            Generazione di numeri random basat su  ROOT.    gmp 03.03.2012
                             -------------------
    copyright            : (C) 2000 by Giuseppe m Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA62  simulation program.  random di tipo Marsenne and Twister                                             *
 *                                                                         *
 ***************************************************************************/

#include "parm.h"
#include "evento.h"
#include "TRandom3.h"   //from root include

TRandom3 rdm;

// per la inizializzazione vedi Correla
// Correla 0   inizializzazione fissa
// Correla 1   inizializzazuone by run
// Correla >1  inizializzazione by run and evento!!


// fix inizializzazione
TRandom3 RBeam(123453);   // produzione del fascio  ottica compresa
TRandom3 RDev (512341);   // errori e multscattering, pair e brems e decay
TRandom3 RPart(456123);   // Cinematica dell'evento
TRandom3 RUser(986743);   // per uso dell'utente 



using namespace std;


//-------------------------------------------------------------
void    Set_Run_Random()
{
    // correlazione =1  con il run
    
    unsigned int unsg=evento_.Gen.Run;
    
    Gout<<"\n Random Correlation for run : " <<unsg;
    cout<<"\n Random Correlation for run : " <<unsg;
    RBeam.SetSeed(unsg);
    RDev.SetSeed(unsg+654321);
    RPart.SetSeed(unsg+765123);
    RUser.SetSeed(unsg+999123);    // togliere i commenti se occorre !!!
    
}
//-------------------------------------------------------------
void Set_Ev_Random()
{
    // per  correlazione >1 ....anche con l' evento
    unsigned int unsg=evento_.Gen.Run+evento_.Gen.Event;
    RBeam.SetSeed(unsg);
    RDev.SetSeed(unsg+654321);
    RPart.SetSeed(unsg+765123);
//    RUser.SetSeed(unsg+999123);  // togliere i commenti se occorre !!!
}


///**********************************************
//------------------------------------------------------------
double Bran()   // fascio ed  ottica del fascio
{
  return RBeam.Rndm();
}
double Dran()     // nel device .. scattering
{
  return RDev.Rndm();
}
double Pran()    // Perticelle cinematica
{
  return RPart.Rndm();
}

double Uran()    // user random
{
  return RUser.Rndm();
}


//-------------------------------------------------------------
//             G a u s s r
//-------------------------------------------------------------
//
double  Bgauss ( double s, double c )
{
    return RBeam.Gaus(c,s);
}

double  Dgauss ( double s, double c )
{
    return RDev.Gaus(c,s);
}

double  Pgauss ( double s, double c )
{
    return RPart.Gaus(c,s);
}
double  Ugauss ( double s, double c )
{
    return RUser.Gaus(c,s);
}



//---------------------------------------------------


