/***************************************************************************
                          partfase.cpp  -  description
                             -------------------
    begin                : Mon Dec 25 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/
#define MPIOQ  0.0182169

#include "flyoh.h"
#include <flyopart.h>

#include <flyomtx.h>
#include <evento.h>
#include <reazione.h>
#include <matrice.h>
#include <p0p0pi.h>

using namespace GmpConst;

//using namespace std;

Dalitz::Dalitz ( Particella *pr )
{
    nome=string ( "dalitz" );
    pdec= ( PartFase* ) pr;
    norma_integral=-1.0;
    Gout<<"\n Generata la matrice dalitz per il decadimento pi0 -> g e+ e-  ";
    pdec->Stampa_questa_particella();
    mass_pi0=ptr_Pi0->Get_Massa();

}


double Dalitz::M_Valore()
{
//
// la matrice diverge troppo.. per valori piccoli  della massa ee
// del resto gli eventi a piccolo massa non vengono spesso ben ricostruiti!!!
//
// Massa minima è di 2*massa_elettrone = 0.00102 Gev!
// la distribuzione  è ben approssimata per eccesso da
// P(mres12)= (0.00102/mres12)**2  ed è piccatissima  a piccole masse di mres12

// taglio sulle piccole masse! Attenzione per la normalisìzzazione degli eventi!
// poichè non si generano eventi con masse sotto il Cutoff
// approssimamente gli eventi persi sono dati dal rapporto tra gli integrali della
// funzione P tra (2.me)**2 e   mcut**2 su l'integrale tra  (2.me)**2 e   mp0**2
// per esempio
// per cutoff=0.0025 persi 4.85%
// per cutoff=0.0030 persi 9.20%
// per cutoff=0.0040 persi 16.1%

// static double Cutoff=0.003;
//
// viste tutte le complicazioni si usa il metodo integrale per il
// termine 1./xq che diverge per piccoli valori della massa ee
// qui allora si calcola il valore della matrice ridotto.. cioè senza
// il fattore 1./xq;


    double mres12=pdec->mres12;


    double x = mres12/mass_pi0;

    double xq=x*x;
    double aux=1.-xq;

    //    double M = (aux*aux*aux)/xq;  valore completo

    double M = ( aux*aux*aux ); // valore ridotto (vedi anche partfase.cpp se Mtx è difinito)
    M*= ( 1.+0.032*xq );


    if ( M<0.0 ) {
        M=0.0;    // check
    }


//  Gout<<setprecision(5)<<"\n M12 "<<mres12<<"  xq"<<xq << " wph "<< M;

    return M;

}

double Dalitz::M_ValoreMax()
{
// dipende solo dalla massa 12 ...

    return M_Valore();
}

//=====

void Dalitz::Get_FaseMass()
{
    // prima di procedere verifico se la lista particella ha la corretta sequenza....
    static int check=1;
    if ( check==1 ) {
        Check_Lista();
        check=-1;

    }
    // qui estrae la massa quadra ee con il metodo integrale
    if ( norma_integral<=0.0 ) {
        norma_integral= log ( pdec->mmaxq12/pdec->mminq12 );
    }
    pdec->mres12=sqrt ( pdec->mresq12=pdec->mminq12*exp ( norma_integral*Pran() ) );

    // cout<<"\n ev "<<Eventi_Generati <<" Get_FaseMass dalitz "<< pdec->mres12;
}



void  Dalitz::Check_Lista()
{
// check lista delle particelle
// se non va bene si termina il programma.
// check the correct order  of particles ( pip pi0 e+ e-)

    if ( pdec->p1->Get_Idm() !=4 ||          //e+
            pdec->p2->Get_Idm() !=3 ||       //e-
            pdec->p3->Get_Idm() !=1 ) {      //gam
        Gout<<"\n ERROR .... Incorrect particles order... has to be ( pi0 => elep elec gam )  instead of: pi0 => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;

        cout<<"\n ERROR .... Incorrect particles order... has to be ( pi0 => elep elec gam )  instead of: pi0 => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;

        //          cout<<"\n "<<pdec->p1->Get_Idm() <<" "<< pdec->p2->Get_Idm() <<" "<<pdec->p3->Get_Idm();

        exit ( 1 );

    }

}





