/***************************************************************************

                             -------------------
    begin                : Mon Dec 25 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/


#include <flyoh.h>
#include <flyopart.h>

#include <flyomtx.h>
#include <evento.h>
#include <reazione.h>
#include <matrice.h>


using namespace GmpConst;

//using namespace std;

Enugam::Enugam(Particella *pr)
{
    nome=string("enugam");
    pdec=(PartFase*)pr;
    Gout<<"\n Generata la matrice per il decadimento K+->e nu gam   ";
    pdec->Stampa_questa_particella();
    mass_e =ptr_Elec->Get_Massa();
    mass_K=ptr_Kapp->Get_Massa();

}


double Enugam::M_Valore()
{
// parametri della matrice double
// si suppone che il decadimento sia stato definito
// con la sequenza K+ -> e+ nu  gam; res12-> e+ nu == (p1 p2) p3
//     Particella *p12, *pe,*pg;
//     p12=pdec->dw;
//     pe=p12->dw;
//     pg=p12->rg;

  if(pdec->Define_CMvalues(1)==0)return 0.0;  //Calcolo dei valori cinematici di decadimento..



    double Ee=pdec->e1;
    double Eg=pdec->e3;
    double x = 2.*Eg/mass_K;
    double y = 2.*Ee/mass_K;
    double rl=pow(mass_e/mass_K,2);
    double A0= 0.034; double V0= 0.092; double lambda= 0.4;
    double V= V0*(1.+lambda*(1.-x));
    double A= A0;
    double M= pow(V+A,2)*(x+y-1.-rl)*((x+y-1.)*(1.-x)-rl);
  
    
    if (M<0.0) M=0.0;  // check
    return M;

}
double Enugam::M_ValoreMax()
{
  return 0.0265;
}
 

void Enugam::Get_FaseMass()
{
    // prima di procedere verifico se la lista particella ha la corretta sequenza....
    static int check=1;
    if ( check==1 ) {
        Check_Lista();
        check=-1;

    }
//   standard: uniform between  min e max
    pdec->mres12    =sqrt ( ( pdec-> mresq12 =pdec->mminq12+Pran() *pdec->dmq12 ) );
}
 

void Enugam::Check_Lista()
{
  
// check lista delle particelle
// se non va bene si termina il programma.
// check the correct order  of particles ( e+ nu gam)

    if ( pdec->p1->Get_Idm() !=4 ||          //e+
            pdec->p2->Get_Idm() !=2 ||       //nu
            pdec->p3->Get_Idm() !=1 ) {      //gam
        Gout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => e+ nu gam )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;

        cout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => e+ nu gam )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;

        //          cout<<"\n "<<pdec->p1->Get_Idm() <<" "<< pdec->p2->Get_Idm() <<" "<<pdec->p3->Get_Idm();

        exit ( 1 );

    }

}

  
  