/***************************************************************************
                          partfase.cpp  -  description
                             -------------------
    begin                : Mon Dec 25 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/

#define MPIOQ  0.018218790529
#include <flyoh.h>
#include <flyopart.h>
#include <evento.h>
#include <reazione.h>
#include <matrice.h>
#include <p0p0pi.h>

using namespace GmpConst;

//using namespace std;

P0p0pi::P0p0pi ( Particella *pr )
{
    nome=string ( "p0p0pi" );
    pdec= ( PartFase* ) pr;
    Gout<<"\n Generata la matrice p0p0pi per il decadimento K->p0 p0 pi ";
    pdec->Stampa_questa_particella();
}

double P0p0pi::M_Valore()
{
    // decdimento del K+ ->p0 p0 pip == (p1 p2) p3
    // nota i parametri e1, e2, .... vanno calcolati prima di chiamare questa procedura!!!

    pdec->Define_CMvalues ( 1 ); //Calcolo dei valori cinematici di decadimento...
    double s0= ( pdec->s1+pdec->s2+pdec->s3 ) /3.;

    double su = ( pdec->s3-s0 ) /MPIOQ;
    // parametro da PPB
    double g=0.6525;
    double h=-0.0433;
    double M= 1. +g*su + h*su*su;
    if ( M<0.0 ) {
        M=0.0;    // check
    }


    return M;

}
double P0p0pi::M_ValoreMax()
{
    // prima di procedere verifico se la lista particella ha la corretta sequenza....
    static int check=1;
    if ( check==1 ) {
        Check_Lista();
        check=-1;

    }
// dipende solo dalla massa 12 ...

    return M_Valore();
}


void P0p0pi::Get_FaseMass()
{
//   standard: uniform between  min e max
    pdec->mres12    =sqrt ( ( pdec-> mresq12 =pdec->mminq12+Pran() *pdec->dmq12 ) );
}


void  P0p0pi::Check_Lista()
{
// check lista delle particelle
// se non va bene si termina il programma.
// check the correct order  of particles ( pi0 pi0 pip)

    if ( pdec->p1->Get_Idm() !=9 ||          //pi0
            pdec->p2->Get_Idm() !=9 ||       //pi0
            pdec->p3->Get_Idm() !=8 ) {      //pip
        Gout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => pi0 pi0 pip )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;
        cout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => pi0 pi0 pip )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;



        //          cout<<"\n "<<pdec->p1->Get_Idm() <<" "<< pdec->p2->Get_Idm() <<" "<<pdec->p3->Get_Idm();

        exit ( 1 );

    }

}



