/***************************************************************************
                          partfase.cpp  -  description
                             -------------------
    begin                : Mon Dec 25 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/

#define MPIPQ  0.0194797849
#include <flyoh.h>
#include <flyopart.h>
#include <evento.h>
#include <reazione.h>
#include <matrice.h>
#include <pipipim.h>

using namespace GmpConst;

//using namespace std;

Pipipim::Pipipim ( Particella *pr )
{
    nome=string ( "pipipim" );
    pdec= ( PartFase* ) pr;
    Gout<<"\n Generata la matrice pipipim per il decadimento K->pi+pi+pi- ";
    pdec->Stampa_questa_particella();
}

double Pipipim::M_Valore()
{
    // decdimento del K -> pi+  pi+ pi- == (p1 p2) p3
    // nota i parametri e1, e2, .... vanno calcolati prima di chiamare questa procedura!!!

    pdec->Define_CMvalues ( 1 ); //Calcolo dei valori cinematici di decadimento...
    double s0= ( pdec->s1+pdec->s2+pdec->s3 ) /3.;
    double su = ( pdec->s3-s0 ) /MPIPQ;
//    Parametri da PPB
    double g=-0.21134;
    double h=1.848;
    double M= 1. +g*su+ h*su*su;
    if ( M<0.0 ) {
        M=0.0;    // check
    }
// cout<<" \n Ev "<<Eventi_Generati<< "  mtr   M "<< M<< "  su "<<su<<" s1 "<<pdec->s1<<" s2 "<<pdec->s2<<" s3 "<<pdec->s3;

    return M;

}


double Pipipim::M_ValoreMax()
{
  // prima di procedere verifico se la lista particella ha la corretta sequenza....
    static int check=1;
    if ( check==1 ) {
        Check_Lista();
        check=-1;
    }
  
// dipende solo dalla massa 12 ...   
  return M_Valore();
}



void Pipipim::Get_FaseMass()
{
//   standard: uniform between  min e max
    pdec->mres12    =sqrt ( ( pdec-> mresq12 =pdec->mminq12+Pran() *pdec->dmq12 ) );
}

void  Pipipim::Check_Lista()
{
// check lista delle particelle
// se non va bene si termina il programma.
// check the correct order  of particles ( pip pip pim)

    if ( pdec->p1->Get_Idm() !=8 ||          //pip
            pdec->p2->Get_Idm() !=8 ||       //pip
            pdec->p3->Get_Idm() !=7 ) {      //pim
        Gout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => pip pip pim )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;
        cout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => pip pip pim )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;
        //          cout<<"\n "<<pdec->p1->Get_Idm() <<" "<< pdec->p2->Get_Idm() <<" "<<pdec->p3->Get_Idm();

        exit ( 1 );

    }

}
