/***************************************************************************
                          partfase.cpp  -  description
                             -------------------
    begin                : Mon Dec 25 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/
#define MPIOQ  0.0182169

#include <flyoh.h>
#include <flyopart.h>

#include <flyomtx.h>
#include <evento.h>
#include <reazione.h>
#include <matrice.h>
#include <pvvmtx.h>

using namespace GmpConst;

//using namespace std;

Pvvmtx::Pvvmtx(Particella *pr)
{
    nome=string("pvv");
    pdec=(PartFase*)pr;
    Gout<<"\n Generata la matrice del decadimenpo K-> pip nu nu ";
    pdec->Stampa_questa_particella();

  mas_pip=ptr_Pip->Get_Massa();
  mas_kp= ptr_Kapp->Get_Massa();
  masq_kp=mas_kp*mas_kp;
  masq_pip=mas_pip*mas_pip;
  Gout<<"\n Pvvmtx  done ";

}  


double Pvvmtx::M_Valore()
{
  // controllare la definizione delle energie  
  // controllare se la serie particelle è giusta 
  

  if(pdec->Define_CMvalues(1)==0)return 0.0;  //Calcolo dei valori cinematici di decadimento..
  double e1=pdec->e1;
   double e2=pdec->e2;
   double e3=pdec->e3;

  double Eprime,a,q2,v;
  Eprime = ( masq_kp +masq_pip ) / ( 2.*mas_kp )-e3;
  a      = mas_kp* ( 2.*e1*e2-mas_kp*Eprime );
  if(a<0.) return 0.0;
  
  q2     = masq_kp +masq_pip-2.*mas_kp*e3;
  v      = 1.+0.0286*q2/ ( masq_pip );
  double M = a*v*v;
 // Gout<<"\n m ev "<<Eventi_Generati<<" "<<se 
  
    return M;

}


double Pvvmtx::M_ValoreMax()
{
  // prima di procedere verifico se la lista particella ha la corretta sequenza....
    static int check=1;
    if ( check==1 ) {
        Check_Lista();
        check=-1;
    }
// dipende solo dalla massa 12 ...   
 
  return M_Valore();
}



void Pvvmtx::Get_FaseMass()
{
//   standard: uniform between  min e max
    pdec->mres12    =sqrt ( ( pdec-> mresq12 =pdec->mminq12+Pran() *pdec->dmq12 ) );
}




void Pvvmtx::Check_Lista()
{
  
// check lista delle particelle
// se non va bene si termina il programma.
// check the correct order  of particles ( pip nu nu )

    if ( pdec->p1->Get_Idm() !=4 ||          //pip
            pdec->p2->Get_Idm() !=2 ||       //nu
            pdec->p3->Get_Idm() !=2 ) {      //nu
        Gout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => pip nu nu  )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;

        cout<<"\n ERROR .... Incorrect particles order... has to be ( K+ => pip nu nu  )  instead of: K+ => "
            <<pdec->p1->Get_Nome() <<" "<< pdec->p2->Get_Nome() <<" "<<pdec->p3->Get_Nome()
            << "  EXIT "<<endl;

        exit ( 1 );

    }

}


