/***************************************************************************
                          partdltz.cpp  -  description
                             -------------------
    begin                : Sun May 9 2004
    copyright            : (C) 2004 by gmp
    email                : peppe@newpeppe
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/



#include "flyoh.h"
#include "reazione.h"

using namespace GmpConst;

/**-------------------------------------------------------------
Procedura che controlla il beam (particella proiettile), nel caso di un urto.

*/


PartBullet::PartBullet()
{
  type=Bullet;
  Gout<<"\n Classe PartBullet  Done : "<<nome;
 }


void  PartBullet::Get_Bersaglio ( Device *dev, double lint )
{

  /**-------------------------------------------------------------
  Determina il punto di interazione dell beam ( definito qui bullet) con la particella bersaglio all'interno del device che ha funzione anche di
  target.

  Questa procedura è chiamata da device::Traccia() se la particella beam (qui bullet)  è nel device definito bersaglio.
  Si ridefisce il cammino potenziale del beam nel materiale del target  prima dell'urto e se minore
  delle dimensioni del dev terget si termina il tracing della particella beam e si calcolano i
  parametri cinematici del centro di massa cms. Se il cammino è  maggiore si procede regolarmente,
  come richiesto nella epc di riferimento nel caso che il beam non urti nulla e decada regolarmente.
  */

//  Gout<<"\n  "<<Eventi_Generati<<"  Bullet in Get_Bersaglio   "<< lint;
  if ( lint==0.0 ) return;
 
// si stima il cammino prima di interagire sfruttando  la lunghezza di interazione.
  double spessore=0.;
  if ( dev->nowpos==0 ) spessore=2.*dev->Get_Lout().z;  //interno
  else spessore=2.*dev->Get_Lin().z;      // nel buco

  double dz= -lint* log(1.0-Pran()*(1.0-exp(-spessore/lint)) );  //interagisce sempre.....per definizione...
  
 

  if ( dz> spessore ) return;    // ha superato il bersaglio senza interagire.. non dovrebbe accadere
  pathok= dz;
  Set_Fato ( Distr,-3 );   // qui  la particella è distrutta con flags -3
  //e diventa sterile, cioè non si fa decadere azzerando il puntatore ai suoi  prodotti di decadimento; vedi flyevent()
  dw=0;   // attenzione 
  
//====================================//
// calcolo i parametri del  ucms

//  pinc+ Pbers => ucms => 
  Particella *madre, *ucms;
  madre=rg;
  
  madre->P.setvn(SelRea->Pbers,madre->Get_Massa());
  
  ucms= madre->dw;
  ucms->P=P+madre->P;
  ucms->P.Invar();
  ucms->Get_Gp() =ucms->P;
  ucms->Set_Massa(ucms->P.m);
  ucms->Set_Fato ( Nata,-1 ); 
  
// definizione dei parametri di decadimento secondo la fisica di produzione 
  ucms->DecParm();



}
