/***************************************************************************
                         partfase.h  -  description
                             -------------------
    begin                : Sun Nov 26 2000
    copyright            : (C) 2000 by Giuseppe m Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA48  titles for simulation program.                                  *
 *                                                                         *
 ***************************************************************************/
// Pisa   6.05.05
//------------------------------------------------------------
//      classe          P a r t i c e l l a

#ifndef PARTFASE_H
#define PARTFASE_H
#include <particella.h>
/**
Procedura per il calcolo dello spazio dell fasi.
<br>
<br>Three, four or five bodies decay <br> following the phase space... via
the dummy resonances:
<br>Res2  for three bodies decay
<br>Res3  for four bodies  decay
<br>Res5  for five bodies decay

@author Giuseppe Pierazzini
*/


class PartFase : public Particella
{
/**
<br>  Esempio di decadimento a tre corpi
<br>
<br>   M => p1 + p2 + p3   generata secondo la catena
<br>  M=> p1 + Res
<br>            Res => p2 + p3;
<br>  M è il padre,
<br>  Questa procedura è chiamata sempre dalla particella Res (this)
<br>  Per la definizione dei decadimenti a 4 corpi e a 5 corpi vedi le procedure
<br>  Partres4 e Partres5.
*/

public:
  int iterfs;
   
//    Particella *pfrate,*pchd1,*pchd2;
    Particella *p1,*p2,*p3,*p4,*p5;
    Particella *pr1,*pr2,*pr3,*pr4;
    qvet P1cm,P2cm,P3cm,P4cm,P5cm;
  
  
  
    double mpadre, mpadreq;     // il padre da cui deriva this
    double mfrate, mfrateq;     // la particella fratello di this ..storico
    double mchd1,mchd2, mchd3, mchd4, mchd5;  // figli
    double mchd1q, mchd2q, mchd3q, mchd4q, mchd5q;

 //   parameters for 3-5 bodies
 
    
//   double mres2,mresq2,eres2,pstar2,estar2,cst2,fistar2;
//    double mmin2,mmax2,mminq2,mmaxq2,dmq2;// three bodies
    double mres12,mresq12,eres12,pstar12,estar12,cst12,fistar12;
    double mmin12,mmax12,mminq12,mmaxq12,dmq12;// three bodies



    double s1,s2,s3;
    double e1,e2,e3,e4,e5;
//    double gam,eta,pstar;
    double  wfase_max;



    PartFase();
    virtual ~PartFase() {};
    virtual void   Get_PhaseSpace();     // phase space point generator + costar ...
    virtual void   Get_PhaseParm();
    virtual void  DecParm();
    virtual int   Define_CMvalues(int);
};

#endif
