/***************************************************************************
                          partres5  -  description
                             -------------------
    begin                : Sat Feb 26 2005
    copyright            : (C) 2005 by Giuseppe Pierazzini
    email                : peppe@peppix
  ***************************************************************************
  *                                                                         *
  *   NA48  simulation program.                                             *
  *                                                                         *
  ***************************************************************************/
#include "flyoh.h"
#include "fasemax.h"
using namespace std;
/**
 Five  bodies decay like  k -> pi0 pi0 pi0 e nu in phase space..
 the decay is via the res123 and res34 and res12  resonance
 generated in the decay chain automatically..
  *@author Giuseppe Pierazzini
  */
Partres5::Partres5()
{
    p1=p2=p3=p4=p5=0;
    type="Dec5";
  Gout<<"\n Class Partres5  : "<<nome<<" done!";
}


void Partres5::

DecParm()
{
    // rivedere !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!?????? mancano Define_CMvalues....


// skip.. if  p1 allready defined....
    if ( p1==NULL )
    {
// define the pointer to the four particles;
// and the decay parameters

        Get_PhaseParm();


    }

//------------------------
// get the invariant values...
    Get_PhaseSpace();

// define the resonace particle parameters..masse...
//
// res 1  == this 
    pr1->Set_Massa (mres123);
    pr1->P.Riposo  (mres123);
// res 2
    pr2->Set_Massa(mres45);
    pr2->P.Riposo (mres45);
// res 3
    pr3->Set_Massa(mres12);
    pr3->P.Riposo (mres12);
}


void Partres5::Get_PhaseParm()
{
//  C O N T R O L L A R E PRIMA dell'u s o
// questo decadimento a 5 corpi non è completo
//  manca la definizione di int Partres5::Define_CMvalues ( int genera )

    /*-------------------------------------------
       five bodies decay
    M => p1  p2  p3 p4  p5 generata secondo la catena
    M => mres123  mres45  
         mres123 => p1 mres23  
         mres23  => p2 p3
         mres45 => p4 p5
       
       Phase space weight
       w = F(padre,mres123,mres45)*F(mres123,p1,mres23)*F(mres23,p2,p3)*F(mres34,p3,p4)

      --------------------------------------------------*/

    if (pr1!=0) return;
    
    pr1=this;
    pr2=pr1->rg; 
    pr3=pr1->dw;
    p1=pr3->rg;
    p2=pr3->dw;
    p3=p2->rg; 
    p4=pr2->dw;
    p5=p4->rg;
    
// particle parameters
    mpadre=Get_Massa();
    mpadreq=mpadre*mpadre;
    mchd1=mfrate=p1->Get_Massa();
    mchd1q=mfrateq=mfrate*mfrate;
    mchd2 =p2->Get_Massa();
    mchd2q=mchd2*mchd2;
    mchd3 =p3->Get_Massa();
    mchd3q=mchd3*mchd3;
    mchd4 =p4->Get_Massa();
    mchd4q=mchd4*mchd4;
    mchd5 =p5->Get_Massa();
    mchd5q=mchd5*mchd5;
    
    



// massimi e minimi valori delle risonanze
    mmin123=mchd1+mchd2+mchd3;
    mminq123=mmin123*mmin123;
    mmax123=mpadre-mchd4-mchd5;
    mmaxq123=mmax123*mmax123;
    
    mmin45=mchd4+mchd5;
    mminq45=mmin45*mmin45;
    mmax45=mpadre-mchd1-mchd2-mchd3;
    mmaxq45=mmax45*mmax45;
    
    mmin12=mchd2+mchd3;
    mminq12 =mmin12*mmin12;
    mmax12=mpadre-mchd1-mchd4-mchd5;
    mmaxq12=mmax12*mmax12;
    
    
    dmq123 =mmaxq123-mminq123;
    dmq45 =mmaxq45-mminq45;
    dmq12 =mmaxq12-mminq12;

    Gout<<"\n *************Get_PhaseParm debug for decay5:  scrivo tutte le particelle ";
    p1->Stampa_questa_particella();
    p2->Stampa_questa_particella();
    p3->Stampa_questa_particella();
    p4->Stampa_questa_particella();
    p5->Stampa_questa_particella();

    pr1->Stampa_questa_particella();
    pr3->Stampa_questa_particella();
    pr2->Stampa_questa_particella();
    Gout<<"\n *************Get_PhaseParm debug for decay5:  end\n ";
// nota Fase
//     cout<<"\n mass  "<<mminq<<" "<<mmaxq<<" "<<pr2->mminq<<" "<<pr2->mmaxq<<" "<<pr3->mminq<<" "<<pr3->mmaxq;
    int p_id[6]= {Get_Idm(),p1->Get_Idm(),p2->Get_Idm(),p3->Get_Idm(),p4->Get_Idm(),p5->Get_Idm()};
    if ( Fasemx!=0 )
    {
        double  wmx=Fasemx->Get_Wmax ( p_id);
        if ( wmx>0. )
        {
            wfase_max=wmx;
//      Gout<<"\n Ev "<<Eventi_Generati<<" F.S. trovato "<<up->Get_Nome() <<" "<<nome<<"=> "<<p1->Get_Nome() <<" "<<p2->Get_Nome() <<"
//  "<<p3->Get_Nome()<<" "<<p4->Get_Nome()<<" "<<p5->Get_Nome();
            return;
        }
    }

//allora calcolo il valore massimo

    double pass123=dmq123/100.;
    double pass45=dmq45/100.;
    double pass12=dmq12/100.;
    double w,w1,w2;

    // define the wfase_max for p.s.  normalizazion
    wfase_max=0.0;
    for ( mresq123=mminq123; mresq123<mmaxq123; mresq123+=pass123 )
    {
        mres123=sqrt ( mresq123 );
      
        for ( mresq45=mminq45; mresq45<mmaxq45; mresq45+=pass45 )
        {
            mres45=sqrt ( mresq45 );
            w1=Fspace ( mpadre,mres123,mres45 )*Fspace(mres45,mchd4,mchd5);
	    
            for ( mresq12=mminq12; mresq12<mmaxq12; mresq12+=pass12 )
            {
                mres12=sqrt ( mresq12 );
                w2=Fspace(mres123,mchd1,mres12)*Fspace ( mres12,mchd2,mchd3);
                w=w1*w2;
                if ( w>wfase_max ) wfase_max=w;
            }
        }
    }

    Gout<<"\n Phase-Space5: w="<<wfase_max<<" done for " <<Get_Nome()<<" ==> "<<p1->Get_Nome()<<" "<<p2->Get_Nome()
    <<"  "<<p3->Get_Nome()<<" "<<p4->Get_Nome()<<" "<<p5->Get_Nome();

    new FaseMax ( p_id,wfase_max );
}


void  Partres5::Get_PhaseSpace()
{
     iterfs=0;
 
    while ( iterfs++<400 )
    {
        // resonance mass selection...
        mres123 =sqrt ( ( mresq123 =mminq123+Pran() *dmq123 ) );
        mres45 = sqrt ( ( mresq45  =mminq45+Pran() *dmq45 ) );
        if ( mres123+mres45>mpadre )  continue;
        mres12 = sqrt ( ( mresq12  =mminq12+Pran() *dmq12 ) );
        if ( mres12+mchd1>mres123 ) continue;

        double w=Fspace ( mpadre,mres123,mres45 )*Fspace(mres45,mchd4,mchd5)*
                 Fspace(mres123,mchd1,mres12)*Fspace ( mres12,mchd2,mchd3);

        if ( w >wfase_max )
        {
            Gout<<"\n Wfas off: Ev "<<evento_.Gen.Event<<" iter="<<iterfs<<" prb="<<w
            <<" prbmax"<<wfase_max<<" "<<SelRea->Get_Titolo();
            wfase_max=w+0.000001;
// aggiorna  wfase_max memorizzato nella lista
            int p_id[6]= {Get_Idm(),p1->Get_Idm(),p2->Get_Idm(),p3->Get_Idm(), p4->Get_Idm(),p5->Get_Idm()};
            Fasemx->Set_Wmax ( p_id, wfase_max );
        }

        if ( Pran() <w/wfase_max ) break;

    }
    if ( iterfs>390 )
        Gout<<"\nPartRes5 iter="<<iterfs<<" Risonaze: m123="<<mres123<<" m45="<<mres45<<" m12="<<mres12;
}
