/***************************************************************************
                             -------------------
    begin                : Sun Nov 26 2000
    copyright            : (C) 2000 by Giuseppe m Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA48  simulation program.    1992----2005                                         *
 *                                                                         *
 ***************************************************************************/
#define UNDEF     6
#define ESTERNO   1
#define INTERNO   0
#define INBUCO   -1
#define NEUTRI  1
#define CARICHI 2
#define ALLCHR  3

#include "flyoh.h"
int Dbg_trasp=0;

using namespace GmpConst;
using namespace std;
/**
Procedura di trasporto delle particelle all'interno dell'apparato
*/
int debgvoldec=-1;
//=============================================================
//              V o l d e c
//=============================================================
// Decay in flight of pa in pb and pc            Voldec
//-------------------------------------------------------------

int Particella::
Voldec ( Particella * pb, Particella * pc )

{
        Particella *pa;
        double eb, pcm,pt,pcmq;
        double rma, rmb, rmc;
        double cost,fi, sinfi, cosfi;
        static qvet Stesso;   //dummy for lorentz buster...
        //============

        pa = this;                // nota giusto per differenziare rispetto a pb e pc

//     pa->Stampa_questa_particella();
//     pb->Stampa_questa_particella();
//     pc->Stampa_questa_particella();



        if ( pa ->fato==Decay );  // particelle che decadono
        else if ( pa->ctau < 0. )
                return -1;        // stable particle. no action is taken*/

        // Test the fato of the father particle, if not normal  */
        // stop the child generation */




        pa->DecParm();


        if ( pa->fato != Nata && pa->fato != Decay ) {
                pb->fato = Undef;
                pb->Ifato=0;
                pc->fato = Undef;
                pc->Ifato=0;
                pc->X = pb->X = pa->X;
                return -2;  //non va trasportato!
        }
// copia P nel vettore ausiliario Qpatre, può essere alterato da DecParm
        pa->Qpatre=pa->P;


//-----------------------------------------------------------
// produzione coppie nella interazione dei gamma nel materiale...
// produzione bremsstrhalung da leptoni...

        if ( pa->Pair_Production>1 )  pa->DecParm_Pair();  // Controllare ora non funge!!!
        if ( pa->Brems_Production>1 ) pa->DecParm_Brems();

        pb->fato = Nata;
        pb->Ifato = -1;
        pc->fato = Nata;
        pc->Ifato = -1;

//  get the parameters for particle : FaseSpace resonance == dec isotropici,
//  coppia dalitz, ... munu da K3l...
// does nothing for stable particles ....
//   pb->DecParm();
//    pc->DecParm();
//     pb->Stampa_questa_particella();
//     pc->Stampa_questa_particella();
//     Gout<<"\n Voldec interno 1 "<<flush;



// define the particles parameters for next use
        rma = Qpatre.m;
        rmb = pb->massa;
        rmc = pc->massa;

        pb->P.e = eb = ( rma * rma + rmb * rmb - rmc * rmc ) * 0.5 / rma;
        pc->P.e = rma - eb;
        pcm = sqrt ( ( pcmq= ( eb + rmb ) * ( eb - rmb ) ) );
        pb->P.normaq = pc->P.normaq = pcmq;
        pb->P.norma = pc->P.norma = pcm;

//******************************************************************/
// decadimento isotropo se cstar non e' stato gia' definito!
        if ( pb->cstar>1. ) {
                pb->cstar=cost = 1.0 -  2.0 * Pran();
                pb->fistar=fi = DuePiGreco* Pran();
                cosfi = cos ( fi );
                sinfi = sin ( fi );
                // aggiorno gli angoli anche dell'altra particella
                pc->cstar=-cost;
                double finew=fi+PiGreco;
                if ( finew>DuePiGreco ) finew=finew-DuePiGreco;
                pc->fistar=finew;

        } else { // fisica di decadimento definita
                cost = pb->cstar;
                fi   = pb->fistar;
                cosfi = cos ( fi );
                sinfi = sin ( fi );
        }


// Gout<<"\n Voldec ev2 "<<Eventi_Generati<<" "<<this<<" "<<pb <<" "<<pc<<flush;
//   Gout<<" "<<this->Get_Nome()<<" "<<pb->Get_Nome() <<" "<<pc->Get_Nome()<<flush;
        // Definisco un sistema con l'asse z nella direzione di moto
        // della particella padre nel baricentro dove fu creata.
        // Come creare l'asse x! adesso a random!!

        // Attenzione Pbar va definito cosi' se si tratta di risonanza
        // altrimenti occorre Pbar=pa->P vedere meglio!!!!!!!!!!!
        gvet vaz=pa->Pbar.Verso();          // asse z
// definizione del miglior asse sghembo a vaz.. arbitrario
        gvet vzn ( 1.,0.,0. );
// attenzione rivedere anche se funziona !!!!!!!!!!!!!
        double ax,ay,az;
        vaz.putv ( ax,ay,az );
        ax=fabs ( ax );
        ay=fabs ( ay );
        az=fabs ( az );
        if ( ay<=az&&ay<=ax )   vzn.setv ( 0.,1.,0. );
        else if ( az<=ax )      vzn.setv ( 0.,0.,1. );
//-------
        gvet vay=vaz&vzn;
        vay.Norma();
        vay=vay.Verso(); // asse y
        gvet vax=vay&vaz;
        vax.Norma();
        vax=vax.Verso(); // asse x
        pt = pcm * ( sqrt ( 1. - cost * cost ) );// pericolo di negativa sqrt!
        gvet mom ( vax*pt*cosfi + vay*pt*sinfi + vaz*pcm*cost );
        //      mom.Norma();
        //    mom.print("mom");

        pc->P.x=- ( pb->P.x=mom.x );
        pc->P.y=- ( pb->P.y=mom.y );
        pc->P.z=- ( pb->P.z=mom.z );



//ricordo il suo momento nel  baricentro.



        pb->Pbar=pb->P;
        pc->Pbar=pc->P;



        pb->Pburst=Qpatre;
        pc->Pburst=Qpatre;  // ricordo il momento del padre  ...
// vedi qui sotto.. si evitano problemi con le trasformate di lrentz   ..





//Get the lorentz booster



        if ( pa->type==Res )   // decadim in 3 or + bodies via Res....   ???????
//    pa->nome==Pic2 ,Pi02,P00p,Gg2
        {
// prima un burst nella direzione e velocità che aveva la Pa
// nel baricentro di suo padre
                pb->P=pb->P.Lburst ( pa->Pbar );

//      pb->P.print(pb->nome);Gout<<" cstr "<<pb->cstar;

                pc->P=pc->P.Lburst ( Stesso );   //sono nel bar del padre della risonanza

//       pc->P.print(pc->nome);Gout<<" cstr "<<pc->cstar;


// quindi passo al lab con  il burst impresso a Pa  a suo tempo
                pb->P=pb->P.Lburst ( pa->Pburst );
                pc->P=pc->P.Lburst ( Stesso );
        }

// se il padre non e' una risonanza passo direttamente al lab if pa moves    *

        else  if ( Qpatre.norma > 0.0 ) {
                pb->P=pb->P.Lburst ( Qpatre );
                pc->P=pc->P.Lburst ( Stesso );


        }
//-------------------------------------



        pb->Gp = pb->P;
        pc->Gp = pc->P;

        pb->Vers=pb->P.Verso();
        pc->Vers=pc->P.Verso();
// nascita set to ok...
        pb->nata=pc->nata=1;
        // define the  initial coordinates at the father space point */
        // see the Transport  routine */
        pb->Gx=pb->X = pc->Gx= pc->X = pa->X;

        /*******************   debug   ***/
        if ( debgvoldec>0&&pa->nome==Res2 )
//     if (Eventi_Generati==129)
        {
//   pa->Stampa_questa_particella();
                Gout<<"\n Ev "<<Eventi_Generati<<" in  Voldec ";
                pa->P.print ( pa->nome );
                pa->X.print ( "Pa_X" );
                Gout<<" "<<setw ( 8 ) <<pa->nome <<" "<<setw ( 4 ) <<pa->ido<<" "<<setw ( 4 ) <<pa->id  <<"  Ev "<<Eventi_Generati;
                pb->P.print ( pb->nome );
                pb->X.print ( "Pb_X" );
                Gout<<" "<<setw ( 8 ) <<pb->nome <<" "<<setw ( 4 ) <<pb->ido<<" "<<setw ( 4 ) <<pb->id;
                pc->P.print ( pc->nome );
                pc->X.print ( "Pc_X" );
                Gout<<" "<<setw ( 8 ) <<pc->nome <<" "<<setw ( 4 ) <<pc->ido<<" "<<setw ( 4 ) <<pc->id;
                Gout<<endl;
        }




        /************   end debug ********/
        return 1;
}


//=============================================================
//              T R A S P O R T
//=============================================================
/**
<P>
 T R A N S P O R T <br>
This procedure transports particles with momentum and life time
different fron zero... and verifies along the path the crossing
of the devices.

<br>
</P>
 Particle status definition during the tracing
 <br>
<ul>
<li>Ifato =  Idev <=> fato = "Nomev"   Id or Name of device where the particle dies.
<li>Ifato = -1    <=> fato = "Norma" o "Nata" particle just born.
<li>Ifato = -2    <=> fato = "Decay"   stop tracing for decay.
<li>Ifato = -3    <=> fato = "Distr"   the particle is destroyed in the interaction or in the collision.
<li>Ifato = -5    <=> fato = "b->in"   it enters in the internal section  from the "hole" of the device  and dies
<li>Ifato = -6    <=> fato = "in->b"   it enters in the  "hole" of the device from the internal section.
<li>Ifato = -8    <=> fato = "Decfar"  it decays very far from the apparatus.
<li>Ifato = -9    <=> fato = "Lost  "  the particle is stable and it is lost very far  from the apparatus.
<li>Ifato = -10   <=> fato = "Novede"  this particle is never seen by the devices
<li>Ifato = -12   <=> fato = "Decay"   for pair production by gammas
<li>Ifato = -13   <=> fato = "Decay"   for charged particle in  brems strahlung
<li>Ifato = -16   <=> fato = "Dead"    for  charged particle in multiplescattering
<li>Ifato = -17   <=> fato = "Dead"    cut for  charged of too low energy.
<li>Ifato = -18   <=> fato = "Dead"    cut for gammas of   too low energy.
<li>Ifato = -20   <=> fato = "Gasint"  the particle is destroyed in the interaction with a molecule of the gas..(vedi Devfluka)
</ul>
</P>
<P>
RIVELA:  <br>
<ul>
<li>-1  = pr non seen
<li> 0  = pr seen
<li> 1  = pr all energy memorized  but tracing goes on
<li> 2  = pr seen and dump and  stop tracing
<li> 3  = pr seen but not registered
<li> 4  = pr dump but not registered
</ul>
<br>

-----------------------------------------
</P>
*/

int Particella::
Trasport ()
{

        int botta = 0, loop = 1000;



// do nothing if .....
        if ( P.norma == 0.0 || ctau == 0.0 || ( fato != Nata ) ) return botta;




//     Gout<<"\n Entro in Transport "<<evento_.Gen.Event;
//     Gout<<"\n Trsa: "<<setprecision(2)
//     <<" Ev "<<evento_.Gen.Event<<" id "<< id<<" "<<fato<<" P "<<P.norma<<" ctau "<<ctau<<" see "<<see;

        if ( see == 0 ) {
                fato = Novede;
                Ifato=-10;
                return botta;
        }



        double lontano=Zona - X.z;  // attenzione veri9fica se si supera la zona sperimentale in zeta....

//cout<<"\n "<<setw(10)<<nome<<" lontano "<<setw(8)<<lontano<<" z "<<setw(8)<<X.z;

        if ( lontano <0. ) {
                fato=Decfar;
                //      cout<<"\n Zona "<<Zona<<" " << X.norma;
                Ifato=-25;
                return  botta ;
        }


        if ( type != Beam && type!=Bullet ) {
                if ( ctau > 0.0 ) { // particella che decade seguita da .....anche nulla..
                        double volo = ctau * P.norma / massa;
                        path_max = -volo * log ( EPSI + Pran() );

                        if ( flyo_unit!=1.0 ) path_max*=flyo_unit; // aggiusto se si lavora in metri....

                        if ( path_max> lontano ) path_max = lontano;

//      if(Eventi_Generati>71&Eventi_Generati<91)
//       Gout<<"\nEv "<<setw(8)<<Eventi_Generati<<" Trans. "<<setw(6)<<nome<<"  "<<setw(5)<< ido<<setprecision(2)
//       <<"  "<<setw(9)<< path_max<<" pz "<<setw(9)<<P.z<<" Rand "<<setw(9)<<Pran()<<flush;

                } else path_max = lontano; // for stable particles...or with decay not defined...


        }

//    Gout<<"\nEv "<<Eventi_Generati<<" Trans. "<<nome<<"  " << path_max<<" X.z "<<X.z<<" pz "<<P.z;
// set the devices accessible to the flighing particle..

        Set_Rivela_in_Dev ( this );
// Apparato->Set_Rivela(this);
//=====================================================
//=====================================================
// start  the loop on the apparatus

        // Vers = flight direction defined in particle object....

        path_done = pathok = 0.0;
        Device *pv,*Dvok;
        Devloop = Apparato;
        Devloopend=last_device;//
        Apparato->Reset_Pos();

        while ( --loop >= 0 ) {
                pv=Devloop;  // starting Dev... can be changed by Get_camm.
                Dvok=pv->Get_camm ( this );



                if ( Dvok == 0 ) break; //end transport: passati tutti i dev...
                pathok=Dvok->camm;


//  if(Dvok->idev==2&&ido==1)
//   Gout<<"\n Ev "<<setw(5)<<Eventi_Generati<< " "<<setw(8)<<nome << "  devloop "<<setw(8)<<pv->nome
//       << "  devok  "<<setw(8)<<Dvok->nome<<" " <<setw(8)<<Dvok->camm<< "   "<<Dvok->nowpos;


                /*
                        if(Dvok->idev==2&&ido==1)
                    cout<<"\n Ev "<<setw(5)<<Eventi_Generati<< " "<<setw(8)<<nome
                    << "   "<<setw(8)<<Dvok->nome<<" pth "<<setw(8)<<pathok
                   << " pos "<<setw(2)<<Dvok->nowpos<<" prev "<<setw(8)<<Dvok->prevpos;*/


                // potential path redefined if bigger then dacay path.
                if ( ctau>0.0 && pathok > ( path_max-path_done ) ) {
                        pathok= ( path_max-path_done+0.000001 );
                        fato=Decay;
                        Ifato=-2;

                }





//==============================================================================
//==============================================================================

                if ( Dvok->nowpos == ESTERNO );  // do nothing


//==============================================================================
//==============================================================================


                else if ( Dvok->nowpos == INTERNO )

                {

                        botta++;

//----------------------------------------------------
//----------------------------------------------------
//            if ( Dvok->idev==44 ) cout<<"\n Ev "<<Eventi_Generati<<" " << nome<<" nel "<<Dvok->nome;


// destino secondo la funzione

                        if ( Dvok->fun == Trig    ||
                                        Dvok->fun == None ||
                                        Dvok->fun == Nodef ); // nessuna decisione .. si continua a tracciare

// altrimenti le cause per terminare il tracing...si cambia il fato

                        else if ( Dvok->fun == Dead ) {
                                fato = Dvok->nome;
                                Ifato=Dvok->idev;
                        }



                        else if ( Dvok->fun == Magn || Dvok->fun == Dump||Dvok->fun == Trigh ) {
                                // nota se è un magnete standard... il frame del magnete (che corrisponde all' INTERNO)
                                // fa da dump. Il campo è sempre  nel "buco"
                                if ( nome!=Mum && nome!=Mup ) { //except the muons..
                                        fato = Dvok->nome;
                                        Ifato=Dvok->idev;
                                }
                        }

                        else if ( Dvok->fun == Veto ) {
 // nel caso del "veto" si uccide addirittura l'evento con il flag botta =-1000  se Vieta=1;

   //             cout<<"\n Ev "<<Eventi_Generati<<" " << nome<<" vetoed  by "<<Dvok->nome;
                              
                                fato = Dvok->nome;
                                Ifato=Dvok->idev;
                                if(Vieta==1) return -1000;  // se vogliamo uccidere l'evento
                        }
                

                // assorbe tutta l'energia e muore
                if ( Dvok->rivela==2|| Dvok->rivela==4 )    {
                        fato = Dvok->nome;
                        Ifato=Dvok->idev;
                }


                // debug  quale decisione?
                /*
                if ( Dvok->idev==2 )
                {
                    X.print ( "X1" );
                    Gout<<setprecision(3)
                        <<" ev "<< Eventi_Generati<<" "<< nome
                        <<" pos " <<Dvok->nowpos<<" "<<Dvok->prevpos
                        <<" dh "<<devhit
                        <<"    ft "<<fato
                        << "    pathok " <<setw(9)<<pathok;
                }
                 */
//----------------------------------------------------
//----------------------------------------------------
// scrivo i colpi (cioè memorizza gli hits nei devices)  quando

                if ( Dvok->prevpos==ESTERNO    ||   // è appena entrata dall'esterno
                                Dvok->prevpos<=INBUCO  ||   // è entrata dal "buco"
                                Dvok->prevpos>=UNDEF   ||   // appena nata o devhit=0 (vedi ScrvColpi() )
                                devhit==0 )    Dvok->ScrvColpi ( this );                 // prima volta vista


        }
// ---------- fine interno -----------
//==============================================================================
//==============================================================================
//------------ E' nel buco
        else if ( Dvok->nowpos <= INBUCO ) {
                if ( Dvok->fun==Magn  &&          // entra nel "buco" del mag o nasce nel mag!
                                ( devhit==0           ||
                                  Dvok->prevpos==UNDEF||
                                  Dvok->prevpos==ESTERNO ) )  {
                        Dvok->ScrvColpi ( this );
                }

                //pro memoria ...dall'INTERNO va  nel buco..per ora si lascia tracciare
                //if ( Dvok->prevpos== INTERNO );

        }
//--------Fine in buco------------
//==============================================================================
//==============================================================================
//.... check the fato

        if ( fato!=Nata&&fato!=Decay ) {
                return botta;  //stop tracking....se il fato è diverso da normale o da "decay"
        }
// qui solo per particelle con fato normale o in decadimento.
//***************************************************************************
//----------------------------- real trasport  -------------------------------
//  now move the particle in the  space doing  also
//  pair production  or bremsstrhalung .or clusters..or move in magnetic field..and multiplescattering.
//


        if ( Dvok->nowpos == ESTERNO ) {

                Move ( pathok );
                if ( Dbg_trasp>0 ) Dvok->Spia_Camm ( "Trans-pos 1",this,pathok,0.0 ,"   " );
                last_path=pathok;
        } else {
                int ift=Dvok->Traccia ( this );

                if ( Dbg_trasp>0 ) Dvok->Spia_Camm ( "Trans-pos <1",this,pathok ,last_path,"   " );

                if ( ift>0||P.e<0.001||pathok<0.001 ) {
                        fato=Dvok->nome;
                        Ifato=Dvok->idev;
                        return botta;
                } else if ( ift < 0 ) { // muore nel tracing ...
                        fato=Dvok->nome;
                        Ifato=ift;
                        return botta;
                }


        }

//==============================================================================
//==============================================================================
        if ( fato==Decay ) { //stop tracking....anche per gam->pair prod and brems ...
                if ( X.Norma() >Zona )  {
                        fato=Decfar;
                        Ifato=-8;
                }

                return botta;
        }
        if ( P.norma<0.0001 ) { // stop tracing  per fine energia
                fato = Dvok->nome;
                Ifato=Dvok->idev;
                if ( Dbg_trasp>0 )
                        Gout<<"\nTrans:  Ev  "<<evento_.Gen.Event<<" Stop tracing "<<nome<<" "<<fato<<" "<<X.z;
                return botta;

        }
}
//==============================================================================
//==============================================================================
//................  e n d    t r a c i n g   lo o p ........
//  here if fato == norm .....  rivedere qui....



if ( ctau < 0.0 )   // particella stabile
{
        if ( X.Norma() <.90*Zona ) {
                // X.Norma();X.print(nome);
                pathok=path_max-path_done;
                X+=Vers*pathok;  //transport
                // X.Norma();X.print(nome);
        }
        fato = Lost;
        Ifato=-9;
}

// particella che decade......
else if ( ctau > 0.0 && P.norma>0.001 )
{

        pathok=path_max-path_done;

        if ( Dbg_trasp>0 ) Gout<<"\nTrans: free path to complete the flight done!  cm "<<pathok;
//        Gout<<"\nTrans: free path to complete the flight done!  cm "<<pathok;

        X+=Vers*pathok;  //transport
        X.Norma();
//       if(idm==6) { X.print(nome);Gout<<" ev "<<Eventi_Generati;}
        fato= Decay;
        Ifato=-2;

        if ( X.norma >Zona ) {
                fato=Decfar;
                Ifato=-8;
        }
}
return ( botta );
}
//====================================
void Particella::Move ( double passo )
{
// move free along  remaining tratto
        X+=Vers*passo;
        X.Norma();
        path_done+=passo;
}

