/***************************************************************************
                             -------------------
    begin                : Sun Nov 26 2000
    copyright            : (C) 2000 by Giuseppe m Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA48  simulation program.    1992----2005                             *
 *                                                                         *
 ***************************************************************************/
#define UNDEF    6
#define ESTERNO  1
#define INTERNO  0
#define INBUCO   -1
#define NEUTRI  1
#define CARICHI 2
#define ALLCHR  3

#include "flyoh.h"
#include "evento.h"

using namespace GmpConst;
using namespace std;


//==============================================================
//          P A R T I C E L L A                  Construttor
//=====================================================================

Particella::Particella ()
{

    if ( ( pointer_db=Matter->Get_matter ( Partname, this )) == 0 )
    {
        Gout<<"\n Particella() Partname error....  "<<Partname<<std::endl;
        exit ( 0 );
    }

// Create a new reaction with links.
    SelRea->Totpart++;
    ido = SelRea->Totpart;

    if ( SelRea->Lastpart != 0 )   SelRea->Lastpart->next = this;
    before= SelRea->Lastpart;
    SelRea->Lastpart = this;
    this->next = 0;
    id=0;    //vedi  Set_Id();
    fato = Undef;
    devhit=Ifato =devstory=0;
    type=Undef;
    if ( charg ==0 )   type = Neut;
    else  type = Char;

    if ( massa==0.0&&width==0.0&&ctau==0.0 ) type=Res;

    nata=0;
    rea_madre=LastReaction;
    Pair_Production=Brems_Production=0;    // 1 attiva la bremsstrhalung, 2 attiva la pair prodution...
    P.Riposo(massa);
    Qpatre=Pburst=Pbar=Gp=P;
    Gx.Reset();

//  Gout<<"\n Part P.mq %12.6lf %12.6lf %12.5lg %12.5lg",massa,P.m,P.mq,Gp.mq);

    pathok=path_max=path_done=last_path=0.0;
    cstar=10.;     // flag esplicitamente voluta...vedi Voldec...

//------------------links----
    up = 0;
    rg = 0;
    dw = 0;
    lf = 0;
    cls = 0;


}

//==============================================================
//                A g g i o r n a _ l i n k
//===============================================================
void Particella::
Aggiorna_link ( Particella * pup, Particella * prg,
                Particella * pdw, Particella * plf )
{
    if ( pup != 0 )     up = pup;
    if ( prg != 0 )     rg = prg;
    if ( pdw != 0 )     dw = pdw;
    if ( plf != 0 )     lf = plf;
}
void Particella::
Aggiusta_link ( Particella * pup, Particella * prg,
                Particella * pdw, Particella * plf )
{
    Aggiorna_link ( pup,prg,pdw,plf );
//restaura i links...
    if ( pup != 0 )  pup->dw=this;
    if ( prg != 0 )  prg->lf=this;
    if ( pdw != 0 )  pdw->up=this;
    if ( plf != 0 )  plf->rg=this;

}


void Particella::
Aggiorna_link_Bullet ( Particella * pbers )
{
    if ( pbers!= 0 )     rg = pbers;
}

void Particella::
Sostituisci_part( Particella *pr)
{

    up=pr->up;
    dw=pr->dw;
    rg=pr->rg;
    lf=pr->lf;
    id=pr->id;
    if ( up != 0 && up->dw==pr ) up->dw=this;
    if ( rg != 0 ) rg->lf=this;
    if ( dw != 0 ) dw->up=this;
    if ( lf != 0 ) lf->rg=this;

// eliminate the old particle fron the nex chianing...
    if (pr->before->next != 0) pr->before->next=pr->next;
    if (pr->next->before != 0) pr->next->before=pr->before;
// just to be safe...
    pr->up=0;
    pr->dw=0;
    pr->rg=0;
    pr->lf=0;
    pr->id=-1;
    pr->nome="xXx";
    pr->fato="Cancel";
}


//=====================================


Particella * Particella::
Decay_in_2 ( const char *pa_nome,const char *pb_nome )
{
// pattern == DECAY2 :padre=> pa,pb

//  Gout<<"\n Ev Dec1.out "<<Eventi_Generati<<" "<<nome<<" ==> "
//       <<pa_nome<<" "<<pb_nome<<flush;


    Particella *padre,*pa,*pb;
    padre=this;
    pa = SelRea->NuovaPart ( pa_nome,0 );

    pb = SelRea->NuovaPart ( pb_nome,0);

//  Aggiorna_link ( up, rg,dw,lf )
    padre->Aggiorna_link ( 0,      0,      pa, 0 );
    pa->Aggiorna_link ( padre,  pb, 0,      0 );
    pb->Aggiorna_link ( padre,  0,      0,      pa );
    pa->Set_Id();
    pb->Set_Id();
//    Gout<<"\n Ev Dec3.out "<<Eventi_Generati<<" "<<nome<<" ==> "
//       <<pa->nome<<" "<<pb->nome<<" [ "<<pa<<" "<<pb<<" ] "<<flush;

    return pa;
}
//====================
Particella * Particella::
Decay_in_3 (const char *pa_nome, const char *pb_nome,const char *pc_nome  )
{
// three bodies decay....pattern == DECAY3;
//   padre 0> pa pb pc    con 
//    padre =>res2 + pc
//    res2   -> pb + pb;
//  but  the muons...

    Particella *padre,*pa,*pres12;
//  const char *word;
    padre=this;

    pres12 = padre->Decay_in_2 (Res2,pc_nome);
    pa=pres12->Decay_in_2 ( pa_nome,pb_nome );

    // Gout<<"\n  *** Definizione three bodies decay";
    // Stampa_particle();
    return pa;
}

//============
Particella * Particella::
Decay_in_4 ( const char *p1_nome,  const char *p2_nome,const char *p3_nome,
             const char *p4_nome  )
{
    Particella *padre,*pres12,*pres34;
    padre=this;

// padre -> p1 p2 p3 p4  con
//decadimento a 2    padre ->  res12+ res34
//decadimento a 2    res12 -> p1 p2 ; res34 -> p3 p4
//
    pres12 = padre->Decay_in_2 (Res2, Res2);
// attenzione la massa della risonanza Vmas2 è  definita in  partres4.cc contemporaneamente a Res3
    pres12->Decay_in_2(p1_nome,p2_nome);
    pres34=pres12->rg;
    pres34->Decay_in_2 (p3_nome,p4_nome);

    return pres12;
}


//============
Particella * Particella::
Decay_in_5 ( const char *p1_nome,  const char *p2_nome,const char *p3_nome,
             const char *p4_nome ,const char *p5_nome )
{
    Particella *padre,*pr1,*pr2,*pr3;
    padre=this;

    //rivedre!!!!!!!!! funziona ma scrivere meglio....

//decadimento a 5    padre->  res123 res45
//                   res123 ->  p1 res12
//                   res12  -> p2 p3
//                   res45  -> p4 p5

    pr1 = padre->Decay_in_2 (Res3,Res2);
    pr3=pr1->Decay_in_2 (Res2,p1_nome);
    pr3->Decay_in_2(p2_nome,p3_nome);
    pr2=pr1->rg;
    pr2->Decay_in_2(p4_nome,p5_nome);

    return pr1;
}

// save and restore  **********************************************
//
void  Particella::Save_Link()
{
    lfsav=lf;
    rgsav=rg;
    upsav=up;
    dwsav=dw;
    if ( next!=0 ) next->Save_Link();
}
void  Particella::Restore_Link()
{
    lf=lfsav;
    rg=rgsav;
    up=upsav;
    dw=dwsav;
    cls=0,nata=0;
    if ( next!=0 ) next->Restore_Link();
}
//==============================================================
//                U p d a t e _ D e v s t o r y
//===============================================================
// salva in formato codificato i devices colpiti dalla particella.
// il bit acceso (in una parola long long) corrisponde al device colpito
// attenzione memorizza per 64 device da Offset_story in poi.
void Particella::
Update_Devstory(int idev) {
    if (Offset_story<1) return;
    unsigned long long bit_uno=1;
    int shift= idev-Offset_story;
    if (shift>-1&&shift<64)
        devstory = (devstory|(bit_uno<<shift));
    return;
}
//================================================================
//              R e s e t _ stato
//=================================================================

void Particella::
Reset_Stato()
{
// start from the tree top.....


//  Gout<<"\n Reset "<<nome <<" id "<<id ;
    fato = Undef;
    nata=0;
    devhit=devstory=Ifato=0;
    P.Riposo();
    Gp.Riposo();
    X.Reset();
    Gx.Reset();
    if ( Pair_Production>0 )   Pair_Production=1;
    if ( Brems_Production>0 ) Brems_Production=1;
    pathok=path_max=path_done=last_path=0.0;
    cstar=10.;     // flag esplicitamente voluta...vedi Voldec...
    if ( next!=0 ) next->Reset_Stato(); //iterate attenzione meglio di no!!!!

}



//===============================================================
//                R i c e r c a
//==============================================================
Particella *Particella::
Ptr_Particle ( const char *pp )
//   attenzione va bene solo per MakeList...
// cerca la particella di nome pp tra le particelle della lista già create...
{
    Particella *ptr;
    ptr = this;
    while ( ptr != 0 )
    {
        if ( pp == ptr->nome && ptr->dw == 0 )
        {
            if (Debugon==1)Gout<<"\n Trovata la particella "<<ptr->nome<<"  ido "<<ptr->ido<<flush;
            return ptr;   // si!
        }

        ptr = ptr->next;
    }
    return ptr;     // no!  return 0

}

//==============================================================
Particella *Particella::
Get_Pointer ( char *pp )
{
//   con procedura iterativa....attenzione va bene solo per MakeList...
// o la dove viene chiamata poche volte per run...
// altrimenti mangia spazio memoria......
    if ( pp==nome ) return this;
    if ( next!=0 ) return Get_Pointer ( pp );
    return 0;
}

//================================================================
//           S t a m p a    q u e s t a   p a r t i c e l l a
//=================================================================
void Particella::
Stampa_questa_particella ()
{
    //Gout<<"\n Ev "<< Eventi_Generati<<"  Stampa part num: "<<flush;

    if ( nome==Dlz && dw == 0 )
    {
        Gout<<"\n Dalitz pair no electrons linking.. stop"<<std::endl;
        exit ( 0 );
    }

//   P.print(nome);
    Gout<<"\n n "<<setw(3)<<ido<<" <"<<setw ( 3 ) <<idm<<"> "<<setw ( 8 ) <<id<<"  "
    <<setw ( 5 ) <<nome<<" ["<<setw ( 6 ) <<fato<<"] Type: "<<setw ( 6 ) <<type <<" m "<<setw(8)<<massa;


    if ( dw != 0 )
    {
        //    Gout<<" =>dw->"    <<setw ( 5 ) <<dw->nome<<" ["<<setw ( 8 ) <<dw->id<<" "  <<setw ( 3 ) <<dw->ido<<"]";
        Gout<<" =>dw->"    <<setw ( 5 ) <<dw->nome<<"("<<setw ( 3 ) <<dw->ido<<")";

        if ( dw->rg != 0 )
            Gout<<" rg "<<setw ( 5 ) <<dw->rg->nome<<" ("<<setw ( 3 ) <<dw->rg->ido<<")";
    }

    if ( rg!=0 && type==Bullet)
        Gout<<" ==> urta-> "<<setw ( 9 ) <<rg->id<<" "
        <<setw ( 3 ) <<rg->ido<<" "
        <<setw ( 4 ) <<rg->nome<<" "<<setw ( 7 ) <<rg->fato;

    if ( before!=0 )
        Gout<<" bf"    <<setw ( 5 ) <<before->nome<<"("<<setw ( 3 ) <<before->ido<<")";


    if ( next!=0 )
        Gout<<" =>next "    <<setw ( 5 ) <<next->nome<<"("<<setw ( 3 ) <<next->ido<<")";


    if ( cls!=0 )

        Gout<<" =>Cls "    <<setw ( 5 ) <<cls->nome<<"("<<setw ( 3 ) <<cls->ido<<")";



}

//================================================================
//           S t a m p a  p a r t i c e l l e
//=================================================================


void Particella::
Stampa_particle ()
{
    //iterative method  attenzione usare con parsimonia!!!!

    Particella *pr=this;
    int n=0;
    Gout<<"\n ido  idm     id     nom   stato                      chaining    Ev "<<evento_.Gen.Event;


    while (pr!=0)
    {
        if (n++>1500)break;
        pr->Stampa_questa_particella();
// iterate....
        pr=pr->next;

    }



}










//================================================================

// redefine the particle id
void Particella::
Set_Id()
{
// The reaction is described as chain of two bodies
// decay.
// The ID is usefull to undertand the particle position.
//
// The id is usefull to undertand the particle position.

//  id = 1000*ido + 100*p + ll dove
//  ido è il numero di ordine della particella nella reazione
//  p= 0 sx (a sinistra)  nel livello, p=1 dx (a destra) nel livello
//  ll indica il livello nel decadimento
//  i valori di ido e p sono fissi nella generazione e dipendono da come è scritta la reazione nell'EPC
//  Nelle file di listing di uscita  si possono leggere i valori di ido e p e ll;

// nelle procedure di simuladev id può essere ridefinito
// id =-1   fusione
// id =-3   pio extra Cls

    if ( up!=0 ) {
        id=(up->id%100)+1+1000*up->ido;
        // rivedere meglio....
        if (lf!=0 ) id+=100; // è la particella di destra
    }
    else id=0;

}

//=============================================================
//             D e b u g _ o u t
//==============================================================
// printout for events debug                      Debug_out
void Particella::Debug_out ()
{
    Particella *pr;
    Device *pv;
    pr = this;

    Gout<<"\n\n Ev "
    <<setprecision ( 2 ) <<fixed
    <<setw ( 7 ) << evento_.Gen.Event<<" time="
    <<setw ( 6 ) <<TBurst->Get_Tempo() <<" "
    <<setw ( 3 ) << pr->id<<" <"
    <<setw ( 3 ) <<pr->idm<<"> "
    <<setw ( 25 ) <<pr->rea_madre->Get_Titolo();
    while ( pr != 0 )
    {
        if ( pr->fato != Undef )
        {
            Gout<<"\n "
            <<setprecision ( 2 ) <<fixed<<" P=("
            <<setw ( 7 ) << pr->P[0]<<" "
            <<setw ( 7 ) << pr->P[1]<<" "
            <<setw ( 8 ) << pr->P[2]<<") E="
            <<setw ( 6 ) << pr->P[3]<<"   Fato: "
            <<setw ( 6 ) << pr->fato;
            Gout<<"\n Gp=("
            <<setw ( 7 ) << pr->Gp[0]<<" "
            <<setw ( 7 ) << pr->Gp[1]<<" "
            <<setw ( 8 ) << pr->Gp[2]<<") "<<pr->Get_Nome();
            Gout<<"\n Gx=("
            <<setw ( 7 ) << pr->Gx[0]<<" "
            <<setw ( 7 ) << pr->Gx[1]<<" "
            <<setw ( 8 ) << pr->Gx[2]<<")";
            Gout<<"\n x =("
            <<setw ( 7 ) << pr->X[0]<<" "
            <<setw ( 7 ) << pr->X[1]<<" "
            <<setw ( 8 ) << pr->X[2]<<")   Path_done: "
            <<setw ( 8 ) <<pr->path_done<<std::endl;
        }

//      if(pr->nome==Res) resmas=pr->massa;
        pr = pr->next;
    }
    double energia=0.0;
    pv = Apparato;
    while ( pv != 0 )
    {
        energia+=pv->eDev;
//           Gout<<"\n %s %8.3lf", pv->nome,pv->eDev);
        pv=pv->next;
    }
    Gout<<"\n Tot E seen ="<<energia;
    Gout<<"\n ----gmp-----   -------    ------\n"<<std::endl;
    return;
}


//================================================================
//                                   S p i a
//=================================================================

void Particella::Spia ( char * tit, Device *stdev, Device * loopdev,int start,int stop )
{
    if ( loopdev->idev<start|| loopdev->idev>stop ) return;
    Gout.setf ( ios::fixed,ios::floatfield );
    Gout<<setprecision ( 2 );
    Gout<<"\n Trans "<<tit<<" "<<evento_.Gen.Event
    <<" StartDev: "<<setw ( 10 ) <<stdev->nome
    <<" at z"<<setw ( 8 ) << stdev->Cface.z
    <<" "<<nome<<" at Z "<< X.z
    << " Path "<<setw ( 8 ) <<path_max
    << "  fatto "<<setw ( 8 ) <<path_done
    <<" in "<<setw ( 8 ) <<loopdev->nome
    <<" at z"<<setw ( 8 ) << loopdev->Cface.z
    <<" prev " <<setw ( 8 ) <<loopdev->prevpos
    <<" nowpos " <<setw ( 8 ) <<loopdev->nowpos
    << "   pathok "<<setw ( 8 ) <<pathok;

}
