/***************************************************************************
 ***
 *                                                                         *
 *   NA48  simulation program.                                             *
 *                                                                         *
 ***************************************************************************/

//
// beam routine   gmp Tirrenia 29-10-99  da...
// Tirrenia  28.08.00

#include "flyoh.h"
using namespace GmpConst;


//--------------------------------------------------------------*/
//          G e t b e a m                                       */
//--------------------------------------------------------------*/
// get the beam ..... versione base   10.02.00   gmp
// per le classe Reazione,Reapmd..............;
// va bene per i decadimenti neutri e carichi... attenzione i carichi
//

int Reazione::
Get_Beam ()
{
        //--------   genration loop
        //metodo
        // loop per l'estrazione di un impulso che soddisfi
        // all'ottica del fascio....  si verifica con
        // la distribuzione di Double.
        int iter=0;
        double prb,fi,ro;
        double dwpb = 2.*wpinc;
        double volo=0.0;

        double pathd=0.0;






        // punto targhetta...
        ro=rtarg * sqrt ( Bran() );

        fi= Bran() * DuePiGreco;
        Xtarg.setv ( ro*cos ( fi ), ro*sin ( fi ),dztarg* ( Bran() - 0.5 ) );
        Xtarg+=Ctarg;

        // calcolo la direzione di volo ricordando che deve passare per il
        // collimatore virtuale che definisce lo spread


        if ( rcoll>0.0 ) {


                if ( ubeam==0 ) ro= rcoll *sqrt ( Bran() ); // distribuzione uniforme...

                else {
                        // fascio definito dall'utente
                        for ( int i=0; i<10; i++ ) {
                                ro= rcoll *sqrt ( Bran() );
                                // attenzione distribuzione piccata al centro collimatore
                                // per fascio definito dall'utente (ubeam>0)
                                double rr=ro*1.6;
                                double peso=exp ( - ( rr*rr ) );
                                if ( Bran() <peso ) break;
                        }
                }


                fi= Bran() *DuePiGreco;
                Vbeam.setv ( ro*cos ( fi ),ro*sin ( fi ), 0.0 ); // coordinate al collimatore virtuale di def.
                Vbeam-=Xtarg-Ccoll;
                Vbeam.Norma();
                Vbeam=Vbeam.Verso(); // versore del beam..
        }

        else Vbeam=Pinc.NVerso();  // se non c'è il collimatore...  beam parallelo

        Vbeam.putv ( vxb,vyb,vzb );

// selezione del momento

        if ( ubeam==0 ) {
                while ( 1 ) { // se la reazione dipende da teta spostare questo while in alto...
                        iter++;
                        ppb = Pinc.norma + dwpb* ( Bran()-0.5 ); // dwpb intervallo in impulso...
                        prb=Produci() /maxspettro;
                        double rrr=Bran();

                        if ( rrr<prb ) break;

                        if ( iter>1000 ) {
                                Gout<<"\nEv "<<evento_.Gen.Event<<" "<<avo->Get_Nome() <<" in rea_Id "<<id<<" Beam_error iter="
                                    <<iter<<" Prb="<< prb<<" Pmx="<<maxspettro;
                                break;  // esco per forza
                        }
                }
        } else { //ubeam==1

                while(1.)
                {
                ppb = Bgauss ( wpinc, Pinc.norma );  //user beam
                // correzione per diminuire le code
                double prdif= fabs( Pinc.norma-ppb ) /wpinc;
                double pbb=1./ ( 1. +prdif*prdif*prdif);
                if(Bran()<pbb)break;
                }

        }



// la particella ha una massa ed una vita media
//
        if ( ctau_avo_su_mass>0.0 ) {
                volo = ctau_avo_su_mass * ppb;

//    cout<<"\n Ctau/m " <<ctau_avo_su_mass<<" p "<<ppb <<" Volo "<<volo;
                pathd= - volo*log ( Bran() ); // potential path

// correzione per l'unità
                if ( flyo_unit!=1.0 ) pathd*=flyo_unit; // si passa per esempio a metri....


//      cout<<"\n pathd... "<<setw(8)<<pathd
//      <<" "<<setw(8)<<evento_.Gen.dt_beam;

                if ( pathd<Beg_fid-Xtarg.z ) return -10;
                evento_.Gen.dt_begfid=TBurst->Get_dt_begfid();

//   cout<<" beg "<<setw(8)<<evento_.Gen.dt_begfid<<" bono..";

// check the upper limit if the reaction is standard.
// otherwise skip the test for special test beam run
// or no upperlimit requested End_fid=1.e+9
                if ( rea_type!=-1 &&  End_fid !=1.e+9 &&
                                pathd>End_fid-Xtarg.z ) return -11;

                // gli eventi accettati sono quelli generati nella regione di fiducia
                // per rendere il programma piu' efficiente, ma attenzione ai fondi....e normalizzazioni varie
                // conviene allora prendere una regione non limitata superiormente...End_fid=1.e+9;
        }

        else {
                pathd=Zona-Xtarg.z;  // massimo path per beam stabili
                evento_.Gen.dt_begfid=TBurst->Get_dt_begfid();
        }

        evento_.Gen.dt_beam=TBurst->Get_dt_beam(); // Tempo tra ev di beam trasmessi

//    cout<<"\n Ev tras "<<Eventi_Generati;




        trasmessi++;
//    Xtarg.print("xt");
//   Vbeam.print("V");


        //-----------------------------------------------------------------
        avo->X = Xtarg;
        Pbeam= Vbeam*ppb;



        avo->P.setvn ( Pbeam,avo->Get_Massa() ); // P quadrivettore impulso energia
        avo->Vers=Vbeam;
        avo->path_max=pathd;
        avo->X2Gx();
        avo->P2Gp();
        avo->Set_Fato ( Nata,-1 );
        avo->Set_Nata();  //nata=1;

        return ( 1 );
}


