/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 05.09.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/
#ifndef REAZIONE_H
#define REAZIONE_H

class Particella;
#include <parm.h>
using namespace std;


/**    
<p align=center> R e a z i o n e <p>
<br>Class Reazione: classe base da cui derivare le  reazioni   
<br>Genera la lista delle reazioni da simulare leggendo i 
<br>parametri di definizione nella file di tipo .epc.

@author Giuseppe Pierazzini
*/
class Reazione    // base class
{

protected:
    std::string header;
    int id ;
    long type;

    int generati,veri,trasmessi,scrnt;

    double vxb,vyb,vzb,ppb,inc_pinc,inc_teta;
    double  branch,prodrate,rate,sommarate, sigm_dpw,pincmx;
    double Dnsudp,maxspettro;
    double ctau_avo_su_mass;
// protoni incidenti
    gvet Pinc_ppp,Vinc_ppp;
// production parameters...
    double wpinc,wpincq;
    int ubeam; // user beam flags
    gvet Pinc,Ctarg;
    double rtarg, dztarg;
// bersaglio e collimatore , centro, raggio e lunghezza;Produci
    double wpbers, drbers;
    gvet Pbersa,Ccoll;
    double rbers,dzbers, rcoll,dzcoll;
//    double slope;


public:
    double Rea_tempo, Rea_tempo_last;
    double mdltz,edltz1,edltz2; // control of particular  prodution
    double mspair,mbrem, eeb,eleb;    // flag: production of particles in fligth done if >1
    int Pipev;               /** Flag di Pileup */
    int Pair_done,Totpair;
    int Tailsrt_done,Tailsrt;
    int Tailong_done,Tailong;
    int Dalitz_done,Totdltz;
    int Brem_done,Totbrem;
    Reazione ();
    virtual ~Reazione () {};
    void Leggi_schede_rea();
    int rea_type;     //  -1 beam only, 0 ->decay, =1 -> urto
    int rea_pattern;
    int Totpart,TotpartSave;
    int Gasint_Done;
//  double ProdPeso;
    gvet Xtarg,Pbeam,Vbeam;  // generation Targ,pinc,verso
    gvet Xbers,Pbers,Vbers;  // generation for bersaglio
    int ss_done;
    double ss0,ss1,ss2;         // partfase save ss....

// Particella * avo,*TreRes, *Lastpart,*LastpartSave;
    Particella * avo, *Lastpart,*LastpartSave;
    Reazione *next, *up;
    Reazione *Select_reation ();
    int   Get_Id() {
        return id;
    }
//    double Get_Slope(){return slope;}; // obsolete
    std::string Get_Titolo() {
        return header;
    }
    void Reset_Rea();
    void Stampa();
    void PrintPinc();
    void PrintPbers();
    void Makelist ();
    void AddNt() {
        scrnt++;
    }
    void SubNt() {
        scrnt--;
    }
    void AddGen();
    void Norma_Rate();
    void Simple_List();
    void Fine_run ();
    virtual void MaxSpettro();

    virtual int Get_Beam ();
    virtual double Produci();
    double UProduci();
    Particella * NuovaPart(const char *, int);
    Particella * NuovaBullet(const char *);
};

#if defined(MAIN)
int   Trigger_flag=0;
double Time_trigger_last=0.0;
#endif

#if !defined(MAIN)
extern  int Trigger_flag;
extern double Time_trigger_last;
#endif

#if defined(MAIN)
int TotRea = 0;
Reazione *Reaction=0,*LastReaction=0,*last_parz=0;
Reazione *SelRea;
double Prodtot=0.0, Protoni=0.0;
int Abilita_Pair=0,Abilita_Brems=0;
#endif

#if !defined(MAIN)
extern int TotRea;
extern Reazione *Reaction,*LastReaction,*last_parz;
extern Reazione *SelRea;
extern double Prodtot,Protoni;
extern int Abilita_Pair,Abilita_Brems;
#endif
#endif



