/***************************************************************************
 *   Copyright (C) 2009 by giuseppe Pierazzini                                      *
 *   giuseppe@pierazzini.it                                                               *
 *                                                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 *                                                                         *
 *  Dipartimento di Fisica  E.Fermi / INFN Pisa Italy                      *
 ***************************************************************************/
#define FASE
#include "parm.h"
#include "fasemax.h"
#include "evento.h"
#include "part_db.h"
 static FaseMax *last_fasemx = 0;
  static int tot_fasemx= 0;

  
  
FaseMax::FaseMax ( int *p,double wfx )
{

//linking
  tot_fasemx++;
  id=tot_fasemx;

  if ( last_fasemx == 0 ) Fasemx=this;
  else  last_fasemx ->next = this;   // linking
  up=last_fasemx;
  last_fasemx  = this;
  this->next = 0;   // end linking
  p0=p[0];
  p1=p[1];
  p2=p[2];
  p3=p[3];
  p4=p[4];
  p5=p[5];
  Wmax=wfx;


}
//======
double FaseMax::Get_Wmax ( int *p )
{
  //iteratore
  FaseMax *prf=Fasemx;
  while ( prf!=0 )
  {
    if ( p[0]==prf->p0 && p[1]==prf->p1 &&
            p[2]==prf->p2 && p[3]==prf->p3 &&
            p[4]==prf->p4&& p[5]==prf->p5 )
    {
      return Wmax;
    }
    prf=prf->next;
  }
  return -1.;
}
//========
void  FaseMax::Set_Wmax ( int *p,double wfx )
{
  //iteratore
  FaseMax *prf=Fasemx;
  while ( prf!=0 )
  {
    if ( p[0]==prf->p0 && p[1]==prf->p1 &&
            p[2]==prf->p2 && p[3]==prf->p3 &&
            p[4]==prf->p4&& p[5]==prf->p5 )
    {
      Wmax=wfx;return;
    }
    prf=prf->next;
  }
}
//======
void FaseMax::Info()
{
  if ( this==Fasemx ) Gout<<"\n\n Fase Max data  List ";
  Gout<<"\n  "
  <<std::setw ( 4 ) <<id<<std::setw ( 6 ) <<Matter->Idm_Nome ( p0 )
  <<"  ==> [ "<<std::setw ( 6 ) <<Matter->Idm_Nome ( p1 )
  <<" "<<std::setw ( 6 ) <<Matter->Idm_Nome ( p2 )
  <<" "<<std::setw ( 6 ) <<Matter->Idm_Nome ( p3 );
  if ( p4!=0 ) Gout<<" "<<std::setw ( 6 ) <<Matter->Idm_Nome ( p4 );
  if ( p5!=0 ) Gout<<" "<<std::setw ( 6 ) <<Matter->Idm_Nome ( p5 );
  Gout<<" ] PesoMax"<<std::setw ( 6 ) << Wmax;
  if ( next!=0 ) next->Info();
}

