/***************************************************************************
                          gcomplx.h  -  description
                             -------------------
    begin                : Wed Aug 15 2001
    copyright            : (C) 2001 by Giuseppe Pierazzini
    email                : peppe@unipi.it
 ***************************************************************************/

#ifndef GCOMPLX_H
#define GCOMPLX_H


/**Semplice classe complex di GmP
Agosto 2001
  *@author Giuseppe Pierazzini
  */

class Gcomplx
{
 private:
 double real,imm;

 public:
  double norma,normaq;
//----
   Gcomplx(double=0.0);
   Gcomplx(double,double);
	~Gcomplx();
//-----
   double Norma( );
   double& operator[](int);
   Gcomplx& operator=(Gcomplx&);           // assegnamento this= &c
   Gcomplx& operator=(Gcomplx *);          //  assegnamento this = *c
   Gcomplx& operator=(double *);        // this = (a,a) vedi nche set.
   Gcomplx& operator=(double );

// operatore unario di cambio segno
   Gcomplx& operator-();

// somma e differenze
   Gcomplx& operator+(Gcomplx &);
   Gcomplx& operator+(Gcomplx *);
   Gcomplx& operator+(double);
   friend Gcomplx& operator+(double,Gcomplx &);

   Gcomplx& operator-(Gcomplx &);
   Gcomplx& operator-(Gcomplx *);
   Gcomplx& operator-(double);
   friend Gcomplx& operator-(double,Gcomplx &);


// incrementi
   Gcomplx & operator+=(Gcomplx *);         //this+=c
   Gcomplx & operator+=(Gcomplx&);          //this+=c
   Gcomplx & operator+=(double);          //this+=reale
   Gcomplx & operator-=(Gcomplx *);         //this-=c;
   Gcomplx & operator-=(Gcomplx&);          //this-=c
   Gcomplx & operator-=(double );          //this-=reale
// prodotto  scalare
   double operator%(Gcomplx &);       // prodotto scalare
   double operator%(Gcomplx * );      // idem
//   friend double operator%(Gcomplx *,Gcomplx &);

// coniugata
   Gcomplx & operator&();


// prodotto
   Gcomplx & operator*(Gcomplx & );
   Gcomplx & operator*(Gcomplx *);
   Gcomplx & operator*(double );      // prodotto per un parametro a*this
   friend  Gcomplx & operator*(double,Gcomplx & );
   Gcomplx & operator*=(Gcomplx & );
   Gcomplx & operator*=(Gcomplx *A){return *this*=(*A);}

// rapporto
   Gcomplx & operator/(Gcomplx & );
   Gcomplx & operator/(Gcomplx *);
   Gcomplx & operator/(double );      // divide per un parametro
   friend Gcomplx & operator/(double,Gcomplx &); //  c/Gcomplex
    Gcomplx & operator/=(Gcomplx & );
    Gcomplx & operator/=(Gcomplx *A){return *this/=(*A);}

//   (1/c), c/|c| ,
   Gcomplx & Inverso( );
   Gcomplx & Verso( );
   Gcomplx & Set(double,double );
   double Real(){return real;}
   double Imm(){return imm;}


   void  print(char *);
  };



#endif
