/***************************************************************************
                        GVET.H
                             -------------------
    revised              : Febbraio settembre 2010    
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************/

#ifndef GVET_H
#define GVET_H


#include <cmath>

class gmatrix;
class gvet
{ 

/**
<p align=Center >g-VETTRORI TRIDIMENSIONALI @author Giuseppe Pierazzini</p>
<p align=Center >@author Giuseppe Pierazzini</p>

<table>
<tr><td>Operator/Method </td><td>Description
</td></tr><tr><td></td><td>  
</td></tr><tr><td>  gvet()             </td><td>                   empty vector
</td></tr><tr><td>  gvet(double a,double b,double c)  </td><td>   vector= (a,b,c)                     
</td></tr><tr><td>  operator +=   </td><td>     combined subtraction and assignment operator
</td></tr><tr><td>  operator -=   </td><td>     combined  subctraction  and assignment operator
</td></tr><tr><td>  operator -    </td><td>     Unary change of sign
</td></tr><tr><td>  gvet & operator=(gvet *a) </td><td>   permette V= *vec
</td></tr><tr><td>  void operator=(double *a) </td><td>   permette V=a;  con a[] = {x,y,z}
</td></tr><tr><td>  gvet & operator+(gvet &)  </td><td>    V= V1 +   V2
</td></tr><tr><td>  gvet & operator+(gvet* a) </td><td>    V= V1 +  *V2
</td></tr><tr><td>  gvet & operator-(gvet &)  </td><td>    V= V1 -  V2
</td></tr><tr><td>  gvet & operator-(gvet* a) </td><td>    V= V1 -  *V2
</td></tr><tr><td>  gvet &  operator&(gvet &) </td><td>    Prodotto vettoriale
</td></tr><tr><td>  gvet & operator&(gvet *b) </td><td>    Prodotto vettoriale
</td></tr><tr><td>  gmat & operator&(gmat &)  </td><td>    Prodotto vettoriale generalizzato ad una matrice M=VxM1
</td></tr><tr><td>  gvet & operator %( gmat &)</td><td>    Prodotto vettore x matrice in vettore  V= V1.M
</td></tr><tr><td>  double operator%(gvet & A)</td><td>    Prodotto scalare
</td></tr><tr><td>  double operator%(gvet * A)</td><td>    Prodotto scalare
</td></tr><tr><td>  gvet & operator*=(double c)  </td><td>   operatore *= per una costante
</td></tr><tr><td>  gvet & operator/=(double c)  </td><td>   operatore /= per una costante

 
</td></tr><tr><td>  gvet &  Verso()   </td><td>   calcola il versore...
</td></tr><tr><td>  gvet & NVerso()   </td><td>   calcola prima la norma.. just in the case!! +
</td></tr><tr><td>  double Norma()    </td><td>   calcola la Norma
</td></tr><tr><td>  double XYNorma()  </td><td>   calcola la norma solo sul piano xy
</td></tr><tr><td>  double YZNorma()  </td><td>   calcola la norma solo sul piano yz
</td></tr><tr><td>  double ZXNorma()  </td><td>   calcola la norma solo sul piano zx
</td></tr><tr><td>  gvet & NxzVerso() </td><td>   Versore sul piano xz
</td></tr><tr><td>  gvet & NyzVerso() </td><td>   Versore sul piano yz
</td></tr><tr><td>  gvet & setvn(double a,double b,double c) </td><td>   define V e normalizza
</td></tr><tr><td>  gvet & setvn(double *a)                  </td><td>   define V e normalizza
</td></tr><tr><td>  gvet & setv(double a,double b,double c) </td><td>    define V e NON normalizza
</td></tr><tr><td>  gvet & setv(double *a)                   </td><td>   define V e NON normalizzarriva solo con if(Nome== 
  
</td></tr><tr><td>  virtual void Reset()                     </td><td>    azzera
</td></tr><tr><td>  void putv(double &x,double &y,double &z) </td><td>    define x,y,z
</td></tr><tr><td>  void putv(float &x,float &y,float &z)    </td><td>    define x,y,z
</td></tr><tr><td>  void putvn(double &a,double &b,double &c,double &d)</td><td>  
</td></tr><tr><td>  void putvn(float &a,float &b,float &c,float &d)</td><td>  
</td></tr><tr><td> virtual void print(char *)               </td><td>    
</td></tr>
</table>

*/

protected:
    union
    {
        struct {
            double x, y, z,t;
        };  // t è anche  per combalità con i quadrivettori
        struct {
            double px, py, pz,e;
        };
        double v[4];// componenti del vettore
    };
public:
    union
    {
        struct {
            double norma,normaq;
        };
        struct {
            double mom,momq;
        };
    };
    // norma ... attenzione va aggiornato se cambia v.

    gvet() {



        x=y=z=0.0;
        normaq=norma=0.0;
    };
    gvet ( double a,double b, double c )
    {
        x= a;
        y= b;
        z= c;
        normaq=x*x+y*y+z*z;
        norma=sqrt ( normaq );
    };
// operatori delicati possono generare grane...meglio usare setvn,setv
//   gvet(double * p){x=p[0];y=p[1];z=p[2];normaq=x*x+y*y+z*z;norma=sqrt(normaq);};
//   gvet(double p){x=y=z=p; normaq=3.*p*p; norma=sqrt(normaq);};
//-------------------
    virtual ~gvet() {};

    double& operator[] ( int i ) {
        return v[i];
    };
    double& operator() ( int i ) {
        return v[i];
    };
// operatore unario di cambio segno
    gvet  operator-();

    double Norma()
    {
        normaq=x*x+y*y+z*z;
        norma=sqrt ( normaq );
        return norma;
    };
    double XYNorma() {
        return sqrt ( x*x+y*y );
    };
    double YZNorma() {
        return sqrt ( y*y+z*z );
    };
    double ZXNorma() {
        return sqrt ( z*z+x*x );
    };
    gvet  Verso() {
        return *this/norma;
    };       // calcola il versore...
    gvet NVerso() {
        Norma();    // calcola la norma.. just in the case!!
        return *this/norma;
    }

    gvet  NxzVerso();      // Versore sul piano xz
    gvet  NyzVerso();       // Versore sul piano yz

////  gvet  operator = (const gvet &a){ x=a.x;y=a.y;z=a.z; return *this;} non serve!!!!!

//     gvet & operator = ( gvet *a )
//     {
//         *this=*a;
//         return *this;
//     }

    gvet & operator = ( gmatrix &m );




    gvet  operator+ ( const gvet & );
    gvet  operator+ ( gvet* a ) {
        return *this+*a;
    }
    gvet  operator- ( const gvet& a );
    gvet  operator- ( gvet* a ) {
        return *this-*a;
    }


    // this+=V; this-=V;
    gvet & operator+= ( const gvet& a )              // attenzione non calcola norma..
    {
        x+=a.x;
        y+=a.y;
        z+=a.z;
        return *this;
    }
    gvet & operator+= ( gvet * a )              // attenzione non calcola norma..
    {
        *this+=*a;
        return *this;
    }

    gvet & operator-= ( const gvet& a ) // attenzione non calcola norma..
    {
        x-=a.x;
        y-=a.y;
        z-=a.z;
        return *this;
    }
    gvet & operator-= ( gvet * a )   // attenzione non calcola norma..
    {
        *this-=*a;
        return *this;
    }


    

//Prodotto vettoriale P=this.x.A
    gvet    operator & ( const gvet & );
    gvet   operator & ( gvet *b ) {
        return *this & *b;
    }
// prodotto esterno per una matrice



// prodotto scalare
    double operator% ( const gvet & A )
    {
        return ( x*A.x+y*A.y+z*A.z );
    };  // prodotto scalare
    double operator% ( gvet * A ) {
        return *this%*A;
    };
    friend double operator% ( gvet * A,gvet & B ) {
        return *A%B;
    } ;

// prodotto per un parametro this*a
    gvet  operator* ( const double );
//   friend  gvet  operator*(double c, gvet & A){ return (A*c);} // friend function
    friend  gvet  operator* ( double c, gvet  A ) {
        return ( A*c );
    }
// divide per un parametro
    gvet  operator/ ( const double a ) {
        double b=1./a;
        return   *this*b;
    }

// operatore *= per una costante
    gvet & operator*= ( double c )
    {
        x*=c;
        y*=c;
        z*=c;
        norma*=fabs ( c );
        normaq=norma*norma;
        return *this;
    }

// operatore /= per una costante
    gvet & operator/= ( double c )
    {
        x/=c;
        y/=c;
        z/=c;
        norma/=fabs ( c );
        normaq=norma*norma;
        return *this;
    }
    
    
    
gmatrix&  operator >> (gmatrix &);
    

// vettore  per una matrice
//   gvet &  operator %( gmat &);
//setting or putting
    virtual void Reset() {
        x=y=z=t=norma=normaq=0.;
    };
    gvet & setvn ( const double a,const double b,const double c ) {
        x=a;
        y=b;
        z=c;
        Norma();
        return *this;
    }
    gvet & setvn ( const float a,const float b,const float c ) {
        x=a;
        y=b;
        z=c;
        Norma();
        return *this;
    }


    gvet & setvn ( double *a ) {
        x=a[0];
        y=a[1];
        z=a[2];
        Norma();
        return *this;
    }
    gvet & setv ( double a,double b,double c ) {
        x=a;
        y=b;
        z=c;
        return *this;
    }
    
      gvet & setvt ( double a,double b,double c,double g) {
        x=a;
        y=b;
        z=c;
		  t=g;   //il tempo !!! 
        return *this;
    }  
    
    
    gvet & setv ( double *a ) {
        x=a[0];
        y=a[1];
        z=a[2];
        return *this;
    }
    
// putv   trasferisce le coordinate in 3 variabili esterne 
//    putvn   trasferisce le coordinate e la norma in 4 variabili esterne 
//Vale anche per la parte spaziale dei quadrovettori
   
    
   void putv( double &a,double &b,double &c ) {
        a=x;
        b=y;
        c=z;
    }
    void putv( float &a,float &b,float &c ) {
        a=x;
        b=y;
        c=z;
    }
    void putv( double *a ) {
        a[0]=x;
        a[1]=y;
        a[2]=z;
    }  
    
     void putvn(double &a,double &b,double &c,double &d ) {
        a=x;
        b=y;
        c=z;
        d=norma;
    }
    void putvn( float &a,float &b,float &c,float &d ) {
        a=x;
        b=y;
        c=z;
        d=norma;
    }
    void putvn( double *a) {
        a[0]=x;
        a[1]=y;
        a[2]=z;
	a[3]=norma;
    }  
 
    virtual void print ( const char * );
    virtual void print ( long ev,const char *pnome,int pid,const char *devnome );
};


//****************************************************
//****************************************************



/**
<p>-------------------   VETTRORI QUADRIDIMENSIONALI --------------</p>
<ul>
<li> q-Vettori:  vettori quadrimensionali derivati da gvet
<li>  @author Giuseppe Pierazzini 
<li>
<li> algebra:
<li> Operator/Method                          Description
<li>   constructor
<li> qvet(double );
<li> qvet(double*);
<li> qvet(gvet &,double);
<li> qvet(double,double,double,double);

<li>      operatori
<li> qvet & operator=(qvet *a)        ;
<li> void   operator=(double *a)      ;attenzione come (px,py,pz,m)
<li> qvet & operator+=(qvet& a)       ;
<li> qvet & operator+=(qvet * a)      ;
<li> qvet & operator-=(qvet& a)       ;
<li> qvet & operator-=(qvet * a)      ;
<li> qvet & operator-()               ;operatore unario: solo space
<li> qvet & operator+(qvet &)         ;
<li> qvet & operator+(qvet* a)        ;
<li> qvet & operator-(qvet &)         ;
<li> qvet & operator-(qvet* a)        ;
<li> double operator*(qvet & A)       ;prodotto scalare tra quadrivettori
<li> double operator*(qvet * A)       ;
<li> friend double operator*(qvet * A,qvet & B)
<li> qvet & operator*(double )        ;prodotto per un parametro
<li> friend qvet & operator*(double a,qvet & B)
<li> qvet & operator/(double a)       ;divisione per un parametro

<li> double Invar();
<li> double Invarq();
<li> double Energia();     Calcola l'energia a partire dalla massa e impulso
<li> double Impulso();     Calcola l'impulso  a partire dalla massa e energia

<li> qvet & setvn(double a,double b,double c, double d)
<li> qvet & setvn(double *a)
<li> qvet & setvn(gvet &Vg,double a)
<li> qvet & setv(double a,double b,double c,double mass)
<li> qvet & setv(double *a)
<li> qvet & setv(gvet &Vg,double a)

<li> set del quadrivettore ; il quarto valore e' l'energia;
<li> qvet & setqn(double a,double b,double c, double d)
<li> qvet & setqn(double *a)
<li> qvet & setqn(gvet &Vg,double a)
<li> void Reset()
<li> void putq(double &a,double &b,double &c,double &d)

<li> void putq(double *a)
<li> qvet & Lburst(qvet &);  <li>lorentz buster....in direzione di Burst...
<li> void print(char *);
</ul>
*/


class qvet:public gvet
{
    friend class gvet;
protected:
//   double e = componente [3] del vettore  V
public: // norma ... attenzione va aggiornato se cambia v.
    double m,mq;    // invariante relativistico...
    qvet() {
        x=y=z=e=m=mq=normaq=norma=0.0;
    };
    qvet ( double );
    qvet ( double* );
    qvet ( gvet ,double );
    qvet ( double,double,double,double );
    ~qvet() {};
    double Invar();
    double Invarq();
    double Energia();  //Calcola l'energia a partire dalla massa e impulso
    double Impulso();  //Calcola l'impulso  a partire dalla massa e energia

//==================================
    qvet & operator= ( qvet *a )    {
        *this=*a;
        return *a;
    }
    void   operator= ( double *a );   // attenzione come (px,py,pz,m)
    qvet & operator+= ( const qvet& a );             // attenzione non calcola norma..
    qvet & operator+= ( qvet * a ) {
        *this+=*a;
        return *this;
    }
    qvet & operator-= ( const qvet& a );             // attenzione non calcola norma..
    qvet & operator-= ( qvet * a ) {
        *this-=*a;
        return *this;
    }
    qvet   operator-();                      // operatore unario: solo space

    qvet   operator+ ( const  qvet & );
    qvet   operator+ ( qvet* a ) {
        return *this+*a;
    };
    qvet   operator- ( const qvet & );
    qvet   operator- ( qvet* a ) {
        return *this-*a;
    }

// prodotto vettoriale... eredita!
// prodotto scalare   quadrivettoriale

    double operator* ( const qvet & A ) {
        return ( e*A.e- ( x*A.x+y*A.y+z*A.z ) );
    }
    double operator* ( qvet * A ) {
        return *this**A;    // idem
    }
    friend double operator* ( qvet * A,qvet & B ) {
        return *A*B;
    }


    qvet   operator* ( double );    // prodotto per un parametro
//   friend qvet  operator*(double a,qvet & B){return B*a;};
    friend qvet  operator* ( double a,qvet  B ) {
        return B*a;
    };

    qvet  operator/ ( double a ) {
        a=1./a;
        return   *this*a;
    }

   
// set del vettore parte spaziale; il quarto valore e' la massa
// calcola la norma  e l'energia

    qvet & setvn ( const double a,const double b,const double c, const double massa )
    {
        x=a;
        y=b;
        z=c;
        m=massa;
	mq=m*m;
	normaq=x*x+y*y+z*z;
	norma=sqrt(normaq);
        e=sqrt(normaq+mq);
        return *this;
    }
    qvet & setvn ( double *a )
    {
        x=a[0];
        y=a[1];
        z=a[2];
        m=a[3];
	mq=m*m;
	normaq=x*x+y*y+z*z;
	norma=sqrt(normaq);
        e=sqrt(normaq+mq);     
        return *this;
    }
    qvet & setvn ( gvet Vg,const double massa )
    {
        x=Vg[0];
        y=Vg[1];
        z=Vg[2];
        m=massa;
	mq=m*m;
	normaq=x*x+y*y+z*z;
	norma=sqrt(normaq);
        e=sqrt(normaq+mq);  
        return *this;
    }

// set del vettore parte spaziale; il quarto valore e' la massa; non normalizza

    qvet & setv ( double a,double b,double c,double massa )
    {
        x=a;
        y=b;
        z=c;
        m=massa;
        return *this;
    }
    qvet & setv ( double *a )
    {
        x=a[0];
        y=a[1];
        z=a[2];
        m=a[3];
        return *this;
    }
    qvet & setv ( gvet &Vg,double massa )
    {
        x=Vg[0];
        y=Vg[1];
        z=Vg[2];
        m=massa;
        return *this;
    }

// set del quadrivettore ; il quarto valore e' l'energia;
// calcolo della norma e dell'invariante
    qvet & setqn ( double a,double b,double c, double eg )
    {
        x=a;
        y=b;
        z=c;
        e=eg;
        Invar();
        return *this;
    }
    qvet & setqn ( double *a )
    {
        x=a[0];
        y=a[1];
        z=a[2];
        e=a[3];
        Invar();
        return *this;
    }
    qvet & setqn ( gvet Vg,double eg )
    {
        x=Vg[0];
        y=Vg[1];
        z=Vg[2];
        e=eg;
        Invar();
        return *this;
    }

    void Reset() {
        x=y=z=e=norma=normaq=m=mq=0.;
    };
    
    
 //
 // putq trasferisce le componenti del quadrovettore in 4 variabili esterne
 // Nota differisce da putvn perchè la quarta variabile è la coordinata temporale del
 // quadrivettore e non la norma  della parte spaziale.
 

    void putq( double &a,double &b,double &c,double &d ) {
        a=x;
        b=y;
        c=z;
        d=e;
    }
    void putq( float &a,float &b,float &c,float &d ) {
        a=x;
        b=y;
        c=z;
        d=e;
    }

    void putq( double *a ) {
        a[0]=x;
        a[1]=y;
        a[2]=z;
        a[3]=e;
    }
     
    void Riposo() {   // con massa già definita
        x=y=z=norma=normaq=0.;
        e=m;
        mq=m*m;
    };
    void Riposo(double massa) {// con massa in input 
        x=y=z=norma=normaq=0.;
        e=m=massa;
        mq=m*m;
    };
    qvet  Lburst ( qvet & Burst );  //lorentz buster....in direzione del Burst...
    void print ( const char * );
    void print ( long ev,const char *pnome,int pid,const char *devnome );
};

#endif
