/***************************************************************************
 *   Copyright (C) 2009 by giuseppe Pierazzini                                      *
 *   giuseppe@pierazzini.it                                                               *
 *                                                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 *                                                                         *
 *  Dipartimento di Fisica  E.Fermi / INFN Pisa Italy                      *
 ***************************************************************************/
#ifndef ILLUMINA_H
#define ILLUMINA_H

/**
	@author giuseppe Pierazzini <giuseppe@pierazzini.it>
Illuminazione dell'apparato con la storia di nascita e morte di ciascuna particella!!!
*/
class Illumina{
int  illumina_buffer_dim;
public:
    Illumina();
    ~Illumina();
//=================================
// Illuminazione   dell'apparato; Attivata da illumina
// ha senso solo se non si attiva il pipeline.
// lo spazio viene gestito in "void Store_Illumina()"
//===============================================


   float Etgas,pxtgas,pytgas,pztgas,mqgas;
    int  npr;
    int *idm,*id,*ifato;
    unsigned long long *devstry;
    float  *xg,*yg,*zg,*tg;
    float  *xf,*yf,*zf;
    float  *pxg,*pyg,*pzg,*eg;
    float  *pxf,*pyf,*pzf,*ef;
    float  *mass,*theta,*thetastar;
    
void Make_illumina_buffer(int);
  void Store_Illumina();    // radiografia dei device
};

#if defined(MAINFLYO)
Illumina *Luce=0;
#endif

#if !defined(MAINFLYO)
extern Illumina *Luce;
#endif
#endif
