/**************************************************************************
                          gdevnt.cpp  -  description
                             -------------------
    begin                : Sun Dec 17 2000
    copyright            : (C) 2000 by Giuseppe M Pierazzini
    email                : pierazzini@unipi.it
 ***************************************************************************
 *                                                                         *
 *   NA48  simulation program.                                             *
 *                                                                         *
 ***************************************************************************/

/***********************/

//
//      NTout new version            5-09-00  Tirrenia   GmP
//

#define APRI    0
#define RIEMPI  1
#define CHIUDI  2


#define NEUTRI  1
#define CARICHI 2
#define ALLCHR  3

#include "flyoh.h"
#include "flyoana.h"
//#include <string.h>
#include  "flyline.h"
#include  "flytrk.h"



#include <TROOT.h>
#include "TObject.h"
#include <TBranch.h>
#include <TChain.h>
#include "TMath.h"
#include "TRandom3.h"
#include <TTree.h>
#include <TFile.h>
#include <TSystem.h>
#include <Rtypes.h>

#include "TH1.h"
#include "TH2.h"
#include "TH3.h"


TFile *outfile;
TTree *mytree;


//-------------------------------------------------------------
//                 S c r i v i _ Dati
//-------------------------------------------------------------

void Scrivi_Dati ( int caso )
{

    if ( WrtNt==0 )    return;
    if ( Wrtype==1 )   Scrivi_Root_out ( caso );
    else if ( Wrtype==2 ) Scrivi_Root_plots ( caso );
    else return;  // do nothing...
}
//=======================================================
//*********************************************************

string  BranchWrap ( void *prt,string nikname,string var,string dim,string tipo )

{
    string first="";
    string second="";

    first=nikname+"_"+var;
    if ( dim.size() <1 ) second=first+tipo;
    else second=first+"["+dim+"]"+tipo;

//     first=nikname;
//     if ( dim.size() <1 ) second=var+tipo;
//     else second=var+"["+dim+"]"+tipo;

//   cout<<"\n "<<second;

    mytree->Branch ( first.c_str(),prt,second.c_str() );
    return first;

}
//=======================================================

//=======================================================
/**
Crea un file di uscite in rout di tipo generale.

*/


void Scrivi_Root_out ( int caso )
{
// No output

    if ( WrtNt==0 ) return;

    string Dim="";
    string cDim="";
    string mDim="";
    string Tub="";
    string nik="";

// Initialization for tree output
// Cases

    Device *dev;

    switch ( caso ) {
    case APRI:

        // Open file and define pointer to the mytree class
        outfile = new TFile ( OutGn,"RECREATE" );
        mytree = new TTree ( "fly","Device Variables" );

   //     mytree->SetAutoFlush(10);



        // Head block

        mytree->Branch ( "Header"  ,  & ( evento_.Gen.type ),
                         "type/I:lastype:event:run:ift:trigf:pipev" );
        mytree->Branch ( "Time"  ,  & ( evento_.Gen.tempo ),
                         "tempo/D:dt_tdif/f:dt_beam:dt_begfid:dt_trig:dt_reazione:"
                         "dt_write" );
        mytree->Branch ( "Beam"  ,  & ( evento_.Gen.xt ),
                         "xt/f:yt:zt:xv:yv:zv:pxk:pyk:pzk:pk:pxkf:pykf:pzkf:pkf" );


// Parametri cinematici risonanze
        mytree->Branch ( "Fase",&evento_.Gen.mres12,
                         "mres12/f:mres34:mres123:mres23:mres45:eres12:eres34:eres123:"
                         "eres23:e1:e2:e3:e4:e5:ss1:ss2:ss3" );
         mytree->Branch ( "Fase2",&evento_.Gen.iterfase,"iterfase/I");
//




        if ( Abilita_Pair>0||Abilita_Brems>0 ) {
            mytree->Branch ( "Prod",& ( evento_.Gen.Ipair ),
                             "Ipair/I:IBR:IDZ:ITSR:ITLG:IFUS" );
        }

        if ( Pipeline==0 ) { //attenzione illuminazione: informazioni utili se pipeline==0!
// blocco illumina. Si abilita con la label illumina nel file epc..

            if ( Luce!=0 ) {


                nik="Lu";
                Dim=BranchWrap ( &Luce->npr, nik,"npr"  , "","/I" );

                BranchWrap ( Luce->idm,  nik,"idm"  , Dim,"/I" );
                BranchWrap ( Luce->id,   nik,"id"   , Dim,"/I" );
                BranchWrap ( Luce->ifato,nik,"ifato", Dim,"/I" );;
                BranchWrap ( Luce->devstry,nik,"devstry", Dim,"/L" );
                BranchWrap ( Luce->theta,nik,"theta", Dim,"/F" );
                BranchWrap ( Luce->thetastar,nik,"thetastar", Dim,"/F" );
                BranchWrap ( Luce->xg,   nik,"xg"   , Dim,"/F" );
                BranchWrap ( Luce->yg,   nik,"yg"   , Dim,"/F" );
                BranchWrap ( Luce->zg,   nik,"zg"   , Dim,"/F" );
                BranchWrap ( Luce->tg,   nik,"tg"   , Dim,"/F" );
                BranchWrap ( Luce->xf,   nik,"xf"   , Dim,"/F" );
                BranchWrap ( Luce->yf,   nik,"yf"   , Dim,"/F" );
                BranchWrap ( Luce->zf,   nik,"zf"   , Dim,"/F" );
                BranchWrap ( Luce->pxg,  nik,"pxg"  , Dim,"/F" );
                BranchWrap ( Luce->pyg,  nik,"pyg"  , Dim,"/F" );
                BranchWrap ( Luce->pzg,  nik,"pzg"  , Dim,"/F" );
                BranchWrap ( Luce->pxf,  nik,"pxf"  , Dim,"/F" );
                BranchWrap ( Luce->pyf,  nik,"pyf"  , Dim,"/F" );
                BranchWrap ( Luce->pzf,  nik,"pzf"  , Dim,"/F" );
                BranchWrap ( Luce->mass, nik,"mass" , Dim,"/F" );

            }

            // radiografia devices.. meglio usare i valori rivelati e misurati???????????????
            // si abilita con la label radx

            if ( Radio!=0 ) {

                // locco radiografia ( hit nei dev)   vedi evento.h....
                nik="Rd";
                Dim=BranchWrap ( &Radio->nrdx,nik, "nrdx", ""  , "/I" );
                BranchWrap ( Radio->dvradx,nik,"dvradx", Dim, "/I" );
                BranchWrap ( Radio->idmx,  nik,"idmx" ,  Dim, "/I" );
                BranchWrap ( Radio->xradx, nik,"xradx",  Dim, "/F" );
                BranchWrap ( Radio->yradx, nik,"yradx" , Dim, "/F" );
                BranchWrap ( Radio->zradx, nik,"zradx",  Dim, "/F" );
                BranchWrap ( Radio->tradx, nik,"tradx",  Dim, "/F" );
                BranchWrap ( Radio->pxradx,nik,"pxradx", Dim, "/F" );
                BranchWrap ( Radio->pyradx,nik,"pyradx", Dim, "/F" );
                BranchWrap ( Radio->pzradx,nik,"pzradx", Dim, "/F" );
                BranchWrap ( Radio->eradx, nik,"eradx" , Dim, "/F" );
                BranchWrap ( Radio->evista,nik,"evista", Dim, "/F" );
            }
        }



        for ( dev=Apparato; dev!=0; dev=dev->next ) {

            if ( dev->wrout==0 || dev->escludi>0 ) continue;
            nik=dev->Get_NickName();


            BranchWrap ( &dev->mhit,       nik,"mhit"  ,"" ,"/I" );          // numeri di hits (da particelle)
            Dim=BranchWrap ( &dev->hit_recorded , nik,"rhit"  ,"" ,"/I" );   //recorded hits (può essere < di  hist)
            BranchWrap ( &dev->emDev , nik,"emdev" ,"" ,"/F" );
            BranchWrap ( &dev->dxynorma, nik,"dxynorma" ,"" ,"/F" );
            BranchWrap ( dev->ido ,    nik,"ido" ,Dim,"/I" );       //  ido della particella
            BranchWrap ( dev->mid,       nik,"idm"   ,Dim,"/I" );        // indice di materia
// idm=  idm della particelle, idm= -1 fusione, idm =-3 extracluster
            BranchWrap ( dev->structinfo,nik,"struct"  ,Dim,"/I" );      //  indice di sottostruttura
            BranchWrap ( dev->mdead,     nik,"dead"  ,Dim,"/I" );        // indice di morte
            BranchWrap ( dev->devstory,  nik,"devstry",Dim,"/L" );       //storia dei dev passati
            BranchWrap ( dev->mxd,  nik,"mxd" ,Dim,"/F" );          //  x in dev system
            BranchWrap ( dev->myd,  nik,"myd" ,Dim,"/F" );          //  y in dev system
            BranchWrap ( dev->mzd,  nik,"mzd" ,Dim,"/F" );          //  z in dev system
            BranchWrap ( dev->pxd,  nik,"pxd" ,Dim,"/F" );          //  x in dev system
            BranchWrap ( dev->pyd,  nik,"pyd" ,Dim,"/F" );          //  y in dev system
            BranchWrap ( dev->pzd,  nik,"pzd" ,Dim,"/F" ); 
            
            BranchWrap ( dev->pxl,  nik,"pxl" ,Dim,"/F" );          //  px in lab system now
            BranchWrap ( dev->pyl,  nik,"pyl" ,Dim,"/F" );         
            BranchWrap ( dev->pzl,  nik,"pzl" ,Dim,"/F" ); 
            BranchWrap ( dev->pel,  nik,"pel" ,Dim,"/F" );         //  e in lab system  now
            
            
            //  z in dev system
            BranchWrap ( dev->mdd,  nik,"mdd" ,Dim,"/F" );          // distanza dall'asse centrale del dev
            BranchWrap ( dev->me,   nik,"me"  ,Dim,"/F" );          // released energy in dev
            BranchWrap ( dev->mxl,  nik,"mxl" ,Dim,"/F" );          // x in lab system
            BranchWrap ( dev->myl,  nik,"myl" ,Dim,"/F" );          // y in lab system
            BranchWrap ( dev->mzl,  nik,"mzl" ,Dim,"/F" );          // z in lab system
            BranchWrap ( dev->gpx,  nik,"gpx" ,Dim,"/F" );          // impulso x 
            BranchWrap ( dev->gpy,  nik,"gpy" ,Dim,"/F" );          // impulso y 
            BranchWrap ( dev->gpz,  nik,"gpz" ,Dim,"/F" );          // impulso z
            BranchWrap ( dev->ge,   nik,"ge" ,Dim,"/F" );           // energia generata
            BranchWrap ( dev->dtemp, nik,"dtempo",Dim,"/D" );       // hits_time-T_trigger (per pipeline)

            string devnome;
            devnome=dev->Get_Nome();

            DevStraw *devstr = ( DevStraw* ) dev;
            if ( devnome=="St1u"|| devnome=="St1v"||devnome=="St1x"||devnome=="St1y"||
                    devnome=="St2u"|| devnome=="St2v"||devnome=="St2x"||devnome=="St2y"||
                    devnome=="St3u"|| devnome=="St3v"||devnome=="St3x"||devnome=="St3y"||
                    devnome=="St4u"|| devnome=="St4v"||devnome=="St4x"||devnome=="St4y"
               ) {
                Dim=BranchWrap ( &devstr->nwire,  nik,"nwire" ,"","/I" );  // numero cluster
                BranchWrap ( devstr->Wirecoor,  nik,"wirex" ,Dim,"/F" );   // coordinate in wire
                BranchWrap ( devstr->Wireout,  nik,"wirexout" ,Dim,"/F" );   // coordinate in wire in uscita
                BranchWrap ( devstr->Wiret12,  nik,"wiret12" ,Dim,"/F" );   // tleading 12
                BranchWrap ( devstr->Wiret34,  nik,"wiret34" ,Dim,"/F" );   // tleading 34
                BranchWrap ( devstr->Wiredtim,  nik,"wiredt" ,Dim,"/F" );  // tot tempo_drift
                BranchWrap ( devstr->Wiretraild, nik,"wiretraild" ,Dim,"/F" );  // dif tempo_trailing
                BranchWrap ( devstr->Wiretrails, nik,"wiretrails" ,Dim,"/F" ); // sum tempo_trailing
                BranchWrap ( devstr->Wiredtempo, nik,"wiredtempo" ,Dim,"/F" ); //dif tempo-tempo_tubo_usato
                BranchWrap ( &devstr->flag_pileup, nik,"flagpileup","","/I" );   // verifica wire pileup
                BranchWrap ( devstr->wplan1, nik,"wplan1" ,Dim,"/I" ); //piani
                BranchWrap ( devstr->wplan2, nik,"wplan2" ,Dim,"/I" ); //piani
                BranchWrap ( devstr->wplan3, nik,"wplan3" ,Dim,"/I" ); //piani
                BranchWrap ( devstr->wplan4, nik,"wplan4" ,Dim,"/I" ); //piani


                BranchWrap ( &devstr->tubiseen, nik,"tubiseen","","/I" );   // numero di tubi colpiti

                Tub=BranchWrap ( &devstr->ntub1,  nik,"ntub1" ,"","/I" );    // N. tubi piano 1
                BranchWrap ( devstr->tubo1,  nik,"tubo1" ,Tub,"/I" );         // indirizzo tubi 0-111
                BranchWrap ( devstr->use_tubo1,  nik,"usetubo1" ,Tub,"/I" );   // > 0 se usato nella ricostruzione
                BranchWrap ( devstr->toc_tubo1,  nik,"toctubo1" ,Tub,"/I" );    // molteplicità di hit nel tubo
                BranchWrap ( devstr->t_end_tb1,  nik,"t0tubo1" ,Tub,"/D" );   // T0 del tubo (+-20ns)
                BranchWrap ( devstr->t_start_tb1,  nik,"tdtubo1" ,Tub,"/D" );   // Tempo fine drift
                BranchWrap ( devstr->tmp_tubo1,  nik,"tmptubo1" ,Tub,"/D" );   //tempo di generazione del tubo

                Tub=BranchWrap ( &devstr->ntub2,  nik,"ntub2" ,"","/I" );
                BranchWrap ( devstr->tubo2,  nik,"tubo2" ,Tub,"/I" );
                BranchWrap ( devstr->use_tubo2,  nik,"usetubo2" ,Tub,"/I" );   // > 0 se usato nella ricost
                BranchWrap ( devstr->toc_tubo2,  nik,"toctubo2" ,Tub,"/I" );
                BranchWrap ( devstr->t_end_tb2,  nik,"t0tubo2" ,Tub,"/D" );
                BranchWrap ( devstr->t_start_tb2,  nik,"tdtubo2" ,Tub,"/D" ) ;
                BranchWrap ( devstr->tmp_tubo2,  nik,"tmptubo2" ,Tub,"/D" );


                Tub=BranchWrap ( &devstr->ntub3,  nik,"ntub3" ,"","/I" );
                BranchWrap ( devstr->tubo3,  nik,"tubo3" ,Tub,"/I" );
                BranchWrap ( devstr->use_tubo3,  nik,"usetubo3" ,Tub,"/I" );   // > 0 se usato nella ricost
                BranchWrap ( devstr->toc_tubo3,  nik,"toctubo3" ,Tub,"/I" );
                BranchWrap ( devstr->t_end_tb3,  nik,"t0tubo3" ,Tub,"/D" );
                BranchWrap ( devstr->t_start_tb3,  nik,"tdtubo3" ,Tub,"/D" );
                BranchWrap ( devstr->tmp_tubo3,  nik,"tmptubo3" ,Tub,"/D" );

                Tub=BranchWrap ( &devstr->ntub4,  nik,"ntub4" ,"","/I" );
                BranchWrap ( devstr->tubo4,  nik,"tubo4" ,Tub,"/I" );
                BranchWrap ( devstr->use_tubo4,  nik,"usetubo4" ,Tub,"/I" );   // > 0 se usato nella ricostri
                BranchWrap ( devstr->toc_tubo4,  nik,"toctubo4" ,Tub,"/I" );
                BranchWrap ( devstr->t_end_tb4,  nik,"t0tubo4" ,Tub,"/D" );
                BranchWrap ( devstr->t_start_tb4,  nik,"tdtubo4" ,Tub,"/D" );
                BranchWrap ( devstr->tmp_tubo4,  nik,"tmptubo4" ,Tub,"/D" );



            }

            else if ( devnome=="Rich"&& dev->Get_Extrawork() ==1 )

            {
                DevRich *devrich = ( DevRich* ) dev; // casting to the correct device
                BranchWrap ( devrich->Pathtrk,  nik,"cammino" ,Dim,"/F" );
                BranchWrap ( devrich->Fototrk,  nik,"fototrk" ,Dim,"/I" );
                BranchWrap ( devrich->Pmtrk,  nik,"pmtrk" ,Dim,"/I" );

                BranchWrap ( &devrich->SottoSoglia, nik,"sottosoglia","","/I" );
                BranchWrap ( &devrich->Npcolpiti, nik,"pmcolpiti","","/I" );
                BranchWrap ( &devrich->Npmseen, nik,"pmseen","","/I" );
                BranchWrap ( &devrich->FotoLost, nik,"fotolost","","/I" );
                cDim = BranchWrap ( &devrich->Ncvfoto, nik, "fotoseen", "", "/I" );
                BranchWrap ( devrich->Ftseen, nik,"ftfato" ,cDim,"/I" );

                BranchWrap ( devrich->traknum, nik,"trknum" ,cDim,"/I" );  // traccia padre

                BranchWrap ( devrich->tanxz, nik,"tanxz" ,cDim,"/F" );
                BranchWrap ( devrich->tanyz, nik,"tanyz" ,cDim,"/F" );
                BranchWrap ( devrich->tetaz, nik,"tetaz" ,cDim,"/F" );
                BranchWrap ( devrich->mom, nik,"mom" ,cDim,"/F" );


                BranchWrap ( devrich->Xspot, nik,"xspot" ,cDim,"/F" ); //coordinate sul piano dei rivelatori
                BranchWrap ( devrich->Yspot, nik,"yspot" ,cDim,"/F" ); //coordinate sul piano dei rivelatori


                BranchWrap ( devrich->Xcvk, nik,"xcvk" ,cDim,"/F" );// coordinate  del fotona alla nascita
                BranchWrap ( devrich->Ycvk, nik,"ycvk" ,cDim,"/F" );
                BranchWrap ( devrich->Zcvk, nik,"zcvk" ,cDim,"/F" );

                BranchWrap ( devrich->Vxcvk, nik,"vxcvk" ,cDim,"/F" );// versore  del fotona alla nascita
                BranchWrap ( devrich->Vycvk, nik,"vycvk" ,cDim,"/F" );
                BranchWrap ( devrich->Vzcvk, nik,"vzcvk" ,cDim,"/F" );
            }






            else if ( devnome=="Lkry" ) {
                //DevLkr *devcal =(DevLkr*) dev;  // casting to the correct device

                DevLkr *devcal=lkry;
                BranchWrap ( &devcal->padhit, nik,"padhit","","/I" );       //npad
                BranchWrap ( &devcal->dist_max, nik,"dist_max","","/F" );   // distanza massima tra due cluster
                BranchWrap ( &devcal->epad28, nik,"epad28","","/F" );       // energia pad 2X8
                BranchWrap ( &devcal->m28x  , nik,"m28x","","/F" );         // momento  in x
                BranchWrap ( &devcal->m28qx , nik,"m28qx","","/F" );        // 2. momento in x
                BranchWrap ( &devcal->m28y  , nik,"m28y","","/F" );         // momento in y
                BranchWrap ( &devcal->m28qy , nik,"m28qy","","/F" );        // 2. momento in y
                BranchWrap ( &devcal->epad44, nik,"epad44","","/F" );       // come sopra per pad 4X4
                BranchWrap ( &devcal->m44x  , nik,"m44x","","/F" );
                BranchWrap ( &devcal->m44qx , nik,"m44qx","","/F" );
                BranchWrap ( &devcal->m44y  , nik,"m44y","","/F" );
                BranchWrap ( &devcal->m44qy , nik,"m44qy","","/F" );

                BranchWrap ( &devcal->quad1 , nik,"quad1","","/F" );        // energia quadrante 1
                BranchWrap ( &devcal->quad2 , nik,"quad2","","/F" );        // energia quadrante 2
                BranchWrap ( &devcal->quad3 , nik,"quad3","","/F" );        // energia quadrante 3
                BranchWrap ( &devcal->quad4 , nik,"quad4","","/F" );        // energia quadrante 4

            }

// nota se ci sono più particelle nell'evento  c'è tanta sovrapposizione ......di fotoni provenienti da particelle diverse...
            else if ( devnome=="Mare" ) {
                BranchWrap ( &mare->Ncvk, nik,"ncvk" ,"","/I" );
                mDim =BranchWrap ( &mare->Nseen, nik,"nseen","","/I" );
                BranchWrap ( mare->OMhit, nik,"OMhit" ,mDim,"/I" );
                BranchWrap ( mare->Icl, nik,"icl" ,mDim,"/I" );
                BranchWrap ( mare->Ip, nik,"ip" ,mDim,"/I" );
                BranchWrap ( mare->effi, nik,"effi" ,mDim,"/F" );
                BranchWrap ( mare->xseen, nik,"xseen" ,mDim,"/F" );
                BranchWrap ( mare->yseen, nik,"yseen" ,mDim,"/F" );
                BranchWrap ( mare->zseen, nik,"zseen" ,mDim,"/F" );
                
                BranchWrap ( mare->tp, nik,"tp" ,mDim,"/F" );
                BranchWrap ( mare->peso, nik,"peso" ,mDim,"/F" );
                BranchWrap ( &mare->totpeso, nik,"totpeso" ,"","/F" );
                BranchWrap ( &mare->mu_tratto, nik,"tratto" ,"","/F" );
            }





        }


//         int Tot_trk;
//         int Totrac;
//         float Tot_Charge;
//         int index[6];
//         float xct[6],yct[6],zct[6],vxt[6],vyt[6],vzt[6];
//         float chiq[6],ptrk[6],ptrk2[6],charge[6];
//         //
        if ( Le_Tracce !=0 ) { // mwpc NA48
            nik = "Trc";

            Dim = BranchWrap ( &Le_Tracce->Totrac, nik, "ntrk", "", "/I" );    // numero di tracce ric.
            BranchWrap ( &Le_Tracce->Tot_Charge, nik, "chall", "", "/F" );        // carica totale
            BranchWrap ( Le_Tracce->index, nik, "maskcam", Dim,"/I" );       // maschere camere usate  per ogni hit
            BranchWrap ( Le_Tracce->chiq, nik, "chiq", Dim,"/F" );
            BranchWrap ( Le_Tracce->charge, nik, "charge", Dim,"/F" );
            BranchWrap ( Le_Tracce->xct, nik, "xct", Dim,"/F" );
            BranchWrap ( Le_Tracce->yct, nik, "yct", Dim,"/F" );
            BranchWrap ( Le_Tracce->zct, nik, "zct", Dim,"/F" );
            BranchWrap ( Le_Tracce->vxt, nik, "vxt", Dim,"/F" );
            BranchWrap ( Le_Tracce->vyt, nik, "vyt", Dim,"/F" );
            BranchWrap ( Le_Tracce->vzt, nik, "vzt", Dim,"/F" );

            BranchWrap ( Le_Tracce->xm48, nik, "xm48", Dim,"/F" );
            BranchWrap ( Le_Tracce->ym48, nik, "ym48", Dim,"/F" );
            BranchWrap ( Le_Tracce->zm48, nik, "zm48", Dim,"/F" );

            BranchWrap ( Le_Tracce->xcm4, nik, "xcm4", Dim,"/F" );
            BranchWrap ( Le_Tracce->ycm4, nik, "ycm4", Dim,"/F" );
            BranchWrap ( Le_Tracce->zcm4, nik, "zcm4", Dim,"/F" );


            BranchWrap ( Le_Tracce->ptrk, nik, "ptrk", Dim,"/F" );

        }









        //traccie  StrawChamber

        if ( Trkstraw !=0 ) { //straw chamber NA62
            nik = "Tr";

            Dim = BranchWrap ( &Trkstraw->ntrk_done, nik, "ntrk", "", "/I" );    // numero di tracce ric.

            BranchWrap ( &Trkstraw->charge_all, nik, "chall", "", "/I" );        // carica totale
            BranchWrap ( Trkstraw->Trk2Root.mask, nik, "mask", Dim,"/I" );       // maschere camere usate  per ogni hit
            BranchWrap ( Trkstraw->Trk2Root.usepl, nik, "usepl", Dim,"/I" );     // numero di piani usati
            BranchWrap ( Trkstraw->Trk2Root.camere, nik, "camere", Dim,"/I" );    //numero di camere usate
            BranchWrap ( Trkstraw->Trk2Root.single, nik, "single", Dim,"/I" );    // piani singoli
            BranchWrap ( Trkstraw->Trk2Root.ic0, nik, "ic0", Dim,"/I" );          //cluster camera 0
            BranchWrap ( Trkstraw->Trk2Root.ic1, nik, "ic1", Dim,"/I" );          //cluster camera 1
            BranchWrap ( Trkstraw->Trk2Root.ic2, nik, "ic2",Dim,"/I" );           //cluster camera 2
            BranchWrap ( Trkstraw->Trk2Root.ic3, nik, "ic3",Dim,"/I" );           //cluster camera 3
            BranchWrap ( Trkstraw->Trk2Root.zbyy, nik,"zbyy", Dim, "/F" );        // z da magnete y test di convergenza
            BranchWrap ( Trkstraw->Trk2Root.zbyx, nik,"zbyx", Dim, "/F" );        // z da magnete x test di convergenza
            BranchWrap ( Trkstraw->Trk2Root.chiq, nik,"chiq", Dim, "/F" );        // fit chiq
            BranchWrap ( Trkstraw->Trk2Root.charge, nik, "charge",Dim,"/F" );     // carica della traccia

            BranchWrap ( Trkstraw->Trk2Root.dx0, nik, "dx0", Dim, "/F" );         // correzione ai parametri misurati;
            BranchWrap ( Trkstraw->Trk2Root.dx1, nik, "dx1", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.dx2, nik, "dx2", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.dx3, nik, "dx3", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.dy0, nik, "dy0", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.dy1, nik, "dy1", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.dy2, nik, "dy2", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.dy3, nik, "dy3", Dim, "/F" );

            BranchWrap ( Trkstraw->Trk2Root.xmg, nik, "xmg", Dim, "/F" );         // x al magnete
            BranchWrap ( Trkstraw->Trk2Root.ymg, nik, "ymg", Dim, "/F" );         // y al magnete
            BranchWrap ( Trkstraw->Trk2Root.p,nik,"ptrk", Dim, "/F" );            // p della traccia
            BranchWrap ( Trkstraw->Trk2Root.py, nik, "py", Dim, "/F" );           // py
            BranchWrap ( Trkstraw->Trk2Root.pxin, nik, "pxin", Dim, "/F" );       // pxin  prima del magnete
            BranchWrap ( Trkstraw->Trk2Root.pzin, nik, "pzin", Dim, "/F" );       // pzin  prima
            BranchWrap ( Trkstraw->Trk2Root.pxout, nik, "pxout", Dim, "/F" );     // pxout  dopo
            BranchWrap ( Trkstraw->Trk2Root.pzout, nik, "pzout", Dim, "/F" );     // pzout  dopo
            BranchWrap ( Trkstraw->Trk2Root.xhodx, nik, "xhodx", Dim, "/F" );     // x at hodx
            BranchWrap ( Trkstraw->Trk2Root.yhodx, nik, "yhodx", Dim, "/F" );     // y at hodx
            BranchWrap ( Trkstraw->Trk2Root.clstgx, nik, "clstgx", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.clstgy, nik, "clstgy", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.tgxfit, nik, "tgxfit", Dim, "/F" );
            BranchWrap ( Trkstraw->Trk2Root.tgyfit, nik, "tgyfit", Dim, "/F" );

        }

//  studio dei cluster  nelle camere

        for ( int ic=0; ic<4; ic++ ) {
            if ( ChambClus[ic]!=0 )


            {
                stringstream sigla;
                sigla<<"Cls"<<ic;
                sigla>>nik;


                Dim = BranchWrap ( &ChambClus[ic]->ncls, nik, "ncls", "", "/I" );  // numero dei cluster

                BranchWrap ( &ChambClus[ic]->nwu , nik, "nwu", "", "/I" );    // numero per piano
                BranchWrap ( &ChambClus[ic]->nwv , nik, "nwv", "", "/I" );
                BranchWrap ( &ChambClus[ic]->nwx , nik, "nwx", "", "/I" );
                BranchWrap ( &ChambClus[ic]->nwy , nik, "nwy", "", "/I" );

//                 BranchWrap (ChambClus[ic]->hitu , nik, "hitu",Dim,"/I");       // hits piano
//                 BranchWrap (ChambClus[ic]->hitv , nik, "hitv",Dim,"/I");
//                 BranchWrap (ChambClus[ic]->hitx , nik, "hitx",Dim,"/I");
//                 BranchWrap (ChambClus[ic]->hity , nik, "hity",Dim,"/I");


                BranchWrap ( ChambClus[ic]->maskera , nik, "mask",Dim,"/I" );
                BranchWrap ( ChambClus[ic]->planes , nik, "planes",Dim,"/I" );  // piani coinvolti
                BranchWrap ( ChambClus[ic]->clsusato , nik, "usato",Dim,"/I" );
                BranchWrap ( ChambClus[ic]->Ufil , nik, "Ufil",Dim,"/F" );      // wire del piano
                BranchWrap ( ChambClus[ic]->Vfil , nik, "Vfil",Dim,"/F" );
                BranchWrap ( ChambClus[ic]->Xfil , nik, "Xfil",Dim,"/F" );
                BranchWrap ( ChambClus[ic]->Yfil , nik, "Yfil",Dim,"/F" );

                BranchWrap ( ChambClus[ic]->Udtim , nik, "Udtim",Dim,"/F" );   // tempo del wire
                BranchWrap ( ChambClus[ic]->Vdtim , nik, "Vdtim",Dim,"/F" );
                BranchWrap ( ChambClus[ic]->Xdtim , nik, "Xdtim",Dim,"/F" );
                BranchWrap ( ChambClus[ic]->Ydtim , nik, "Ydtim",Dim,"/F" );



                BranchWrap ( ChambClus[ic]->X , nik, "X",Dim,"/F" );           // cordinata ricostruita
                BranchWrap ( ChambClus[ic]->Y , nik, "Y",Dim,"/F" );
                BranchWrap ( ChambClus[ic]->Z , nik, "Z",Dim,"/F" );
                BranchWrap ( ChambClus[ic]->chiq , nik, "chiq",Dim,"/F" );     // chiq del fit





            }

        }


        if ( Akpivv!=0 ) {
            mytree->Branch ( "Anakpivv",&Akpivv->good,"kvv_good/I:kvv_charge/f:kvv_chiqtrk/f"
                             ":kvv_pxkp:kvv_pykp:kvv_pzkp:kvv_momk"
                             ":kvv_pxpi:kvv_pypi:kvv_pzpi:kvv_mompi:kvv_tmom:kvv_epi:kvv_pxvv:kvv_pyvv:kvv_pzvv:kvv_momvv:kvv_mqvv:kvv_evv"
                             ":kvv_masvv:kvv_chiqvert:kvv_xvv:kvv_yvv:kvv_zvv:kvv_xlac:kvv_ylac:kvv_zlac:kvv_diverge" );
        }


        // dati per le analisi
        if ( Akmunu!=0 ) {

            mytree->Branch ( "Anakmunu",&Akmunu->np,"knu_np/I:knu_charge/f:knu_chiqtrk/f"
                             ":knu_pxkp:knu_pykp:knu_pzkp:knu_momk"
                             ":knu_pxmu:knu_pymu:knu_pzmu:knu_mommu:knu_tmom:knu_emu:knu_pxnu:knu_pynu:knu_pznu:knu_momnu:knu_mqnu:knu_enu"
                             ":knu_masnu:knu_chiqvert:knu_xnu:knu_ynu:knu_znu:knu_xlac:knu_ylac:knu_zlac:knu_timedif" );
        }






        if ( Akpip0!=0 ) {
            //float charge,chisq,pmis,masmis, ppip;
            mytree->Branch ( "Anakpip0",&Akpip0->good,"pip0_good/I:pip0_charge/f:pip0_chisq/f:"
                             "pip0_pmis/f:pip0_masmis/f:pip0_ppip/f:"
                             "pip0_msgg:pip0_dtet:pip0_xvv:pip0_yvv:pip0_zvv" );
        }
 
        if ( Akpip0ee!=0 ) {

            mytree->Branch ( "Anakpip0ee",&Akpip0ee->good,"p0ee_good/I:p0ee_associa:p0ee_chiq/f:"
                             "p0ee_xvtx:p0ee_yvtx:p0ee_zvtx:p0ee_momk:"
                             "p0ee_mk:p0ee_mpi0:p0ee_sommap:p0ee_cog:p0ee_cox:p0ee_coy:"
                             "p0ee_mmqee:p0ee_mqpip0:p0ee_mqpiee:p0ee_mqp0ee:p0ee_pxkp:p0ee_pykp:p0ee_pzkp"
                           );
        }


        if ( Akenug!=0 ) {

            mytree->Branch ( "Anakenug",&Akenug->ntrk,"enug_ntrk/I:enug_good/I:"
                             "enug_pxkp/f:enug_pykp:enug_pzkp:"
                             "enug_chiq/f:enug_xvtx:enug_yvtx:enug_zvtx:enug_momk:enug_mnu:"
                             "enug_mnuq:enug_kelep:enug_kegam:enug_kenu:"
                             "enug_cogd:enug_cox:enug_coy"
                           );
        }


        if ( Akpip0dlz!=0 ) {

            mytree->Branch ( "Anakpip0dlz",&Akpip0dlz->good,"pip0dlz_good/I:pip0dlz_chiq/f:"
                             "pip0dlz_xvtx:pip0dlz_yvtx:pip0dlz_zvtx:pip0dlz_momk:"
                             "pip0dlz_mk:pip0dlz_mpi0:pip0dlz_sommap:pip0dlz_cog:pip0dlz_cox:pip0dlz_coy:pip0dlz_mmqee:pip0dlz_mmee"
                           );
        }

        if ( Akpip0p0dlz!=0 ) {

            mytree->Branch ( "Anakpip0p0dlz",&Akpip0p0dlz->good,"pip0p0dlz_good/I:pip0p0dlz_chiq/f:"
                             "pip0p0dlz_xvtx:pip0p0dlz_yvtx:pip0p0dlz_zvtx:pip0p0dlz_momk:"
                             "pip0p0dlz_mk:pip0p0dlz_mpi0gg:pip0p0dlz_mpi0gee:pip0p0dlz_sommap:pip0p0dlz_cog:pip0p0dlz_cox:pip0p0dlz_coy:pip0p0dlz_mmqee"
                           );
        }

        if ( Aklambda!=0 ) {
            mytree->Branch ( "Anaklambda",&Aklambda->np,"lam_np/I:lam_charge/f:lam_pxlam:lam_pylam:lam_pzlam:lam_momlam"
                             ":lam_elam:lam_masqlam:lam_pxpim:lam_pypim:lam_pzpim:lam_mompim:lam_epim:lam_pxprt:lam_pyprt:lam_pzprt"
                             ":lam_momprt:lam_eprt:lam_xlam:lam_ylam:lam_zlam:lam_dlam" );

        }

// gallorini 2012

        if ( Ake2g!=0 ) {

            mytree->Branch ( "Anake2g",&Ake2g->ntrk,"e2g_ntrk/I:e2g_good/I:"
                             "e2g_pxkp/f:e2g_pykp:e2g_pzkp:"
                             "e2g_chiq/f:e2g_xvtx:e2g_yvtx:e2g_zvtx:e2g_momk:"
                             "e2g_MM2:e2g_xdlz:e2g_ydlz:e2g_zdlz:"
                             "e2g_cogd:e2g_cox:e2g_coy:e2g_ptrk:e2g_eg:e2g_ecla"
                           );
        }


        if ( ANemo!=0 ) {

            mytree->Branch ( "AnaNemo",&ANemo->good,"nemo_good/I:nemo_iter/I:"
                             "nemo_chiq/f:nemo_lambd0/f:nemo_lambd1:nemo_lambd2:nemo_vxauto:nemo_vyauto:nemo_vzauto:"
                             "nemo_t0fit:nemo_vxfit:nemo_vyfit:nemo_vzfit:nemo_xfit:nemo_yfit:nemo_zfit");
        }





//chod_acc_0,rich_hit_3,muv3_acc,lkr_4x4_30,lav_12,lav_all;
        if ( Auser!=0 ) {
            mytree->Branch ( "Anauser",&Auser->chod_acc_0,
                             "chod_acc_0/I:rich_hit_3:muv3_acc:lkr_4x4_30:lavs[12]:lav_12:lav_all:buoncut[7]:lkr_epad35:lkr_npad2:lkr_npad3:hod_n3x3:jaccut[8]" );

        }


        break;
//==============================================================================
    case RIEMPI:


        if ( FitDone>0 || WrtNt>1 ) { //WrtNT =0,1 (solobuoni),10(tutti) 

            evento_.Gen.dt_write=TBurst->Get_dt_write();

            SelRea->AddNt();
            mytree->Fill();
            Eventi_Scritti++;              
        }

        break;


    case CHIUDI:

        mytree->Write();
        outfile->Close();
        break;

    default:
        break;
    }
}


//=======================================================

/**
Procedura realizzata solo per studiare il CUPS nel  decadimento del Kl->3pi0
*/
void Scrivi_Root_plots ( int caso )
{
// da riscrivere secondo le necessità.....adesso è dummy
}
