/***************************************************************************
 *   Copyright (C) 2009 by giuseppe Pierazzini                                      *
 *   giuseppe@pierazzini.it                                                               *
 *                                                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 *                                                                         *
 *  Dipartimento di Fisica  E.Fermi / INFN Pisa Italy                      *
 ***************************************************************************/
#include "parm.h"
#include "evento.h"
#include "tempo.h"
#include "mattpar.h"
#include "part_db.h"
#include "apparato.h"
#include "radiografia.h"

//using namespace std;

Radiografia::Radiografia(int primo, int last)
{ 
 primo_dev=primo-1;  // gruppo di device radiografati 
 if(last!=0) ultimo_dev=last+1;else ultimo_dev=100000;
 radx_buffer_dim=150;
 Make_radx_buffer ( radx_buffer_dim );

 Gout<<"\n Apparatus radiography required?: between idev "<< primo_dev
     <<" and "<<ultimo_dev;
}


Radiografia::~Radiografia()
{
}

//==================R a d x =============================
void Radiografia::Make_radx_buffer ( int rdim )
{
//====
// make space
  dvradx = new int [rdim];
  idmx   = new int [rdim];
  xradx  = new float[rdim];
  yradx  = new float[rdim];
  zradx  = new float[rdim];
  tradx  = new float[rdim];
  pxradx = new float[rdim];
  pyradx = new float[rdim];
  pzradx = new float[rdim];
  eradx  = new float[rdim];
  evista = new float[rdim];

}

void Radiografia::Store_Radx()
{
  
 // meglio se Pipeline è off   comunque è su dati misurati!!!..

  Device *dev;
  dev=Apparato;

  nrdx=0;

  while ( dev )
  {
    if ( dev->mhit>0 &&(dev->idev>primo_dev&&dev->idev<ultimo_dev) )  
    {
//     nota da mettere in root??????????????
      for ( int i=0;i<dev->mhit; i++ )
      {
        dvradx[nrdx]=dev->Get_Idev();
        idmx[nrdx]=dev->M_Hits[i].idm;
        dev->M_Hits[i].Xlab.putv( xradx[nrdx],yradx[nrdx],zradx[nrdx] );
        tradx[nrdx]=dev->M_Hits[i].tempo;
        dev->M_Hits[i].P.putq( pxradx[nrdx],pyradx[nrdx],pzradx[nrdx],eradx[nrdx] );
        evista[nrdx]=dev->M_Hits[i].e_rivela;
        nrdx++;
        if ( nrdx> radx_buffer_dim-2 ) {Gout<<"\nToo many rdax hits... cut to "<<  radx_buffer_dim ; break;}

      }
    }
    dev=dev->next;
  }
}
