/***************************************************************************
 *   Copyright (C) 2009 by giuseppe Pierazzini                                      *
 *   giuseppe@pierazzini.it                                                               *
 *                                                                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 *                                                                         *
 *  Dipartimento di Fisica  E.Fermi / INFN Pisa Italy                      *
 ***************************************************************************/
#ifndef RADIOGRAFIA_H
#define RADIOGRAFIA_H

/**
	@author giuseppe Pierazzini <giuseppe@pierazzini.it>
Procedura per memorizzare tutti gli hits dei dev in un solo buffer e presentarlo 
in un grafico root, come una radigrafia dell'apparato.

*/
class Radiografia{

int  radx_buffer_dim;

public:
int primo_dev, ultimo_dev; // gruppo di device radiografati 
    Radiografia(int,int);

    ~Radiografia();  
//=================================
//  R A D I O G R A F I A  dell'apparato; Attivata da radx
// ha senso solo se non si attiva il pipeline.
// lo spazio viene gestito in "void Store_Radx()"
//===============================================
    int nrdx;
    int *dvradx , *idmx ;
    float  *xradx , *yradx , *zradx , *tradx ;
    float  *pxradx , *pyradx , *pzradx , *eradx ;
    float  *evista ;

//================================   
  void Make_radx_buffer(int);
  void Store_Radx();    // radiografia dei device
};
#if defined(MAINFLYO)
Radiografia *Radio=0;
#endif

#if !defined(MAINFLYO)
extern Radiografia *Radio;
#endif
#endif
