/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 20.02.05      *
 *   pierazzini@unipi.it                                                   * 
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/
#ifndef FLYLINE_H
#define FLYLINE_H



//using namespace std;
 class Flytrk;

/**
Procedura per la ricostruzione delle tracce in NA48
@author Giuseppe Pierazzini
*/


class Flyline
  {
    friend class Flytrk;
    friend class Flytrk2;

  protected:
    const char *Title;
    int nhit1,nhit2,nhit3,nhit4,nhit5,nhit6;
    gvet xhit1[10],xhit2[10],xhit3[10],xhit4[10],xhit5[10],xhit6[10];
    // for calculations...
    int Iter_trk,used_trk[6][10];
    int i1,i2,i3,i4,i5,i6;
    double y1,y2,y3,y4,y5,y6;
    double z1,z2,z3,z4,z5,z6;
    double chiq_ora,chiqlast;


  public:
    Flytrk *First_trk,*Last_trk;
    double mas_pip;
    double Bsegno1,Bsegno2,kick1,kick2;

    // saved values...
    int TrkNata,IterSav,isv1,isv2,isv3,isv4,isv5,isv6, indexsav;
    double chiqsav;

    //paw_data/root  max 6 tracce,. ma puo' aumentare...
    int Tot_trk;
    int Totrac;
    int index[6];
    float Tot_Charge;
    float xct[6],yct[6],zct[6],vxt[6],vyt[6],vzt[6];
    float chiq[6],ptrk[6],charge[6];
     float xm48[6],ym48[6],zm48[6],xcm4[6],ycm4[6],zcm4[6];
    
    //

    Flyline();
    virtual ~Flyline();
    void Get_Hits_from_Dev();
    virtual void Find_Tracce();
    void Save_Traccia();
    void Reset()
    {
      Totrac=0;
      Tot_Charge=0.;
    }

  };

#if defined(MAINFLYO)
Flyline  * Le_Tracce;
#endif

#if !defined(MAINFLYO)
extern Flyline * Le_Tracce;
#endif

#endif

