/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 20.02.05      *
 *   pierazzini@unipi.it                                                   * 
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/
#include <math.h>
#include "flyoh.h"
#include  "flyline.h"
#include  "flytrk.h"

//using namespace std;
int Trkdebug=0;
// procedura chiamata da Flyline per il calcolo dell'impulso della traccia

Flytrk::Flytrk()
{
  id=Le_Tracce->Tot_trk++;
  index=-1;
  tottrk=0;
  charge=0.;
  // linking
  if(Le_Tracce->First_trk==0)
    {
      Le_Tracce->First_trk=this;
      Le_Tracce->Last_trk=this;
      up=0;
    }
  else
    {
      up=Le_Tracce->Last_trk;
      up->next=this;
    }
  next=0;
  Le_Tracce->Last_trk=this;


}



Flytrk::~Flytrk()
{}

void  Flytrk::Get_Traccia()
{

  index=Le_Tracce->indexsav;
  //  Gout<<"\n Get_Traccia!! "<<index<<endl;
  if(index<0)
    {
      Reset();
      Le_Tracce->Tot_trk--;
      return;
    }  // ner has to happened...
  //get space pints with its index...
  // if index==-1 point not found in the chamber 1 and 6
  if((i1=Le_Tracce->isv1)>-1)
    Pc1=Le_Tracce->xhit1[i1]; // devono esistere....
  if((i2=Le_Tracce->isv2)>-1)
    Pc2=Le_Tracce->xhit2[i2];
  if((i3=Le_Tracce->isv3)>-1)
    Pc3=Le_Tracce->xhit3[i3];
  if((i4=Le_Tracce->isv4)>-1)
    Pc4=Le_Tracce->xhit4[i4];
  X=Pc1;
  chiq=Le_Tracce->chiqsav;

  if(Trkdebug==1) Gout<<setprecision(4)<<fixed<<
   "\n Ev "<<Eventi_Generati<<" Tottrk "<<Le_Tracce->Tot_trk<<" id "<< id<<"  <"<<i1<<i2<<i3<<i4<<"> "<<
   " chiq "<<chiq<<endl;
 
  //==================
  // procedure to get Momentum from spectrometer,
  // charge
  // position and Versus at chamber 1
  // now only test for four chamber of na48....
  // define the index of used space_points....

  V12=(Pc2-Pc1).NVerso();
  Verso=V12;
  cosdip=sqrt(V12[0]*V12[0]+V12[2]*V12[2]); // cos of dip angle...
  V12=V12.NxzVerso();
  V34 =(Pc4-Pc3).NxzVerso();
  bend1=Le_Tracce->Bsegno1*asin(V12[2]*V34[0]-V34[2]*V12[0]);
  if(bend1>0.0)
    charge=-1.;
  else if(bend1<0.0)
    charge=1.;
  else if(bend1==0.0)
    {
      Reset();
      Le_Tracce->Tot_trk--;
      return;
    } // just in the case....
  //
  ptrk=fabs(Le_Tracce->kick1/(2.*sin(bend1*0.5)*cosdip));    //impuls per charg...
  
   if(ptrk>100.){  // caso di bendig troppo piccolo
    Reset();
      Le_Tracce->Tot_trk--;
      return;
    } 
     
  // quadrimomentum come pai....tuttavia l'impulso e'indipendente dalla massa...
  P.setvn(Verso*ptrk,Le_Tracce->mas_pip);     // attenzione a come si usa  nella analisi...
  //
  // Xlk  coordinate al calorimetro....
  double dlkrc1=lkry->Get_Cface().z-Pc4[2]; 
  V34 =(Pc4-Pc3).Verso();
  double t= dlkrc1/V34[2];
  Xlk=Pc4+V34*t;
  
  
    // Xm48 coordinate al magnete na48....
  double dlm48=Mag48->Get_Cface().z-Pc2.z; 
  t= dlm48/Verso.z;
  Xm48=Pc2+Verso*t;
  

   // Xlk0  coordinate estrapolate al calorimetro "senza magnete" 
  double dlmrc0=lkry->Get_Cface().z-Pc2.z; 
  t= dlmrc0/Verso.z;
  Xlk0=Pc2+Verso*t;
   
 
  
  

  if(Trkdebug==1)
    {
      P.print(evento_.Gen.Event,"P",-1,"Trak");
      Gout<<" id "<<id <<" cs "<<cosdip<<" bend "<<bend1<<"  ptr "<<ptrk<<std::endl;
    }

  // save in root data 
  
  Le_Tracce->index[id]=index;
  X.putv(Le_Tracce->xct[id],Le_Tracce->yct[id],Le_Tracce->zct[id]);
  Verso.putv(Le_Tracce->vxt[id],Le_Tracce->vyt[id],Le_Tracce->vzt[id]);
  
  
   Xm48.putv(Le_Tracce->xm48[id],Le_Tracce->ym48[id],Le_Tracce->zm48[id]); 
  Pc4.putv(Le_Tracce->xcm4[id],Le_Tracce->ycm4[id],Le_Tracce->zcm4[id]);
   
 
  
  
  
  Le_Tracce->ptrk[id]=ptrk;
  
  Le_Tracce->chiq[id]=chiq;
  Le_Tracce->charge[id]=charge;
  Le_Tracce->Tot_Charge+=charge;
  //   total
  tottrk++;
}

void  Flytrk::Spia_Trk()
{
  // debug out...
  if(index>-1)
    {
      X.print("X");
      Gout<<" Ev "<<evento_.Gen.Event<<" <"<<i1<<i2<<i3<<i4<<"> chiq "<<chiq;
      P.print("P");
      Gout<<" bend "<<bend1<<" ch "<<charge<<std::endl;
    }
   if(next!=0)next->Spia_Trk();
}

void  Flytrk::Reset()
{
  i1=i2=i3=i4=i5=i6=index=-1;
  charge=0.0;
}

