/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 20.02.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/
#ifndef FLYTRK_H
#define FLYTRK_H
#include "gvet.h"
/**
@author Giuseppe Pierazzini
Procedura per NA48 (Tracc)
*/

class Flytrk
{

protected:
    int id;
    int i1,i2,i3,i4,i5,i6, IterSav;

public:
    gvet Pc1,Pc2,Pc3,Pc4,Pc5,Pc6;
    gvet V12, V34, V56;
    double bend1,bend2,cosdip;
    gvet X,Verso;  //at chamber 1
    qvet P;

    Flytrk *up,*next;
    gvet Xlk0; //at lkr  extrapolated; with direction  before magnet 
    gvet Xlk;  //at lkr  extrapolated; with directio after  magnet
    gvet Xm48; // at magnet
    int tottrk;
    int index;
    double chiq,ptrk,charge;

    // procedure
    Flytrk();
    virtual ~Flytrk();
    void   Reset();
    int    Get_Id() {
        return id;
    }
    virtual void   Get_Traccia();
    void   Spia_Trk();
};
#if defined(MAINFLYO)
Flytrk  *Tracc;
#endif

#if !defined(MAINFLYO)
extern Flytrk *Tracc;
#endif
#endif
