
/*  file di test  Authors G.Pierazzini  */
/* new version 20 ottopbre 2010    */

#ifndef CLUGMP_H
#define CLUGMP_H
#include "devstraw.h"
#include "gmatrix.h"


/**
Procedura per la ricostruzione delle tracce nelle camere straw;
  */
using namespace std;

struct  HitClus
{
    string nome;
    int id,mask,planes;
    int hitu,hitv,hitx,hity;  //ordinati secondo zeta
    float Ufil,Vfil,Xfil,Yfil;
	 float Udtim,Vdtim,Xdtim,Ydtim;
    double chiq;
    gvet Centro;
    gvet Xcls;// coordinate medie del cluster, parametro di validità
    double Filo;
   void Cluster_Print ();
};



class ClusterStraw
{
private:

    // Primo piano:   direzioni fili lungo x corrdinata corrente y
    // Secondo piano: direzioni fili lungo y corrdinata corrente x
    // Terzo   piano: direzioni fili ruotati di -45(v = (x+y)/sqrt(2) )
    // Quarto  piano: direzioni fili ruotati di 45 (u = (x-y)/sqrt(2) )

    static const int MAXCLUSTER=30;
    int ny,nx,nv,nu,mask; // Hits in each plain;
    DevStraw *stwy,*stwx,*stwv,*stwu;
    double zy,zx,zv,zu,z_centro_mag;  // zeta del piano
    gmatrix Pij,Pjx,Pjy,Pju,Pjv;


public:
    ClusterStraw(DevStraw*);
    ~ClusterStraw() { };
    gvet xwc,ywc,uwc,vwc;
    double ufl,vfl,xfl,yfl; // current were address
    double udt,vdt,xdt,ydt; 
    int nclust, single_plans;
    int Filtro_1(gvet &,double &);
    int Filtro_23(gvet);


    HitClus Clus[MAXCLUSTER];// max 30 clusters
    HitClus ClusSave;



    // dati per root  30 anche troppi....
    int ncls, nwu,nwv,nwx,nwy,hitu[30],hitv[30],hitx[30],hity[30],maskera[30],planes[30];
    int clsusato[30];
    float  Ufil[30],Vfil[30],Xfil[30],Yfil[30];
		float  Udtim[30],Vdtim[30],Xdtim[30],Ydtim[30];
    float X[30],Y[30],Z[30];
    float chiq[30];
    // end dati per root



    // Methods & Functions
    int Get_Cluster();
    void Ordina();
    void Cluster2Root();
};

#if defined(MAINFLYO)
ClusterStraw *ChambClus[4];
#endif

#if !defined(MAINFLYO)
extern ClusterStraw *ChambClus[4];
#endif

#endif
