/***************************************************************************
 *   Copyright (C) 2005 by Giuseppe Pierazzini          Pisa 05.09.05      *
 *   pierazzini@unipi.it                                                   *
 *                                     F l y o                             *
 *   Epsi/NA48                                                             *
 ***************************************************************************/
/* Authors G.Pierazzini - G.Ruggiero */

#ifndef TRGMPTRAW_H
#define TRGMPTRAW_H
#include <gmatrix.h>
#include "devstraw.h"
#include "clusgmp.h"


struct Track
{
    int id,mask,camere,single;
    int ic0,ic1,ic2,ic3;
    short int msk0,msk1,msk2,msk3, used_plans;
    double zby_y,zby_x;
    double clstgx,clstgy,tgxfit,tgyfit;
    double dx0,dx1,dx2,dx3,dy0,dy1,dy2,dy3;
    double chiq_fit;
    double charge;
    gvet Xmg;
    gvet Xhodx;
    gvet Xlkr,Xlkr0;
    gvet P_in,P_out;
    void Print_Trk();
};

static const int MAXTRACK=10;
class TrgmpStraw
{
private:
    int ntrk;
    int ncls0,ncls1,ncls2,ncls3;
    double z_centro_mag, Scatter_base;
    ClusterStraw  *pcl,*pcl0,*pcl1,*pcl2,*pcl3;

    void Track2Root();


public:
    TrgmpStraw();
    ~TrgmpStraw();

    void Make_Trk();
    double Fitting(short int);
    int Verify(short int,int );
    
    

    //general public ddata
    // Max 10 tracks reconstruced
    Track Traccia[MAXTRACK];
    Track TrkNow;

    // Structure for root
    int charge_all;
    int ntrk_done;
    struct
    {
        int id[MAXTRACK],mask[MAXTRACK],camere[MAXTRACK],single[MAXTRACK],usepl[MAXTRACK],
        ic0[MAXTRACK],ic1[MAXTRACK],ic2[MAXTRACK],ic3[MAXTRACK];
        float zbyy[MAXTRACK],  zbyx[MAXTRACK];
        float chiq[MAXTRACK], charge[MAXTRACK], xmg[MAXTRACK], ymg[MAXTRACK],p[MAXTRACK],py[MAXTRACK];
        float  pxin[MAXTRACK],pzin[MAXTRACK],pxout[MAXTRACK],pzout[MAXTRACK];
        float  xhodx[MAXTRACK],yhodx[MAXTRACK];
        float  xlkr[MAXTRACK],ylkr[MAXTRACK];
        float   clstgx[MAXTRACK],clstgy[MAXTRACK], tgxfit[MAXTRACK],tgyfit[MAXTRACK];
        float  dx0[MAXTRACK], dx1[MAXTRACK], dx2[MAXTRACK], dx3[MAXTRACK];
        float  dy0[MAXTRACK], dy1[MAXTRACK], dy2[MAXTRACK], dy3[MAXTRACK];
        
    } Trk2Root;

};

#if defined(MAINFLYO)
TrgmpStraw  * Trkstraw;
#endif

#if !defined(MAINFLYO)
extern TrgmpStraw* Trkstraw;
#endif

#endif
